/*************************************************************************
 *
 *  $RCSfile: offmgr_internationaloptions.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:25:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESS OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc..
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {

//STRIP001 #ifndef _OFFAPP_INTERNATIONALOPTIONS_HXX_
//STRIP001 #include "internationaloptions.hxx"
//STRIP001 #endif
//STRIP001 #ifndef _OFFAPP_INTERNATIONALOPTIONS_HRC_
//STRIP001 #include "internationaloptions.hrc"
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _OFF_APP_HRC
//STRIP001 #include "app.hrc"
//STRIP001 #endif
//STRIP001 #ifndef _OFF_RESID_HXX 
//STRIP001 #include "resid.hxx"
//STRIP001 #endif
//STRIP001 #ifndef _SFXENUMITEM_HXX
//STRIP001 #include <svtools/eitem.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SVX_SVXIDS_HRC
//STRIP001 #include <bf_svx/svxids.hrc>
//STRIP001 #endif
//STRIP001 
//STRIP001 
//STRIP001 namespace offapp
//STRIP001 {
//STRIP001 
//STRIP001 	struct InternationalOptionsPage::IMPL
//STRIP001 	{
//STRIP001 		FixedLine			m_aFL_DefaultTextDirection;
//STRIP001 		RadioButton			m_aRB_TxtDirLeft2Right;
//STRIP001 		RadioButton			m_aRB_TxtDirRight2Left;
//STRIP001 		FixedLine			m_aFL_SheetView;
//STRIP001 		CheckBox			m_aCB_ShtVwRight2Left;
//STRIP001 		CheckBox			m_aCB_ShtVwCurrentDocOnly;
//STRIP001 
//STRIP001 		BOOL				m_bEnable_SheetView_Opt : 1;
//STRIP001 
//STRIP001 		inline				IMPL( Window* _pParent );
//STRIP001 	
//STRIP001 		inline void			EnableOption_SheetView( BOOL _bEnable = TRUE );
//STRIP001 		void				ShowOption_SheetView( BOOL _bShow = TRUE );
//STRIP001 
//STRIP001 		BOOL				FillItemSet( SfxItemSet& _rSet );
//STRIP001 		void				Reset( const SfxItemSet& _rSet );
//STRIP001 	};
//STRIP001 
//STRIP001 	inline InternationalOptionsPage::IMPL::IMPL( Window* _pParent ) :
//STRIP001 		m_aFL_DefaultTextDirection	( _pParent,	ResId( FL_DEFTXTDIRECTION ) )
//STRIP001 		,m_aRB_TxtDirLeft2Right		( _pParent,	ResId( RB_TXTDIR_LEFT2RIGHT ) )
//STRIP001 		,m_aRB_TxtDirRight2Left		( _pParent, ResId( RB_TXTDIR_RIGHT2LEFT ) )
//STRIP001 		,m_aFL_SheetView			( _pParent, ResId( FL_SHEETVIEW ) )
//STRIP001 		,m_aCB_ShtVwRight2Left		( _pParent, ResId( CB_SHTVW_RIGHT2LEFT ) )
//STRIP001 		,m_aCB_ShtVwCurrentDocOnly	( _pParent, ResId( CB_SHTVW_CURRENTDOCONLY ) )
//STRIP001 
//STRIP001 		,m_bEnable_SheetView_Opt	( FALSE )
//STRIP001 	{
//STRIP001 		ShowOption_SheetView( m_bEnable_SheetView_Opt );
//STRIP001 	}
//STRIP001 
//STRIP001 	inline void InternationalOptionsPage::IMPL::EnableOption_SheetView( BOOL _bEnable )
//STRIP001 	{
//STRIP001 		if( m_bEnable_SheetView_Opt != _bEnable )
//STRIP001 		{
//STRIP001 			ShowOption_SheetView( _bEnable );
//STRIP001 
//STRIP001 			m_bEnable_SheetView_Opt = _bEnable;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	void InternationalOptionsPage::IMPL::ShowOption_SheetView( BOOL _bShow )
//STRIP001 	{
//STRIP001 		m_aFL_SheetView.Show( _bShow );
//STRIP001 		m_aCB_ShtVwRight2Left.Show( _bShow );
//STRIP001 		m_aCB_ShtVwCurrentDocOnly.Show( _bShow );
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL InternationalOptionsPage::IMPL::FillItemSet( SfxItemSet& _rSet )
//STRIP001 	{
//STRIP001 		DBG_ASSERT( _rSet.GetPool(), "-InternationalOptionsPage::FillItemSet(): no pool gives rums!" );
//STRIP001 
//STRIP001 		// handling of DefaultTextDirection stuff
//STRIP001 		_rSet.Put(	SfxBoolItem(	_rSet.GetPool()->GetWhich( SID_ATTR_PARA_LEFT_TO_RIGHT ),
//STRIP001 									m_aRB_TxtDirLeft2Right.IsChecked() ),
//STRIP001 					SID_ATTR_PARA_LEFT_TO_RIGHT );
//STRIP001 
//STRIP001 		// handling of SheetView stuff
//STRIP001 //		if( m_bEnable_SheetView_Opt )
//STRIP001 //		{
//STRIP001 //		}
//STRIP001 
//STRIP001 		return TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	void InternationalOptionsPage::IMPL::Reset( const SfxItemSet& _rSet )
//STRIP001 	{
//STRIP001 		// handling of DefaultTextDirection stuff
//STRIP001 		const SfxBoolItem*	pLeft2RightItem = static_cast< const SfxBoolItem* >( GetItem( _rSet, SID_ATTR_PARA_LEFT_TO_RIGHT ) );
//STRIP001 
//STRIP001 		DBG_ASSERT( pLeft2RightItem, "+InternationalOptionsPage::Reset(): SID_ATTR_PARA_LEFT_TO_RIGHT not set!" );
//STRIP001 
//STRIP001 		BOOL				bLeft2Right = pLeft2RightItem? pLeft2RightItem->GetValue() : TRUE;
//STRIP001 		m_aRB_TxtDirLeft2Right.Check( bLeft2Right );
//STRIP001 
//STRIP001 		// handling of SheetView stuff
//STRIP001 //		if( m_bEnable_SheetView_Opt )
//STRIP001 //		{
//STRIP001 //			m_aCB_ShtVwRight2Left.Check( FALSE );
//STRIP001 //
//STRIP001 //			m_aCB_ShtVwCurrentDocOnly.Check( FALSE );
//STRIP001 //		}
//STRIP001 	}
//STRIP001 
//STRIP001 	InternationalOptionsPage::InternationalOptionsPage( Window* _pParent, const SfxItemSet& _rAttrSet ) :
//STRIP001 		SfxTabPage	( _pParent, OffResId( RID_OFA_TP_INTERNATIONAL ), _rAttrSet )
//STRIP001 
//STRIP001 		,m_pImpl	( new IMPL( this ) )
//STRIP001 	{
//STRIP001 		FreeResource();
//STRIP001 	}
//STRIP001 
//STRIP001 	SfxTabPage* InternationalOptionsPage::CreateSd( Window* _pParent, const SfxItemSet& _rAttrSet )
//STRIP001 	{
//STRIP001 		return new InternationalOptionsPage( _pParent, _rAttrSet );
//STRIP001 	}
//STRIP001 
//STRIP001 	SfxTabPage* InternationalOptionsPage::CreateSc( Window* _pParent, const SfxItemSet& _rAttrSet )
//STRIP001 	{
//STRIP001 		InternationalOptionsPage*	p = new InternationalOptionsPage( _pParent, _rAttrSet );
//STRIP001 //		p->m_pImpl->EnableOption_SheetView();
//STRIP001 		return p;
//STRIP001 	}
//STRIP001 
//STRIP001 	InternationalOptionsPage::~InternationalOptionsPage()
//STRIP001 	{
//STRIP001 		DELETEZ( m_pImpl );
//STRIP001 	}
//STRIP001 
//STRIP001 	BOOL InternationalOptionsPage::FillItemSet( SfxItemSet& _rSet )
//STRIP001 	{
//STRIP001 		return m_pImpl->FillItemSet( _rSet );
//STRIP001 	}
//STRIP001 
//STRIP001 	void InternationalOptionsPage::Reset( const SfxItemSet& _rSet )
//STRIP001 	{
//STRIP001 		m_pImpl->Reset( _rSet );
//STRIP001 	}
//STRIP001 	
//STRIP001 }	// /namespace offapp

}
