/*************************************************************************
 *
 *  $RCSfile: sc_reffind.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:21:33 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "core_pch.hxx"
#endif

#pragma hdrstop

// INCLUDE ---------------------------------------------------------------

#include <string.h>

// auto strip #include "reffind.hxx"
// auto strip #include "global.hxx"
// auto strip #include "compiler.hxx"
namespace binfilter {


// STATIC DATA -----------------------------------------------------------

//	incl. Doppelpunkt -> Doppelte Referenzen werden einzeln behandelt
//STRIP001 const sal_Unicode __FAR_DATA ScRefFinder::pDelimiters[] = {
//STRIP001 	'=','(',')',';','+','-','*','/','^','&',' ','{','}','<','>',':', 0
//STRIP001 };

// =======================================================================

//STRIP001 inline BOOL IsText( sal_Unicode c )
//STRIP001 {
//STRIP001 	return !ScGlobal::UnicodeStrChr( ScRefFinder::pDelimiters, c );
//STRIP001 }

//STRIP001 inline BOOL IsText( BOOL& bQuote, sal_Unicode c )
//STRIP001 {
//STRIP001 	if ( c == '\'' )
//STRIP001 	{
//STRIP001 		bQuote = !bQuote;
//STRIP001 		return TRUE;
//STRIP001 	}
//STRIP001 	if ( bQuote )
//STRIP001 		return TRUE;
//STRIP001 	return IsText( c );
//STRIP001 }

//STRIP001 ScRefFinder::ScRefFinder(const String& rFormula, ScDocument* pDocument) :
//STRIP001 	aFormula( rFormula ),
//STRIP001 	pDoc( pDocument )
//STRIP001 {
//STRIP001 	nSelStart = nSelEnd = nFound = 0;
//STRIP001 }

//STRIP001 ScRefFinder::~ScRefFinder()
//STRIP001 {
//STRIP001 }

//STRIP001 USHORT lcl_NextFlags( USHORT nOld )
//STRIP001 {
//STRIP001 	USHORT nNew = nOld & 7;					// die drei Abs-Flags
//STRIP001 	nNew = ( nNew - 1 ) & 7;				// weiterzaehlen
//STRIP001 
//STRIP001 	if (!(nOld & SCA_TAB_3D))
//STRIP001 		nNew &= ~SCA_TAB_ABSOLUTE;			// nicht 3D -> nie absolut!
//STRIP001 
//STRIP001 	return ( nOld & 0xfff8 ) | nNew;
//STRIP001 }

//STRIP001 void ScRefFinder::ToggleRel( xub_StrLen nStartPos, xub_StrLen nEndPos )
//STRIP001 {
//STRIP001 	xub_StrLen nLen = aFormula.Len();
//STRIP001 	if (!nLen)
//STRIP001 		return;
//STRIP001 	const sal_Unicode* pSource = aFormula.GetBuffer();		// fuer schnellen Zugriff
//STRIP001 
//STRIP001 	//	Selektion erweitern, und statt Selektion Start- und Endindex
//STRIP001 
//STRIP001 	if ( nEndPos < nStartPos )
//STRIP001 	{
//STRIP001 		xub_StrLen nTemp = nStartPos; nStartPos = nEndPos; nEndPos = nTemp;
//STRIP001 	}
//STRIP001 	while (nStartPos > 0 && IsText(pSource[nStartPos - 1]) )
//STRIP001 		--nStartPos;
//STRIP001 	if (nEndPos)
//STRIP001 		--nEndPos;
//STRIP001 	while (nEndPos+1 < nLen && IsText(pSource[nEndPos + 1]) )
//STRIP001 		++nEndPos;
//STRIP001 
//STRIP001 	String aResult;
//STRIP001 	String aExpr;
//STRIP001 	String aSep;
//STRIP001 	ScAddress aAddr;
//STRIP001 	nFound = 0;
//STRIP001 
//STRIP001 	xub_StrLen nLoopStart = nStartPos;
//STRIP001 	while ( nLoopStart <= nEndPos )
//STRIP001 	{
//STRIP001 		//	Formel zerlegen
//STRIP001 
//STRIP001 		xub_StrLen nEStart = nLoopStart;
//STRIP001 		while ( nEStart <= nEndPos && !IsText(pSource[nEStart]) )
//STRIP001 			++nEStart;
//STRIP001 
//STRIP001 		BOOL bQuote = FALSE;
//STRIP001 		xub_StrLen nEEnd = nEStart;
//STRIP001 		while ( nEEnd <= nEndPos && IsText(bQuote,pSource[nEEnd]) )
//STRIP001 			++nEEnd;
//STRIP001 
//STRIP001 		aSep  = aFormula.Copy( nLoopStart, nEStart-nLoopStart );
//STRIP001 		aExpr = aFormula.Copy( nEStart, nEEnd-nEStart );
//STRIP001 
//STRIP001 		//	Test, ob aExpr eine Referenz ist
//STRIP001 
//STRIP001 		USHORT nResult = aAddr.Parse( aExpr, pDoc );
//STRIP001 		if ( nResult & SCA_VALID )
//STRIP001 		{
//STRIP001 			USHORT nFlags = lcl_NextFlags( nResult );
//STRIP001 			aAddr.Format( aExpr, nFlags, pDoc );
//STRIP001 
//STRIP001 			xub_StrLen nAbsStart = nStartPos+aResult.Len()+aSep.Len();
//STRIP001 
//STRIP001 			if (!nFound)							// erste Referenz ?
//STRIP001 				nSelStart = nAbsStart;
//STRIP001 			nSelEnd = nAbsStart+aExpr.Len();		// Selektion, keine Indizes
//STRIP001 			++nFound;
//STRIP001 		}
//STRIP001 
//STRIP001 		//	zusammenbauen
//STRIP001 
//STRIP001 		aResult += aSep;
//STRIP001 		aResult += aExpr;
//STRIP001 
//STRIP001 		nLoopStart = nEEnd;
//STRIP001 	}
//STRIP001 
//STRIP001 	String aTotal = aFormula.Copy( 0, nStartPos );
//STRIP001 	aTotal += aResult;
//STRIP001 	aTotal += aFormula.Copy( nEndPos+1 );
//STRIP001 
//STRIP001 	aFormula = aTotal;
//STRIP001 }




}
