/*************************************************************************
 *
 *  $RCSfile: sc_tpsubt.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:44:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

//#ifndef PCH
//#include <vcl/system.hxx>
//#endif

//#include <checklbx.hxx>

// auto strip #include "scitems.hxx"
// auto strip #include "uiitems.hxx"
// auto strip #include "global.hxx"
// auto strip #include "userlist.hxx"
// auto strip #include "viewdata.hxx"
// auto strip #include "document.hxx"
// auto strip #include "scresid.hxx"
#include "bf_sc.hrc"       // -> Slot IDs

// auto strip #include "subtdlg.hxx"
#include "subtdlg.hrc"
// auto strip #include "tpsubt.hxx"
namespace binfilter {

// STATIC DATA -----------------------------------------------------------

//STRIP001 static USHORT pSubTotalsRanges[] =
//STRIP001 {
//STRIP001 	SID_SUBTOTALS,
//STRIP001 	SID_SUBTOTALS,
//STRIP001 	0
//STRIP001 };

//========================================================================
// Zwischenergebnisgruppen-Tabpage:

//STRIP001 ScTpSubTotalGroup::ScTpSubTotalGroup( Window* pParent, USHORT nResId,
//STRIP001 									  const SfxItemSet& rArgSet )
//STRIP001 		:	SfxTabPage		( pParent,
//STRIP001 							  ScResId( nResId ),
//STRIP001 							  rArgSet ),
//STRIP001 			//
//STRIP001 			aLbGroup		( this, ScResId( LB_GROUP ) ),
//STRIP001 			aLbColumns		( this, ScResId( WND_COLUMNS ) ),
//STRIP001 			aLbFunctions	( this, ScResId( LB_FUNCTIONS ) ),
//STRIP001 			aFtGroup		( this, ScResId( FT_GROUP ) ),
//STRIP001 			aFtColumns		( this, ScResId( FT_COLUMNS ) ),
//STRIP001 			aFtFunctions	( this, ScResId( FT_FUNCTIONS ) ),
//STRIP001 			aStrNone		( ScResId( SCSTR_NONE ) ),
//STRIP001 			aStrColumn		( ScResId( SCSTR_COLUMN ) ),
//STRIP001 			//
//STRIP001 			nWhichSubTotals ( rArgSet.GetPool()->GetWhich( SID_SUBTOTALS ) ),
//STRIP001 			rSubTotalData	( ((const ScSubTotalItem&)
//STRIP001 							  rArgSet.Get( nWhichSubTotals )).
//STRIP001 								GetSubTotalData() ),
//STRIP001 			nFieldCount 	( 0 ),
//STRIP001 			pViewData		( NULL ),
//STRIP001 			pDoc			( NULL )
//STRIP001 {
//STRIP001 	// Font is correctly initialized by SvTreeListBox ctor
//STRIP001 	aLbColumns.SetSelectionMode( SINGLE_SELECTION );
//STRIP001 	aLbColumns.SetDragDropMode( SV_DRAGDROP_NONE );
//STRIP001 	aLbColumns.SetSpaceBetweenEntries( 0 );
//STRIP001 	aLbColumns.Show();
//STRIP001 
//STRIP001 	Init ();
//STRIP001 	FreeResource();
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 __EXPORT ScTpSubTotalGroup::~ScTpSubTotalGroup()
//STRIP001 {
//STRIP001 	USHORT	nCount = (USHORT)aLbColumns.GetEntryCount();
//STRIP001 
//STRIP001 	if ( nCount > 0 )
//STRIP001 	{
//STRIP001 		USHORT* pData = NULL;
//STRIP001 
//STRIP001 		for ( USHORT i=0; i<nCount; i++ )
//STRIP001 		{
//STRIP001 			pData = (USHORT*)(aLbColumns.GetEntryData( i ));
//STRIP001 			DBG_ASSERT( pData, "EntryData not found" );
//STRIP001 
//STRIP001 			delete pData;
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void ScTpSubTotalGroup::Init()
//STRIP001 {
//STRIP001 	const ScSubTotalItem& rSubTotalItem = (const ScSubTotalItem&)
//STRIP001 										  GetItemSet().Get( nWhichSubTotals );
//STRIP001 
//STRIP001 	pViewData	= rSubTotalItem.GetViewData();
//STRIP001 	pDoc		= ( pViewData ) ? pViewData->GetDocument() : NULL;
//STRIP001 
//STRIP001 	DBG_ASSERT( pViewData && pDoc, "ViewData or Document not found :-(" );
//STRIP001 
//STRIP001 	aLbGroup.SetSelectHdl		( LINK( this, ScTpSubTotalGroup, SelectHdl ) );
//STRIP001 	aLbColumns.SetSelectHdl		( LINK( this, ScTpSubTotalGroup, SelectHdl ) );
//STRIP001 	aLbColumns.SetCheckButtonHdl	( LINK( this, ScTpSubTotalGroup, CheckHdl ) );
//STRIP001 	aLbFunctions.SetSelectHdl	( LINK( this, ScTpSubTotalGroup, SelectHdl ) );
//STRIP001 
//STRIP001 	nFieldArr[0] = 0;
//STRIP001 	FillListBoxes();
//STRIP001 }

//------------------------------------------------------------------------

//STRIP001 USHORT* __EXPORT ScTpSubTotalGroup::GetRanges()
//STRIP001 {
//STRIP001 	return pSubTotalsRanges;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 BOOL ScTpSubTotalGroup::DoReset( USHORT 			nGroupNo,
//STRIP001 								 const SfxItemSet&	rArgSet  )
//STRIP001 {
//STRIP001 	USHORT nGroupIdx = 0;
//STRIP001 
//STRIP001 	DBG_ASSERT( (nGroupNo<=3) && (nGroupNo>0), "Invalid group" );
//STRIP001 
//STRIP001 	if ( (nGroupNo > 3) || (nGroupNo == 0) )
//STRIP001 		return FALSE;
//STRIP001 	else
//STRIP001 		nGroupIdx = nGroupNo-1;
//STRIP001 
//STRIP001 	//----------------------------------------------------------
//STRIP001 
//STRIP001     // #79058# first we have to clear the listboxes...
//STRIP001     for ( USHORT nLbEntry = 0; nLbEntry < aLbColumns.GetEntryCount(); ++nLbEntry )
//STRIP001     {
//STRIP001         aLbColumns.CheckEntryPos( nLbEntry, FALSE );
//STRIP001         *((USHORT*)aLbColumns.GetEntryData( nLbEntry )) = 0;
//STRIP001     }
//STRIP001     aLbFunctions.SelectEntryPos( 0 );
//STRIP001 
//STRIP001 	ScSubTotalParam theSubTotalData( ((const ScSubTotalItem&)
//STRIP001 									  rArgSet.Get( nWhichSubTotals )).
//STRIP001 											GetSubTotalData() );
//STRIP001 
//STRIP001 	if ( theSubTotalData.bGroupActive[nGroupIdx] )
//STRIP001 	{
//STRIP001 		USHORT			nField		= theSubTotalData.nField[nGroupIdx];
//STRIP001 		USHORT			nSubTotals	= theSubTotalData.nSubTotals[nGroupIdx];
//STRIP001 		USHORT* 		pSubTotals	= theSubTotalData.pSubTotals[nGroupIdx];
//STRIP001 		ScSubTotalFunc* pFunctions	= theSubTotalData.pFunctions[nGroupIdx];
//STRIP001 
//STRIP001 		aLbGroup.SelectEntryPos( GetFieldSelPos( nField )+1 );
//STRIP001 
//STRIP001 		for ( USHORT i=0; i<nSubTotals; i++ )
//STRIP001 		{
//STRIP001 			USHORT	nCheckPos = GetFieldSelPos( pSubTotals[i] );
//STRIP001 			USHORT* pFunction = (USHORT*)aLbColumns.GetEntryData( nCheckPos );
//STRIP001 
//STRIP001 			aLbColumns.CheckEntryPos( nCheckPos );
//STRIP001 			*pFunction = FuncToLbPos( pFunctions[i] );
//STRIP001 		}
//STRIP001         aLbColumns.SelectEntryPos( 0 );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aLbGroup.SelectEntryPos( (nGroupNo == 1) ? 1 : 0 );
//STRIP001 		aLbColumns.SelectEntryPos( 0 );
//STRIP001 		aLbFunctions.SelectEntryPos( 0 );
//STRIP001 	}
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 BOOL ScTpSubTotalGroup::DoFillItemSet( USHORT		nGroupNo,
//STRIP001 									   SfxItemSet&	rArgSet  )
//STRIP001 {
//STRIP001 	USHORT nGroupIdx = 0;
//STRIP001 
//STRIP001 	DBG_ASSERT( (nGroupNo<=3) && (nGroupNo>0), "Invalid group" );
//STRIP001 	DBG_ASSERT(    (aLbGroup.GetEntryCount() > 0)
//STRIP001 				&& (aLbColumns.GetEntryCount() > 0)
//STRIP001 				&& (aLbFunctions.GetEntryCount() > 0),
//STRIP001 				"Non-initialized Lists" );
//STRIP001 
//STRIP001 
//STRIP001 	if (  (nGroupNo > 3) || (nGroupNo == 0)
//STRIP001 		|| (aLbGroup.GetEntryCount() == 0)
//STRIP001 		|| (aLbColumns.GetEntryCount() == 0)
//STRIP001 		|| (aLbFunctions.GetEntryCount() == 0)
//STRIP001 	   )
//STRIP001 		return FALSE;
//STRIP001 	else
//STRIP001 		nGroupIdx = nGroupNo-1;
//STRIP001 
//STRIP001 	//----------------------------------------------------------
//STRIP001 
//STRIP001 	ScSubTotalParam theSubTotalData;			// auslesen, wenn schon teilweise gefuellt
//STRIP001 	SfxTabDialog* pDlg = GetTabDialog();
//STRIP001 	if ( pDlg )
//STRIP001 	{
//STRIP001 		const SfxItemSet* pExample = pDlg->GetExampleSet();
//STRIP001 		const SfxPoolItem* pItem;
//STRIP001 		if ( pExample && pExample->GetItemState( nWhichSubTotals, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 			theSubTotalData = ((const ScSubTotalItem*)pItem)->GetSubTotalData();
//STRIP001 	}
//STRIP001 
//STRIP001 	ScSubTotalFunc* pFunctions	= NULL;
//STRIP001 	USHORT* 		pSubTotals	= NULL;
//STRIP001 	USHORT			nGroup		= aLbGroup.GetSelectEntryPos();
//STRIP001 	USHORT			nEntryCount = (USHORT)aLbColumns.GetEntryCount();
//STRIP001 	USHORT			nCheckCount = aLbColumns.GetCheckedEntryCount();
//STRIP001 
//STRIP001 	theSubTotalData.nCol1					= rSubTotalData.nCol1;
//STRIP001 	theSubTotalData.nRow1					= rSubTotalData.nRow1;
//STRIP001 	theSubTotalData.nCol2					= rSubTotalData.nCol2;
//STRIP001 	theSubTotalData.nRow2					= rSubTotalData.nRow2;
//STRIP001 	theSubTotalData.bGroupActive[nGroupIdx] = (nGroup != 0);
//STRIP001 	theSubTotalData.nField[nGroupIdx]		= (nGroup != 0)
//STRIP001 												? nFieldArr[nGroup-1]
//STRIP001 												: 0;
//STRIP001 
//STRIP001 	if ( nEntryCount>0 && nCheckCount>0 && nGroup!=0 )
//STRIP001 	{
//STRIP001 		USHORT nFunction	= 0;
//STRIP001 
//STRIP001 		pSubTotals = new USHORT 		[nCheckCount];
//STRIP001 		pFunctions = new ScSubTotalFunc [nCheckCount];
//STRIP001 
//STRIP001 		for ( USHORT i=0, nCheck=0; i<nEntryCount; i++ )
//STRIP001 		{
//STRIP001 			if ( aLbColumns.IsChecked( i ) )
//STRIP001 			{
//STRIP001 				DBG_ASSERT( nCheck <= nCheckCount,
//STRIP001 							"Range error :-(" );
//STRIP001 				nFunction = *((USHORT*)aLbColumns.GetEntryData( i ));
//STRIP001 				pSubTotals[nCheck] = nFieldArr[i];
//STRIP001 				pFunctions[nCheck] = LbPosToFunc( nFunction );
//STRIP001 				nCheck++;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		theSubTotalData.SetSubTotals( nGroupNo, 	 // Gruppen-Nr.
//STRIP001 									  pSubTotals,
//STRIP001 									  pFunctions,
//STRIP001 									  nCheckCount ); // Anzahl der Array-Elemente
//STRIP001 
//STRIP001 	}
//STRIP001 
//STRIP001 	rArgSet.Put( ScSubTotalItem( SCITEM_SUBTDATA, &theSubTotalData ) );
//STRIP001 
//STRIP001 	if ( pSubTotals ) delete pSubTotals;
//STRIP001 	if ( pFunctions ) delete pFunctions;
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void ScTpSubTotalGroup::FillListBoxes()
//STRIP001 {
//STRIP001 	DBG_ASSERT( pViewData && pDoc, "ViewData or Document not found :-/" );
//STRIP001 
//STRIP001 	if ( pViewData && pDoc )
//STRIP001 	{
//STRIP001 		USHORT	nFirstCol	= rSubTotalData.nCol1;
//STRIP001 		USHORT	nFirstRow	= rSubTotalData.nRow1;
//STRIP001 		USHORT	nTab		= pViewData->GetTabNo();
//STRIP001 		USHORT	nMaxCol 	= rSubTotalData.nCol2;
//STRIP001 		USHORT	col;
//STRIP001 		USHORT	i=0;
//STRIP001 		String	aFieldName;
//STRIP001 
//STRIP001 		aLbGroup.Clear();
//STRIP001 		aLbColumns.Clear();
//STRIP001 		aLbGroup.InsertEntry( aStrNone, 0 );
//STRIP001 
//STRIP001 		i=0;
//STRIP001 		for ( col=nFirstCol; col<=nMaxCol && i<SC_MAXFIELDS; col++ )
//STRIP001 		{
//STRIP001 			pDoc->GetString( col, nFirstRow, nTab, aFieldName );
//STRIP001 			if ( aFieldName.Len() == 0 )
//STRIP001 			{
//STRIP001                 aFieldName = aStrColumn;
//STRIP001                 aFieldName += ' ';
//STRIP001                 aFieldName += ::ColToAlpha( col );  // from global.hxx
//STRIP001 			}
//STRIP001 			nFieldArr[i] = col;
//STRIP001 			aLbGroup.InsertEntry( aFieldName, i+1 );
//STRIP001 			aLbColumns.InsertEntry( aFieldName, i );
//STRIP001 			aLbColumns.SetEntryData( i, new USHORT(0) );
//STRIP001 			i++;
//STRIP001 		}
//STRIP001 		// Nachtraegliche "Konstanteninitialisierung":
//STRIP001 		(USHORT&)nFieldCount = i;
//STRIP001 	}
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 USHORT ScTpSubTotalGroup::GetFieldSelPos( USHORT nField )
//STRIP001 {
//STRIP001 	USHORT	nFieldPos	= 0;
//STRIP001 	BOOL	bFound		= FALSE;
//STRIP001 
//STRIP001 	for ( USHORT n=0; n<nFieldCount && !bFound; n++ )
//STRIP001 	{
//STRIP001 		if ( nFieldArr[n] == nField )
//STRIP001 		{
//STRIP001 			nFieldPos = n;
//STRIP001 			bFound = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return nFieldPos;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 ScSubTotalFunc ScTpSubTotalGroup::LbPosToFunc( USHORT nPos )
//STRIP001 {
//STRIP001 	switch ( nPos )
//STRIP001 	{
//STRIP001 //		case  0:	return SUBTOTAL_FUNC_NONE;
//STRIP001 		case  2:	return SUBTOTAL_FUNC_AVE;
//STRIP001 		case  6:	return SUBTOTAL_FUNC_CNT;
//STRIP001 		case  1:	return SUBTOTAL_FUNC_CNT2;
//STRIP001 		case  3:	return SUBTOTAL_FUNC_MAX;
//STRIP001 		case  4:	return SUBTOTAL_FUNC_MIN;
//STRIP001 		case  5:	return SUBTOTAL_FUNC_PROD;
//STRIP001 		case  7:	return SUBTOTAL_FUNC_STD;
//STRIP001 		case  8:	return SUBTOTAL_FUNC_STDP;
//STRIP001 		case  0:	return SUBTOTAL_FUNC_SUM;
//STRIP001 		case  9:	return SUBTOTAL_FUNC_VAR;
//STRIP001 		case 10:	return SUBTOTAL_FUNC_VARP;
//STRIP001 		default:
//STRIP001 			DBG_ERROR( "ScTpSubTotalGroup::LbPosToFunc" );
//STRIP001 			return SUBTOTAL_FUNC_NONE;
//STRIP001 	}
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 USHORT ScTpSubTotalGroup::FuncToLbPos( ScSubTotalFunc eFunc )
//STRIP001 {
//STRIP001 	switch ( eFunc )
//STRIP001 	{
//STRIP001 //		case SUBTOTAL_FUNC_NONE:	return 0;
//STRIP001 		case SUBTOTAL_FUNC_AVE: 	return 2;
//STRIP001 		case SUBTOTAL_FUNC_CNT: 	return 6;
//STRIP001 		case SUBTOTAL_FUNC_CNT2:	return 1;
//STRIP001 		case SUBTOTAL_FUNC_MAX: 	return 3;
//STRIP001 		case SUBTOTAL_FUNC_MIN: 	return 4;
//STRIP001 		case SUBTOTAL_FUNC_PROD:	return 5;
//STRIP001 		case SUBTOTAL_FUNC_STD: 	return 7;
//STRIP001 		case SUBTOTAL_FUNC_STDP:	return 8;
//STRIP001 		case SUBTOTAL_FUNC_SUM: 	return 0;
//STRIP001 		case SUBTOTAL_FUNC_VAR: 	return 9;
//STRIP001 		case SUBTOTAL_FUNC_VARP:	return 10;
//STRIP001 		default:
//STRIP001 			DBG_ERROR( "ScTpSubTotalGroup::FuncToLbPos" );
//STRIP001 			return 0;
//STRIP001 	}
//STRIP001 }

// -----------------------------------------------------------------------
// Handler:
//---------

//STRIP001 IMPL_LINK( ScTpSubTotalGroup, SelectHdl, ListBox *, pLb )
//STRIP001 {
//STRIP001 	if (   (aLbColumns.GetEntryCount() > 0)
//STRIP001 		&& (aLbColumns.GetSelectionCount() > 0) )
//STRIP001 	{
//STRIP001 		USHORT		nFunction	= aLbFunctions.GetSelectEntryPos();
//STRIP001 		USHORT		nColumn 	= aLbColumns.GetSelectEntryPos();
//STRIP001 		USHORT* 	pFunction	= (USHORT*)aLbColumns.GetEntryData( nColumn );
//STRIP001 
//STRIP001 		DBG_ASSERT( pFunction, "EntryData nicht gefunden!" );
//STRIP001 		if ( !pFunction )
//STRIP001 			return 0;
//STRIP001 
//STRIP001 		if ( ((SvxCheckListBox*)pLb) == &aLbColumns )
//STRIP001 		{
//STRIP001 			aLbFunctions.SelectEntryPos( *pFunction );
//STRIP001 		}
//STRIP001 		else if ( pLb == &aLbFunctions )
//STRIP001 		{
//STRIP001 			*pFunction = nFunction;
//STRIP001 //			aLbColumns.CheckEntryPos( nColumn, (nFunction != 0) );//XXX
//STRIP001 			aLbColumns.CheckEntryPos( nColumn, TRUE );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 IMPL_LINK( ScTpSubTotalGroup, CheckHdl, ListBox *, pLb )
//STRIP001 {
//STRIP001 	if ( ((SvxCheckListBox*)pLb) == &aLbColumns )
//STRIP001 	{
//STRIP001 		SvLBoxEntry* pEntry = aLbColumns.GetHdlEntry();
//STRIP001 
//STRIP001 		if ( pEntry )
//STRIP001 		{
//STRIP001 			aLbColumns.SelectEntryPos( (USHORT)aLbColumns.GetModel()->GetAbsPos( pEntry ) );
//STRIP001 			SelectHdl( pLb );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

//========================================================================
// Abgeleitete Gruppen-TabPages:

//STRIP001 SfxTabPage* __EXPORT ScTpSubTotalGroup1::Create( Window*			pParent,
//STRIP001 												 const SfxItemSet&	rArgSet )
//STRIP001 	{ return ( new ScTpSubTotalGroup1( pParent, rArgSet ) ); }

// -----------------------------------------------------------------------

//STRIP001 SfxTabPage* __EXPORT ScTpSubTotalGroup2::Create( Window*			 pParent,
//STRIP001 									   const SfxItemSet&	rArgSet )
//STRIP001 	{ return ( new ScTpSubTotalGroup2( pParent, rArgSet ) ); }

// -----------------------------------------------------------------------

//STRIP001 SfxTabPage* __EXPORT ScTpSubTotalGroup3::Create( Window*			 pParent,
//STRIP001 									   const SfxItemSet&	rArgSet )
//STRIP001 	{ return ( new ScTpSubTotalGroup3( pParent, rArgSet ) ); }

// -----------------------------------------------------------------------

//STRIP001 ScTpSubTotalGroup1::ScTpSubTotalGroup1( Window* pParent, const SfxItemSet& rArgSet ) :
//STRIP001 	ScTpSubTotalGroup( pParent, RID_SCPAGE_SUBT_GROUP1, rArgSet )
//STRIP001 {}

//STRIP001 ScTpSubTotalGroup2::ScTpSubTotalGroup2( Window* pParent, const SfxItemSet& rArgSet ) :
//STRIP001 	ScTpSubTotalGroup( pParent, RID_SCPAGE_SUBT_GROUP2, rArgSet )
//STRIP001 {}

//STRIP001 ScTpSubTotalGroup3::ScTpSubTotalGroup3( Window* pParent, const SfxItemSet& rArgSet ) :
//STRIP001 	ScTpSubTotalGroup( pParent, RID_SCPAGE_SUBT_GROUP3, rArgSet )
//STRIP001 {}

// -----------------------------------------------------------------------


//STRIP001 #define RESET(i) (ScTpSubTotalGroup::DoReset( (i), rArgSet ))

//STRIP001 void __EXPORT ScTpSubTotalGroup1::Reset( const SfxItemSet& rArgSet ) { RESET(1); }

//STRIP001 void __EXPORT ScTpSubTotalGroup2::Reset( const SfxItemSet& rArgSet ) { RESET(2); }

//STRIP001 void __EXPORT ScTpSubTotalGroup3::Reset( const SfxItemSet& rArgSet ) { RESET(3); }

//STRIP001 #undef RESET

// -----------------------------------------------------------------------

//STRIP001 #define FILLSET(i) (ScTpSubTotalGroup::DoFillItemSet( (i), rArgSet ))

//STRIP001 BOOL __EXPORT ScTpSubTotalGroup1::FillItemSet( SfxItemSet& rArgSet ) { return FILLSET(1); }

//STRIP001 BOOL __EXPORT ScTpSubTotalGroup2::FillItemSet( SfxItemSet& rArgSet ) { return FILLSET(2); }

//STRIP001 BOOL __EXPORT ScTpSubTotalGroup3::FillItemSet( SfxItemSet& rArgSet ) { return FILLSET(3); }

//STRIP001 #undef FILL

//========================================================================
// Optionen-Tabpage:

//STRIP001 ScTpSubTotalOptions::ScTpSubTotalOptions( Window*				pParent,
//STRIP001 										  const SfxItemSet& 	rArgSet )
//STRIP001 
//STRIP001 		:	SfxTabPage		( pParent,
//STRIP001 							  ScResId( RID_SCPAGE_SUBT_OPTIONS ),
//STRIP001 							  rArgSet ),
//STRIP001 			//
//STRIP001             aFlGroup        ( this, ScResId( FL_GROUP ) ),
//STRIP001 			aBtnPagebreak	( this, ScResId( BTN_PAGEBREAK ) ),
//STRIP001 			aBtnCase		( this, ScResId( BTN_CASE ) ),
//STRIP001 			aBtnSort		( this, ScResId( BTN_SORT ) ),
//STRIP001             aFlSort         ( this, ScResId( FL_SORT ) ),
//STRIP001 			aBtnAscending	( this, ScResId( BTN_ASCENDING ) ),
//STRIP001 			aBtnDescending	( this, ScResId( BTN_DESCENDING ) ),
//STRIP001 			aBtnFormats 	( this, ScResId( BTN_FORMATS ) ),
//STRIP001 			aBtnUserDef 	( this, ScResId( BTN_USERDEF ) ),
//STRIP001 			aLbUserDef		( this, ScResId( LB_USERDEF ) ),
//STRIP001 			//
//STRIP001 			nWhichSubTotals ( rArgSet.GetPool()->GetWhich( SID_SUBTOTALS ) ),
//STRIP001 			rSubTotalData	( ((const ScSubTotalItem&)
//STRIP001 							  rArgSet.Get( nWhichSubTotals )).
//STRIP001 								GetSubTotalData() ),
//STRIP001 			pViewData		( NULL ),
//STRIP001 			pDoc			( NULL )
//STRIP001 {
//STRIP001 	Init();
//STRIP001 	FreeResource();
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 __EXPORT ScTpSubTotalOptions::~ScTpSubTotalOptions()
//STRIP001 {
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void ScTpSubTotalOptions::Init()
//STRIP001 {
//STRIP001 	const ScSubTotalItem& rSubTotalItem = (const ScSubTotalItem&)
//STRIP001 										  GetItemSet().Get( nWhichSubTotals );
//STRIP001 
//STRIP001 	pViewData	= rSubTotalItem.GetViewData();
//STRIP001 	pDoc		= ( pViewData ) ? pViewData->GetDocument() : NULL;
//STRIP001 
//STRIP001 	DBG_ASSERT( pViewData && pDoc, "ViewData oder Document nicht gefunden!" );
//STRIP001 
//STRIP001 	aBtnSort.SetClickHdl 	( LINK( this, ScTpSubTotalOptions, CheckHdl ) );
//STRIP001 	aBtnUserDef.SetClickHdl	( LINK( this, ScTpSubTotalOptions, CheckHdl ) );
//STRIP001 
//STRIP001 	FillUserSortListBox();
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 SfxTabPage* __EXPORT ScTpSubTotalOptions::Create( Window*				 pParent,
//STRIP001 										  const SfxItemSet& 	rArgSet )
//STRIP001 {
//STRIP001 	return ( new ScTpSubTotalOptions( pParent, rArgSet ) );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void __EXPORT ScTpSubTotalOptions::Reset( const SfxItemSet& rArgSet )
//STRIP001 {
//STRIP001 	aBtnPagebreak.Check ( rSubTotalData.bPagebreak );
//STRIP001 	aBtnCase.Check		( rSubTotalData.bCaseSens );
//STRIP001 	aBtnFormats.Check	( rSubTotalData.bIncludePattern );
//STRIP001 	aBtnSort.Check		( rSubTotalData.bDoSort );
//STRIP001 	aBtnAscending.Check ( rSubTotalData.bAscending );
//STRIP001 	aBtnDescending.Check( !rSubTotalData.bAscending );
//STRIP001 
//STRIP001 	if ( rSubTotalData.bUserDef )
//STRIP001 	{
//STRIP001 		aBtnUserDef.Check( TRUE );
//STRIP001 		aLbUserDef.Enable();
//STRIP001 		aLbUserDef.SelectEntryPos( rSubTotalData.nUserIndex );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aBtnUserDef.Check( FALSE );
//STRIP001 		aLbUserDef.Disable();
//STRIP001 		aLbUserDef.SelectEntryPos( 0 );
//STRIP001 	}
//STRIP001 
//STRIP001 	CheckHdl( &aBtnSort );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 BOOL __EXPORT ScTpSubTotalOptions::FillItemSet( SfxItemSet& rArgSet )
//STRIP001 {
//STRIP001 	ScSubTotalParam theSubTotalData;			// auslesen, wenn schon teilweise gefuellt
//STRIP001 	SfxTabDialog* pDlg = GetTabDialog();
//STRIP001 	if ( pDlg )
//STRIP001 	{
//STRIP001 		const SfxItemSet* pExample = pDlg->GetExampleSet();
//STRIP001 		const SfxPoolItem* pItem;
//STRIP001 		if ( pExample && pExample->GetItemState( nWhichSubTotals, TRUE, &pItem ) == SFX_ITEM_SET )
//STRIP001 			theSubTotalData = ((const ScSubTotalItem*)pItem)->GetSubTotalData();
//STRIP001 	}
//STRIP001 
//STRIP001 	theSubTotalData.bPagebreak		= aBtnPagebreak.IsChecked();
//STRIP001 	theSubTotalData.bReplace		= TRUE;
//STRIP001 	theSubTotalData.bCaseSens		= aBtnCase.IsChecked();
//STRIP001 	theSubTotalData.bIncludePattern = aBtnFormats.IsChecked();
//STRIP001 	theSubTotalData.bDoSort 		= aBtnSort.IsChecked();
//STRIP001 	theSubTotalData.bAscending		= aBtnAscending.IsChecked();
//STRIP001 	theSubTotalData.bUserDef		= aBtnUserDef.IsChecked();
//STRIP001 	theSubTotalData.nUserIndex		= (aBtnUserDef.IsChecked())
//STRIP001 									? aLbUserDef.GetSelectEntryPos()
//STRIP001 									: 0;
//STRIP001 
//STRIP001 	rArgSet.Put( ScSubTotalItem( nWhichSubTotals, &theSubTotalData ) );
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 void ScTpSubTotalOptions::FillUserSortListBox()
//STRIP001 {
//STRIP001 	ScUserList* pUserLists = ScGlobal::GetUserList();
//STRIP001 
//STRIP001 	aLbUserDef.Clear();
//STRIP001 	if ( pUserLists )
//STRIP001 	{
//STRIP001 		USHORT nCount = pUserLists->GetCount();
//STRIP001 		if ( nCount > 0 )
//STRIP001 			for ( USHORT i=0; i<nCount; i++ )
//STRIP001 				aLbUserDef.InsertEntry( (*pUserLists)[i]->GetString() );
//STRIP001 	}
//STRIP001 }

// -----------------------------------------------------------------------
// Handler:

//STRIP001 IMPL_LINK( ScTpSubTotalOptions, CheckHdl, CheckBox *, pBox )
//STRIP001 {
//STRIP001 	if ( pBox == &aBtnSort )
//STRIP001 	{
//STRIP001 		if ( aBtnSort.IsChecked() )
//STRIP001 		{
//STRIP001             aFlSort         .Enable();
//STRIP001 			aBtnFormats 	.Enable();
//STRIP001 			aBtnUserDef 	.Enable();
//STRIP001 			aBtnAscending	.Enable();
//STRIP001 			aBtnDescending	.Enable();
//STRIP001 
//STRIP001 			if ( aBtnUserDef.IsChecked() )
//STRIP001 				aLbUserDef.Enable();
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001             aFlSort         .Disable();
//STRIP001 			aBtnFormats 	.Disable();
//STRIP001 			aBtnUserDef 	.Disable();
//STRIP001 			aBtnAscending	.Disable();
//STRIP001 			aBtnDescending	.Disable();
//STRIP001 			aLbUserDef		.Disable();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if ( pBox == &aBtnUserDef )
//STRIP001 	{
//STRIP001 		if ( aBtnUserDef.IsChecked() )
//STRIP001 		{
//STRIP001 			aLbUserDef.Enable();
//STRIP001 			aLbUserDef.GrabFocus();
//STRIP001 		}
//STRIP001 		else
//STRIP001 			aLbUserDef.Disable();
//STRIP001 	}
//STRIP001 
//STRIP001 	return 0;
//STRIP001 }

//STRIP001 __EXPORT ScTpSubTotalGroup1::~ScTpSubTotalGroup1()
//STRIP001 {
//STRIP001 }

//STRIP001 __EXPORT ScTpSubTotalGroup2::~ScTpSubTotalGroup2()
//STRIP001 {
//STRIP001 }

//STRIP001 __EXPORT ScTpSubTotalGroup3::~ScTpSubTotalGroup3()
//STRIP001 {
//STRIP001 }

}
