/*************************************************************************
 *
 *  $RCSfile: sc_structpg.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:57:32 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

//----------------------------------------------------------------------------

// auto strip #include "scitems.hxx"
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #include <bf_sfx2/docfile.hxx>
// auto strip #include <bf_sfx2/objsh.hxx>
// auto strip #include <svtools/zforlist.hxx>

// auto strip #ifndef _SFXSTRITEM_HXX //autogen
// auto strip #include <svtools/stritem.hxx>
// auto strip #endif

#include "structpg.hxx"
#include "formdlgs.hrc"
// auto strip #include "formdata.hxx"
#include "globstr.hrc"
// auto strip #include "scresid.hxx"
// auto strip #include "reffact.hxx"
// auto strip #include "document.hxx"
// auto strip #include "cell.hxx"
// auto strip #include "scmod.hxx"
// auto strip #include "inputhdl.hxx"
// auto strip #include "tabvwsh.hxx"
// auto strip #include "appoptio.hxx"
namespace binfilter {

//----------------------------------------------------------------------------

//STRIP001 ScStructListBox::ScStructListBox(Window* pParent, const ResId& rResId ):
//STRIP001 	SvTreeListBox(pParent,rResId )
//STRIP001 {
//STRIP001 	bActiveFlag=FALSE;
//STRIP001 }

//STRIP001 SvLBoxEntry* ScStructListBox::InsertStaticEntry(
//STRIP001         const XubString& rText,
//STRIP001         const Image& rEntryImg, const Image& rEntryImgHC,
//STRIP001         SvLBoxEntry* pParent, ULONG nPos, ScToken* pToken )
//STRIP001 {
//STRIP001     SvLBoxEntry* pEntry = InsertEntry( rText, rEntryImg, rEntryImg, pParent, FALSE, nPos, pToken );
//STRIP001     SvLBoxContextBmp* pBmpItem = static_cast< SvLBoxContextBmp* >( pEntry->GetFirstItem( SV_ITEM_ID_LBOXCONTEXTBMP ) );
//STRIP001     DBG_ASSERT( pBmpItem, "ScStructListBox::InsertStaticEntry - missing item" );
//STRIP001     pBmpItem->SetBitmap1( pEntry, rEntryImgHC, BMP_COLOR_HIGHCONTRAST );
//STRIP001     pBmpItem->SetBitmap2( pEntry, rEntryImgHC, BMP_COLOR_HIGHCONTRAST );
//STRIP001     return pEntry;
//STRIP001 }

//STRIP001 void ScStructListBox::SetActiveFlag(BOOL bFlag)
//STRIP001 {
//STRIP001 	bActiveFlag=bFlag;
//STRIP001 }

//STRIP001 BOOL ScStructListBox::GetActiveFlag()
//STRIP001 {
//STRIP001 	return bActiveFlag;
//STRIP001 }

//STRIP001 void ScStructListBox::MouseButtonDown( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	bActiveFlag=TRUE;
//STRIP001 	SvTreeListBox::MouseButtonDown(rMEvt);
//STRIP001 }

//STRIP001 void ScStructListBox::GetFocus()
//STRIP001 {
//STRIP001 	bActiveFlag=TRUE;
//STRIP001 	SvTreeListBox::GetFocus();
//STRIP001 }

//STRIP001 void ScStructListBox::LoseFocus()
//STRIP001 {
//STRIP001 	bActiveFlag=FALSE;
//STRIP001 	SvTreeListBox::LoseFocus();
//STRIP001 }

//==============================================================================

//STRIP001 ScStructPage::ScStructPage(Window* pParent):
//STRIP001 	TabPage(pParent,ScResId(RID_SCTAB_STRUCT)),
//STRIP001 	//
//STRIP001 	aFtStruct		( this, ScResId( FT_STRUCT ) ),
//STRIP001 	aTlbStruct		( this, ScResId( TLB_STRUCT ) ),
//STRIP001     maImgEnd        ( ScResId( BMP_STR_END ) ),
//STRIP001     maImgError      ( ScResId( BMP_STR_ERROR ) ),
//STRIP001     maImgEndHC      ( ScResId( BMP_STR_END_H ) ),
//STRIP001     maImgErrorHC    ( ScResId( BMP_STR_ERROR_H ) ),
//STRIP001 	pSelectedToken	( NULL )
//STRIP001 {
//STRIP001 	aTlbStruct.SetWindowBits(WB_HASLINES|WB_CLIPCHILDREN|
//STRIP001 						WB_HASBUTTONS|WB_HSCROLL|WB_NOINITIALSELECTION);
//STRIP001 
//STRIP001     aTlbStruct.SetNodeDefaultImages();
//STRIP001     aTlbStruct.SetDefaultExpandedEntryBmp( Image( ScResId( BMP_STR_OPEN ) ) );
//STRIP001     aTlbStruct.SetDefaultCollapsedEntryBmp( Image( ScResId( BMP_STR_CLOSE ) ) );
//STRIP001     aTlbStruct.SetDefaultExpandedEntryBmp( Image( ScResId( BMP_STR_OPEN_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001     aTlbStruct.SetDefaultCollapsedEntryBmp( Image( ScResId( BMP_STR_CLOSE_H ) ), BMP_COLOR_HIGHCONTRAST );
//STRIP001 
//STRIP001     FreeResource();
//STRIP001 
//STRIP001 	Font aFont=GetFont();
//STRIP001 	Size aSize=aFont.GetSize();
//STRIP001 	aSize.Height()-=2;
//STRIP001 	aFont.SetSize(aSize);
//STRIP001 	aTlbStruct.SetFont(aFont);
//STRIP001 	aTlbStruct.SetSelectHdl(LINK( this, ScStructPage, SelectHdl ) );
//STRIP001 
//STRIP001 }

//STRIP001 void ScStructPage::ClearStruct()
//STRIP001 {
//STRIP001 	aTlbStruct.SetActiveFlag(FALSE);
//STRIP001 	aTlbStruct.Clear();
//STRIP001 }

//STRIP001 SvLBoxEntry* ScStructPage::InsertEntryWithError(USHORT nError,SvLBoxEntry* pParent,ULONG nPos)
//STRIP001 {
//STRIP001 
//STRIP001     SvLBoxEntry* pEntry = NULL;
//STRIP001     switch( nError )
//STRIP001 	{
//STRIP001 		case STRUCT_ERR_C1:
//STRIP001             pEntry = InsertEntry( STR_STRUCT_ERR1, pParent, STRUCT_ERROR, nPos );
//STRIP001         break;
//STRIP001 		case STRUCT_ERR_C2:
//STRIP001             pEntry = InsertEntry( STR_STRUCT_ERR2, pParent, STRUCT_ERROR, nPos );
//STRIP001         break;
//STRIP001 	}
//STRIP001 	return pEntry;
//STRIP001 }


//STRIP001 SvLBoxEntry* ScStructPage::InsertEntry( const XubString& rText, SvLBoxEntry* pParent,
//STRIP001 									   USHORT nFlag,ULONG nPos,ScToken* pScToken)
//STRIP001 {
//STRIP001     aTlbStruct.SetActiveFlag( FALSE );
//STRIP001 
//STRIP001     SvLBoxEntry* pEntry = NULL;
//STRIP001     switch( nFlag )
//STRIP001 	{
//STRIP001 		case STRUCT_FOLDER:
//STRIP001             pEntry = aTlbStruct.InsertEntry( rText, pParent, FALSE, nPos, pScToken );
//STRIP001         break;
//STRIP001         case STRUCT_END:
//STRIP001             pEntry = aTlbStruct.InsertStaticEntry( rText, maImgEnd, maImgEndHC, pParent, nPos, pScToken );
//STRIP001         break;
//STRIP001         case STRUCT_ERROR:
//STRIP001             pEntry = aTlbStruct.InsertStaticEntry( rText, maImgError, maImgErrorHC, pParent, nPos, pScToken );
//STRIP001         break;
//STRIP001 	}
//STRIP001 
//STRIP001     if( pEntry && pParent )
//STRIP001         aTlbStruct.Expand( pParent );
//STRIP001 	return pEntry;
//STRIP001 }

//STRIP001 String ScStructPage::GetEntryText(SvLBoxEntry* pEntry)
//STRIP001 {
//STRIP001 	String aString;
//STRIP001 	if(pEntry!=NULL)
//STRIP001 		aString=aTlbStruct.GetEntryText(pEntry);
//STRIP001 	return	aString;
//STRIP001 }

//STRIP001 ScToken* ScStructPage::GetFunctionEntry(SvLBoxEntry* pEntry)
//STRIP001 {
//STRIP001 	if(pEntry!=NULL)
//STRIP001 	{
//STRIP001 		ScToken * pToken=(ScToken *)pEntry->GetUserData();
//STRIP001 		if(pToken!=NULL)
//STRIP001 		{
//STRIP001 			OpCode eOp = pToken->GetOpCode();
//STRIP001 			if(!(pToken->IsFunction()|| ocArcTan2<=eOp))
//STRIP001 			{
//STRIP001 				return GetFunctionEntry(aTlbStruct.GetParent(pEntry));
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				return pToken;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return NULL;
//STRIP001 }

//STRIP001 IMPL_LINK( ScStructPage, SelectHdl, SvTreeListBox*, pTlb )
//STRIP001 {
//STRIP001 	if(aTlbStruct.GetActiveFlag())
//STRIP001 	{
//STRIP001 		if(pTlb==&aTlbStruct)
//STRIP001 		{
//STRIP001 			SvLBoxEntry*	pCurEntry=aTlbStruct.GetCurEntry();
//STRIP001 			if(pCurEntry!=NULL)
//STRIP001 			{
//STRIP001 				pSelectedToken=(ScToken *)pCurEntry->GetUserData();
//STRIP001 				if(pSelectedToken!=NULL)
//STRIP001 				{
//STRIP001 					OpCode eOp = pSelectedToken->GetOpCode();
//STRIP001 					if(!(pSelectedToken->IsFunction()|| ocArcTan2<=eOp))
//STRIP001 					{
//STRIP001 						pSelectedToken=GetFunctionEntry(pCurEntry);
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		aSelLink.Call(this);
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

//STRIP001 ScToken * ScStructPage::GetSelectedToken()
//STRIP001 {
//STRIP001 	return pSelectedToken;
//STRIP001 }

//STRIP001 String ScStructPage::GetSelectedEntryText()
//STRIP001 {
//STRIP001 	return aTlbStruct.GetEntryText(aTlbStruct.GetCurEntry());
//STRIP001 }



}
