/*************************************************************************
 *
 *  $RCSfile: undostyl.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:06:08 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SC_UNDOSTYL_HXX
#define SC_UNDOSTYL_HXX

#ifndef _RSCSFX_HXX 
#include <rsc/rscsfx.hxx>
#endif

// auto strip #ifndef SC_UNDOBASE_HXX
// auto strip #include "undobase.hxx"
// auto strip #endif
namespace binfilter {

//STRIP001 class ScDocShell;
//STRIP001 class SfxStyleSheetBase;

//----------------------------------------------------------------------------

//STRIP001 class ScStyleSaveData
//STRIP001 {
//STRIP001 private:
//STRIP001 	String			aName;
//STRIP001 	String			aParent;
//STRIP001 	SfxItemSet*		pItems;
//STRIP001 
//STRIP001 public:
//STRIP001 						ScStyleSaveData();
//STRIP001 						ScStyleSaveData( const ScStyleSaveData& rOther );
//STRIP001 						~ScStyleSaveData();
//STRIP001 	ScStyleSaveData&	operator=( const ScStyleSaveData& rOther );
//STRIP001 
//STRIP001 	void				InitFromStyle( const SfxStyleSheetBase* pSource );
//STRIP001 
//STRIP001 	const String&		GetName() const		{ return aName; }
//STRIP001 	const String&		GetParent() const	{ return aParent; }
//STRIP001 	const SfxItemSet*	GetItems() const	{ return pItems; }
//STRIP001 };

//STRIP001 class ScUndoModifyStyle: public ScSimpleUndo
//STRIP001 {
//STRIP001 private:
//STRIP001 	SfxStyleFamily	eFamily;
//STRIP001 	ScStyleSaveData	aOldData;
//STRIP001 	ScStyleSaveData	aNewData;
//STRIP001 
//STRIP001 	static void		DoChange( ScDocShell* pDocSh, 
//STRIP001 								const String& rName, SfxStyleFamily eStyleFamily,
//STRIP001 								const ScStyleSaveData& rData );
//STRIP001 
//STRIP001 public:
//STRIP001 					TYPEINFO();
//STRIP001 					ScUndoModifyStyle( ScDocShell* pDocSh,
//STRIP001 										SfxStyleFamily eFam,
//STRIP001 										const ScStyleSaveData& rOld,
//STRIP001 										const ScStyleSaveData& rNew );
//STRIP001 	virtual 		~ScUndoModifyStyle();
//STRIP001 
//STRIP001 	virtual void	Undo();
//STRIP001 	virtual void	Redo();
//STRIP001 	virtual void	Repeat(SfxRepeatTarget& rTarget);
//STRIP001 	virtual BOOL	CanRepeat(SfxRepeatTarget& rTarget) const;
//STRIP001 
//STRIP001 	virtual String	GetComment() const;
//STRIP001 };

//STRIP001 class ScUndoApplyPageStyle: public ScSimpleUndo
//STRIP001 {
//STRIP001 private:
//STRIP001 	USHORT			nTab;
//STRIP001 	String			aOldStyle;
//STRIP001 	String			aNewStyle;
//STRIP001 
//STRIP001 public:
//STRIP001 					TYPEINFO();
//STRIP001 					ScUndoApplyPageStyle( ScDocShell* pDocSh, USHORT nT,
//STRIP001 										const String& rOld, const String& rNew );
//STRIP001 	virtual 		~ScUndoApplyPageStyle();
//STRIP001 
//STRIP001 	virtual void	Undo();
//STRIP001 	virtual void	Redo();
//STRIP001 	virtual void	Repeat(SfxRepeatTarget& rTarget);
//STRIP001 	virtual BOOL	CanRepeat(SfxRepeatTarget& rTarget) const;
//STRIP001 
//STRIP001 	virtual String	GetComment() const;
//STRIP001 };


} //namespace binfilter
#endif

