/*************************************************************************
 *
 *  $RCSfile: tpscaley.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:13:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SCH_TPSCALEY_HXX_
#define _SCH_TPSCALEY_HXX_

// header for SfxTabPage
// auto strip #ifndef _SFXTABDLG_HXX
// auto strip #include <bf_sfx2/tabdlg.hxx>
// auto strip #endif
// header for FixedText
// auto strip #ifndef _SV_FIXED_HXX
// auto strip #include <vcl/fixed.hxx>
// auto strip #endif
// header for Edit
// auto strip #ifndef _SV_EDIT_HXX
// auto strip #include <vcl/edit.hxx>
// auto strip #endif
// header for CheckBox
// auto strip #ifndef _SV_BUTTON_HXX
// auto strip #include <vcl/button.hxx>
// auto strip #endif
// header for MetricField
// auto strip #ifndef _SV_FIELD_HXX
// auto strip #include <vcl/field.hxx>
// auto strip #endif
// header for class FormattedField
// auto strip #ifndef _FMTFIELD_HXX_
// auto strip #include <svtools/fmtfield.hxx>
// auto strip #endif
class SvNumberFormatter;
namespace binfilter {

class ChartModel;

//STRIP001 class SchScaleYAxisTabPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	ChartModel          *pMyModel;
//STRIP001 
//STRIP001 	FixedLine			aFlScale;
//STRIP001 	FixedText			aTxtMin;
//STRIP001 	FormattedField		aFmtFldMin;
//STRIP001 	CheckBox			aCbxAutoMin;
//STRIP001 	FixedText			aTxtMax;
//STRIP001 	FormattedField		aFmtFldMax;
//STRIP001 	CheckBox			aCbxAutoMax;
//STRIP001 	FixedText           aTxtMain;
//STRIP001 	FormattedField		aFmtFldStepMain;
//STRIP001 	CheckBox			aCbxAutoStepMain;
//STRIP001 	FixedText           aTxtHelp;
//STRIP001 	FormattedField		aFmtFldStepHelp;
//STRIP001 	MetricField         aMtStepHelp;
//STRIP001 	CheckBox			aCbxAutoStepHelp;
//STRIP001 	FixedText           aTxtOrigin;
//STRIP001 	FormattedField		aFmtFldOrigin;
//STRIP001 	CheckBox			aCbxAutoOrigin;
//STRIP001 	CheckBox			aCbxLogarithm;
//STRIP001 
//STRIP001 	FixedLine aFlTicks;
//STRIP001 	CheckBox aCbxTicksInner;
//STRIP001 	CheckBox aCbxTicksOuter;
//STRIP001 
//STRIP001 	FixedLine aFlHelpTicks;
//STRIP001 	CheckBox aCbxHelpTicksInner;
//STRIP001 	CheckBox aCbxHelpTicksOuter;
//STRIP001 
//STRIP001 	double				fMin;
//STRIP001 	double				fMax;
//STRIP001 	double				fStepMain;
//STRIP001 	double				fStepHelp;
//STRIP001 	double				fOrigin;
//STRIP001 	int                 nAxisType;
//STRIP001 	const SfxItemSet&	rOutAttrs;
//STRIP001 	SvNumberFormatter*	pNumFormatter;
//STRIP001 
//STRIP001 	BOOL				bLastStepMain;
//STRIP001 
//STRIP001 	void CheckLogs ();
//STRIP001 	void CheckLogControls ();
//STRIP001 
//STRIP001 	BOOL GetHelpValue ();
//STRIP001 
//STRIP001 	DECL_LINK( EnableValueHdl, CheckBox* );
//STRIP001 	DECL_LINK( HandleLogs, CheckBox * );
//STRIP001 
//STRIP001 public:
//STRIP001 	SchScaleYAxisTabPage( Window* pParent, const SfxItemSet& rInAttrs );
//STRIP001 
//STRIP001 	static SfxTabPage* Create( Window* pParent, const SfxItemSet& rInAttrs );
//STRIP001 	virtual BOOL FillItemSet( SfxItemSet& rOutAttrs );
//STRIP001 	virtual void Reset( const SfxItemSet& rInAttrs );
//STRIP001 	virtual int DeactivatePage( SfxItemSet* pItemSet = NULL );
//STRIP001 
//STRIP001 	void SetNumFormatter( SvNumberFormatter* pFormatter );
//STRIP001 	void SetNumFormat();
//STRIP001 
//STRIP001 	void SetModel( ChartModel *pModel )						{ pMyModel = pModel; }
//STRIP001 };

} //namespace binfilter
#endif // _SCH_TPSCALEY_HXX_

