/*************************************************************************
 *
 *  $RCSfile: sch_guiutil.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:25:21 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #include "guiutil.hxx"
// auto strip #ifndef _CHTMODEL_HXX
// auto strip #include "chtmodel.hxx"
// auto strip #endif
// auto strip #include "objid.hxx"
// auto strip #include "schresid.hxx"
#include "strings.hrc"
#include "glob.hrc"
namespace binfilter {

//*************************************************************************
//*************************************************************************

//STRIP001 USHORT GuiUtilities::GetObjectNameResId(UINT16 nObjId, ChartModel& rDoc)
//STRIP001 {
//STRIP001 	USHORT nResId;
//STRIP001 	switch (nObjId)
//STRIP001 	{
//STRIP001 		case CHOBJID_DIAGRAM_AREA:
//STRIP001 			nResId = STR_DIAGRAM_AREA;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_TITLE_MAIN:
//STRIP001 			nResId = STR_TITLE_MAIN;
//STRIP001 			break;;
//STRIP001 
//STRIP001 		case CHOBJID_TITLE_SUB:
//STRIP001 			nResId = STR_TITLE_SUB;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM:
//STRIP001 			nResId = STR_DIAGRAM;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_WALL:
//STRIP001 			nResId = STR_DIAGRAM_WALL;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_FLOOR:
//STRIP001 			nResId = STR_DIAGRAM_FLOOR;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_TITLE_X_AXIS:
//STRIP001 			nResId = STR_DIAGRAM_TITLE_X_AXIS;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_TITLE_Y_AXIS:
//STRIP001 			nResId = STR_DIAGRAM_TITLE_Y_AXIS;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_TITLE_Z_AXIS:
//STRIP001 			nResId = STR_DIAGRAM_TITLE_Z_AXIS;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_A_AXIS:
//STRIP001 		case CHOBJID_DIAGRAM_X_AXIS:
//STRIP001 			nResId = STR_DIAGRAM_X_AXIS;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_B_AXIS:
//STRIP001 		case CHOBJID_DIAGRAM_Y_AXIS:
//STRIP001 			nResId = STR_DIAGRAM_Y_AXIS;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_C_AXIS:
//STRIP001 		case CHOBJID_DIAGRAM_Z_AXIS:
//STRIP001 			nResId = STR_DIAGRAM_Z_AXIS;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_X_GRID_MAIN:
//STRIP001 		case CHOBJID_DIAGRAM_X_GRID_MAIN_GROUP:
//STRIP001 			nResId = STR_DIAGRAM_X_GRID_MAIN;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_Y_GRID_MAIN:
//STRIP001         case CHOBJID_DIAGRAM_Y_GRID_MAIN_GROUP:
//STRIP001 			nResId = STR_DIAGRAM_Y_GRID_MAIN;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_Z_GRID_MAIN:
//STRIP001         case CHOBJID_DIAGRAM_Z_GRID_MAIN_GROUP:
//STRIP001 			nResId = STR_DIAGRAM_Z_GRID_MAIN;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_X_GRID_HELP:
//STRIP001         case CHOBJID_DIAGRAM_X_GRID_HELP_GROUP:
//STRIP001 			nResId = STR_DIAGRAM_X_GRID_HELP;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_Y_GRID_HELP:
//STRIP001         case CHOBJID_DIAGRAM_Y_GRID_HELP_GROUP:
//STRIP001 			nResId = STR_DIAGRAM_Y_GRID_HELP;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_Z_GRID_HELP:
//STRIP001         case CHOBJID_DIAGRAM_Z_GRID_HELP_GROUP:
//STRIP001 			nResId = STR_DIAGRAM_Z_GRID_HELP;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_ROWGROUP:
//STRIP001 		case CHOBJID_DIAGRAM_ROWS:
//STRIP001 		case CHOBJID_DIAGRAM_ROWSLINE:
//STRIP001 		case CHOBJID_DIAGRAM_SPECIAL_GROUP:
//STRIP001 		case CHOBJID_DIAGRAM_STACKEDGROUP:
//STRIP001 			nResId = STR_DIAGRAM_ROW;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_DATA:
//STRIP001 			nResId    = STR_STATUS_DATAPOINT_MARKED;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_DESCRGROUP:
//STRIP001 			nResId = STR_DIAGRAM_DESCRGROUP;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_DESCR_ROW:
//STRIP001 			nResId = STR_DIAGRAM_DESCR_ROW;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_DIAGRAM_DESCR_COL:
//STRIP001 			nResId = STR_DIAGRAM_DESCR_COL;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_LEGEND:
//STRIP001 			nResId = STR_LEGEND;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_LEGEND_SYMBOL_ROW:
//STRIP001 			nResId = STR_LEGEND_SYMBOL_ROW;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case CHOBJID_LEGEND_SYMBOL_COL:
//STRIP001 			nResId = STR_LEGEND_SYMBOL_COL;
//STRIP001 			break;
//STRIP001 
//STRIP001 		default:
//STRIP001 			nResId = 0;
//STRIP001 			break;
//STRIP001 	}
//STRIP001 	return nResId;
//STRIP001 }
} //namespace binfilter
