/*************************************************************************
 *
 *  $RCSfile: sd_sdpptwrp.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:30:46 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #include <bf_sfx2/docfile.hxx>
// auto strip #include <bf_sfx2/docfilt.hxx>
// auto strip #include <vos/module.hxx>
// auto strip #include <bf_sfx2/interno.hxx>
// auto strip #include <bf_svx/msoleexp.hxx>
#include <bf_svx/svxmsbas.hxx>
// auto strip #include <bf_offmgr/app.hxx>
// auto strip #include <bf_offmgr/fltrcfg.hxx>

#include "sdpptwrp.hxx"
// auto strip #include "pptin.hxx"
// auto strip #include "drawdoc.hxx"
namespace binfilter {

// --------------
// - Namespaces -
// --------------

using namespace ::com::sun::star::uno;
using namespace ::com::sun::star::task;
using namespace ::com::sun::star::frame;


//STRIP001 typedef BOOL ( __LOADONCALLAPI *ExportPPT )( SvStorageRef&,
//STRIP001 											 Reference< XModel > &,
//STRIP001 											 Reference< XStatusIndicator > &,
//STRIP001 											 SvMemoryStream*, sal_uInt32 nCnvrtFlags );

// ---------------
// - SdPPTFilter -
// ---------------

//STRIP001 SdPPTFilter::SdPPTFilter( SfxMedium& rMedium, SdDrawDocShell& rDocShell, sal_Bool bShowProgress ) :
//STRIP001 	SdFilter( rMedium, rDocShell, bShowProgress ),
//STRIP001 	pBas	( NULL )
//STRIP001 {
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 SdPPTFilter::~SdPPTFilter()
//STRIP001 {
//STRIP001 	delete pBas;	// deleting the compressed basic storage
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 sal_Bool SdPPTFilter::Import()
//STRIP001 {
//STRIP001 	sal_Bool	bRet = sal_False;
//STRIP001 	SvStorage*	pStorage;
//STRIP001 
//STRIP001 	if( ( pStorage = mrMedium.GetStorage() ) != NULL )
//STRIP001 	{
//STRIP001 		/* check if there is a dualstorage, then the
//STRIP001 		document is propably a PPT95 containing PPT97 */
//STRIP001 		SvStorageRef xDualStorage;
//STRIP001 		String sDualStorage( RTL_CONSTASCII_USTRINGPARAM( "PP97_DUALSTORAGE" ) );
//STRIP001 		if ( pStorage->IsContained( sDualStorage ) )
//STRIP001 		{
//STRIP001 			xDualStorage = pStorage->OpenStorage( sDualStorage, STREAM_STD_READ );
//STRIP001 			pStorage = xDualStorage;
//STRIP001 		}
//STRIP001 		SvStream* pDocStream = pStorage->OpenStream( String( RTL_CONSTASCII_USTRINGPARAM("PowerPoint Document") ), STREAM_STD_READ );
//STRIP001 		if( pDocStream )
//STRIP001 		{
//STRIP001 			pDocStream->SetVersion( pStorage->GetVersion() );
//STRIP001 			pDocStream->SetKey( pStorage->GetKey() );
//STRIP001 
//STRIP001 			SdPPTImport* pImport = new SdPPTImport( &mrDocument, *pDocStream, *pStorage, mrMedium );
//STRIP001 
//STRIP001 			if ( !( bRet = pImport->Import() ) )
//STRIP001 				mrMedium.SetError( SVSTREAM_WRONGVERSION );
//STRIP001 
//STRIP001 			delete pImport;
//STRIP001 			delete pDocStream;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return bRet;
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 sal_Bool SdPPTFilter::Export()
//STRIP001 {
//STRIP001 	::vos::OModule* pLibrary = OpenLibrary( mrMedium.GetFilter()->GetUserData() );
//STRIP001 	sal_Bool		bRet = sal_False;
//STRIP001 
//STRIP001 	if( pLibrary )
//STRIP001 	{
//STRIP001 		if( mxModel.is() )
//STRIP001 		{
//STRIP001 			SvStorageRef	xStorRef;
//STRIP001 			ExportPPT		PPTExport = ( ExportPPT ) pLibrary->getSymbol( ::rtl::OUString::createFromAscii("ExportPPT") );
//STRIP001 
//STRIP001 			/* !!!
//STRIP001 			if ( pViewShell && pViewShell->GetView() )
//STRIP001 				pViewShell->GetView()->EndTextEdit();
//STRIP001 			*/
//STRIP001 			if( PPTExport && ( xStorRef = mrMedium.GetOutputStorage() ).Is() )
//STRIP001 			{
//STRIP001 				sal_uInt32			nCnvrtFlags = 0;
//STRIP001 				OfficeApplication*	pApplication = OFF_APP();
//STRIP001 
//STRIP001 				if( pApplication )
//STRIP001 				{
//STRIP001 					OfaFilterOptions* pFilterOptions = pApplication->GetFilterOptions();
//STRIP001 					if ( pFilterOptions )
//STRIP001 					{
//STRIP001 						if ( pFilterOptions->IsMath2MathType() )
//STRIP001 							nCnvrtFlags |= OLE_STARMATH_2_MATHTYPE;
//STRIP001 						if ( pFilterOptions->IsWriter2WinWord() )
//STRIP001 							nCnvrtFlags |= OLE_STARWRITER_2_WINWORD;
//STRIP001 						if ( pFilterOptions->IsCalc2Excel() )
//STRIP001 							nCnvrtFlags |= OLE_STARCALC_2_EXCEL;
//STRIP001 						if ( pFilterOptions->IsImpress2PowerPoint() )
//STRIP001 							nCnvrtFlags |= OLE_STARIMPRESS_2_POWERPOINT;
//STRIP001 					}
//STRIP001 				}
//STRIP001 				mrDocument.SetSwapGraphicsMode( SDR_SWAPGRAPHICSMODE_TEMP );
//STRIP001 
//STRIP001 				if( mbShowProgress )
//STRIP001 					CreateStatusIndicator();
//STRIP001 
//STRIP001 				bRet = PPTExport( xStorRef, mxModel, mxStatusIndicator, pBas, nCnvrtFlags );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		delete pLibrary;
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }

//STRIP001 void SdPPTFilter::PreSaveBasic()
//STRIP001 {
//STRIP001 	OfficeApplication*	pApplication = OFF_APP();
//STRIP001 	if( pApplication )
//STRIP001 	{
//STRIP001 		OfaFilterOptions* pFilterOptions = pApplication->GetFilterOptions();
//STRIP001 		if( pFilterOptions && pFilterOptions->IsLoadPPointBasicStorage() )
//STRIP001 		{	
//STRIP001 			SvStorageRef xDest( new SvStorage( new SvMemoryStream(), TRUE ) );
//STRIP001 			SvxImportMSVBasic aMSVBas( (SfxObjectShell&) mrDocShell, *xDest, FALSE, FALSE );
//STRIP001 			aMSVBas.SaveOrDelMSVBAStorage( TRUE, String( RTL_CONSTASCII_USTRINGPARAM("_MS_VBA_Overhead") ) );
//STRIP001 
//STRIP001 			SvStorageRef xOverhead = xDest->OpenStorage( String( RTL_CONSTASCII_USTRINGPARAM("_MS_VBA_Overhead") ) );
//STRIP001 			if ( xOverhead.Is() && ( xOverhead->GetError() == SVSTREAM_OK ) )
//STRIP001 			{
//STRIP001 				SvStorageRef xOverhead2 = xOverhead->OpenStorage( String( RTL_CONSTASCII_USTRINGPARAM("_MS_VBA_Overhead") ) );
//STRIP001 				if ( xOverhead2.Is() && ( xOverhead2->GetError() == SVSTREAM_OK ) )
//STRIP001 				{
//STRIP001 					SvStorageStreamRef xTemp = xOverhead2->OpenStream( String( RTL_CONSTASCII_USTRINGPARAM("_MS_VBA_Overhead2") ) );
//STRIP001 					if ( xTemp.Is() && ( xTemp->GetError() == SVSTREAM_OK ) )
//STRIP001 					{
//STRIP001 						UINT32 nLen = xTemp->GetSize();
//STRIP001 						if ( nLen )
//STRIP001 						{
//STRIP001 							char* pTemp = new char[ nLen ];
//STRIP001 							if ( pTemp )
//STRIP001 							{
//STRIP001 								xTemp->Seek( STREAM_SEEK_TO_BEGIN );
//STRIP001 								xTemp->Read( pTemp, nLen );
//STRIP001 								pBas = new SvMemoryStream( pTemp, nLen, STREAM_READ );
//STRIP001 								pBas->ObjectOwnsMemory( TRUE );
//STRIP001 							}
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 }
}
