/*************************************************************************
 *
 *  $RCSfile: sd_inspagob.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:39:11 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #include "inspagob.hxx"

#include "strings.hrc"
#include "res_bmp.hrc"
// auto strip #include "sdresid.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "docshell.hxx"
// auto strip #include "viewshel.hxx"
#include "inspagob.hrc"
namespace binfilter {


/*************************************************************************
|*
|*	Ctor
|*
\************************************************************************/

//STRIP001 SdInsertPagesObjsDlg::SdInsertPagesObjsDlg( Window* pWindow,
//STRIP001 											const SdDrawDocument* pInDoc,
//STRIP001 											SfxMedium* pSfxMedium,
//STRIP001 											const String& rFileName ) :
//STRIP001 			ModalDialog     ( pWindow, SdResId( DLG_INSERT_PAGES_OBJS ) ),
//STRIP001 		aLbTree         ( this, SdResId( LB_TREE ) ),
//STRIP001 		aBtnOk          ( this, SdResId( BTN_OK ) ),
//STRIP001 		aBtnCancel      ( this, SdResId( BTN_CANCEL ) ),
//STRIP001 		aBtnHelp        ( this, SdResId( BTN_HELP ) ),
//STRIP001 		aCbxLink        ( this, SdResId( CBX_LINK ) ),
//STRIP001 		aCbxMasters     ( this, SdResId( CBX_CHECK_MASTERS ) ),
//STRIP001 		pDoc			( pInDoc ),
//STRIP001 		pMedium 		( pSfxMedium ),
//STRIP001 		rName			( rFileName )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	aLbTree.SetViewFrame( ( (SdDrawDocument*) pInDoc )->GetDocSh()->GetViewShell()->GetViewFrame() );
//STRIP001 
//STRIP001 	aLbTree.SetSelectHdl( LINK( this, SdInsertPagesObjsDlg, SelectObjectHdl ) );
//STRIP001 
//STRIP001 	// Text wird eingefuegt
//STRIP001 	if( !pMedium )
//STRIP001 		SetText( String( SdResId( STR_INSERT_TEXT ) ) );
//STRIP001 
//STRIP001 	Reset();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	Dtor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdInsertPagesObjsDlg::~SdInsertPagesObjsDlg()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	Fuellt die TreeLB in Abhaengigkeit des Mediums. Ist kein Medium
//STRIP001 |*	vorhanden, handelt es sich um ein Text- und kein Drawdokument
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdInsertPagesObjsDlg::Reset()
//STRIP001 {
//STRIP001 	if( pMedium )
//STRIP001 	{
//STRIP001 		aLbTree.SetSelectionMode( MULTIPLE_SELECTION );
//STRIP001 		aLbTree.Fill( pDoc, pMedium, rName );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		Color aColor( COL_WHITE );
//STRIP001 		Bitmap aBmpText( SdResId( BMP_DOC_TEXT ) );
//STRIP001 		Image aImgText( aBmpText, aColor );
//STRIP001 		Bitmap aBmpTextH( SdResId( BMP_DOC_TEXT_H ) );
//STRIP001 		Image aImgTextH( aBmpTextH, Color( COL_BLACK ) );
//STRIP001 		SvLBoxEntry* pEntry = aLbTree.InsertEntry( rName, aImgText, aImgText );
//STRIP001 		aLbTree.SetExpandedEntryBmp( pEntry, aImgTextH, BMP_COLOR_HIGHCONTRAST );
//STRIP001 		aLbTree.SetCollapsedEntryBmp( pEntry, aImgTextH, BMP_COLOR_HIGHCONTRAST );
//STRIP001 	}
//STRIP001 
//STRIP001 	aCbxMasters.Check( TRUE );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	Liefert die Liste zurueck
//STRIP001 |*	nType == 0 -> Seiten
//STRIP001 |*	nType == 1 -> Objekte
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 List* SdInsertPagesObjsDlg::GetList( USHORT nType )
//STRIP001 {
//STRIP001 	// Bei Draw-Dokumenten muss bei der Selektion des Dokumentes NULL
//STRIP001 	// zurueckgegeben werden
//STRIP001 	if( pMedium )
//STRIP001 	{
//STRIP001 		// Um zu gewaehrleisten, dass die Bookmarks geoeffnet sind
//STRIP001 		// (Wenn gesamtes Dokument ausgewaehlt wurde)
//STRIP001 		aLbTree.GetBookmarkDoc();
//STRIP001 
//STRIP001 		// Wenn das Dokument (mit-)selektiert oder nichst selektiert ist,
//STRIP001 		// wird das gesamte Dokument (und nicht mehr!) eingefuegt.
//STRIP001 		if( aLbTree.GetSelectionCount() == 0 ||
//STRIP001 			( aLbTree.IsSelected( aLbTree.First() ) ) )
//STRIP001 			//return( aLbTree.GetBookmarkList( nType ) );
//STRIP001 			return( NULL ); // #37350#
//STRIP001 	}
//STRIP001 	return( aLbTree.GetSelectEntryList( nType ) );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	Ist Verknuepfung gechecked
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL SdInsertPagesObjsDlg::IsLink()
//STRIP001 {
//STRIP001 	return( aCbxLink.IsChecked() );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	Ist Verknuepfung gechecked
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL SdInsertPagesObjsDlg::IsRemoveUnnessesaryMasterPages() const
//STRIP001 {
//STRIP001 	return( aCbxMasters.IsChecked() );
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Enabled und selektiert Endfarben-LB
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK( SdInsertPagesObjsDlg, SelectObjectHdl, void *, p )
//STRIP001 {
//STRIP001 	if( aLbTree.IsLinkableSelected() )
//STRIP001 		aCbxLink.Enable();
//STRIP001 	else
//STRIP001 		aCbxLink.Disable();
//STRIP001 
//STRIP001 	return( 0 );
//STRIP001 }


}
