/*************************************************************************
 *
 *  $RCSfile: sd_unchss.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:43:12 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #ifndef _SFXITEMSET_HXX //autogen
// auto strip #include <svtools/itemset.hxx>
// auto strip #endif
// auto strip #ifndef _SFXSTYLE_HXX //autogen
// auto strip #include <svtools/style.hxx>
// auto strip #endif
// auto strip #ifndef _SFXSMPLHINT_HXX //autogen
// auto strip #include <svtools/smplhint.hxx>
// auto strip #endif
#ifndef _SVDOBJ_HXX 
#include <bf_svx/svdobj.hxx>
#endif

// auto strip #include "unchss.hxx"

#include "strings.hrc"
// auto strip #include "glob.hxx"
// auto strip #include "sdresid.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "stlsheet.hxx"
namespace binfilter {



//STRIP001 TYPEINIT1(StyleSheetUndoAction, SdUndoAction);
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 StyleSheetUndoAction::StyleSheetUndoAction(SdDrawDocument* pTheDoc,
//STRIP001 										   SfxStyleSheet* pTheStyleSheet,
//STRIP001 										   const SfxItemSet* pTheNewItemSet) :
//STRIP001 					  SdUndoAction(pTheDoc)
//STRIP001 {
//STRIP001 	DBG_ASSERT(pTheStyleSheet, "Undo ohne StyleSheet ???");
//STRIP001 	pStyleSheet = pTheStyleSheet;
//STRIP001 
//STRIP001 	// ItemSets anlegen; Vorsicht, das neue koennte aus einem anderen Pool
//STRIP001 	// stammen, also mitsamt seinen Items clonen
//STRIP001 	pNewSet = new SfxItemSet(*(SfxItemPool*)SdrObject::GetGlobalDrawObjectItemPool(), pTheNewItemSet->GetRanges());
//STRIP001 	pTheDoc->MigrateItemSet( pTheNewItemSet, pNewSet, pTheDoc );
//STRIP001 
//STRIP001 	pOldSet = new SfxItemSet(*(SfxItemPool*)SdrObject::GetGlobalDrawObjectItemPool(),pStyleSheet->GetItemSet().GetRanges());
//STRIP001 	pTheDoc->MigrateItemSet( &pStyleSheet->GetItemSet(), pOldSet, pTheDoc );
//STRIP001 
//STRIP001 	aComment = String(SdResId(STR_UNDO_CHANGE_PRES_OBJECT));
//STRIP001 	String aName(pStyleSheet->GetName());
//STRIP001 
//STRIP001 	// Layoutnamen und Separator loeschen
//STRIP001 	String aSep( RTL_CONSTASCII_USTRINGPARAM( SD_LT_SEPARATOR ) );
//STRIP001 	USHORT nPos = aName.Search(aSep);
//STRIP001 	if( nPos != STRING_NOTFOUND )
//STRIP001 		aName.Erase(0, nPos + aSep.Len());
//STRIP001 
//STRIP001 	// Platzhalter durch Vorlagennamen ersetzen
//STRIP001 	nPos = aComment.Search(sal_Unicode('$'));
//STRIP001 	aComment.Erase(nPos, 1);
//STRIP001 	aComment.Insert(aName, nPos);
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Undo()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void StyleSheetUndoAction::Undo()
//STRIP001 {
//STRIP001 	SfxItemSet aNewSet( pDoc->GetItemPool(), pOldSet->GetRanges() );
//STRIP001 	pDoc->MigrateItemSet( pOldSet, &aNewSet, pDoc );
//STRIP001 
//STRIP001 	pStyleSheet->GetItemSet().Set(aNewSet);
//STRIP001 	if( pStyleSheet->GetFamily() == SFX_STYLE_FAMILY_PSEUDO )
//STRIP001 		( (SdStyleSheet*)pStyleSheet )->GetRealStyleSheet()->Broadcast(SfxSimpleHint(SFX_HINT_DATACHANGED));
//STRIP001 	else
//STRIP001 		pStyleSheet->Broadcast(SfxSimpleHint(SFX_HINT_DATACHANGED));
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Redo()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void StyleSheetUndoAction::Redo()
//STRIP001 {
//STRIP001 	SfxItemSet aNewSet( pDoc->GetItemPool(), pOldSet->GetRanges() );
//STRIP001 	pDoc->MigrateItemSet( pNewSet, &aNewSet, pDoc );
//STRIP001 
//STRIP001 	pStyleSheet->GetItemSet().Set(aNewSet);
//STRIP001 	if( pStyleSheet->GetFamily() == SFX_STYLE_FAMILY_PSEUDO )
//STRIP001 		( (SdStyleSheet*)pStyleSheet )->GetRealStyleSheet()->Broadcast(SfxSimpleHint(SFX_HINT_DATACHANGED));
//STRIP001 	else
//STRIP001 		pStyleSheet->Broadcast(SfxSimpleHint(SFX_HINT_DATACHANGED));
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Repeat()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void StyleSheetUndoAction::Repeat()
//STRIP001 {
//STRIP001 	DBG_ASSERT(FALSE, "StyleSheetUndoAction::Repeat: nicht implementiert");
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 StyleSheetUndoAction::~StyleSheetUndoAction()
//STRIP001 {
//STRIP001 	delete pNewSet;
//STRIP001 	delete pOldSet;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Kommentar liefern
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 String StyleSheetUndoAction::GetComment() const
//STRIP001 {
//STRIP001 	return aComment;
//STRIP001 }






}
