/*************************************************************************
 *
 *  $RCSfile: sd_fuconarc.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:46:36 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


// auto strip #ifndef _SVDPAGV_HXX //autogen
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOCIRC_HXX //autogen
// auto strip #include <bf_svx/svdocirc.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
// auto strip #ifndef _SFXINTITEM_HXX //autogen
// auto strip #include <svtools/intitem.hxx>
// auto strip #endif
// auto strip #ifndef _AEITEM_HXX //autogen
// auto strip #include <svtools/aeitem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOBJ_HXX //autogen
// auto strip #include <bf_svx/svdobj.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif

#pragma hdrstop

#include <bf_svx/svxids.hrc>
#include <math.h>

#include "app.hrc"

// auto strip #include "viewshel.hxx"
#include "sdview.hxx"
// auto strip #include "sdwindow.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "fuconarc.hxx"
#include "res_bmp.hrc"

// #97016#
// auto strip #ifndef _SXCIAITM_HXX
// auto strip #include <bf_svx/sxciaitm.hxx>
// auto strip #endif
namespace binfilter {

//STRIP001 TYPEINIT1( FuConstArc, FuConstruct );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuConstArc::FuConstArc( SdViewShell*	pViewSh,
//STRIP001 						SdWindow*		pWin,
//STRIP001 						SdView* 		pView,
//STRIP001 						SdDrawDocument* pDoc,
//STRIP001 						SfxRequest& 	rReq )
//STRIP001 	: FuConstruct( pViewSh, pWin, pView, pDoc, rReq )
//STRIP001 {
//STRIP001 	pViewShell->SwitchObjectBar(RID_DRAW_OBJ_TOOLBOX);
//STRIP001 
//STRIP001 	const SfxItemSet *pArgs = rReq.GetArgs ();
//STRIP001 
//STRIP001 	if (pArgs)
//STRIP001 	{
//STRIP001 		SFX_REQUEST_ARG (rReq, pCenterX, SfxUInt32Item, ID_VAL_CENTER_X, FALSE);
//STRIP001 		SFX_REQUEST_ARG (rReq, pCenterY, SfxUInt32Item, ID_VAL_CENTER_Y, FALSE);
//STRIP001 		SFX_REQUEST_ARG (rReq, pAxisX, SfxUInt32Item, ID_VAL_AXIS_X, FALSE);
//STRIP001 		SFX_REQUEST_ARG (rReq, pAxisY, SfxUInt32Item, ID_VAL_AXIS_Y, FALSE);
//STRIP001 		SFX_REQUEST_ARG (rReq, pPhiStart, SfxUInt32Item, ID_VAL_ANGLESTART, FALSE);
//STRIP001 		SFX_REQUEST_ARG (rReq, pPhiEnd, SfxUInt32Item, ID_VAL_ANGLEEND, FALSE);
//STRIP001 
//STRIP001 		Rectangle	aNewRectangle (pCenterX->GetValue () - pAxisX->GetValue () / 2,
//STRIP001 								   pCenterY->GetValue () - pAxisY->GetValue () / 2,
//STRIP001 								   pCenterX->GetValue () + pAxisX->GetValue () / 2,
//STRIP001 								   pCenterY->GetValue () + pAxisY->GetValue () / 2);
//STRIP001 
//STRIP001 		Activate();  // Setzt aObjKind
//STRIP001 		SdrCircObj* pNewCircle =
//STRIP001 		new SdrCircObj((SdrObjKind) pView->GetCurrentObjIdentifier(),
//STRIP001 					   aNewRectangle,
//STRIP001 					   (long) (pPhiStart->GetValue () * 10.0),
//STRIP001 					   (long) (pPhiEnd->GetValue () * 10.0));
//STRIP001 		SdrPageView *pPV = pView->GetPageViewPvNum (0);
//STRIP001 
//STRIP001 		pView->InsertObject(pNewCircle, *pPV, SDRINSERT_SETDEFLAYER);
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuConstArc::~FuConstArc()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonDown-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuConstArc::MouseButtonDown( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	BOOL bReturn = FuConstruct::MouseButtonDown( rMEvt );
//STRIP001 
//STRIP001 	if ( rMEvt.IsLeft() && !pView->IsAction() )
//STRIP001 	{
//STRIP001 		Point aPnt( pWindow->PixelToLogic( rMEvt.GetPosPixel() ) );
//STRIP001 		pWindow->CaptureMouse();
//STRIP001 		USHORT nDrgLog = USHORT ( pWindow->PixelToLogic(Size(DRGPIX,0)).Width() );
//STRIP001 		pView->BegCreateObj(aPnt, (OutputDevice*) NULL, nDrgLog);
//STRIP001 
//STRIP001 		SdrObject* pObj = pView->GetCreateObj();
//STRIP001 
//STRIP001 		if (pObj)
//STRIP001 		{
//STRIP001 			SfxItemSet aAttr(pDoc->GetPool());
//STRIP001 			SetStyleSheet(aAttr, pObj);
//STRIP001 
//STRIP001 //-/			pObj->NbcSetAttributes(aAttr, FALSE);
//STRIP001 			pObj->SetItemSet(aAttr);
//STRIP001 		}
//STRIP001 
//STRIP001 		bReturn = TRUE;
//STRIP001 	}
//STRIP001 	return bReturn;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseMove-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuConstArc::MouseMove( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	return FuConstruct::MouseMove(rMEvt);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonUp-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuConstArc::MouseButtonUp( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 	BOOL bCreated = FALSE;
//STRIP001 
//STRIP001 	if ( pView->IsCreateObj() && rMEvt.IsLeft() )
//STRIP001 	{
//STRIP001 		Point aPnt( pWindow->PixelToLogic( rMEvt.GetPosPixel() ) );
//STRIP001 
//STRIP001 		ULONG nCount = pView->GetPageViewPvNum(0)->GetObjList()->GetObjCount();
//STRIP001 
//STRIP001 		if (pView->EndCreateObj(SDRCREATE_NEXTPOINT) )
//STRIP001 		{
//STRIP001 			if (nCount != pView->GetPageViewPvNum(0)->GetObjList()->GetObjCount())
//STRIP001 			{
//STRIP001 				bCreated = TRUE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		bReturn = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	bReturn = FuConstruct::MouseButtonUp (rMEvt) || bReturn;
//STRIP001 
//STRIP001 	if (!bPermanent && bCreated)
//STRIP001 		pViewShell->GetViewFrame()->GetDispatcher()->Execute(SID_OBJECT_SELECT, SFX_CALLMODE_ASYNCHRON);
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Tastaturereignisse bearbeiten
//STRIP001 |*
//STRIP001 |* Wird ein KeyEvent bearbeitet, so ist der Return-Wert TRUE, andernfalls
//STRIP001 |* FALSE.
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuConstArc::KeyInput(const KeyEvent& rKEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FuConstruct::KeyInput(rKEvt);
//STRIP001 	return(bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function aktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuConstArc::Activate()
//STRIP001 {
//STRIP001 	SdrObjKind aObjKind;
//STRIP001 
//STRIP001 	switch( nSlotId )
//STRIP001 	{
//STRIP001 		case SID_DRAW_ARC	   :
//STRIP001 		case SID_DRAW_CIRCLEARC:
//STRIP001 		{
//STRIP001 			aObjKind = OBJ_CARC;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAW_PIE			  :
//STRIP001 		case SID_DRAW_PIE_NOFILL	  :
//STRIP001 		case SID_DRAW_CIRCLEPIE 	  :
//STRIP001 		case SID_DRAW_CIRCLEPIE_NOFILL:
//STRIP001 		{
//STRIP001 			aObjKind = OBJ_SECT;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case SID_DRAW_ELLIPSECUT	   :
//STRIP001 		case SID_DRAW_ELLIPSECUT_NOFILL:
//STRIP001 		case SID_DRAW_CIRCLECUT 	   :
//STRIP001 		case SID_DRAW_CIRCLECUT_NOFILL :
//STRIP001 		{
//STRIP001 			aObjKind = OBJ_CCUT;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		default:
//STRIP001 		{
//STRIP001 			aObjKind = OBJ_CARC;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	pView->SetCurrentObj(aObjKind);
//STRIP001 
//STRIP001 	FuConstruct::Activate();
//STRIP001 //	FuDraw::Activate();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function deaktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuConstArc::Deactivate()
//STRIP001 {
//STRIP001 	FuConstruct::Deactivate();
//STRIP001 //	FuDraw::Deactivate();
//STRIP001 }
//STRIP001 
//STRIP001 // #97016#
//STRIP001 SdrObject* FuConstArc::CreateDefaultObject(const sal_uInt16 nID, const Rectangle& rRectangle)
//STRIP001 {
//STRIP001 	// case SID_DRAW_ARC:
//STRIP001 	// case SID_DRAW_CIRCLEARC:
//STRIP001 	// case SID_DRAW_PIE:
//STRIP001 	// case SID_DRAW_PIE_NOFILL:
//STRIP001 	// case SID_DRAW_CIRCLEPIE:
//STRIP001 	// case SID_DRAW_CIRCLEPIE_NOFILL:
//STRIP001 	// case SID_DRAW_ELLIPSECUT:
//STRIP001 	// case SID_DRAW_ELLIPSECUT_NOFILL:
//STRIP001 	// case SID_DRAW_CIRCLECUT:
//STRIP001 	// case SID_DRAW_CIRCLECUT_NOFILL:
//STRIP001 
//STRIP001 	SdrObject* pObj = SdrObjFactory::MakeNewObject(
//STRIP001 		pView->GetCurrentObjInventor(), pView->GetCurrentObjIdentifier(),
//STRIP001 		0L, pDoc);
//STRIP001 
//STRIP001 	if(pObj)
//STRIP001 	{
//STRIP001 		if(pObj->ISA(SdrCircObj))
//STRIP001 		{
//STRIP001 			Rectangle aRect(rRectangle);
//STRIP001 
//STRIP001 			if(SID_DRAW_ARC == nID ||
//STRIP001 				SID_DRAW_CIRCLEARC == nID ||
//STRIP001 				SID_DRAW_CIRCLEPIE == nID ||
//STRIP001 				SID_DRAW_CIRCLEPIE_NOFILL == nID ||
//STRIP001 				SID_DRAW_CIRCLECUT == nID ||
//STRIP001 				SID_DRAW_CIRCLECUT_NOFILL == nID)
//STRIP001 			{
//STRIP001 				// force quadratic
//STRIP001 				ImpForceQuadratic(aRect);
//STRIP001 			}
//STRIP001 
//STRIP001 			pObj->SetLogicRect(aRect);
//STRIP001 
//STRIP001 			SfxItemSet aAttr(pDoc->GetPool());
//STRIP001 			aAttr.Put(SdrCircStartAngleItem(9000));
//STRIP001 			aAttr.Put(SdrCircEndAngleItem(0));
//STRIP001 
//STRIP001 			if(SID_DRAW_PIE_NOFILL == nID ||
//STRIP001 				SID_DRAW_CIRCLEPIE_NOFILL == nID ||
//STRIP001 				SID_DRAW_ELLIPSECUT_NOFILL == nID ||
//STRIP001 				SID_DRAW_CIRCLECUT_NOFILL == nID)
//STRIP001 			{
//STRIP001 				aAttr.Put(XFillStyleItem(XFILL_NONE));
//STRIP001 			}
//STRIP001 
//STRIP001 			pObj->SetItemSet(aAttr);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			DBG_ERROR("Object is NO circle object");
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return pObj;
//STRIP001 }

}
