/*************************************************************************
 *
 *  $RCSfile: sd_fuexpand.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:48:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #ifndef _SVDOTEXT_HXX //autogen
// auto strip #include <bf_svx/svdotext.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XLINEIT0_HXX //autogen
// auto strip #include <bf_svx/xlineit0.hxx>
// auto strip #endif
// auto strip #ifndef _SVDUNDO_HXX //autogen
// auto strip #include <bf_svx/svdundo.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_PRINTER_HXX //autogen
// auto strip #include <bf_sfx2/printer.hxx>
// auto strip #endif

// auto strip #ifndef _OUTLOBJ_HXX
// auto strip #include <bf_svx/outlobj.hxx>
// auto strip #endif
// auto strip #ifndef _SVDETC_HXX
// auto strip #include <bf_svx/svdetc.hxx>
// auto strip #endif

#include "app.hrc"
#include "strings.hrc"
// auto strip #include "fuexpand.hxx"
// auto strip #include "pres.hxx"
// auto strip #include "sdview.hxx"
// auto strip #include "sdpage.hxx"
// auto strip #include "sdoutl.hxx"
// auto strip #include "drawview.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "viewshel.hxx"
// auto strip #include "docshell.hxx"
// auto strip #include "sdresid.hxx"
// auto strip #include "optsitem.hxx"
// auto strip #include "sdmod.hxx"

// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _EEITEM_HXX //autogen
// auto strip #include <bf_svx/eeitem.hxx>
// auto strip #endif
namespace binfilter {

//STRIP001 TYPEINIT1( FuExpandPage, FuPoor );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuExpandPage::FuExpandPage(SdViewShell* pViewSh, SdWindow* pWin, SdView* pView,
//STRIP001 				 SdDrawDocument* pDoc, SfxRequest& rReq)
//STRIP001 	   : FuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	// Selektierte Seite finden (nur Standard-Seiten)
//STRIP001 	SdPage* pActualPage = NULL;
//STRIP001 	USHORT i = 0;
//STRIP001 	USHORT nCount = pDoc->GetSdPageCount(PK_STANDARD);
//STRIP001 
//STRIP001 	while (!pActualPage && i < nCount)
//STRIP001 	{
//STRIP001 		if (pDoc->GetSdPage(i, PK_STANDARD)->IsSelected())
//STRIP001 		{
//STRIP001 			pActualPage = pDoc->GetSdPage(i, PK_STANDARD);
//STRIP001 		}
//STRIP001 
//STRIP001 		i++;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pActualPage)
//STRIP001 	{
//STRIP001 		SdOutliner* pOutl = new SdOutliner( pDoc, OUTLINERMODE_OUTLINEOBJECT );
//STRIP001 		pOutl->SetUpdateMode(FALSE);
//STRIP001 		pOutl->EnableUndo(FALSE);
//STRIP001 
//STRIP001 		if (pDocSh)
//STRIP001 			pOutl->SetRefDevice( SD_MOD()->GetRefDevice( *pDocSh ) );
//STRIP001 
//STRIP001 		pOutl->SetDefTab( pDoc->GetDefaultTabulator() );
//STRIP001 		pOutl->SetStyleSheetPool((SfxStyleSheetPool*) pDoc->GetStyleSheetPool());
//STRIP001 		pOutl->SetMinDepth(0);
//STRIP001 
//STRIP001 		SetOfByte aVisibleLayers = pActualPage->GetMasterPageVisibleLayers(0);
//STRIP001 		USHORT nActualPageNum = pActualPage->GetPageNum();
//STRIP001 		SdPage* pActualNotesPage = (SdPage*) pDoc->GetPage(nActualPageNum + 1);
//STRIP001 		SdrTextObj* pActualOutline = (SdrTextObj*) pActualPage->GetPresObj(PRESOBJ_OUTLINE);
//STRIP001 
//STRIP001 		if (pActualOutline)
//STRIP001 		{
//STRIP001 			pView->BegUndo(String(SdResId(STR_UNDO_EXPAND_PAGE)));
//STRIP001 
//STRIP001 			// Aktuelles Gliederungsobjekt in Outliner setzen
//STRIP001 			OutlinerParaObject* pParaObj = pActualOutline->GetOutlinerParaObject();
//STRIP001 			pOutl->SetText(*pParaObj);
//STRIP001 
//STRIP001 			// Harte Absatz- und Zeichenattribute entfernen
//STRIP001 			SfxItemSet aEmptyEEAttr(pDoc->GetPool(), EE_ITEMS_START, EE_ITEMS_END);
//STRIP001 			ULONG nParaCount = pOutl->GetParagraphCount();
//STRIP001 
//STRIP001 			for (USHORT nPara = 0; nPara < nParaCount; nPara++)
//STRIP001 			{
//STRIP001 				pOutl->QuickRemoveCharAttribs(nPara);
//STRIP001 				pOutl->SetParaAttribs(nPara, aEmptyEEAttr);
//STRIP001 				Paragraph* pPara = pOutl->GetParagraph(nPara);
//STRIP001 			}
//STRIP001 
//STRIP001 			USHORT nPos = 2;
//STRIP001 			Paragraph* pPara = pOutl->GetParagraph( 0 );
//STRIP001 
//STRIP001 			while (pPara)
//STRIP001 			{
//STRIP001 				ULONG nParaPos = pOutl->GetAbsPos( pPara );
//STRIP001 				USHORT nDepth = pOutl->GetDepth( (USHORT) nParaPos );
//STRIP001 				if ( nDepth == 1 )
//STRIP001 				{
//STRIP001 					// Seite mit Titel & Gliederung!
//STRIP001 					SdPage* pPage = (SdPage*) pDoc->AllocPage(FALSE);
//STRIP001 					pPage->SetSize(pActualPage->GetSize() );
//STRIP001 					pPage->SetBorder(pActualPage->GetLftBorder(),
//STRIP001 									 pActualPage->GetUppBorder(),
//STRIP001 									 pActualPage->GetRgtBorder(),
//STRIP001 									 pActualPage->GetLwrBorder() );
//STRIP001 					pPage->SetName(String());
//STRIP001 
//STRIP001 					// Seite hinter aktueller Seite einfuegen
//STRIP001 					pDoc->InsertPage(pPage, nActualPageNum + nPos);
//STRIP001 					nPos++;
//STRIP001 					pView->AddUndo(new SdrUndoNewPage(*pPage));
//STRIP001 
//STRIP001 					// MasterPage der aktuellen Seite verwenden
//STRIP001 					USHORT nPgNum = pActualPage->GetMasterPageNum(0);
//STRIP001 					pPage->InsertMasterPage(nPgNum);
//STRIP001 					pPage->SetLayoutName(pActualPage->GetLayoutName());
//STRIP001 					pPage->SetAutoLayout(AUTOLAYOUT_ENUM, TRUE);
//STRIP001 					pPage->SetMasterPageVisibleLayers(aVisibleLayers, 0);
//STRIP001 
//STRIP001 					// Notiz-Seite
//STRIP001 					SdPage* pNotesPage = (SdPage*) pDoc->AllocPage(FALSE);
//STRIP001 					pNotesPage->SetSize(pActualNotesPage->GetSize());
//STRIP001 					pNotesPage->SetBorder(pActualNotesPage->GetLftBorder(),
//STRIP001 										  pActualNotesPage->GetUppBorder(),
//STRIP001 										  pActualNotesPage->GetRgtBorder(),
//STRIP001 										  pActualNotesPage->GetLwrBorder() );
//STRIP001 					pNotesPage->SetPageKind(PK_NOTES);
//STRIP001 					pNotesPage->SetName(String());
//STRIP001 
//STRIP001 					// Seite hinter aktueller Seite einfuegen
//STRIP001 					pDoc->InsertPage(pNotesPage, nActualPageNum + nPos);
//STRIP001 					nPos++;
//STRIP001 					pView->AddUndo(new SdrUndoNewPage(*pNotesPage));
//STRIP001 
//STRIP001 					// MasterPage der aktuellen Seite verwenden
//STRIP001 					nPgNum = pActualNotesPage->GetMasterPageNum(0);
//STRIP001 					pNotesPage->InsertMasterPage(nPgNum);
//STRIP001 					pNotesPage->SetLayoutName(pActualNotesPage->GetLayoutName());
//STRIP001 					pNotesPage->SetAutoLayout(pActualNotesPage->GetAutoLayout(), TRUE);
//STRIP001 					pNotesPage->SetMasterPageVisibleLayers(aVisibleLayers, 0);
//STRIP001 
//STRIP001 					// Title-Textobjekt erstellen
//STRIP001 					SdrTextObj* pTextObj = (SdrTextObj*) pPage->GetPresObj(PRESOBJ_TITLE);
//STRIP001 					
//STRIP001 //
//STRIP001 					OutlinerParaObject* pOutlinerParaObject = pOutl->CreateParaObject( (USHORT) nParaPos, 1);
//STRIP001 					pOutlinerParaObject->SetOutlinerMode(OUTLINERMODE_TITLEOBJECT);
//STRIP001 
//STRIP001 					if( pOutlinerParaObject->GetDepth(0) != 0 )
//STRIP001 					{
//STRIP001 						SdrOutliner* pTempOutl = SdrMakeOutliner( OUTLINERMODE_TITLEOBJECT, pDoc );
//STRIP001 
//STRIP001 						pTempOutl->SetText( *pOutlinerParaObject );
//STRIP001 						pTempOutl->SetMinDepth(0);
//STRIP001 
//STRIP001 						delete pOutlinerParaObject;
//STRIP001 
//STRIP001 						pTempOutl->SetDepth( pTempOutl->GetParagraph( 0 ), 0 );
//STRIP001 
//STRIP001 						pOutlinerParaObject = pTempOutl->CreateParaObject();
//STRIP001 						delete pTempOutl;
//STRIP001 					}
//STRIP001 
//STRIP001 					pTextObj->SetOutlinerParaObject(pOutlinerParaObject);
//STRIP001 
//STRIP001 					pTextObj->SetEmptyPresObj(FALSE);
//STRIP001 
//STRIP001 					SfxStyleSheet* pSheet = pPage->GetStyleSheetForPresObj(PRESOBJ_TITLE);
//STRIP001 					pTextObj->NbcSetStyleSheet(pSheet, FALSE);
//STRIP001 
//STRIP001 					ULONG nChildCount = pOutl->GetChildCount(pPara);
//STRIP001 
//STRIP001 					if (nChildCount > 0)
//STRIP001 					{
//STRIP001 						// Gliederungs-Textobjekt erstellen
//STRIP001 						SdrTextObj* pTextObj = (SdrTextObj*) pPage->GetPresObj(PRESOBJ_OUTLINE);
//STRIP001 						pPara = pOutl->GetParagraph( ++nParaPos );
//STRIP001 
//STRIP001 						OutlinerParaObject* pOutlinerParaObject = pOutl->CreateParaObject( (USHORT) nParaPos, (USHORT) nChildCount);
//STRIP001 
//STRIP001 // --
//STRIP001 						SdrOutliner* pTempOutl = SdrMakeOutliner( OUTLINERMODE_OUTLINEOBJECT, pDoc );
//STRIP001 						pTempOutl->SetText( *pOutlinerParaObject );
//STRIP001 						
//STRIP001 						ULONG nParaCount = pTempOutl->GetParagraphCount();
//STRIP001 						ULONG nPara;
//STRIP001 						for( nPara = 0; nPara < nParaCount; nPara++ )
//STRIP001 						{
//STRIP001 							pTempOutl->SetDepth( pTempOutl->GetParagraph( nPara ), pTempOutl->GetDepth( nPara ) - 1 );
//STRIP001 						}
//STRIP001 
//STRIP001 						delete pOutlinerParaObject;
//STRIP001 						pOutlinerParaObject = pTempOutl->CreateParaObject();
//STRIP001 						delete pTempOutl;
//STRIP001 
//STRIP001 // --
//STRIP001 						pTextObj->SetOutlinerParaObject( pOutlinerParaObject );
//STRIP001 						pTextObj->SetEmptyPresObj(FALSE);
//STRIP001 
//STRIP001 						// Harte Attribute entfernen (Flag auf TRUE)
//STRIP001 						SfxItemSet aAttr(pDoc->GetPool());
//STRIP001 						aAttr.Put(XLineStyleItem(XLINE_NONE));
//STRIP001 						aAttr.Put(XFillStyleItem(XFILL_NONE));
//STRIP001 
//STRIP001 //-/						pTextObj->NbcSetAttributes(aAttr, TRUE);
//STRIP001 						pTextObj->SetItemSet(aAttr);
//STRIP001 					}
//STRIP001 				}
//STRIP001 
//STRIP001 				pPara = pOutl->GetParagraph( ++nParaPos );
//STRIP001 			}
//STRIP001 
//STRIP001 			pView->EndUndo();
//STRIP001 		}
//STRIP001 
//STRIP001 		delete pOutl;
//STRIP001 
//STRIP001 		pViewShell->GetViewFrame()->GetDispatcher()->Execute(SID_DELETE_PAGE, SFX_CALLMODE_SYNCHRON | SFX_CALLMODE_RECORD);
//STRIP001 	}
//STRIP001 }

}
