/*************************************************************************
 *
 *  $RCSfile: sd_fuslshw6.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:55:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#define FUSLIDESHOW_INTERN

// auto strip #include <vcl/gradient.hxx>
// auto strip #ifndef _SVDPAGV_HXX //autogen
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #endif

#ifndef _XDEF_HXX
#include <bf_svx/xdef.hxx>
#endif

// auto strip #ifndef _SVX_XFLHTIT_HXX //autogen
// auto strip #include <bf_svx/xflhtit.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XGRAD_HXX //autogen
// auto strip #include <bf_svx/xgrad.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XHATCH_HXX //autogen
// auto strip #include <bf_svx/xhatch.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XFLHTIT_HXX //autogen
// auto strip #include <bf_svx/xflhtit.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XFLCLIT_HXX //autogen
// auto strip #include <bf_svx/xflclit.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XLNCLIT_HXX //autogen
// auto strip #include <bf_svx/xlnclit.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XLNTRIT_HXX //autogen
// auto strip #include <bf_svx/xlntrit.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XFLTRIT_HXX //autogen
// auto strip #include <bf_svx/xfltrit.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_XFLFTRIT_HXX //autogen
// auto strip #include <bf_svx/xflftrit.hxx>
// auto strip #endif
// auto strip #ifndef _XOUTX_HXX //autogen
// auto strip #include <bf_svx/xoutx.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOGRP_HXX //autogen
// auto strip #include <bf_svx/svdogrp.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOGRAF_HXX //autogen
// auto strip #include <bf_svx/svdograf.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOTEXT_HXX //autogen
// auto strip #include <bf_svx/svdotext.hxx>
// auto strip #endif
// auto strip #ifndef _SV_SOUND_HXX //autogen
// auto strip #include <vcl/sound.hxx>
// auto strip #endif
// auto strip #ifndef _SVDORECT_HXX //autogen
// auto strip #include <bf_svx/svdorect.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOPATH_HXX //autogen
// auto strip #include <bf_svx/svdopath.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOOLE2_HXX //autogen
// auto strip #include <bf_svx/svdoole2.hxx>
// auto strip #endif
// auto strip #ifndef _SVDITER_HXX //autogen
// auto strip #include <bf_svx/svditer.hxx>
// auto strip #endif
// auto strip #ifndef _IPENV_HXX //autogen
// auto strip #include <so3/ipenv.hxx>
// auto strip #endif
// auto strip #ifndef _SFXSMPLHINT_HXX //autogen
// auto strip #include <svtools/smplhint.hxx>
// auto strip #endif
// auto strip #ifndef _OUTLOBJ_HXX //autogen
// auto strip #include <bf_svx/outlobj.hxx>
// auto strip #endif

// auto strip #include "showview.hxx"
// auto strip #include "drawdoc.hxx"
#include "sdpage.hxx"
// auto strip #include "anminfo.hxx"
// auto strip #include "mover.hxx"
#include "glob.hrc"
// auto strip #include "showview.hxx"
// auto strip #include "outlinfo.hxx"
// auto strip #include "fader.hxx"
// auto strip #include "sprite.hxx"
// auto strip #include "fuslshow.hxx"
namespace binfilter {

using namespace ::com::sun::star;

// ---------------
// - FuSlideShow -
// ---------------

//STRIP001 BOOL FuSlideShow::AnimateObject( SdrObject* pSubstitute )
//STRIP001 {
//STRIP001 	SdrObject*			pAnmObject = (SdrObject*) pCurAnmList->First();
//STRIP001 	SdAnimationInfo*	pInfo = pDoc->GetAnimationInfo( pSubstitute ? pSubstitute : pAnmObject );
//STRIP001 	BOOL				bAbort = FALSE;
//STRIP001 
//STRIP001 	DBG_ASSERT( pInfo, "keine Animationsinformation gefunden" );
//STRIP001 
//STRIP001     ( (SdrView*) pView )->SetAnimationPause( TRUE );
//STRIP001 
//STRIP001 	// Animation einer Gliederung ( auch Compound)?
//STRIP001     if( ( pLayoutText == pAnmObject || pCompoundText != NULL ) && pInfo->bShow && !pSubstitute )
//STRIP001 		bAbort = !AnimateLayoutText();
//STRIP001     // getrennter Grafik- und Texteffekt?
//STRIP001     else if( pInfo->eTextEffect != presentation::AnimationEffect_NONE )
//STRIP001         bAbort = !CompoundEffect();
//STRIP001 	else
//STRIP001 	{
//STRIP001 		// eine Gliederung? (unsichtbar machen von Gliederungstext geschieht wie bei normalen Objekten)
//STRIP001 		if( ( pAnmObject->GetObjInventor() == SdrInventor ) && 
//STRIP001             ( pAnmObject->GetObjIdentifier() == OBJ_OUTLINETEXT ) &&
//STRIP001             pInfo->bShow && ( presentation::AnimationEffect_PATH != pInfo->eEffect ) &&
//STRIP001             !pSubstitute )
//STRIP001 		{
//STRIP001 			if( pLayoutText && ( pLayoutText != pAnmObject ) )
//STRIP001 				pLayoutText = NULL;
//STRIP001 
//STRIP001 			bAbort = !AnimateLayoutText();
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			// oder was anderes
//STRIP001 			Rectangle						aAnimRect;
//STRIP001 			presentation::AnimationEffect	eEffect = pInfo->eEffect;
//STRIP001 			presentation::AnimationSpeed	eSpeed = pInfo->eSpeed;
//STRIP001 			BOOL							bIsMovie = pInfo->bIsMovie;
//STRIP001 			BOOL							bIsSlow = ( GetSlowObjRecord( (SdrAttrObj*) pAnmObject ) != NULL );
//STRIP001 
//STRIP001 			if( eEffect == presentation::AnimationEffect_RANDOM )
//STRIP001 				eEffect = RandomAnimationEffect( pInfo->bShow );
//STRIP001 
//STRIP001 			eObjectEffect = eEffect;
//STRIP001 
//STRIP001 			// Abblendinformationen in Membern sichern
//STRIP001 			if( pInfo->bDimPrevious && pInfo->bShow )
//STRIP001 			{
//STRIP001 				aDimColor = pInfo->aDimColor;
//STRIP001 				pDimObject = pAnmObject;
//STRIP001                 pHideObject = NULL;
//STRIP001 			}
//STRIP001             else if( pInfo->bDimHide )
//STRIP001             {
//STRIP001                 pHideObject = pAnmObject;
//STRIP001                 pDimObject = NULL;
//STRIP001             }
//STRIP001             else
//STRIP001 			{
//STRIP001                 pHideObject = NULL;
//STRIP001 				pDimObject = NULL;
//STRIP001 			}
//STRIP001 
//STRIP001 			aAnimRect = pAnmObject->GetBoundRect();
//STRIP001 
//STRIP001 			Size  aTolSize( pShowWindow->PixelToLogic( Size( VDEV_TOLERANCE, VDEV_TOLERANCE ) ) );
//STRIP001 			Point aStart, aEnd( aAnimRect.Left() - aTolSize.Width(), aAnimRect.Top() - aTolSize.Height() );
//STRIP001 
//STRIP001             // jetzt kommt eine kleine Sauerei:
//STRIP001             // presentation::AnimationEffect_NONE wird vom Mover bearbeitet; damit koennen
//STRIP001             // die einzelnen Phasen eines Animationsobjektes an einem Punkt
//STRIP001             // dargestellt werden (macht also nur Sinn fuer Animationsobjekte,
//STRIP001             // pInfo->bIsMovie == TRUE). Ist das Objekt kein Animationsobjekt,
//STRIP001             // so wird angenommen, dass es ohne besonderen Effekt erscheinen soll.
//STRIP001             // Dazu wird der Effekt auf ANIMATION_EFFECT_HIDE umgesetzt, das
//STRIP001             // von EffectAToF() wieder auf NONE gemappt wird. Sinn der ganzen
//STRIP001             // Sache: Abarbeitung im zweiten case-Zweig (Fader, nicht Mover).
//STRIP001             // Das gleiche machen wir fuer ein Objekt, das einen inaktivierten Effekt hat.
//STRIP001             if( eEffect == presentation::AnimationEffect_NONE && !pInfo->bIsMovie || !pInfo->bActive )
//STRIP001                 eEffect = presentation::AnimationEffect_HIDE;
//STRIP001 
//STRIP001 			StopTextOrGraphicAnimation( pAnmObject, TRUE );
//STRIP001 			
//STRIP001 			switch( eEffect )
//STRIP001 			{
//STRIP001 				case presentation::AnimationEffect_MOVE_FROM_LEFT:
//STRIP001 				case presentation::AnimationEffect_MOVE_FROM_UPPERLEFT:
//STRIP001 				case presentation::AnimationEffect_MOVE_FROM_TOP:
//STRIP001 				case presentation::AnimationEffect_MOVE_FROM_UPPERRIGHT:
//STRIP001 				case presentation::AnimationEffect_MOVE_FROM_RIGHT :
//STRIP001 				case presentation::AnimationEffect_MOVE_FROM_LOWERRIGHT:
//STRIP001 				case presentation::AnimationEffect_MOVE_FROM_BOTTOM:
//STRIP001 				case presentation::AnimationEffect_MOVE_FROM_LOWERLEFT:
//STRIP001 				case presentation::AnimationEffect_MOVE_SHORT_FROM_LEFT:
//STRIP001 				case presentation::AnimationEffect_MOVE_SHORT_FROM_UPPERLEFT:
//STRIP001 				case presentation::AnimationEffect_MOVE_SHORT_FROM_TOP:
//STRIP001 				case presentation::AnimationEffect_MOVE_SHORT_FROM_UPPERRIGHT:
//STRIP001 				case presentation::AnimationEffect_MOVE_SHORT_FROM_RIGHT:
//STRIP001 				case presentation::AnimationEffect_MOVE_SHORT_FROM_LOWERRIGHT:
//STRIP001 				case presentation::AnimationEffect_MOVE_SHORT_FROM_BOTTOM:
//STRIP001 				case presentation::AnimationEffect_MOVE_SHORT_FROM_LOWERLEFT:
//STRIP001 				case presentation::AnimationEffect_MOVE_TO_LEFT:
//STRIP001 				case presentation::AnimationEffect_MOVE_TO_UPPERLEFT:
//STRIP001 				case presentation::AnimationEffect_MOVE_TO_TOP:
//STRIP001 				case presentation::AnimationEffect_MOVE_TO_UPPERRIGHT:
//STRIP001 				case presentation::AnimationEffect_MOVE_TO_RIGHT :
//STRIP001 				case presentation::AnimationEffect_MOVE_TO_LOWERRIGHT:
//STRIP001 				case presentation::AnimationEffect_MOVE_TO_BOTTOM:
//STRIP001 				case presentation::AnimationEffect_MOVE_TO_LOWERLEFT:
//STRIP001 				case presentation::AnimationEffect_MOVE_SHORT_TO_LEFT:
//STRIP001 				case presentation::AnimationEffect_MOVE_SHORT_TO_UPPERLEFT:
//STRIP001 				case presentation::AnimationEffect_MOVE_SHORT_TO_TOP:
//STRIP001 				case presentation::AnimationEffect_MOVE_SHORT_TO_UPPERRIGHT:
//STRIP001 				case presentation::AnimationEffect_MOVE_SHORT_TO_RIGHT:
//STRIP001 				case presentation::AnimationEffect_MOVE_SHORT_TO_LOWERRIGHT:
//STRIP001 				case presentation::AnimationEffect_MOVE_SHORT_TO_BOTTOM:
//STRIP001 				case presentation::AnimationEffect_MOVE_SHORT_TO_LOWERLEFT:
//STRIP001 				case presentation::AnimationEffect_STRETCH_FROM_LEFT:
//STRIP001 				case presentation::AnimationEffect_STRETCH_FROM_UPPERLEFT:
//STRIP001 				case presentation::AnimationEffect_STRETCH_FROM_TOP:
//STRIP001 				case presentation::AnimationEffect_STRETCH_FROM_UPPERRIGHT:
//STRIP001 				case presentation::AnimationEffect_STRETCH_FROM_RIGHT:
//STRIP001 				case presentation::AnimationEffect_STRETCH_FROM_LOWERRIGHT:
//STRIP001 				case presentation::AnimationEffect_STRETCH_FROM_BOTTOM:
//STRIP001 				case presentation::AnimationEffect_STRETCH_FROM_LOWERLEFT:
//STRIP001 				case presentation::AnimationEffect_HORIZONTAL_STRETCH:
//STRIP001 				case presentation::AnimationEffect_VERTICAL_STRETCH:
//STRIP001 				case presentation::AnimationEffect_HORIZONTAL_ROTATE:
//STRIP001 				case presentation::AnimationEffect_VERTICAL_ROTATE:
//STRIP001 				case presentation::AnimationEffect_PATH:
//STRIP001 				case presentation::AnimationEffect_NONE:
//STRIP001                 {
//STRIP001 					Point			aUpperLeft( pActualPage->GetLftBorder(), pActualPage->GetUppBorder() );
//STRIP001 					Point			aLowerRight( pActualPage->GetSize().Width() - pActualPage->GetRgtBorder(),
//STRIP001 												 pActualPage->GetSize().Height() - pActualPage->GetLwrBorder() );
//STRIP001 					List			aListOfImages;
//STRIP001 					double			fStartScaleX = 1.0, fEndScaleX = 1.0, fStartScaleY = 1.0, fEndScaleY = 1.0;
//STRIP001 
//STRIP001 					pMetaFile->Play( pVDev, MTF_START, OBJ_START( pAnmObject, bIsSlow ) );
//STRIP001 					UpdateVDevWithAnimations();
//STRIP001 
//STRIP001 					switch( eEffect )
//STRIP001 					{
//STRIP001 						case presentation::AnimationEffect_MOVE_FROM_LEFT:
//STRIP001 							aStart.X() = aUpperLeft.X() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 							aStart.Y() = aEnd.Y();
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_FROM_UPPERLEFT:
//STRIP001 							aStart.X() = aUpperLeft.X() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 							aStart.Y() = aUpperLeft.Y() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_FROM_TOP:
//STRIP001 							aStart.X() = aEnd.X();
//STRIP001 							aStart.Y() = aUpperLeft.Y() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_FROM_UPPERRIGHT:
//STRIP001 							aStart.X() = aLowerRight.X();
//STRIP001 							aStart.Y() = aUpperLeft.Y() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_FROM_RIGHT:
//STRIP001 							aStart.X() = aLowerRight.X();
//STRIP001 							aStart.Y() = aEnd.Y();
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_FROM_LOWERRIGHT:
//STRIP001 							aStart.X() = aLowerRight.X();
//STRIP001 							aStart.Y() = aLowerRight.Y();
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_FROM_BOTTOM:
//STRIP001 							aStart.X() = aEnd.X();
//STRIP001 							aStart.Y() = aLowerRight.Y();
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_FROM_LOWERLEFT:
//STRIP001 							aStart.X() = aUpperLeft.X() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 							aStart.Y() = aLowerRight.Y();
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_TO_LEFT:
//STRIP001 							aStart = aEnd;
//STRIP001 							aEnd.X() = aUpperLeft.X() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 							aEnd.Y() = aStart.Y();
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_TO_UPPERLEFT:
//STRIP001 							aStart = aEnd;
//STRIP001 							aEnd.X() = aUpperLeft.X() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 							aEnd.Y() = aUpperLeft.Y() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_TO_TOP:
//STRIP001 							aStart = aEnd;
//STRIP001 							aEnd.X() = aStart.X();
//STRIP001 							aEnd.Y() = aUpperLeft.Y() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_TO_UPPERRIGHT:
//STRIP001 							aStart = aEnd;
//STRIP001 							aEnd.X() = aLowerRight.X();
//STRIP001 							aEnd.Y() = aUpperLeft.Y() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_TO_RIGHT:
//STRIP001 							aStart = aEnd;
//STRIP001 							aEnd.X() = aLowerRight.X();
//STRIP001 							aEnd.Y() = aStart.Y();
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_TO_LOWERRIGHT:
//STRIP001 							aStart = aEnd;
//STRIP001 							aEnd.X() = aLowerRight.X();
//STRIP001 							aEnd.Y() = aLowerRight.Y();
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_TO_BOTTOM:
//STRIP001 							aStart = aEnd;
//STRIP001 							aEnd.X() = aStart.X();
//STRIP001 							aEnd.Y() = aLowerRight.Y();
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_TO_LOWERLEFT:
//STRIP001 							aStart = aEnd;
//STRIP001 							aEnd.X() = aUpperLeft.X() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 							aEnd.Y() = aLowerRight.Y();
//STRIP001 						break;
//STRIP001 
//STRIP001 						// ---
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_SHORT_FROM_LEFT:
//STRIP001 							aStart.X() = aAnimRect.Left() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 							aStart.Y() = aEnd.Y();
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_SHORT_FROM_UPPERLEFT:
//STRIP001 							aStart.X() = aAnimRect.Left() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 							aStart.Y() = aAnimRect.Top() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_SHORT_FROM_TOP:
//STRIP001 							aStart.X() = aEnd.X();
//STRIP001 							aStart.Y() = aAnimRect.Top() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_SHORT_FROM_UPPERRIGHT:
//STRIP001 							aStart.X() = aAnimRect.Right();
//STRIP001 							aStart.Y() = aAnimRect.Top() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_SHORT_FROM_RIGHT:
//STRIP001 							aStart.X() = aAnimRect.Right();
//STRIP001 							aStart.Y() = aEnd.Y();
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_SHORT_FROM_LOWERRIGHT:
//STRIP001 							aStart.X() = aAnimRect.Right();
//STRIP001 							aStart.Y() = aAnimRect.Bottom();
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_SHORT_FROM_BOTTOM:
//STRIP001 							aStart.X() = aEnd.X();
//STRIP001 							aStart.Y() = aAnimRect.Bottom();
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_SHORT_FROM_LOWERLEFT:
//STRIP001 							aStart.X() = aAnimRect.Left() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 							aStart.Y() = aAnimRect.Bottom();
//STRIP001 						break;
//STRIP001 
//STRIP001 						// ----
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_SHORT_TO_LEFT:
//STRIP001 							aStart = aEnd;
//STRIP001 							aEnd.X() = aAnimRect.Left() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 							aEnd.Y() = aStart.Y();
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_SHORT_TO_UPPERLEFT:
//STRIP001 							aStart = aEnd;
//STRIP001 							aEnd.X() = aAnimRect.Left() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 							aEnd.Y() = aAnimRect.Top() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_SHORT_TO_TOP:
//STRIP001 							aStart = aEnd;
//STRIP001 							aEnd.X() = aStart.X();
//STRIP001 							aEnd.Y() = aAnimRect.Top() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_SHORT_TO_UPPERRIGHT:
//STRIP001 							aStart = aEnd;
//STRIP001 							aEnd.X() = aAnimRect.Right();
//STRIP001 							aEnd.Y() = aAnimRect.Top() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_SHORT_TO_RIGHT:
//STRIP001 							aStart = aEnd;
//STRIP001 							aEnd.X() = aAnimRect.Right();
//STRIP001 							aEnd.Y() = aStart.Y();
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_SHORT_TO_LOWERRIGHT:
//STRIP001 							aStart = aEnd;
//STRIP001 							aEnd.X() = aAnimRect.Right();
//STRIP001 							aEnd.Y() = aAnimRect.Bottom();
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_SHORT_TO_BOTTOM:
//STRIP001 							aStart = aEnd;
//STRIP001 							aEnd.X() = aStart.X();
//STRIP001 							aEnd.Y() = aAnimRect.Bottom();
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_MOVE_SHORT_TO_LOWERLEFT:
//STRIP001 							aStart = aEnd;
//STRIP001 							aEnd.X() = aAnimRect.Left() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 							aEnd.Y() = aAnimRect.Bottom();
//STRIP001 						break;
//STRIP001 
//STRIP001 						// ----
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_STRETCH_FROM_LEFT:
//STRIP001 							aStart = aEnd;
//STRIP001 							fStartScaleX = 0.0;
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_STRETCH_FROM_UPPERLEFT:
//STRIP001 							aStart = aEnd;
//STRIP001 							fStartScaleX = fStartScaleY = 0.0;
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_STRETCH_FROM_TOP:
//STRIP001 							aStart = aEnd;
//STRIP001 							fStartScaleY = 0.0;
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_STRETCH_FROM_UPPERRIGHT:
//STRIP001 							aStart = aAnimRect.TopRight();
//STRIP001 							fStartScaleX = fStartScaleY = 0.0;
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_STRETCH_FROM_RIGHT:
//STRIP001 							aStart.X() = aAnimRect.Right();
//STRIP001 							aStart.Y() = aEnd.Y();
//STRIP001 							fStartScaleX = 0.0;
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_STRETCH_FROM_LOWERRIGHT:
//STRIP001 							aStart.X() = aAnimRect.Right();
//STRIP001 							aStart.Y() = aAnimRect.Bottom();
//STRIP001 							fStartScaleX = fStartScaleY = 0.0;
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_STRETCH_FROM_BOTTOM:
//STRIP001 							aStart.X() = aEnd.X();
//STRIP001 							aStart.Y() = aAnimRect.Bottom();
//STRIP001 							fStartScaleY = 0.0;
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_STRETCH_FROM_LOWERLEFT:
//STRIP001 							aStart.X() = aEnd.X();
//STRIP001 							aStart.Y() = aAnimRect.Bottom();
//STRIP001 							fStartScaleX = fStartScaleY = 0.0;
//STRIP001 						break;
//STRIP001 
//STRIP001 						// ----
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_HORIZONTAL_STRETCH:
//STRIP001 						case presentation::AnimationEffect_HORIZONTAL_ROTATE:
//STRIP001 							aStart.X() = aAnimRect.Center().X();
//STRIP001 							aStart.Y() = aEnd.Y();
//STRIP001 							fStartScaleX = 0.0;
//STRIP001 						break;
//STRIP001 
//STRIP001 						case presentation::AnimationEffect_VERTICAL_STRETCH:
//STRIP001 						case presentation::AnimationEffect_VERTICAL_ROTATE:
//STRIP001 							aStart.X() = aEnd.X();
//STRIP001 							aStart.Y() = aAnimRect.Center().Y();
//STRIP001 							fStartScaleY = 0.0;
//STRIP001 						break;
//STRIP001 
//STRIP001 						// ----
//STRIP001 						
//STRIP001 						case presentation::AnimationEffect_NONE:
//STRIP001 							DBG_ASSERT( bIsMovie, "NONE works only with Movies" );
//STRIP001 							aStart = aEnd;
//STRIP001 						break;
//STRIP001 
//STRIP001 					}
//STRIP001 
//STRIP001 					const Marker	aStartMarker( OBJ_START( pAnmObject, bIsSlow ) );
//STRIP001 					const Marker	aEndMarker( OBJ_END( pAnmObject, bIsSlow ) );
//STRIP001 					Region			aClipRegion;
//STRIP001 
//STRIP001 					// short effect or normal effect => set correct clip region
//STRIP001 					if( presentation::AnimationEffect_MOVE_SHORT_FROM_LEFT == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_FROM_UPPERLEFT == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_FROM_TOP == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_FROM_UPPERRIGHT == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_FROM_RIGHT == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_FROM_LOWERRIGHT == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_FROM_BOTTOM == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_FROM_LOWERLEFT == eEffect ||
//STRIP001 					
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_TO_LEFT == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_TO_UPPERLEFT == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_TO_TOP == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_TO_UPPERRIGHT == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_TO_RIGHT == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_TO_LOWERRIGHT == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_TO_BOTTOM == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_TO_LOWERLEFT == eEffect ||
//STRIP001 
//STRIP001 						presentation::AnimationEffect_STRETCH_FROM_LEFT == eEffect ||
//STRIP001 						presentation::AnimationEffect_STRETCH_FROM_UPPERLEFT == eEffect ||
//STRIP001 						presentation::AnimationEffect_STRETCH_FROM_TOP == eEffect ||
//STRIP001 						presentation::AnimationEffect_STRETCH_FROM_UPPERRIGHT == eEffect ||
//STRIP001 						presentation::AnimationEffect_STRETCH_FROM_RIGHT == eEffect ||
//STRIP001 						presentation::AnimationEffect_STRETCH_FROM_LOWERRIGHT == eEffect ||
//STRIP001 						presentation::AnimationEffect_STRETCH_FROM_BOTTOM == eEffect ||
//STRIP001 						presentation::AnimationEffect_STRETCH_FROM_LOWERLEFT == eEffect ||
//STRIP001 
//STRIP001 						presentation::AnimationEffect_HORIZONTAL_STRETCH == eEffect ||
//STRIP001 						presentation::AnimationEffect_VERTICAL_STRETCH == eEffect ||
//STRIP001 
//STRIP001 						presentation::AnimationEffect_HORIZONTAL_ROTATE == eEffect ||
//STRIP001 						presentation::AnimationEffect_VERTICAL_ROTATE == eEffect )
//STRIP001 					{
//STRIP001 						pMover->SetClipRegion( aAnimRect );
//STRIP001 					}
//STRIP001 					else
//STRIP001 						pMover->SetClipRegion( Rectangle( aUpperLeft, aLowerRight ) );
//STRIP001 
//STRIP001 					// fill list of images
//STRIP001 					if( ( bAbort = !AdjustAnmVDev( aAnimRect, COL_WHITE ) ) == TRUE )
//STRIP001 						HandleError( STR_NOT_ENOUGH_MEMORY );
//STRIP001 					else
//STRIP001 					{
//STRIP001 						ExtOutputDevice aOut( pAnmVDev );
//STRIP001 						SdrPaintInfoRec aPaintInfoRec;
//STRIP001 
//STRIP001 						SetPaintModes((SdrView*)pView, NULL, &aOut, &aPaintInfoRec);
//STRIP001 						pAnmVDev->SetDrawMode( pShowWindow->GetDrawMode() );
//STRIP001 
//STRIP001 						if( pInfo->bIsMovie )
//STRIP001 						{
//STRIP001 							SdrObjList* pObjList = ( (SdrObjGroup*) pAnmObject )->GetSubList();
//STRIP001 
//STRIP001 							for( USHORT nObject = 0; nObject < pObjList->GetObjCount(); nObject++ )
//STRIP001 								aListOfImages.Insert( new BitmapEx( CreateReplacement( (SdrObject*) pObjList->GetObj( (ULONG) nObject ), &aOut ) ), LIST_APPEND );
//STRIP001 						}
//STRIP001 						else if( pAnmObject == pLayoutText )
//STRIP001 						{
//STRIP001 							PaintLayoutClone( pAnmVDev );
//STRIP001 							aListOfImages.Insert( new BitmapEx( pAnmVDev->GetBitmap( pAnmVDev->PixelToLogic( Point() ),
//STRIP001 																					 pAnmVDev->GetOutputSize() ), COL_WHITE ),
//STRIP001 												  LIST_APPEND );
//STRIP001 						}
//STRIP001 						else
//STRIP001 						{
//STRIP001 							aListOfImages.Insert( new BitmapEx( CreateReplacement( ( !pInfo->bDimmed && pSubstitute ) ?
//STRIP001 																				   pSubstitute : pAnmObject, &aOut ) ),
//STRIP001 												  LIST_APPEND );
//STRIP001 						}
//STRIP001 						
//STRIP001 						pAnmVDev->SetDrawMode( DRAWMODE_DEFAULT );
//STRIP001 					}
//STRIP001 
//STRIP001 					if( !bAbort && aListOfImages.Count() )
//STRIP001 					{
//STRIP001 						pMover->SetGraphicInfo( pVDev, &pMetaFile, aStartMarker, aEndMarker );
//STRIP001 						pMover->SetListOfImages( &aListOfImages );
//STRIP001 						pMover->SetSpeed( SpeedAToM( eSpeed ), 1 );
//STRIP001 
//STRIP001 						// set correct path
//STRIP001 						if( ( eEffect == presentation::AnimationEffect_PATH ) && pInfo->pPathObj )
//STRIP001 						{
//STRIP001 							XPolyPolygon			aXPolyPoly( pInfo->pPathObj->GetPathPoly() );
//STRIP001 							const presentation::AnimationEffect	eOldTextEffect = pInfo->eTextEffect;
//STRIP001 							const BOOL				bOldShow = pInfo->bShow;
//STRIP001 
//STRIP001 							pCurAnmList->Remove( pLayoutText );
//STRIP001 							pDimObject = NULL;
//STRIP001 							pHideObject = NULL;
//STRIP001 							pInfo->bShow = FALSE;
//STRIP001 							pInfo->eEffect = presentation::AnimationEffect_HIDE;
//STRIP001 							pInfo->eTextEffect = presentation::AnimationEffect_NONE;
//STRIP001 							AnimateObject();
//STRIP001 
//STRIP001 							// und jetzt Objekt noch einmal am Pfad animieren
//STRIP001 							pCurAnmList->Insert( pAnmObject, (ULONG) 0 );
//STRIP001 							pInfo->eEffect = presentation::AnimationEffect_PATH;
//STRIP001 							pInfo->eTextEffect = eOldTextEffect;
//STRIP001 							pInfo->bShow = bOldShow;
//STRIP001 
//STRIP001 							if( aXPolyPoly.Count() )
//STRIP001 							{
//STRIP001 								const XPolygon& rLastPoly = aXPolyPoly[ aXPolyPoly.Count() - 1 ];
//STRIP001 								
//STRIP001 								if( rLastPoly.GetPointCount() )
//STRIP001 								{
//STRIP001 									const long nDiffX = ( aAnimRect.GetWidth() >> 1 ) + aTolSize.Width();
//STRIP001 									const long nDiffY = ( aAnimRect.GetHeight() >> 1 ) + aTolSize.Height();
//STRIP001 
//STRIP001 									aXPolyPoly.Move( -nDiffX, -nDiffY );
//STRIP001 
//STRIP001                                     // #96190# Flatten polygon befor giving it to mover
//STRIP001                                     Polygon aFlattenedPolygon = XOutCreatePolygon( rLastPoly, pAnmVDev );
//STRIP001 
//STRIP001 									pMover->SetPath( PolyPolygon(aFlattenedPolygon) );
//STRIP001 								} 
//STRIP001 							}
//STRIP001 						}
//STRIP001 						else
//STRIP001 							pMover->SetPath( aStart, aEnd, &fStartScaleX, &fEndScaleX, &fStartScaleY, &fEndScaleY );
//STRIP001 
//STRIP001 						if( pInfo->bSoundOn )
//STRIP001 						{
//STRIP001 							bPlayFull = pInfo->bPlayFull;
//STRIP001 							StartSound(pInfo->aSoundFile);
//STRIP001 						}
//STRIP001 
//STRIP001 						bAbort = !pMover->Move();
//STRIP001 
//STRIP001 						if( !bAbort && 
//STRIP001 							eEffect == presentation::AnimationEffect_HORIZONTAL_ROTATE || 
//STRIP001 							eEffect == presentation::AnimationEffect_VERTICAL_ROTATE )
//STRIP001 						{
//STRIP001 							const Point	aMediumPos( aStart ), aFinalPos( aEnd );
//STRIP001 
//STRIP001 							for( long i = 0; ( i < 4 ) && !bAbort; i++ )
//STRIP001 							{
//STRIP001 								const BOOL		bOdd = ( ( i & 1 ) != 0 );
//STRIP001 								const Point*	pStart = bOdd ? &aMediumPos : &aFinalPos;
//STRIP001 								const Point*	pEnd = bOdd ? &aFinalPos : &aMediumPos;
//STRIP001 
//STRIP001 								if( eEffect == presentation::AnimationEffect_HORIZONTAL_ROTATE )
//STRIP001 								{
//STRIP001 									fStartScaleX = bOdd ? 0.0 : 1.0;
//STRIP001 									fEndScaleX = bOdd ? 1.0 : 0.0;
//STRIP001 								}
//STRIP001 								else
//STRIP001 								{
//STRIP001 									fStartScaleY = bOdd ? 0.0 : 1.0;
//STRIP001 									fEndScaleY = bOdd ? 1.0 : 0.0;
//STRIP001 								}
//STRIP001 
//STRIP001 								pMover->SetPath( *pStart, *pEnd, &fStartScaleX, &fEndScaleX, &fStartScaleY, &fEndScaleY );
//STRIP001 								bAbort = !pMover->Move();
//STRIP001 
//STRIP001                                 if( nMagic != SLIDESHOW_MAGIC )
//STRIP001                                 {
//STRIP001                                     break;
//STRIP001                                 }
//STRIP001 							}
//STRIP001 						}
//STRIP001 
//STRIP001 						for( void* pBmpEx = aListOfImages.First(); pBmpEx; pBmpEx = aListOfImages.Next() )
//STRIP001 							delete (BitmapEx*) pBmpEx;
//STRIP001 						
//STRIP001 						if( nMagic != SLIDESHOW_MAGIC )
//STRIP001 							return TRUE;
//STRIP001 					}
//STRIP001 
//STRIP001 					// merken fuers abblenden
//STRIP001 					aDimRect = Rectangle( pAnmVDev->PixelToLogic( Point() ), pAnmVDev->GetOutputSize() );
//STRIP001 				}
//STRIP001 				break;
//STRIP001 
//STRIP001 				case presentation::AnimationEffect_APPEAR:
//STRIP001 				case presentation::AnimationEffect_FADE_FROM_LEFT:
//STRIP001 				case presentation::AnimationEffect_FADE_FROM_UPPERLEFT:
//STRIP001 				case presentation::AnimationEffect_FADE_FROM_TOP:
//STRIP001 				case presentation::AnimationEffect_FADE_FROM_UPPERRIGHT:
//STRIP001 				case presentation::AnimationEffect_FADE_FROM_RIGHT:
//STRIP001 				case presentation::AnimationEffect_FADE_FROM_BOTTOM:
//STRIP001 				case presentation::AnimationEffect_FADE_FROM_LOWERRIGHT:
//STRIP001 				case presentation::AnimationEffect_FADE_FROM_LOWERLEFT:
//STRIP001 				case presentation::AnimationEffect_FADE_TO_CENTER:
//STRIP001 				case presentation::AnimationEffect_FADE_FROM_CENTER:
//STRIP001 				case presentation::AnimationEffect_VERTICAL_STRIPES:
//STRIP001 				case presentation::AnimationEffect_HORIZONTAL_STRIPES:
//STRIP001 				case presentation::AnimationEffect_VERTICAL_LINES:
//STRIP001 				case presentation::AnimationEffect_HORIZONTAL_LINES:
//STRIP001 				case presentation::AnimationEffect_VERTICAL_CHECKERBOARD:
//STRIP001 				case presentation::AnimationEffect_HORIZONTAL_CHECKERBOARD:
//STRIP001 				case presentation::AnimationEffect_CLOCKWISE:
//STRIP001 				case presentation::AnimationEffect_COUNTERCLOCKWISE:
//STRIP001 				case presentation::AnimationEffect_CLOSE_VERTICAL:
//STRIP001 				case presentation::AnimationEffect_CLOSE_HORIZONTAL:
//STRIP001 				case presentation::AnimationEffect_OPEN_VERTICAL:
//STRIP001 				case presentation::AnimationEffect_OPEN_HORIZONTAL:
//STRIP001 				case presentation::AnimationEffect_SPIRALIN_LEFT:
//STRIP001 				case presentation::AnimationEffect_SPIRALIN_RIGHT:
//STRIP001 				case presentation::AnimationEffect_SPIRALOUT_LEFT:
//STRIP001 				case presentation::AnimationEffect_SPIRALOUT_RIGHT:
//STRIP001 				case presentation::AnimationEffect_DISSOLVE:
//STRIP001 				case presentation::AnimationEffect_WAVYLINE_FROM_LEFT:
//STRIP001 				case presentation::AnimationEffect_WAVYLINE_FROM_TOP:
//STRIP001 				case presentation::AnimationEffect_WAVYLINE_FROM_RIGHT:
//STRIP001 				case presentation::AnimationEffect_WAVYLINE_FROM_BOTTOM:
//STRIP001 				case presentation::AnimationEffect_HIDE:
//STRIP001 				{
//STRIP001 					bAbort = !AdjustAnmVDev( aAnimRect, COL_WHITE );
//STRIP001 
//STRIP001 					if( bAbort )
//STRIP001 						HandleError( STR_NOT_ENOUGH_MEMORY );
//STRIP001 					else
//STRIP001 					{
//STRIP001 						Rectangle aTolRect( aAnimRect );
//STRIP001 
//STRIP001 						aTolRect.Left() -= aTolSize.Width(); aTolRect.Top() -= aTolSize.Height();
//STRIP001 						aTolRect.Right() += aTolSize.Height(); aTolRect.Bottom() += aTolSize.Height();
//STRIP001 
//STRIP001 						pMetaFile->Play( pAnmVDev, MTF_START, FIRST_START );
//STRIP001 
//STRIP001                         // soll das Objekt nicht aus dem Metafile sondern durch
//STRIP001                         // eine Ersatzdarstellung gezeichnet werden?
//STRIP001                         if( pSubstitute )
//STRIP001                         {
//STRIP001 							pMetaFile->Play( pAnmVDev, FIRST_START, OBJ_START( pAnmObject, bIsSlow ) );
//STRIP001                             ExtOutputDevice aOut(pAnmVDev);
//STRIP001 							SdrPaintInfoRec aPaintInfoRec;
//STRIP001 							SetPaintModes((SdrView*)pView, NULL, &aOut, &aPaintInfoRec);
//STRIP001 							pAnmVDev->SetDrawMode( pShowWindow->GetDrawMode() );
//STRIP001                             pSubstitute->Paint(aOut, aPaintInfoRec);
//STRIP001 							pAnmVDev->SetDrawMode( DRAWMODE_DEFAULT );
//STRIP001 							pMetaFile->Play( pAnmVDev, OBJ_END( pAnmObject, bIsSlow ), MTF_END );
//STRIP001                         }
//STRIP001 						else if( ( eEffect != presentation::AnimationEffect_HIDE ) && OBJIS_GRAFANIM( pAnmObject ) )
//STRIP001 						{
//STRIP001 							// Animation muss getrennt aufbereitet werden, da diese nicht im MetaFile enthalten ist
//STRIP001 							pMetaFile->Play( pAnmVDev, FIRST_START, OBJ_START( pAnmObject, bIsSlow ) );
//STRIP001 							DrawOrStartAnimation( pAnmObject, pAnmVDev, FALSE, FALSE );
//STRIP001 							pMetaFile->Play( pAnmVDev, OBJ_END( pAnmObject, bIsSlow ), MTF_END );
//STRIP001 						}
//STRIP001                         else
//STRIP001 							pMetaFile->Play( pAnmVDev, FIRST_START, MTF_END );
//STRIP001 
//STRIP001 						pFader->SetNewVirtualDevice( pAnmVDev );
//STRIP001 
//STRIP001 						Point		aUpperLeft(pActualPage->GetLftBorder(), pActualPage->GetUppBorder());
//STRIP001 						Point		aLowerRight(pActualPage->GetSize().Width() - pActualPage->GetRgtBorder(),
//STRIP001 												pActualPage->GetSize().Height() - pActualPage->GetLwrBorder());
//STRIP001 
//STRIP001 						aTolRect.Intersection( Rectangle( aUpperLeft, aLowerRight ) );
//STRIP001 						pFader->SetTarget( aTolRect );
//STRIP001 						pFader->SetSource( aTolRect );
//STRIP001 						pFader->SetSpeed( SpeedAToF( eSpeed ) );
//STRIP001 						pFader->SetEffect( EffectAToF( eEffect ) );
//STRIP001 
//STRIP001 						if( pInfo->bSoundOn )
//STRIP001 						{
//STRIP001 							bPlayFull = pInfo->bPlayFull;
//STRIP001 							StartSound( pInfo->aSoundFile );
//STRIP001 						}
//STRIP001 
//STRIP001 						pFader->Fade();
//STRIP001                         
//STRIP001 						if( nMagic != SLIDESHOW_MAGIC )
//STRIP001                             return TRUE;
//STRIP001 
//STRIP001 						// merken fuers abblenden, falls das Objekt nicht
//STRIP001 						// versteckt wurde
//STRIP001 						if( pInfo->bShow )
//STRIP001 							aDimRect = Rectangle( pAnmVDev->PixelToLogic( Point() ), pAnmVDev->GetOutputSize() );
//STRIP001 					}
//STRIP001 				}
//STRIP001 				break;
//STRIP001 			}
//STRIP001 
//STRIP001 			// GGf. die Animation wieder starten
//STRIP001 			if( pInfo->bShow )
//STRIP001 			{
//STRIP001 				// animierte Grafik starten
//STRIP001 				if( OBJIS_GRAFANIM( pAnmObject ) )
//STRIP001 				{
//STRIP001 					Rectangle aRect( ( (SdrGrafObj*) pAnmObject )->GetAnimationRect( pShowWindow ) );
//STRIP001 
//STRIP001 					pMetaFile->Play( pAnmVDev, MTF_START, MTF_END );
//STRIP001 					pShowWindow->DrawOutDev( aRect.TopLeft(), aRect.GetSize(),
//STRIP001 											 aRect.TopLeft(), aRect.GetSize(),
//STRIP001 											 *pAnmVDev);
//STRIP001 
//STRIP001 					// Animation starten oder zeichnen
//STRIP001 					DrawOrStartAnimation( (SdrGrafObj*) pAnmObject, pShowWindow, bAnimationAllowed, TRUE );
//STRIP001 					pCurAnimGraphs->Insert( pAnmObject, LIST_APPEND );
//STRIP001 				}
//STRIP001 			}
//STRIP001 
//STRIP001 			pCurAnmList->Remove( (ULONG) 0 );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001     ( (SdrView*) pView )->SetAnimationPause( FALSE );
//STRIP001 
//STRIP001 	if( bAbort )
//STRIP001 		StopShow();
//STRIP001 
//STRIP001 	return( !bAbort );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL FuSlideShow::AnimateLayoutText()
//STRIP001 {
//STRIP001 	BOOL bAbort = FALSE, bInit = FALSE;
//STRIP001 
//STRIP001 	// beim ersten Durchlauf Membervariablen initialisieren
//STRIP001 	if( !pLayoutText )
//STRIP001 	{
//STRIP001 		if( pCompoundText )
//STRIP001 		{
//STRIP001 			// Zuweisung des TextClones, der in CompoundEffect erzeugt wurde
//STRIP001 			pLayoutClone = pCompoundText;
//STRIP001 			pLayoutText = (SdrRectObj*) pCurAnmList->First();
//STRIP001 			pCompoundText = NULL;
//STRIP001 			bIsCompoundLayoutText = TRUE;
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			pLayoutText = (SdrRectObj*) pCurAnmList->First();
//STRIP001 			pLayoutClone = (SdrRectObj*)((SdrTextObj*)pLayoutText)->Clone();
//STRIP001 			bIsCompoundLayoutText = FALSE;
//STRIP001 		}
//STRIP001 
//STRIP001 		bInit = TRUE;
//STRIP001 		nParaPos = nDimPos = 0L;		
//STRIP001 		eRandomLayout = presentation::AnimationEffect_NONE;
//STRIP001 		bFullBckgnd = FALSE;
//STRIP001 		
//STRIP001 		delete pLayoutClip;
//STRIP001 		pLayoutClip = NULL;
//STRIP001 		
//STRIP001 		delete pLayoutBmpEx;
//STRIP001 		pLayoutBmpEx = NULL;
//STRIP001 	}
//STRIP001 
//STRIP001 	// die Animationsinformation holen
//STRIP001 	SdAnimationInfo*				pInfo = pDoc->GetAnimationInfo( pLayoutText );
//STRIP001 	presentation::AnimationEffect	eEffect;
//STRIP001 	presentation::AnimationSpeed	eSpeed = pInfo->eSpeed;
//STRIP001 
//STRIP001 	// richtigen Effekt bestimmen
//STRIP001 	if( !bIsCompoundLayoutText )
//STRIP001 		eEffect = pInfo->eEffect;
//STRIP001 	else
//STRIP001 	{
//STRIP001 		// nach der Initalisierung ( ab 2. Absatz ) wird der TextEffekt
//STRIP001 		// des CompoundEffects an der OutlinerInfo gehalten, da der
//STRIP001 		// LayoutClone (init. ==pCompoundText) waehrend der Animation
//STRIP001 		// evtl. geloescht und neu erzeugt wird, wodurch der Texteffekt
//STRIP001 		// verloren geht und auf den Objekteffekt zurueckgesetzt wird
//STRIP001 		if( bInit )
//STRIP001 			eEffect = pDoc->GetAnimationInfo( pLayoutClone )->eEffect;
//STRIP001 		else
//STRIP001 			eEffect = (presentation::AnimationEffect) pOutlInfo->GetExtraData();
//STRIP001 	}
//STRIP001 
//STRIP001 	// Zufallseffekt bevorzugen bzw. erzeugen
//STRIP001 	if( eRandomLayout != presentation::AnimationEffect_NONE )
//STRIP001 		eEffect = eRandomLayout;
//STRIP001 	else if( eEffect == presentation::AnimationEffect_RANDOM )
//STRIP001 		eEffect = eRandomLayout = RandomAnimationEffect( TRUE );
//STRIP001 
//STRIP001 	// merken ( z.B. fuer DimLayoutParagraph )
//STRIP001 	eObjectEffect = eEffect;
//STRIP001 
//STRIP001     // Abblendinformationen in Membern sichern
//STRIP001     if( pInfo->bDimPrevious )
//STRIP001     {
//STRIP001        if( bInit )
//STRIP001            aDimColor = pInfo->aDimColor;
//STRIP001 
//STRIP001        // muss bei jedem Durchlauf neu gesetzt werden, da es nach dem
//STRIP001        // Abblenden eines Absatzes zurueckgesetzt wird
//STRIP001        pDimObject = pLayoutText;
//STRIP001     }
//STRIP001     else
//STRIP001         pDimObject = NULL;
//STRIP001 
//STRIP001 	pHideObject = NULL;
//STRIP001 
//STRIP001 	Rectangle	aObjRect( pLayoutText->GetBoundRect() );
//STRIP001 	const Size	aTolSize( pShowWindow->PixelToLogic( Size( VDEV_TOLERANCE, VDEV_TOLERANCE ) ) );
//STRIP001 
//STRIP001 	// MapMode, Groesse und Hintergrundfarbe des Animationsdevice setzen
//STRIP001 	if( bInit )
//STRIP001 	{
//STRIP001 		BOOL bIsSlow = GetSlowObjRecord( (SdrAttrObj*) pLayoutText ) != NULL;
//STRIP001 
//STRIP001 		bAbort = !AdjustAnmVDev( aObjRect, COL_WHITE );
//STRIP001 
//STRIP001 		// wenn der Fader benutzt wird, muss alles ins Animationsdevice gezeichnet werden
//STRIP001 		switch( eEffect )
//STRIP001 		{
//STRIP001 			case( presentation::AnimationEffect_APPEAR ):
//STRIP001 			case( presentation::AnimationEffect_FADE_FROM_LEFT ):
//STRIP001 			case( presentation::AnimationEffect_FADE_FROM_UPPERLEFT ):
//STRIP001 			case( presentation::AnimationEffect_FADE_FROM_TOP ):
//STRIP001 			case( presentation::AnimationEffect_FADE_FROM_UPPERRIGHT ):
//STRIP001 			case( presentation::AnimationEffect_FADE_FROM_RIGHT ):
//STRIP001 			case( presentation::AnimationEffect_FADE_FROM_LOWERRIGHT ):
//STRIP001 			case( presentation::AnimationEffect_FADE_FROM_BOTTOM ):
//STRIP001 			case( presentation::AnimationEffect_FADE_FROM_LOWERLEFT ):
//STRIP001 			case( presentation::AnimationEffect_FADE_TO_CENTER ):
//STRIP001 			case( presentation::AnimationEffect_FADE_FROM_CENTER ):
//STRIP001 			case( presentation::AnimationEffect_VERTICAL_STRIPES ):
//STRIP001 			case( presentation::AnimationEffect_HORIZONTAL_STRIPES ):
//STRIP001 			case( presentation::AnimationEffect_VERTICAL_LINES ):
//STRIP001 			case( presentation::AnimationEffect_HORIZONTAL_LINES ):
//STRIP001 			case( presentation::AnimationEffect_VERTICAL_CHECKERBOARD ):
//STRIP001 			case( presentation::AnimationEffect_HORIZONTAL_CHECKERBOARD ):
//STRIP001 			case( presentation::AnimationEffect_CLOCKWISE ):
//STRIP001 			case( presentation::AnimationEffect_COUNTERCLOCKWISE ):
//STRIP001 			case( presentation::AnimationEffect_CLOSE_VERTICAL ):
//STRIP001 			case( presentation::AnimationEffect_CLOSE_HORIZONTAL ):
//STRIP001 			case( presentation::AnimationEffect_OPEN_VERTICAL ):
//STRIP001 			case( presentation::AnimationEffect_OPEN_HORIZONTAL ):
//STRIP001 			case( presentation::AnimationEffect_SPIRALIN_LEFT ):
//STRIP001 			case( presentation::AnimationEffect_SPIRALIN_RIGHT ):
//STRIP001 			case( presentation::AnimationEffect_SPIRALOUT_LEFT ):
//STRIP001 			case( presentation::AnimationEffect_SPIRALOUT_RIGHT ):
//STRIP001 			case( presentation::AnimationEffect_DISSOLVE	):
//STRIP001 			case( presentation::AnimationEffect_WAVYLINE_FROM_LEFT ):
//STRIP001 			case( presentation::AnimationEffect_WAVYLINE_FROM_TOP ):
//STRIP001 			case( presentation::AnimationEffect_WAVYLINE_FROM_RIGHT ):
//STRIP001 			case( presentation::AnimationEffect_WAVYLINE_FROM_BOTTOM ):
//STRIP001 			{
//STRIP001 				Rectangle aTolRect( aObjRect );
//STRIP001 
//STRIP001 				aTolRect.Left() -= aTolSize.Width();
//STRIP001 				aTolRect.Top() -= aTolSize.Height();
//STRIP001 				aTolRect.Right() += aTolSize.Height();
//STRIP001 				aTolRect.Bottom() += aTolSize.Height();
//STRIP001 
//STRIP001     		    // draw background till start of object to VDev
//STRIP001     		    pMetaFile->Play( pVDev, MTF_START, OBJ_START( pLayoutText, bIsSlow ) );
//STRIP001                
//STRIP001                 // quick BitBlt of background and background objects from VDev to AnmVDev;
//STRIP001                 // afterwards draw whole metafile with nParaPos set to number of paragraphs (=>PaintLayoutClone)
//STRIP001 				const ULONG	nTrueParaPos = nParaPos;
//STRIP001 				nParaPos = pLayoutText->GetOutlinerParaObject()->Count();
//STRIP001                 pAnmVDev->DrawOutDev( aTolRect.TopLeft(), aTolRect.GetSize(), aTolRect.TopLeft(), aTolRect.GetSize(), *pVDev );
//STRIP001 				pMetaFile->Play( pAnmVDev, OBJ_START( pLayoutText, bIsSlow ), MTF_END );
//STRIP001 				nParaPos = nTrueParaPos;
//STRIP001     		    
//STRIP001     		    // draw everything else without object to VDev
//STRIP001 				pMetaFile->Play( pVDev, OBJ_END( pLayoutText, bIsSlow ), MTF_END );
//STRIP001 				UpdateVDevWithAnimations();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case( presentation::AnimationEffect_MOVE_FROM_LEFT ):
//STRIP001 			case( presentation::AnimationEffect_MOVE_FROM_UPPERLEFT ):
//STRIP001 			case( presentation::AnimationEffect_MOVE_FROM_TOP ):
//STRIP001 			case( presentation::AnimationEffect_MOVE_FROM_UPPERRIGHT ):
//STRIP001 			case( presentation::AnimationEffect_MOVE_FROM_RIGHT ):
//STRIP001 			case( presentation::AnimationEffect_MOVE_FROM_LOWERRIGHT ):
//STRIP001 			case( presentation::AnimationEffect_MOVE_FROM_BOTTOM ):
//STRIP001 			case( presentation::AnimationEffect_MOVE_FROM_LOWERLEFT ):
//STRIP001 			case( presentation::AnimationEffect_MOVE_SHORT_FROM_LEFT ):
//STRIP001 			case( presentation::AnimationEffect_MOVE_SHORT_FROM_UPPERLEFT ):
//STRIP001 			case( presentation::AnimationEffect_MOVE_SHORT_FROM_TOP ):
//STRIP001 			case( presentation::AnimationEffect_MOVE_SHORT_FROM_UPPERRIGHT ):
//STRIP001 			case( presentation::AnimationEffect_MOVE_SHORT_FROM_RIGHT ):
//STRIP001 			case( presentation::AnimationEffect_MOVE_SHORT_FROM_LOWERRIGHT ):
//STRIP001 			case( presentation::AnimationEffect_MOVE_SHORT_FROM_BOTTOM ):
//STRIP001 			case( presentation::AnimationEffect_MOVE_SHORT_FROM_LOWERLEFT ):
//STRIP001 			case( presentation::AnimationEffect_STRETCH_FROM_LEFT ):
//STRIP001 			case( presentation::AnimationEffect_STRETCH_FROM_UPPERLEFT ):
//STRIP001 			case( presentation::AnimationEffect_STRETCH_FROM_TOP ):
//STRIP001 			case( presentation::AnimationEffect_STRETCH_FROM_UPPERRIGHT ):
//STRIP001 			case( presentation::AnimationEffect_STRETCH_FROM_RIGHT ):
//STRIP001 			case( presentation::AnimationEffect_STRETCH_FROM_LOWERRIGHT ):
//STRIP001 			case( presentation::AnimationEffect_STRETCH_FROM_BOTTOM ):
//STRIP001 			case( presentation::AnimationEffect_STRETCH_FROM_LOWERLEFT ):
//STRIP001 			case( presentation::AnimationEffect_HORIZONTAL_STRETCH ):
//STRIP001 			case( presentation::AnimationEffect_VERTICAL_STRETCH ):
//STRIP001 			case( presentation::AnimationEffect_HORIZONTAL_ROTATE ):
//STRIP001 			case( presentation::AnimationEffect_VERTICAL_ROTATE ):
//STRIP001 			{
//STRIP001 				ExtOutputDevice aOut( pAnmVDev );
//STRIP001 				SdrPaintInfoRec aPaintInfoRec;
//STRIP001 
//STRIP001        		    // draw background till start of object to VDev
//STRIP001         		pMetaFile->Play( pVDev, MTF_START, OBJ_START( pLayoutText, bIsSlow ) );
//STRIP001 				UpdateVDevWithAnimations();
//STRIP001 				SetPaintModes( (SdrView*) pView, NULL, &aOut, &aPaintInfoRec );
//STRIP001 				pAnmVDev->SetDrawMode( pShowWindow->GetDrawMode() );
//STRIP001 
//STRIP001 				// create substitution bitmap
//STRIP001 				if( bIsCompoundLayoutText )
//STRIP001 				{
//STRIP001 					ExtOutputDevice aBackOut( pVDev );
//STRIP001 					SdrPaintInfoRec aPaintInfoRec;
//STRIP001 					SfxItemSet		aAttr( pDoc->GetPool(), XATTR_LINESTYLE, XATTR_LINESTYLE,
//STRIP001 															XATTR_FILLSTYLE, XATTR_FILLSTYLE, 0 );
//STRIP001 
//STRIP001 					// paint object without text into VDev
//STRIP001 					SdrRectObj*		pBackClone = (SdrRectObj*) pLayoutText->Clone();
//STRIP001  					const Rectangle	aLogicRect( pBackClone->GetLogicRect() );
//STRIP001 					
//STRIP001 					pVDev->SetDrawMode( pShowWindow->GetDrawMode() );
//STRIP001 					pBackClone->NbcSetOutlinerParaObject( NULL );
//STRIP001 					pBackClone->NbcSetLogicRect( aLogicRect );
//STRIP001 					SetPaintModes( (SdrView*) pView, NULL, &aBackOut, &aPaintInfoRec );
//STRIP001 					pBackClone->Paint( aBackOut, aPaintInfoRec );
//STRIP001 					delete pBackClone;
//STRIP001 
//STRIP001 					// create substitute for text
//STRIP001 					SdrRectObj*	pTextClone = (SdrRectObj*) pLayoutText->Clone();
//STRIP001 
//STRIP001     				aAttr.Set(pTextClone->GetItemSet());
//STRIP001 					aAttr.Put( XLineStyleItem( XLINE_NONE ) );
//STRIP001 					aAttr.Put( XFillStyleItem( XFILL_NONE ) );
//STRIP001 
//STRIP001 					pTextClone->SetItemSet(aAttr);
//STRIP001 					
//STRIP001 					pLayoutBmpEx = new BitmapEx( CreateReplacement( pTextClone, &aOut ) );
//STRIP001 					delete pTextClone;
//STRIP001 				}
//STRIP001 				else
//STRIP001 					pLayoutBmpEx = new BitmapEx( CreateReplacement( pLayoutText, &aOut ) );
//STRIP001 
//STRIP001 				pAnmVDev->SetDrawMode( DRAWMODE_DEFAULT );
//STRIP001 			}
//STRIP001 			break;
//STRIP001 			
//STRIP001 			default:
//STRIP001         		pMetaFile->Play( pVDev, MTF_START, OBJ_START( pLayoutText, bIsSlow ) );
//STRIP001             break;
//STRIP001 
//STRIP001 		}
//STRIP001 
//STRIP001 		pOutlInfo->SetTextObj( pDoc, pLayoutText, pAnmVDev );
//STRIP001 		pOutlInfo->SetExtraData( (const long) eEffect );
//STRIP001 	}
//STRIP001 
//STRIP001 	if( !bAbort )
//STRIP001 	{
//STRIP001 		Point		aUpperLeft( pActualPage->GetLftBorder(), pActualPage->GetUppBorder() );
//STRIP001 		Point		aLowerRight( pActualPage->GetSize().Width() - pActualPage->GetRgtBorder(),
//STRIP001 								 pActualPage->GetSize().Height() - pActualPage->GetLwrBorder() );
//STRIP001 		Rectangle	aClip( Rectangle( aUpperLeft, aLowerRight ) );
//STRIP001         Rectangle   aVDevRect( pAnmVDev->PixelToLogic( Point() ), pAnmVDev->GetOutputSize() );
//STRIP001 		Rectangle	aAnimRect;
//STRIP001 		ULONG		nNextParaPos = nParaPos + 1;
//STRIP001 
//STRIP001 		if( !nParaPos )
//STRIP001 		{
//STRIP001 			if( pOutlInfo->GetParaCount() == 1 )
//STRIP001 				aAnimRect = aVDevRect;
//STRIP001 			else
//STRIP001 			{
//STRIP001                 if( pOutlInfo->IsVertical() )
//STRIP001                 {
//STRIP001 				    aAnimRect.SetPos( Point( pOutlInfo->GetParaRect( 0 ).Left(), aVDevRect.Top() ) );
//STRIP001 				    aAnimRect.SetSize( Size( aVDevRect.Right() - pOutlInfo->GetParaRect( 0 ).Left() + 1, aVDevRect.GetHeight() ) );
//STRIP001                 }
//STRIP001                 else
//STRIP001                 {
//STRIP001 				    aAnimRect.SetPos( aVDevRect.TopLeft() );
//STRIP001 				    aAnimRect.SetSize( Size( aVDevRect.GetWidth(), pOutlInfo->GetParaRect( 0 ).Bottom() - aVDevRect.Top() + 1 ) );
//STRIP001                 }
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else if( nParaPos < ( pOutlInfo->GetParaCount() - 1 ) )
//STRIP001 		{
//STRIP001             if( pOutlInfo->IsVertical() )
//STRIP001             {
//STRIP001 			    aAnimRect.SetPos( Point( pOutlInfo->GetParaRect( nParaPos ).Left(), aVDevRect.Top() ) );
//STRIP001 				aAnimRect.SetSize( Size( pOutlInfo->GetParaRect( nParaPos ).GetWidth(), aVDevRect.GetHeight() ) );
//STRIP001             }
//STRIP001             else
//STRIP001             {
//STRIP001 			    aAnimRect.SetPos( Point( aVDevRect.Left(), pOutlInfo->GetParaRect( nParaPos ).Top() ) );
//STRIP001 			    aAnimRect.SetSize( Size( aVDevRect.GetWidth(), pOutlInfo->GetParaRect( nParaPos ).GetHeight() ) );
//STRIP001             }
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001             if( pOutlInfo->IsVertical() )
//STRIP001             {
//STRIP001 			    aAnimRect.SetPos( aVDevRect.TopLeft() );
//STRIP001 				aAnimRect.SetSize( Size( pOutlInfo->GetParaRect( nParaPos ).Right() - aVDevRect.Left() + 1, aVDevRect.GetHeight() ) );
//STRIP001             }
//STRIP001             else
//STRIP001             {
//STRIP001 			    aAnimRect.SetPos( Point( aVDevRect.Left(), pOutlInfo->GetParaRect( nParaPos ).Top() ) );
//STRIP001 			    aAnimRect.SetSize( Size( aVDevRect.GetWidth(), aVDevRect.Bottom() - pOutlInfo->GetParaRect( nParaPos ).Top() + 1 ) );
//STRIP001             }
//STRIP001 		}
//STRIP001 
//STRIP001 		while( ( nNextParaPos < pOutlInfo->GetParaCount() ) && !pOutlInfo->GetParaCharCount( nNextParaPos ) )
//STRIP001 		{
//STRIP001    			Size                aSize( aAnimRect.GetSize() );
//STRIP001             const Rectangle&    rNextRect = pOutlInfo->GetParaRect( nNextParaPos++ );
//STRIP001 
//STRIP001             if( pOutlInfo->IsVertical() )
//STRIP001             {
//STRIP001 			    aAnimRect.SetPos( Point( rNextRect.Left(), aVDevRect.Top() ) );
//STRIP001                 aSize.Width() += rNextRect.GetWidth();
//STRIP001             }
//STRIP001             else
//STRIP001     			aSize.Height() += rNextRect.GetHeight();
//STRIP001 
//STRIP001    			aAnimRect.SetSize( aSize );
//STRIP001 		}
//STRIP001 
//STRIP001 		Point   aStart, aEnd( aAnimRect.TopLeft() );
//STRIP001         double	fStartScaleX = 1.0, fEndScaleX = 1.0, fStartScaleY = 1.0, fEndScaleY = 1.0;
//STRIP001 
//STRIP001 		switch( eEffect )
//STRIP001 		{
//STRIP001 			case presentation::AnimationEffect_MOVE_FROM_LEFT:
//STRIP001 			case presentation::AnimationEffect_MOVE_FROM_UPPERLEFT:
//STRIP001 			case presentation::AnimationEffect_MOVE_FROM_TOP:
//STRIP001 			case presentation::AnimationEffect_MOVE_FROM_UPPERRIGHT:
//STRIP001 			case presentation::AnimationEffect_MOVE_FROM_RIGHT :
//STRIP001 			case presentation::AnimationEffect_MOVE_FROM_LOWERRIGHT:
//STRIP001 			case presentation::AnimationEffect_MOVE_FROM_BOTTOM:
//STRIP001 			case presentation::AnimationEffect_MOVE_FROM_LOWERLEFT:
//STRIP001 			case presentation::AnimationEffect_MOVE_SHORT_FROM_LEFT:
//STRIP001 			case presentation::AnimationEffect_MOVE_SHORT_FROM_UPPERLEFT:
//STRIP001 			case presentation::AnimationEffect_MOVE_SHORT_FROM_TOP:
//STRIP001 			case presentation::AnimationEffect_MOVE_SHORT_FROM_UPPERRIGHT:
//STRIP001 			case presentation::AnimationEffect_MOVE_SHORT_FROM_RIGHT:
//STRIP001 			case presentation::AnimationEffect_MOVE_SHORT_FROM_LOWERRIGHT:
//STRIP001 			case presentation::AnimationEffect_MOVE_SHORT_FROM_BOTTOM:
//STRIP001 			case presentation::AnimationEffect_MOVE_SHORT_FROM_LOWERLEFT:
//STRIP001 			case presentation::AnimationEffect_STRETCH_FROM_LEFT:
//STRIP001 			case presentation::AnimationEffect_STRETCH_FROM_UPPERLEFT:
//STRIP001 			case presentation::AnimationEffect_STRETCH_FROM_TOP:
//STRIP001 			case presentation::AnimationEffect_STRETCH_FROM_UPPERRIGHT:
//STRIP001 			case presentation::AnimationEffect_STRETCH_FROM_RIGHT:
//STRIP001 			case presentation::AnimationEffect_STRETCH_FROM_LOWERRIGHT:
//STRIP001 			case presentation::AnimationEffect_STRETCH_FROM_BOTTOM:
//STRIP001 			case presentation::AnimationEffect_STRETCH_FROM_LOWERLEFT:
//STRIP001 			case presentation::AnimationEffect_HORIZONTAL_STRETCH:
//STRIP001 			case presentation::AnimationEffect_VERTICAL_STRETCH:
//STRIP001 			case presentation::AnimationEffect_HORIZONTAL_ROTATE:
//STRIP001 			case presentation::AnimationEffect_VERTICAL_ROTATE:
//STRIP001 			{
//STRIP001 				switch( eEffect )
//STRIP001 				{				 
//STRIP001 					case presentation::AnimationEffect_MOVE_FROM_LEFT:
//STRIP001 						aStart.X() = aUpperLeft.X() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 						aStart.Y() = aEnd.Y();
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_MOVE_FROM_UPPERLEFT:
//STRIP001 						aStart.X() = aUpperLeft.X() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 						aStart.Y() = aUpperLeft.Y() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_MOVE_FROM_TOP:
//STRIP001 						aStart.X() = aEnd.X();
//STRIP001 						aStart.Y() = aUpperLeft.Y() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_MOVE_FROM_UPPERRIGHT:
//STRIP001 						aStart.X() = aLowerRight.X();
//STRIP001 						aStart.Y() = aUpperLeft.Y() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_MOVE_FROM_RIGHT:
//STRIP001 						aStart.X() = aLowerRight.X();
//STRIP001 						aStart.Y() = aEnd.Y();
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_MOVE_FROM_LOWERRIGHT:
//STRIP001 						aStart.X() = aLowerRight.X();
//STRIP001 						aStart.Y() = aLowerRight.Y();
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_MOVE_FROM_BOTTOM:
//STRIP001 						aStart.X() = aEnd.X();
//STRIP001 						aStart.Y() = aLowerRight.Y();
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_MOVE_FROM_LOWERLEFT:
//STRIP001 						aStart.X() = aUpperLeft.X() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 						aStart.Y() = aLowerRight.Y();
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_MOVE_SHORT_FROM_LEFT:
//STRIP001 						aStart.X() = aAnimRect.Left() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 						aStart.Y() = aEnd.Y();
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_MOVE_SHORT_FROM_UPPERLEFT:
//STRIP001 						aStart.X() = aAnimRect.Left() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 						aStart.Y() = aAnimRect.Top() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_MOVE_SHORT_FROM_TOP:
//STRIP001 						aStart.X() = aEnd.X();
//STRIP001 						aStart.Y() = aAnimRect.Top() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_MOVE_SHORT_FROM_UPPERRIGHT:
//STRIP001 						aStart.X() = aAnimRect.Right();
//STRIP001 						aStart.Y() = aAnimRect.Top() - aAnimRect.GetHeight() - ( aTolSize.Height() << 1 );
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_MOVE_SHORT_FROM_RIGHT:
//STRIP001 						aStart.X() = aAnimRect.Right();
//STRIP001 						aStart.Y() = aEnd.Y();
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_MOVE_SHORT_FROM_LOWERRIGHT:
//STRIP001 						aStart.X() = aAnimRect.Right();
//STRIP001 						aStart.Y() = aAnimRect.Bottom();
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_MOVE_SHORT_FROM_BOTTOM:
//STRIP001 						aStart.X() = aEnd.X();
//STRIP001 						aStart.Y() = aAnimRect.Bottom();
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_MOVE_SHORT_FROM_LOWERLEFT:
//STRIP001 						aStart.X() = aAnimRect.Left() - aAnimRect.GetWidth() - ( aTolSize.Width() << 1 );
//STRIP001 						aStart.Y() = aAnimRect.Bottom();
//STRIP001 					break;
//STRIP001 
//STRIP001 					// ----
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_STRETCH_FROM_LEFT:
//STRIP001 						aStart = aEnd;
//STRIP001 						fStartScaleX = 0.0;
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_STRETCH_FROM_UPPERLEFT:
//STRIP001 						aStart = aEnd;
//STRIP001 						fStartScaleX = fStartScaleY = 0.0;
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_STRETCH_FROM_TOP:
//STRIP001 						aStart = aEnd;
//STRIP001 						fStartScaleY = 0.0;
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_STRETCH_FROM_UPPERRIGHT:
//STRIP001 						aStart = aAnimRect.TopRight();
//STRIP001 						fStartScaleX = fStartScaleY = 0.0;
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_STRETCH_FROM_RIGHT:
//STRIP001 						aStart.X() = aAnimRect.Right();
//STRIP001 						aStart.Y() = aEnd.Y();
//STRIP001 						fStartScaleX = 0.0;
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_STRETCH_FROM_LOWERRIGHT:
//STRIP001 						aStart.X() = aAnimRect.Right();
//STRIP001 						aStart.Y() = aAnimRect.Bottom();
//STRIP001 						fStartScaleX = fStartScaleY = 0.0;
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_STRETCH_FROM_BOTTOM:
//STRIP001 						aStart.X() = aEnd.X();
//STRIP001 						aStart.Y() = aAnimRect.Bottom();
//STRIP001 						fStartScaleY = 0.0;
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_STRETCH_FROM_LOWERLEFT:
//STRIP001 						aStart.X() = aEnd.X();
//STRIP001 						aStart.Y() = aAnimRect.Bottom();
//STRIP001 						fStartScaleX = fStartScaleY = 0.0;
//STRIP001 					break;
//STRIP001 
//STRIP001 					// ----
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_HORIZONTAL_STRETCH:
//STRIP001 					case presentation::AnimationEffect_HORIZONTAL_ROTATE:
//STRIP001 						aStart.X() = aAnimRect.Center().X();
//STRIP001 						aStart.Y() = aEnd.Y();
//STRIP001 						fStartScaleX = 0.0;
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_VERTICAL_STRETCH:
//STRIP001 					case presentation::AnimationEffect_VERTICAL_ROTATE:
//STRIP001 						aStart.X() = aEnd.X();
//STRIP001 						aStart.Y() = aAnimRect.Center().Y();
//STRIP001 						fStartScaleY = 0.0;
//STRIP001 					break;
//STRIP001 				}
//STRIP001 
//STRIP001 				if( bAbort )
//STRIP001 					HandleError( STR_NOT_ENOUGH_MEMORY );
//STRIP001 				else
//STRIP001 				{
//STRIP001 					List				aListOfImages;
//STRIP001 					Rectangle			aTextRectPix( pAnmVDev->LogicToPixel( aAnimRect.TopLeft() ), 
//STRIP001 													  pAnmVDev->LogicToPixel( aAnimRect.GetSize() ) );
//STRIP001 					const BOOL			bSlow = GetSlowObjRecord( pLayoutText ) != NULL;
//STRIP001 					const Marker		aStartMarker( OBJ_START( pLayoutText, bSlow ) );
//STRIP001 					const Marker		aEndMarker( OBJ_END( pLayoutText, bSlow ) );
//STRIP001 					const Size			aTextRectSize( aTextRectPix.GetSize() );
//STRIP001 					VirtualDevice*		pCropVDev = new VirtualDevice;
//STRIP001 					BitmapEx*			pPartBmpEx;
//STRIP001 
//STRIP001 					// get cropped bitmap
//STRIP001 					if( pCropVDev->SetOutputSizePixel( aTextRectSize ) )
//STRIP001 					{
//STRIP001 						Bitmap aPaint, aMask;
//STRIP001 
//STRIP001 						pCropVDev->DrawBitmap( Point(), aTextRectSize, aTextRectPix.TopLeft(), aTextRectSize, pLayoutBmpEx->GetBitmap() );
//STRIP001 						aPaint = pCropVDev->GetBitmap( Point(), aTextRectSize );
//STRIP001 
//STRIP001 						if( pLayoutBmpEx->IsTransparent() )
//STRIP001 						{
//STRIP001 							pCropVDev->DrawBitmap( Point(), aTextRectSize, aTextRectPix.TopLeft(), aTextRectSize, pLayoutBmpEx->GetMask() );
//STRIP001 							aMask = pCropVDev->GetBitmap( Point(), aTextRectSize );
//STRIP001 						}
//STRIP001 
//STRIP001 						pPartBmpEx = new BitmapEx( aPaint, aMask );
//STRIP001 						delete pCropVDev;
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{	
//STRIP001 						delete pCropVDev;
//STRIP001 						pPartBmpEx = new BitmapEx( *pLayoutBmpEx );
//STRIP001 						pPartBmpEx->Crop( aTextRectPix );
//STRIP001 					}
//STRIP001 
//STRIP001 					aListOfImages.Insert( pPartBmpEx );
//STRIP001 					pVDev->SetDrawMode( pShowWindow->GetDrawMode() );
//STRIP001 
//STRIP001 					if( presentation::AnimationEffect_MOVE_SHORT_FROM_LEFT == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_FROM_UPPERLEFT == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_FROM_TOP == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_FROM_UPPERRIGHT == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_FROM_RIGHT == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_FROM_LOWERRIGHT == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_FROM_BOTTOM == eEffect ||
//STRIP001 						presentation::AnimationEffect_MOVE_SHORT_FROM_LOWERLEFT == eEffect ||
//STRIP001 
//STRIP001 						presentation::AnimationEffect_STRETCH_FROM_LEFT == eEffect ||
//STRIP001 						presentation::AnimationEffect_STRETCH_FROM_UPPERLEFT == eEffect ||
//STRIP001 						presentation::AnimationEffect_STRETCH_FROM_TOP == eEffect ||
//STRIP001 						presentation::AnimationEffect_STRETCH_FROM_UPPERRIGHT == eEffect ||
//STRIP001 						presentation::AnimationEffect_STRETCH_FROM_RIGHT == eEffect ||
//STRIP001 						presentation::AnimationEffect_STRETCH_FROM_LOWERRIGHT == eEffect ||
//STRIP001 						presentation::AnimationEffect_STRETCH_FROM_BOTTOM == eEffect ||
//STRIP001 						presentation::AnimationEffect_STRETCH_FROM_LOWERLEFT == eEffect ||
//STRIP001 
//STRIP001 						presentation::AnimationEffect_HORIZONTAL_STRETCH == eEffect ||
//STRIP001 						presentation::AnimationEffect_VERTICAL_STRETCH == eEffect ||
//STRIP001 
//STRIP001 						presentation::AnimationEffect_HORIZONTAL_ROTATE == eEffect ||
//STRIP001 						presentation::AnimationEffect_VERTICAL_ROTATE == eEffect )
//STRIP001 					{
//STRIP001 						pMover->SetClipRegion( aAnimRect );
//STRIP001 					}
//STRIP001 					else
//STRIP001 						pMover->SetClipRegion( aClip );
//STRIP001 
//STRIP001 					pMover->SetGraphicInfo( pVDev, &pMetaFile, aStartMarker, aEndMarker );
//STRIP001 					pMover->SetListOfImages( &aListOfImages );
//STRIP001 					pMover->SetSpeed( SpeedAToM( eSpeed ), 1 );
//STRIP001 					pMover->SetPath( aStart, aEnd, &fStartScaleX, &fEndScaleX, &fStartScaleY, &fEndScaleY );
//STRIP001 
//STRIP001 					if( pInfo->bSoundOn )
//STRIP001 					{
//STRIP001 						bPlayFull = pInfo->bPlayFull;
//STRIP001 						StartSound( pInfo->aSoundFile );
//STRIP001 					}
//STRIP001 
//STRIP001 					bAbort = !pMover->Move();
//STRIP001 
//STRIP001 					if( !bAbort && 
//STRIP001 						eEffect == presentation::AnimationEffect_HORIZONTAL_ROTATE || 
//STRIP001 						eEffect == presentation::AnimationEffect_VERTICAL_ROTATE )
//STRIP001 					{
//STRIP001 						const Point	aMediumPos( aStart ), aFinalPos( aEnd );
//STRIP001 
//STRIP001 						for( long i = 0; ( i < 4 ) && !bAbort; i++ )
//STRIP001 						{
//STRIP001 							const BOOL		bOdd = ( ( i & 1 ) != 0 );
//STRIP001 							const Point*	pStart = bOdd ? &aMediumPos : &aFinalPos;
//STRIP001 							const Point*	pEnd = bOdd ? &aFinalPos : &aMediumPos;
//STRIP001 
//STRIP001 							if( eEffect == presentation::AnimationEffect_HORIZONTAL_ROTATE )
//STRIP001 							{
//STRIP001 								fStartScaleX = bOdd ? 0.0 : 1.0;
//STRIP001 								fEndScaleX = bOdd ? 1.0 : 0.0;
//STRIP001 							}
//STRIP001 							else
//STRIP001 							{
//STRIP001 								fStartScaleY = bOdd ? 0.0 : 1.0;
//STRIP001 								fEndScaleY = bOdd ? 1.0 : 0.0;
//STRIP001 							}
//STRIP001 
//STRIP001 							pMover->SetPath( *pStart, *pEnd, &fStartScaleX, &fEndScaleX, &fStartScaleY, &fEndScaleY );
//STRIP001 							bAbort = !pMover->Move();
//STRIP001 
//STRIP001                             if( nMagic != SLIDESHOW_MAGIC )
//STRIP001                             {
//STRIP001                                 break;
//STRIP001                             }
//STRIP001 						}
//STRIP001 					}
//STRIP001 
//STRIP001                     if( nMagic != SLIDESHOW_MAGIC )
//STRIP001 					{
//STRIP001 						delete (BitmapEx*) aListOfImages.First();
//STRIP001 						return TRUE;
//STRIP001 					}
//STRIP001 					else
//STRIP001 						pVDev->DrawBitmapEx( aAnimRect.TopLeft(), *(BitmapEx*) aListOfImages.First() );
//STRIP001 
//STRIP001 					pVDev->SetDrawMode( DRAWMODE_DEFAULT );
//STRIP001 					delete (BitmapEx*) aListOfImages.First();
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case presentation::AnimationEffect_APPEAR:
//STRIP001 			case presentation::AnimationEffect_FADE_FROM_LEFT:
//STRIP001 			case presentation::AnimationEffect_FADE_FROM_UPPERLEFT:
//STRIP001 			case presentation::AnimationEffect_FADE_FROM_TOP:
//STRIP001 			case presentation::AnimationEffect_FADE_FROM_UPPERRIGHT:
//STRIP001 			case presentation::AnimationEffect_FADE_FROM_RIGHT:
//STRIP001 			case presentation::AnimationEffect_FADE_FROM_LOWERRIGHT:
//STRIP001 			case presentation::AnimationEffect_FADE_FROM_BOTTOM:
//STRIP001 			case presentation::AnimationEffect_FADE_FROM_LOWERLEFT:
//STRIP001 			case presentation::AnimationEffect_FADE_TO_CENTER:
//STRIP001 			case presentation::AnimationEffect_FADE_FROM_CENTER:
//STRIP001 			case presentation::AnimationEffect_VERTICAL_STRIPES:
//STRIP001 			case presentation::AnimationEffect_HORIZONTAL_STRIPES:
//STRIP001 			case presentation::AnimationEffect_VERTICAL_LINES:
//STRIP001 			case presentation::AnimationEffect_HORIZONTAL_LINES:
//STRIP001 			case presentation::AnimationEffect_VERTICAL_CHECKERBOARD:
//STRIP001 			case presentation::AnimationEffect_HORIZONTAL_CHECKERBOARD:
//STRIP001 			case presentation::AnimationEffect_CLOCKWISE:
//STRIP001 			case presentation::AnimationEffect_COUNTERCLOCKWISE:
//STRIP001 			case presentation::AnimationEffect_CLOSE_VERTICAL:
//STRIP001 			case presentation::AnimationEffect_CLOSE_HORIZONTAL:
//STRIP001 			case presentation::AnimationEffect_OPEN_VERTICAL:
//STRIP001 			case presentation::AnimationEffect_OPEN_HORIZONTAL:
//STRIP001 			case presentation::AnimationEffect_SPIRALIN_LEFT:
//STRIP001 			case presentation::AnimationEffect_SPIRALIN_RIGHT:
//STRIP001 			case presentation::AnimationEffect_SPIRALOUT_LEFT:
//STRIP001 			case presentation::AnimationEffect_SPIRALOUT_RIGHT:
//STRIP001 			case presentation::AnimationEffect_DISSOLVE:
//STRIP001 			case presentation::AnimationEffect_WAVYLINE_FROM_LEFT:
//STRIP001 			case presentation::AnimationEffect_WAVYLINE_FROM_TOP:
//STRIP001 			case presentation::AnimationEffect_WAVYLINE_FROM_RIGHT:
//STRIP001 			case presentation::AnimationEffect_WAVYLINE_FROM_BOTTOM:
//STRIP001 			{
//STRIP001 				aAnimRect.Intersection( aClip );
//STRIP001 				pFader->SetNewVirtualDevice( pAnmVDev );
//STRIP001 				pFader->SetTarget( aAnimRect );
//STRIP001 				pFader->SetSource( aAnimRect );
//STRIP001 				pFader->SetSpeed( SpeedAToF( eSpeed ) );
//STRIP001 				pFader->SetEffect( EffectAToF( eEffect ) );
//STRIP001 
//STRIP001 				if( pInfo->bSoundOn )
//STRIP001 				{
//STRIP001 					bPlayFull = pInfo->bPlayFull;
//STRIP001 					StartSound(pInfo->aSoundFile);
//STRIP001 				}
//STRIP001 
//STRIP001 				pFader->Fade();
//STRIP001 				
//STRIP001 				if( nMagic != SLIDESHOW_MAGIC )
//STRIP001 					return TRUE;
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 			case presentation::AnimationEffect_LASER_FROM_LEFT:
//STRIP001 			case presentation::AnimationEffect_LASER_FROM_UPPERLEFT:
//STRIP001 			case presentation::AnimationEffect_LASER_FROM_TOP:
//STRIP001 			case presentation::AnimationEffect_LASER_FROM_UPPERRIGHT:
//STRIP001 			case presentation::AnimationEffect_LASER_FROM_RIGHT:
//STRIP001 			case presentation::AnimationEffect_LASER_FROM_LOWERRIGHT:
//STRIP001 			case presentation::AnimationEffect_LASER_FROM_BOTTOM:
//STRIP001 			case presentation::AnimationEffect_LASER_FROM_LOWERLEFT:
//STRIP001 			{
//STRIP001 				Point		aStart;
//STRIP001 				Rectangle	aPageRect( aPageOrigin, aPageSize );
//STRIP001 
//STRIP001 				switch( eEffect )
//STRIP001 				{
//STRIP001 					case presentation::AnimationEffect_LASER_FROM_LEFT:
//STRIP001 						aStart = aPageRect.LeftCenter();
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_LASER_FROM_UPPERLEFT:
//STRIP001 						aStart = aPageRect.TopLeft();
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_LASER_FROM_TOP:
//STRIP001 						aStart = aPageRect.TopCenter();
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_LASER_FROM_UPPERRIGHT:
//STRIP001 						aStart = aPageRect.TopRight();
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_LASER_FROM_RIGHT:
//STRIP001 						aStart = aPageRect.RightCenter();
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_LASER_FROM_LOWERRIGHT:
//STRIP001 						aStart = aPageRect.BottomRight();
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_LASER_FROM_BOTTOM:
//STRIP001 						aStart = aPageRect.BottomCenter();
//STRIP001 					break;
//STRIP001 
//STRIP001 					case presentation::AnimationEffect_LASER_FROM_LOWERLEFT:
//STRIP001 						aStart = aPageRect.BottomLeft();
//STRIP001 					break;
//STRIP001 				}
//STRIP001 
//STRIP001 				bFullBckgnd = TRUE;
//STRIP001                 bAbort = !LaserEffect( (SdrRectObj*) pLayoutText, (USHORT) nParaPos, aStart );
//STRIP001 
//STRIP001                 // im Reschedule des Effekts zerstoert?
//STRIP001                 if( nMagic != SLIDESHOW_MAGIC )
//STRIP001                     return TRUE;
//STRIP001             }
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		// naechster Gliederungspunkt
//STRIP001 		nParaPos = nNextParaPos;
//STRIP001 
//STRIP001 		// altes Clipping des LayoutClones jetzt ungueltig
//STRIP001 		delete pLayoutClip;
//STRIP001 		pLayoutClip = NULL;
//STRIP001 
//STRIP001 		// Textposition weitersetzen
//STRIP001 		aDimRect = aAnimRect;
//STRIP001 
//STRIP001 		// wenn das der letzte Absatz war
//STRIP001 		if( nParaPos == pOutlInfo->GetParaCount() )
//STRIP001 		{
//STRIP001  			delete pMskVDev, pMskVDev = NULL;
//STRIP001  			delete pTopLayer, pTopLayer = NULL;
//STRIP001 
//STRIP001 			pOutlInfo->Clear();
//STRIP001 			pCurAnmList->Remove( (ULONG) 0 ); // das Gliederungsobjekt austragen
//STRIP001 
//STRIP001             // wenn die Gliederung auf Klick verschwinden kann
//STRIP001             if( pInfo->bDimHide )
//STRIP001                 pHideObject = pLayoutText;
//STRIP001 
//STRIP001 			delete pLayoutBmpEx;
//STRIP001 			pLayoutBmpEx = NULL;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return !bAbort;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL FuSlideShow::LaserEffect( SdrRectObj* pObject, USHORT nPara, const Point& rStart )
//STRIP001 {
//STRIP001 	SdAnimationInfo*	pInfo = pDoc->GetAnimationInfo( pObject );
//STRIP001 	Rectangle			aObjRect( pObject->GetBoundRect() );
//STRIP001 	Point				aPos;
//STRIP001 	Size				aSize;
//STRIP001 	Size				aTolSize( pShowWindow->PixelToLogic( Size( VDEV_TOLERANCE, VDEV_TOLERANCE ) ) );
//STRIP001 	USHORT				nParaCount = 0;
//STRIP001 	BOOL				bText = pObject->GetOutlinerParaObject() != NULL;
//STRIP001 	BOOL				bIsSlow = (GetSlowObjRecord( pObject ) != NULL );
//STRIP001 	BOOL				bAbort = FALSE;
//STRIP001 
//STRIP001 	// Animationsdevice initialisieren
//STRIP001 	if( !nPara || ( LASER_ALL_PARAS == nPara ) )
//STRIP001 	{
//STRIP001 		bAbort = !AdjustAnmVDev( aObjRect, COL_WHITE );
//STRIP001 
//STRIP001 		// Hintergrund und Objektflaeche ohne Text einblenden
//STRIP001 		if( !bAbort )
//STRIP001 		{
//STRIP001 			ExtOutputDevice aOut( pVDev );
//STRIP001 			SdrPaintInfoRec aPaintInfoRec;
//STRIP001 			SdrObject*		pClone = pObject->Clone();
//STRIP001 			const Rectangle	aLogicRect( pClone->GetLogicRect() );
//STRIP001 
//STRIP001 			SetPaintModes( (SdrView*) pView, NULL, &aOut, &aPaintInfoRec );
//STRIP001 			aPos = Point( aObjRect.Left() - aTolSize.Width(), aObjRect.Top() - aTolSize.Height() );
//STRIP001 			aSize = pAnmVDev->GetOutputSize();
//STRIP001 
//STRIP001 			pClone->NbcSetOutlinerParaObject( NULL );
//STRIP001 			pClone->NbcSetLogicRect( aLogicRect );
//STRIP001 			pMetaFile->Play( pVDev, MTF_START, OBJ_START( pObject, bIsSlow ) );
//STRIP001 			UpdateVDevWithAnimations();
//STRIP001 			pVDev->SetDrawMode( pShowWindow->GetDrawMode() );
//STRIP001 			pClone->Paint( aOut, aPaintInfoRec );
//STRIP001 			pVDev->SetDrawMode( DRAWMODE_DEFAULT );
//STRIP001 			delete pClone;
//STRIP001 
//STRIP001 			// TopLayer erzeugen
//STRIP001 			if( !CreateTopLayer( pVDev, OBJ_END( pObject, bIsSlow ), MTF_END ) )
//STRIP001 				bAbort = TRUE;
//STRIP001 		}
//STRIP001 
//STRIP001 		// Den Text des Objekts ohne Rand und Flaeche ins Animationsdevice zeichnen.
//STRIP001 		if( bText && !bAbort )
//STRIP001 		{
//STRIP001 			const Color		aBlack( COL_BLACK );
//STRIP001 			ExtOutputDevice aOut( pAnmVDev );
//STRIP001 			SdrPaintInfoRec aPaintInfoRec;
//STRIP001 			SdrObject*		pClone = pObject->Clone();
//STRIP001 			SfxItemSet		aPntAttr( pDoc->GetPool(), XATTR_FILLSTYLE, XATTR_FILLSTYLE, 
//STRIP001 													   XATTR_LINESTYLE, XATTR_LINESTYLE, 
//STRIP001 													   0 );
//STRIP001 			SfxItemSet		aMskAttr( pDoc->GetPool(), SDRATTR_SHADOWCOLOR, SDRATTR_SHADOWCOLOR, 0 );
//STRIP001 	        USHORT          nOldAntialiasing;
//STRIP001 
//STRIP001 			SetPaintModes((SdrView*)pView, NULL, &aOut, &aPaintInfoRec);
//STRIP001 		
//STRIP001 			// Hintergrund und Rand dieses Clones transparent machen
//STRIP001 			aPntAttr.Set(pClone->GetItemSet());
//STRIP001 
//STRIP001 			aPntAttr.Put( XLineStyleItem( XLINE_NONE ) );
//STRIP001 			aPntAttr.Put( XFillStyleItem( XFILL_NONE ) );
//STRIP001 
//STRIP001 			pClone->SetItemSet(aPntAttr);
//STRIP001 
//STRIP001 			// bei Grafikobjekten einfach die Grafik am Clone zuruecksetzen
//STRIP001 			if( pObject->ISA( SdrGrafObj ) )
//STRIP001 				( (SdrGrafObj*) pClone )->SetGraphic( Graphic() );
//STRIP001 
//STRIP001 			pAnmVDev->SetDrawMode( pShowWindow->GetDrawMode() );
//STRIP001             nOldAntialiasing = pAnmVDev->GetAntialiasing();
//STRIP001             pAnmVDev->SetAntialiasing( ANTIALIASING_DISABLE_TEXT );
//STRIP001 			pClone->Paint( aOut, aPaintInfoRec );
//STRIP001 			pAnmVDev->SetDrawMode( DRAWMODE_DEFAULT );
//STRIP001 			pAnmVDev->SetAntialiasing( nOldAntialiasing );
//STRIP001 
//STRIP001 			// Zeichen- und Schattenfarbe fuer Maske auf Schwarz setzen
//STRIP001 			aMskAttr.Set(pClone->GetItemSet());
//STRIP001 			aMskAttr.Put( SdrShadowColorItem( String(), aBlack ) );
//STRIP001 			pClone->SetItemSet( aMskAttr );
//STRIP001 			
//STRIP001 			pMskVDev = new VirtualDevice( *pAnmVDev, 1 );
//STRIP001 			nOldAntialiasing = pMskVDev->GetAntialiasing();
//STRIP001             pMskVDev->SetAntialiasing( ANTIALIASING_DISABLE_TEXT );
//STRIP001 			pMskVDev->SetMapMode( pAnmVDev->GetMapMode() );
//STRIP001 			pMskVDev->SetOutputSize( pAnmVDev->GetOutputSize() );
//STRIP001 			pMskVDev->SetDrawMode( DRAWMODE_BLACKTEXT );
//STRIP001 			aOut.SetOutDev( pMskVDev );
//STRIP001 			SetPaintModes((SdrView*)pView, NULL, &aOut, &aPaintInfoRec);
//STRIP001 			pClone->Paint( aOut, aPaintInfoRec );
//STRIP001 			pMskVDev->SetDrawMode( DRAWMODE_DEFAULT );
//STRIP001 			pMskVDev->SetAntialiasing( nOldAntialiasing );
//STRIP001 			
//STRIP001 			delete pClone;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	// Falls dies ein Gliederungstext ist und nicht dessen erster Absatz, so
//STRIP001 	// koennten die vorhergehenden Absaetze abgeblendet worden sein. Dann
//STRIP001 	// muss das Image ebenfalls mit der Abblendung versehen werden.
//STRIP001 	else if( pObject == pLayoutText && pInfo->bDimmed )
//STRIP001 		PaintLayoutClone( pVDev );
//STRIP001 
//STRIP001 	if( bText && !bAbort )
//STRIP001 	{
//STRIP001 		nParaCount = (USHORT) pObject->GetOutlinerParaObject()->Count();
//STRIP001 		nParaCount = ( nPara != LASER_ALL_PARAS ) ? ( nPara + 1 ) : 0;
//STRIP001 
//STRIP001 		List			aListOfImages;
//STRIP001 		Point			aUpperLeft( pActualPage->GetLftBorder(), pActualPage->GetUppBorder() );
//STRIP001 		Point			aLowerRight( pActualPage->GetSize().Width() - pActualPage->GetRgtBorder(),
//STRIP001 									 pActualPage->GetSize().Height() - pActualPage->GetLwrBorder() );
//STRIP001 		const Marker	aObjStartMarker( OBJ_START( pObject, bIsSlow ) );
//STRIP001 		const Marker	aObjEndMarker( OBJ_END( pObject, bIsSlow ) );
//STRIP001 		Rectangle		aAncRect;
//STRIP001 		Point			aRotOffset;
//STRIP001 		const GeoStat&	rGeo = pObject->GetGeoStat();
//STRIP001 
//STRIP001 		// Grundeinstellungen fuer Mover
//STRIP001 		if( !bAbort ) 
//STRIP001 		{	
//STRIP001 			pMover->SetSpeed( SpeedAToM( pInfo->eSpeed ), 4 );
//STRIP001 			pMover->SetClipRegion( Rectangle( aUpperLeft, aLowerRight ) );
//STRIP001 		}
//STRIP001 
//STRIP001 		// Drehung rueckgaengig
//STRIP001 		if( rGeo.nDrehWink )
//STRIP001 		{
//STRIP001 			pObject->TakeTextAnchorRect( aAncRect );
//STRIP001 			aRotOffset = pOutlInfo->GetTextOffset();
//STRIP001 			RotatePoint( aRotOffset, aAncRect.TopLeft(), -rGeo.nSin, rGeo.nCos );
//STRIP001 			aRotOffset -= pOutlInfo->GetTextOffset();
//STRIP001 		}
//STRIP001 
//STRIP001 		// Buchstaben aller Absaetze hereinfliegen lassen
//STRIP001 		for( USHORT nCurPara = nPara; nCurPara < nParaCount && !bAbort; nCurPara++ )
//STRIP001 		{
//STRIP001 			OutlinerCharacter* pChar = pOutlInfo->GetFirstCharacter();
//STRIP001 
//STRIP001 			// erst einmal bis auf den aktuellen Absatz kommen
//STRIP001 			while( pChar && pChar->nPara < nCurPara )
//STRIP001 				pChar = pOutlInfo->GetNextCharacter();
//STRIP001 
//STRIP001 			// und auswerten
//STRIP001 			while( !bAbort && pChar && pChar->nPara == nCurPara )
//STRIP001 			{
//STRIP001 				// #101500# nCharCode was removed for BiDi; now all single spaces
//STRIP001 				// are simply not created.
//STRIP001 				//if( pChar->nCharCode != 32 )
//STRIP001 				Rectangle aCharRect( pChar->aRect );
//STRIP001 
//STRIP001 				// ggf. Drehung beruecksichtigen
//STRIP001 				if( rGeo.nDrehWink )
//STRIP001 				{
//STRIP001 					aCharRect.Move( aRotOffset.X(), aRotOffset.Y() );
//STRIP001 
//STRIP001 					VirtualDevice	aRotVDev( (OutputDevice&) *pAnmVDev );
//STRIP001 					Polygon			aCharPoly( aCharRect );
//STRIP001 					Polygon			aPixPoly;
//STRIP001 					Rectangle		aPixBound;
//STRIP001 					Size			aSizePix;	
//STRIP001 					
//STRIP001 					RotatePoly( aCharPoly, aAncRect.TopLeft(), rGeo.nSin, rGeo.nCos );
//STRIP001 					aCharRect = aCharPoly.GetBoundRect();
//STRIP001 					aPixPoly = pAnmVDev->LogicToPixel( aCharPoly );
//STRIP001 					aPixBound = aPixPoly.GetBoundRect();
//STRIP001 					aPixPoly.Move( -aPixBound.TopLeft().X(), -aPixBound.TopLeft().Y() );
//STRIP001 					aRotVDev.SetOutputSizePixel( aSizePix = pAnmVDev->LogicToPixel( aCharRect.GetSize() ) );
//STRIP001 					aRotVDev.SetClipRegion( aPixPoly );
//STRIP001 					
//STRIP001 					aRotVDev.DrawOutDev( Point(), aSizePix, aCharRect.TopLeft(), aCharRect.GetSize(), *pAnmVDev );
//STRIP001 					Bitmap aPaint( aRotVDev.GetBitmap( Point(), aSizePix ) );
//STRIP001 
//STRIP001 					aRotVDev.DrawOutDev( Point(), aSizePix, aCharRect.TopLeft(), aCharRect.GetSize(), *pMskVDev );
//STRIP001 					aListOfImages.Insert( new BitmapEx( aPaint, aRotVDev.GetBitmap( Point(), aSizePix ) ) );
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					aCharRect.Intersection( aObjRect );
//STRIP001 					aListOfImages.Insert( new BitmapEx( pAnmVDev->GetBitmap( aCharRect.TopLeft(), aCharRect.GetSize() ),
//STRIP001 														pMskVDev->GetBitmap( aCharRect.TopLeft(), aCharRect.GetSize() ) ) );
//STRIP001 				}
//STRIP001 
//STRIP001 				if( !bAbort )
//STRIP001 				{
//STRIP001 					// Mover parametrieren
//STRIP001 					pMover->SetListOfImages( &aListOfImages );
//STRIP001 					pMover->SetPath( rStart, aCharRect.TopLeft() );
//STRIP001 					pMover->SetGraphicInfo( pVDev, pTopLayer );
//STRIP001 
//STRIP001 					// ggfs. Sound anschalten
//STRIP001 					if( pInfo->bSoundOn )
//STRIP001 					{
//STRIP001 						bPlayFull = pInfo->bPlayFull;
//STRIP001 						StartSound( pInfo->aSoundFile );
//STRIP001 					}
//STRIP001 
//STRIP001 					// und los (aber keine internen Waits)
//STRIP001 					bAbort = bAbort || !pMover->Move();
//STRIP001 
//STRIP001                     // im Reschedule des Effekts zerstoert?
//STRIP001                     if( nMagic != SLIDESHOW_MAGIC )
//STRIP001 					{
//STRIP001 						delete (BitmapEx*) aListOfImages.First();
//STRIP001 						return TRUE;
//STRIP001 					}
//STRIP001 
//STRIP001 					// Hintergrund mit neuem Zeichen aktualisieren
//STRIP001 					pVDev->DrawBitmapEx( aCharRect.TopLeft(), *(BitmapEx*) aListOfImages.First() );
//STRIP001 				}
//STRIP001 
//STRIP001 				delete (BitmapEx*) aListOfImages.First();
//STRIP001 				aListOfImages.Clear();
//STRIP001 
//STRIP001 				pChar = pOutlInfo->GetNextCharacter();
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return( !bAbort );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 BitmapEx FuSlideShow::CreateReplacement( SdrObject* pObj, ExtOutputDevice* pOut )
//STRIP001 {
//STRIP001 	SdrPaintInfoRec		aPaintInfoRec;
//STRIP001 	SdAnimationInfo*	pInfo = pDoc->GetAnimationInfo( pObj );
//STRIP001 	BitmapEx			aRet;
//STRIP001 	OutputDevice*		pRealOut = pOut->GetOutDev();
//STRIP001 	const USHORT        nOldAntialiasing = pRealOut->GetAntialiasing();
//STRIP001 	
//STRIP001 	SetPaintModes( (SdrView*) pView, NULL, pOut, &aPaintInfoRec );
//STRIP001 	
//STRIP001 	pRealOut->Push();
//STRIP001 	pRealOut->SetBackground( Wallpaper( Color( COL_WHITE ) ) );
//STRIP001 	pRealOut->Erase();
//STRIP001 	pRealOut->Pop();
//STRIP001 	pRealOut->SetAntialiasing( ANTIALIASING_DISABLE_TEXT );
//STRIP001 
//STRIP001 	if( IsAlphaObj( (SdrAttrObj*) pObj ) )
//STRIP001 	{
//STRIP001 		// create alpha mask
//STRIP001 		PaintDimmedObject( (SdrAttrObj*) pObj, pRealOut, Color( COL_BLACK ), FALSE );
//STRIP001 		AlphaMask aAlpha( pRealOut->GetBitmap( pRealOut->PixelToLogic( Point() ), pRealOut->GetOutputSize() ) );
//STRIP001 
//STRIP001 		// create paint bitmap
//STRIP001 		SdrObjGroup* pClone;
//STRIP001 
//STRIP001 		if( pObj->ISA( SdrObjGroup ) )
//STRIP001 			pClone = (SdrObjGroup*) pObj->Clone(); 
//STRIP001 		else
//STRIP001 		{
//STRIP001 			pClone = new SdrObjGroup; 
//STRIP001 			pClone->GetSubList()->NbcInsertObject( pObj->Clone() );
//STRIP001 		}
//STRIP001 
//STRIP001 		pClone->SetModel( pDoc );
//STRIP001 
//STRIP001 		SdrObjListIter aIter( *pClone->GetSubList(), IM_DEEPWITHGROUPS );
//STRIP001 		
//STRIP001 		for( SdrObject*	pO = aIter.Next(); pO; pO = aIter.Next() )
//STRIP001 		{
//STRIP001 			if( !pO->ISA( SdrObjGroup ) )
//STRIP001 			{
//STRIP001 				SfxItemSet	aAttr( pDoc->GetPool(), XATTR_FILLTRANSPARENCE, XATTR_FILLTRANSPARENCE,
//STRIP001 													XATTR_LINETRANSPARENCE, XATTR_LINETRANSPARENCE,
//STRIP001 													XATTR_FILLFLOATTRANSPARENCE, XATTR_FILLFLOATTRANSPARENCE,
//STRIP001 													0, 0 );
//STRIP001 
//STRIP001 				aAttr.Set(pO->GetItemSet());
//STRIP001 
//STRIP001 				// set minimal transparence values to get same results (as alpha painting) 
//STRIP001 				if( ( ( aAttr.GetItemState( XATTR_FILLFLOATTRANSPARENCE ) == SFX_ITEM_SET ) &&
//STRIP001 					( (const XFillFloatTransparenceItem&) aAttr.Get( XATTR_FILLFLOATTRANSPARENCE ) ).IsEnabled() ) )
//STRIP001 				{
//STRIP001 					const Color aTransCol( 1, 1, 1 );
//STRIP001 					aAttr.Put( XFillFloatTransparenceItem( String(), XGradient( aTransCol, aTransCol, XGRAD_LINEAR, 0, 0, 0, 0, 100, 100, 3 ) ) );
//STRIP001 				}
//STRIP001 				else if( ( ( (const XFillTransparenceItem&) aAttr.Get( XATTR_FILLTRANSPARENCE ) ).GetValue() ) )
//STRIP001 					aAttr.Put( XFillTransparenceItem( 1 ) );
//STRIP001 
//STRIP001 				if( ( (const XLineTransparenceItem&) aAttr.Get( XATTR_LINETRANSPARENCE ) ).GetValue() )
//STRIP001 					aAttr.Put( XLineTransparenceItem( 1 ) );
//STRIP001 			
//STRIP001 				pO->SetItemSet(aAttr);
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		pRealOut->Push();
//STRIP001 		pRealOut->SetBackground( Wallpaper( Color( COL_WHITE ) ) );
//STRIP001 		pRealOut->Erase();
//STRIP001 		pRealOut->Pop();
//STRIP001 		pClone->Paint( *pOut, aPaintInfoRec );
//STRIP001 		aRet = BitmapEx( pRealOut->GetBitmap( pRealOut->PixelToLogic( Point() ), pRealOut->GetOutputSize() ), aAlpha );
//STRIP001 
//STRIP001 		delete pClone;
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pObj->Paint( *pOut, aPaintInfoRec );
//STRIP001 		Bitmap aPaint( pRealOut->GetBitmap( pRealOut->PixelToLogic( Point() ), pRealOut->GetOutputSize() ) );

//STRIP001 		pRealOut->Push();
//STRIP001 		pRealOut->SetBackground( Wallpaper( Color( COL_WHITE ) ) );
//STRIP001 		pRealOut->Erase();
//STRIP001 		pRealOut->Pop();
//STRIP001 		PaintDimmedObject( (SdrAttrObj*) pObj, pRealOut, Color( COL_BLACK ), TRUE );
//STRIP001 		Bitmap aMask( pRealOut->GetBitmap( pRealOut->PixelToLogic( Point() ), pRealOut->GetOutputSize() ) );
//STRIP001     	aMask.MakeMono( 254 );
//STRIP001 		aRet = BitmapEx( aPaint, aMask );
//STRIP001 	}
//STRIP001 
//STRIP001     pRealOut->SetAntialiasing( nOldAntialiasing );
//STRIP001 
//STRIP001 	return aRet;
//STRIP001 }
}
