/*************************************************************************
 *
 *  $RCSfile: sd_fusumry.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:56:00 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop


// auto strip #ifndef _EEITEM_HXX //autogen
// auto strip #include <bf_svx/eeitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOTEXT_HXX //autogen
// auto strip #include <bf_svx/svdotext.hxx>
// auto strip #endif
// auto strip #ifndef _SVDUNDO_HXX //autogen
// auto strip #include <bf_svx/svdundo.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_PRINTER_HXX //autogen
// auto strip #include <bf_sfx2/printer.hxx>
// auto strip #endif
// auto strip #ifndef _OUTLOBJ_HXX
// auto strip #include <bf_svx/outlobj.hxx>
// auto strip #endif

#include "strings.hrc"

// auto strip #include "pres.hxx"
// auto strip #include "sdview.hxx"
// auto strip #include "sdpage.hxx"
// auto strip #include "sdoutl.hxx"
// auto strip #include "drawview.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "viewshel.hxx"
// auto strip #include "docshell.hxx"
// auto strip #include "fusumry.hxx"
// auto strip #include "sdresid.hxx"
// auto strip #include "optsitem.hxx"
// auto strip #include "drviewsh.hxx"
namespace binfilter {

//STRIP001 TYPEINIT1( FuSummaryPage, FuPoor );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 FuSummaryPage::FuSummaryPage(SdViewShell* pViewSh, SdWindow* pWin, SdView* pView,
//STRIP001 				 SdDrawDocument* pDoc, SfxRequest& rReq)
//STRIP001  : FuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	SdOutliner* pOutl = NULL;
//STRIP001 	SdPage* pSummaryPage = NULL;
//STRIP001 	USHORT i = 0;
//STRIP001 	USHORT nFirstPage = SDRPAGE_NOTFOUND;
//STRIP001 	USHORT nSelectedPages = 0;
//STRIP001 	USHORT nCount = pDoc->GetSdPageCount(PK_STANDARD);
//STRIP001 
//STRIP001 	while (i < nCount && nSelectedPages <= 1)
//STRIP001 	{
//STRIP001 		/**********************************************************************
//STRIP001 		* Wieviele Seiten sind selektiert?
//STRIP001 		* Genau eine Seite selektiert: Ab dieser Seite alles zusammenfassen
//STRIP001 		* sonst: Nur die selektierten Seiten zusammenfassen
//STRIP001 		**********************************************************************/
//STRIP001 		SdPage* pActualPage = pDoc->GetSdPage(i, PK_STANDARD);
//STRIP001 
//STRIP001 		if (pActualPage->IsSelected())
//STRIP001 		{
//STRIP001 			if (nFirstPage == SDRPAGE_NOTFOUND)
//STRIP001 			{
//STRIP001 				nFirstPage = i;
//STRIP001 			}
//STRIP001 
//STRIP001 			nSelectedPages++;
//STRIP001 		}
//STRIP001 
//STRIP001 		i++;
//STRIP001 	}
//STRIP001 
//STRIP001 	SfxStyleSheet* pStyle = NULL;
//STRIP001 
//STRIP001 	for (i = nFirstPage; i < nCount; i++)
//STRIP001 	{
//STRIP001 		SdPage* pActualPage = pDoc->GetSdPage(i, PK_STANDARD);
//STRIP001 
//STRIP001 		if (nSelectedPages <= 1 || pActualPage->IsSelected())
//STRIP001 		{
//STRIP001 			SdPage* pActualNotesPage = pDoc->GetSdPage(i, PK_NOTES);
//STRIP001 			SdrTextObj* pTextObj = (SdrTextObj*) pActualPage->GetPresObj(PRESOBJ_TITLE);
//STRIP001 
//STRIP001 			if (pTextObj && !pTextObj->IsEmptyPresObj())
//STRIP001 			{
//STRIP001 				if (!pSummaryPage)
//STRIP001 				{
//STRIP001 					/**********************************************************
//STRIP001 					* Inhaltsverzeichnis-Seite einfuegen und Outliner anlegen
//STRIP001 					**********************************************************/
//STRIP001 					pView->BegUndo(String(SdResId(STR_UNDO_SUMMARY_PAGE)));
//STRIP001 					SetOfByte aVisibleLayers = pActualPage->GetMasterPageVisibleLayers(0);
//STRIP001 
//STRIP001 					// Seite mit Titel & Gliederung!
//STRIP001 					pSummaryPage = (SdPage*) pDoc->AllocPage(FALSE);
//STRIP001 					pSummaryPage->SetSize(pActualPage->GetSize() );
//STRIP001 					pSummaryPage->SetBorder(pActualPage->GetLftBorder(),
//STRIP001 									 pActualPage->GetUppBorder(),
//STRIP001 									 pActualPage->GetRgtBorder(),
//STRIP001 									 pActualPage->GetLwrBorder() );
//STRIP001 
//STRIP001 					// Seite hinten einfuegen
//STRIP001 					pDoc->InsertPage(pSummaryPage, nCount * 2 + 1);
//STRIP001 					pView->AddUndo(new SdrUndoNewPage(*pSummaryPage));
//STRIP001 
//STRIP001 					// MasterPage der aktuellen Seite verwenden
//STRIP001 					USHORT nPgNum = pActualPage->GetMasterPageNum(0);
//STRIP001 					pSummaryPage->InsertMasterPage(nPgNum);
//STRIP001 					pSummaryPage->SetLayoutName(pActualPage->GetLayoutName());
//STRIP001 					pSummaryPage->SetAutoLayout(AUTOLAYOUT_ENUM, TRUE);
//STRIP001 					pSummaryPage->SetMasterPageVisibleLayers(aVisibleLayers, 0);
//STRIP001 
//STRIP001 					// Notiz-Seite
//STRIP001 					SdPage* pNotesPage = (SdPage*) pDoc->AllocPage(FALSE);
//STRIP001 					pNotesPage->SetSize(pActualNotesPage->GetSize());
//STRIP001 					pNotesPage->SetBorder(pActualNotesPage->GetLftBorder(),
//STRIP001 										  pActualNotesPage->GetUppBorder(),
//STRIP001 										  pActualNotesPage->GetRgtBorder(),
//STRIP001 										  pActualNotesPage->GetLwrBorder() );
//STRIP001 					pNotesPage->SetPageKind(PK_NOTES);
//STRIP001 
//STRIP001 					// Seite hinten einfuegen
//STRIP001 					pDoc->InsertPage(pNotesPage, nCount * 2 + 2);
//STRIP001 					pView->AddUndo(new SdrUndoNewPage(*pNotesPage));
//STRIP001 
//STRIP001 					// MasterPage der aktuellen Seite verwenden
//STRIP001 					nPgNum = pActualNotesPage->GetMasterPageNum(0);
//STRIP001 					pNotesPage->InsertMasterPage(nPgNum);
//STRIP001 					pNotesPage->SetLayoutName(pActualNotesPage->GetLayoutName());
//STRIP001 					pNotesPage->SetAutoLayout(pActualNotesPage->GetAutoLayout(), TRUE);
//STRIP001 					pNotesPage->SetMasterPageVisibleLayers(aVisibleLayers, 0);
//STRIP001 
//STRIP001 					pOutl = new SdOutliner( pDoc, OUTLINERMODE_OUTLINEOBJECT );
//STRIP001 					pOutl->SetUpdateMode(FALSE);
//STRIP001 					pOutl->EnableUndo(FALSE);
//STRIP001 
//STRIP001 					if (pDocSh)
//STRIP001 						pOutl->SetRefDevice(SD_MOD()->GetRefDevice( *pDocSh ));
//STRIP001 
//STRIP001 					pOutl->SetDefTab( pDoc->GetDefaultTabulator() );
//STRIP001 					pOutl->SetStyleSheetPool((SfxStyleSheetPool*) pDoc->GetStyleSheetPool());
//STRIP001 					pStyle = pSummaryPage->GetStyleSheetForPresObj( PRESOBJ_OUTLINE );
//STRIP001 					pOutl->SetStyleSheet( 0, pStyle );
//STRIP001 					pOutl->SetMinDepth(0);
//STRIP001 				}
//STRIP001 
//STRIP001 				/**************************************************************
//STRIP001 				* Text hinzufuegen
//STRIP001 				**************************************************************/
//STRIP001 				OutlinerParaObject* pParaObj = pTextObj->GetOutlinerParaObject();
//STRIP001 				pParaObj->SetOutlinerMode( OUTLINERMODE_OUTLINEOBJECT );
//STRIP001 				pOutl->AddText(*pParaObj);
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pSummaryPage)
//STRIP001 	{
//STRIP001 		SdrTextObj* pTextObj = (SdrTextObj*) pSummaryPage->GetPresObj(PRESOBJ_OUTLINE);
//STRIP001 
//STRIP001 		// Harte Absatz- und Zeichenattribute entfernen
//STRIP001 		SfxItemSet aEmptyEEAttr(pDoc->GetPool(), EE_ITEMS_START, EE_ITEMS_END);
//STRIP001 		ULONG nParaCount = pOutl->GetParagraphCount();
//STRIP001 
//STRIP001 		for (USHORT nPara = 0; nPara < nParaCount; nPara++)
//STRIP001 		{
//STRIP001 			pOutl->SetStyleSheet( nPara, pStyle );
//STRIP001 			pOutl->QuickRemoveCharAttribs(nPara);
//STRIP001 			pOutl->SetParaAttribs(nPara, aEmptyEEAttr);
//STRIP001 			pOutl->SetDepth(pOutl->GetParagraph(nPara), 1);
//STRIP001 		}
//STRIP001 
//STRIP001 		pTextObj->SetOutlinerParaObject( pOutl->CreateParaObject() );
//STRIP001 		pTextObj->SetEmptyPresObj(FALSE);
//STRIP001 
//STRIP001 		// Harte Attribute entfernen (Flag auf TRUE)
//STRIP001 		SfxItemSet aAttr(pDoc->GetPool());
//STRIP001 		aAttr.Put(XLineStyleItem(XLINE_NONE));
//STRIP001 		aAttr.Put(XFillStyleItem(XFILL_NONE));
//STRIP001 
//STRIP001 //-/		pTextObj->NbcSetAttributes(aAttr, TRUE);
//STRIP001 		pTextObj->SetItemSet(aAttr);
//STRIP001 
//STRIP001 		pView->EndUndo();
//STRIP001 		delete pOutl;
//STRIP001 
//STRIP001 		if (pViewSh->ISA(SdDrawViewShell))
//STRIP001 		{
//STRIP001 			((SdDrawViewShell*) pViewSh)->SwitchPage((pSummaryPage->GetPageNum() - 1) / 2);
//STRIP001 		}
//STRIP001 	}
//STRIP001 }


}
