/*************************************************************************
 *
 *  $RCSfile: sd_fuzoom.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:57:44 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#include <bf_svx/svxids.hrc>
// auto strip #ifndef _SFX_BINDINGS_HXX //autogen
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif
#include "app.hrc"

// auto strip #ifndef _SVDPAGV_HXX //autogen
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #endif

// auto strip #include "fuzoom.hxx"
// auto strip #include "frmview.hxx"
// auto strip #include "viewshel.hxx"
// auto strip #include "sdview.hxx"
// auto strip #include "sdwindow.hxx"
// auto strip #include "drawdoc.hxx"
#include "zoomlist.hxx"
namespace binfilter {

USHORT SidArrayZoom[] = {
					SID_ATTR_ZOOM,
					SID_ZOOM_OUT,
					SID_ZOOM_IN,
					0 };

//STRIP001 TYPEINIT1( FuZoom, FuPoor );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuZoom::FuZoom(SdViewShell* 	pViewSh,
//STRIP001 			   SdWindow*		pWin,
//STRIP001 			   SdView*			pView,
//STRIP001 			   SdDrawDocument*	pDoc,
//STRIP001 			   SfxRequest&		rReq) :
//STRIP001 	FuPoor(pViewSh, pWin, pView, pDoc, rReq),
//STRIP001 	bVisible(FALSE),
//STRIP001 	bStartDrag(FALSE),
//STRIP001 	bLineDraft(FALSE),
//STRIP001 	bFillDraft(FALSE),
//STRIP001 	bTextDraft(FALSE),
//STRIP001 	bGrafDraft(FALSE)
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuZoom::~FuZoom()
//STRIP001 {
//STRIP001 	if (bVisible)
//STRIP001 	{
//STRIP001 		// Hide ZoomRect
//STRIP001 		pViewShell->DrawMarkRect(aZoomRect);
//STRIP001 
//STRIP001 		bVisible = FALSE;
//STRIP001 		bStartDrag = FALSE;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonDown-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuZoom::MouseButtonDown(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	// #95491# remember button state for creation of own MouseEvents
//STRIP001 	SetMouseButtonCode(rMEvt.GetButtons());
//STRIP001 
//STRIP001 	pWindow->CaptureMouse();
//STRIP001 	bStartDrag = TRUE;
//STRIP001 
//STRIP001 	aBeginPosPix = rMEvt.GetPosPixel();
//STRIP001 	aBeginPos = pWindow->PixelToLogic(aBeginPosPix);
//STRIP001 
//STRIP001 	if (nSlotId == SID_ZOOM_PANNING)
//STRIP001 	{
//STRIP001 		// Ersatzdarstellung merken
//STRIP001 		FrameView* pFrameView = pViewShell->GetFrameView();
//STRIP001 		bLineDraft = pFrameView->IsLineDraft();
//STRIP001 		bFillDraft = pFrameView->IsFillDraft();
//STRIP001 		bTextDraft = pFrameView->IsTextDraft();
//STRIP001 		bGrafDraft = pFrameView->IsGrafDraft();
//STRIP001 
//STRIP001 		// Ersatzdarstellungen einschalten
//STRIP001 		pView->SetLineDraft(TRUE);
//STRIP001 		pView->SetFillDraft(TRUE);
//STRIP001 		pView->SetTextDraft(TRUE);
//STRIP001 		pView->SetGrafDraft(TRUE);
//STRIP001 	}
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseMove-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuZoom::MouseMove(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	if (bStartDrag)
//STRIP001 	{
//STRIP001 		if (bVisible)
//STRIP001 		{
//STRIP001 			pViewShell->DrawMarkRect(aZoomRect);
//STRIP001 		}
//STRIP001 
//STRIP001 		Point aPosPix = rMEvt.GetPosPixel();
//STRIP001 		ForceScroll(aPosPix);
//STRIP001 
//STRIP001 		aEndPos = pWindow->PixelToLogic(aPosPix);
//STRIP001 		aBeginPos = pWindow->PixelToLogic(aBeginPosPix);
//STRIP001 
//STRIP001 		if (nSlotId == SID_ZOOM_PANNING)
//STRIP001 		{
//STRIP001 			// Panning
//STRIP001 
//STRIP001 			Point aScroll = aBeginPos - aEndPos;
//STRIP001 
//STRIP001 			// #i2237#
//STRIP001 			// removed old stuff here which still forced zoom to be
//STRIP001 			// %BRUSH_SIZE which is outdated now
//STRIP001 
//STRIP001 			if (aScroll.X() != 0 || aScroll.Y() != 0)
//STRIP001 			{
//STRIP001 				Size aWorkSize = pView->GetWorkArea().GetSize();
//STRIP001 				Size aPageSize = pView->GetPageViewPvNum(0)->GetPage()->GetSize();
//STRIP001 				aScroll.X() /= aWorkSize.Width()  / aPageSize.Width();
//STRIP001 				aScroll.Y() /= aWorkSize.Height() / aPageSize.Height();
//STRIP001 				pViewShell->Scroll(aScroll.X(), aScroll.Y());
//STRIP001 				aBeginPosPix = aPosPix;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			Rectangle aRect(aBeginPos, aEndPos);
//STRIP001 			aZoomRect = aRect;
//STRIP001 			aZoomRect.Justify();
//STRIP001 			pViewShell->DrawMarkRect(aZoomRect);
//STRIP001 		}
//STRIP001 
//STRIP001 		bVisible = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	return bStartDrag;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonUp-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 BOOL FuZoom::MouseButtonUp(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	// #95491# remember button state for creation of own MouseEvents
//STRIP001 	SetMouseButtonCode(rMEvt.GetButtons());
//STRIP001 
//STRIP001 	if (bVisible)
//STRIP001 	{
//STRIP001 		// Hide ZoomRect
//STRIP001 		pViewShell->DrawMarkRect(aZoomRect);
//STRIP001 		bVisible = FALSE;
//STRIP001 	}
//STRIP001 
//STRIP001 	Point aPosPix = rMEvt.GetPosPixel();
//STRIP001 
//STRIP001 	if (nSlotId == SID_ZOOM_PANNING)
//STRIP001 	{
//STRIP001 		// Panning
//STRIP001 		// Ersatzdarstellung restaurieren
//STRIP001 		pView->SetLineDraft(bLineDraft);
//STRIP001 		pView->SetFillDraft(bFillDraft);
//STRIP001 		pView->SetTextDraft(bTextDraft);
//STRIP001 		pView->SetGrafDraft(bGrafDraft);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		// Zoom
//STRIP001 		Size aZoomSizePixel = pWindow->LogicToPixel(aZoomRect).GetSize();
//STRIP001 		ULONG nTol = DRGPIX + DRGPIX;
//STRIP001 
//STRIP001 		if ( aZoomSizePixel.Width() < (long) nTol && aZoomSizePixel.Height() < (long) nTol )
//STRIP001 		{
//STRIP001 			// Klick auf der Stelle: Zoomfaktor verdoppeln
//STRIP001 			Point aPos = pWindow->PixelToLogic(aPosPix);
//STRIP001 			Size aSize = pWindow->PixelToLogic(pWindow->GetOutputSizePixel());
//STRIP001 			aSize.Width() /= 2;
//STRIP001 			aSize.Height() /= 2;
//STRIP001 			aPos.X() -= aSize.Width() / 2;
//STRIP001 			aPos.Y() -= aSize.Height() / 2;
//STRIP001 			aZoomRect.SetPos(aPos);
//STRIP001 			aZoomRect.SetSize(aSize);
//STRIP001 		}
//STRIP001 
//STRIP001 		pViewShell->SetZoomRect(aZoomRect);
//STRIP001 	}
//STRIP001 
//STRIP001 	Rectangle aVisAreaWin = pWindow->PixelToLogic(Rectangle(Point(0,0),
//STRIP001 										   pWindow->GetOutputSizePixel()));
//STRIP001 	pViewShell->GetZoomList()->InsertZoomRect(aVisAreaWin);
//STRIP001 
//STRIP001 	bStartDrag = FALSE;
//STRIP001 	pWindow->ReleaseMouse();
//STRIP001 	pViewShell->Cancel();
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function aktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuZoom::Activate()
//STRIP001 {
//STRIP001 	aPtr = pWindow->GetPointer();
//STRIP001 
//STRIP001 	if (nSlotId == SID_ZOOM_PANNING)
//STRIP001 	{
//STRIP001 		pWindow->SetPointer(Pointer(POINTER_HAND));
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pWindow->SetPointer(Pointer(POINTER_MAGNIFY));
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function deaktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuZoom::Deactivate()
//STRIP001 {
//STRIP001 	pWindow->SetPointer( aPtr );
//STRIP001 	pViewShell->GetViewFrame()->GetBindings().Invalidate( SidArrayZoom );
//STRIP001 }
}
