/*************************************************************************
 *
 *  $RCSfile: navigatr.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hjs $ $Date: 2003/10/01 12:19:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


//STRIP001 #ifndef _SD_NAVIGATR_HXX
//STRIP001 #define _SD_NAVIGATR_HXX
//STRIP001 
//STRIP001 
//STRIP001 #ifndef _SV_LSTBOX_HXX //autogen
//STRIP001 #include <vcl/lstbox.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _TOOLBOX_HXX //autogen
//STRIP001 #include <vcl/toolbox.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFXCTRLITEM_HXX //autogen
//STRIP001 #include <bf_sfx2/ctrlitem.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SDTREELB_HXX
//STRIP001 #include "sdtreelb.hxx"
//STRIP001 #endif
//STRIP001 #ifndef _PRESENTATION_HXX
//STRIP001 #include "pres.hxx"
//STRIP001 #endif
//STRIP001 
//STRIP001 #define NAVSTATE_NONE			0x00000000
//STRIP001 
//STRIP001 #define NAVBTN_LIVE_ENABLED 	0x00000001
//STRIP001 #define NAVBTN_LIVE_DISABLED	0x00000002
//STRIP001 #define NAVBTN_LIVE_CHECKED 	0x00000004
//STRIP001 #define NAVBTN_LIVE_UNCHECKED	0x00000008
//STRIP001 
//STRIP001 #define NAVBTN_PEN_ENABLED		0x00000010
//STRIP001 #define NAVBTN_PEN_DISABLED 	0x00000020
//STRIP001 #define NAVBTN_PEN_CHECKED		0x00000040
//STRIP001 #define NAVBTN_PEN_UNCHECKED	0x00000080
//STRIP001 
//STRIP001 #define NAVTLB_UPDATE			0x00000100
//STRIP001 
//STRIP001 #define NAVBTN_FIRST_ENABLED	0x00001000
//STRIP001 #define NAVBTN_FIRST_DISABLED	0x00002000
//STRIP001 #define NAVBTN_PREV_ENABLED 	0x00004000
//STRIP001 #define NAVBTN_PREV_DISABLED	0x00008000
//STRIP001 
//STRIP001 #define NAVBTN_LAST_ENABLED 	0x00010000
//STRIP001 #define NAVBTN_LAST_DISABLED	0x00020000
//STRIP001 #define NAVBTN_NEXT_ENABLED 	0x00040000
//STRIP001 #define NAVBTN_NEXT_DISABLED	0x00080000
//STRIP001 
//STRIP001 // forward
//STRIP001 class SdView;
//STRIP001 class SdDrawDocShell;
//STRIP001 class Menu;
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 class NavDocInfo
//STRIP001 {
//STRIP001  friend class SdNavigatorWin;
//STRIP001 
//STRIP001 private:
//STRIP001 	BOOL			bName	: 1;
//STRIP001 	BOOL			bActive : 1;
//STRIP001 	SdDrawDocShell* pDocShell;
//STRIP001 
//STRIP001 
//STRIP001 public:
//STRIP001 			NavDocInfo() { pDocShell = NULL; }
//STRIP001 
//STRIP001 	BOOL	HasName() { return( (BOOL) bName ); }
//STRIP001 	BOOL	IsActive() { return( (BOOL) bActive ); }
//STRIP001 
//STRIP001 	void	SetName( BOOL bOn = TRUE ) { bName = bOn; }
//STRIP001 	void	SetActive( BOOL bOn = TRUE ) { bActive = bOn; }
//STRIP001 };
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 class SdNavigatorWin : public Window
//STRIP001 {
//STRIP001  friend class SdNavigatorChildWindow;
//STRIP001  friend class SdNavigatorControllerItem;
//STRIP001  friend class SdPageNameControllerItem;
//STRIP001 
//STRIP001 private:
//STRIP001 	
//STRIP001 	ToolBox						aToolbox;
//STRIP001 	SdPageObjsTLB				aTlbObjects;
//STRIP001 	ListBox 					aLbDocs;
//STRIP001 
//STRIP001 	SdNavigatorChildWindow*		pChildWinContext;
//STRIP001 	Size						aSize;
//STRIP001 	Size						aMinSize;
//STRIP001 	Size						aFltWinSize;
//STRIP001 	BOOL						bDocImported;
//STRIP001 	String						aDropFileName;
//STRIP001 	NavigatorDragType			eDragType;
//STRIP001 	List*						pDocList;
//STRIP001 	SfxBindings*				pBindings;
//STRIP001 	SdNavigatorControllerItem*	pNavigatorCtrlItem;
//STRIP001 	SdPageNameControllerItem*	pPageNameCtrlItem;
//STRIP001 
//STRIP001 	ImageList					maImageList;
//STRIP001 	ImageList					maImageListH;
//STRIP001 
//STRIP001 	USHORT						GetDragTypeSdResId( NavigatorDragType eDT, BOOL bImage = FALSE );
//STRIP001 	NavDocInfo*					GetDocInfo();
//STRIP001 
//STRIP001 								DECL_LINK( GetFocusObjectsHdl, void * );
//STRIP001 								DECL_LINK( SelectToolboxHdl, void * );
//STRIP001 								DECL_LINK( ClickToolboxHdl, ToolBox * );
//STRIP001 								DECL_LINK( ClickPageHdl, void * );
//STRIP001 								DECL_LINK( ClickObjectHdl, void * );
//STRIP001 								DECL_LINK( SelectDocumentHdl, void * );
//STRIP001 								DECL_LINK( MenuSelectHdl, Menu * );
//STRIP001 
//STRIP001 	virtual void				DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 	void						SetDragImage();
//STRIP001 	void						ApplyImageList();
//STRIP001 
//STRIP001 protected:
//STRIP001 	
//STRIP001 	virtual void				Resize();
//STRIP001 	virtual long				ParentNotify(NotifyEvent& rNEvt);
//STRIP001 								
//STRIP001 public:							
//STRIP001 								SdNavigatorWin( Window* pParent,
//STRIP001 									SdNavigatorChildWindow* pChildWinContext,
//STRIP001 									const SdResId& rSdResId,
//STRIP001 									SfxBindings* pBindings );
//STRIP001 								~SdNavigatorWin();
//STRIP001 								
//STRIP001 	virtual void				KeyInput( const KeyEvent& rKEvt );
//STRIP001 								
//STRIP001 	void						InitTreeLB( const SdDrawDocument* pDoc );
//STRIP001 	void						RefreshDocumentLB( const String* pDocName = NULL );
//STRIP001 	
//STRIP001 	BOOL						InsertFile(const String& rFileName);
//STRIP001 	
//STRIP001 	NavigatorDragType			GetNavigatorDragType();
//STRIP001 	void						SetNavigatorDragType(NavigatorDragType eType) { eDragType = eType; }
//STRIP001 };
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* ControllerItem fuer Navigator
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 class SdNavigatorControllerItem : public SfxControllerItem
//STRIP001 {
//STRIP001 	SdNavigatorWin* pNavigatorWin;
//STRIP001 
//STRIP001  protected:
//STRIP001 	virtual void StateChanged( USHORT nSId, SfxItemState eState,
//STRIP001 								const SfxPoolItem* pState );
//STRIP001 
//STRIP001  public:
//STRIP001 	SdNavigatorControllerItem( USHORT, SdNavigatorWin*, SfxBindings* );
//STRIP001 };
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* ControllerItem fuer Navigator zum Anzeigen der Seite in der TreeLB
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 class SdPageNameControllerItem : public SfxControllerItem
//STRIP001 {
//STRIP001 	SdNavigatorWin* pNavigatorWin;
//STRIP001 
//STRIP001  protected:
//STRIP001 	virtual void StateChanged( USHORT nSId, SfxItemState eState,
//STRIP001 								const SfxPoolItem* pState );
//STRIP001 
//STRIP001  public:
//STRIP001 	SdPageNameControllerItem( USHORT, SdNavigatorWin*, SfxBindings* );
//STRIP001 };
//STRIP001 
//STRIP001 #endif		// _SD_NAVIGATR_HXX

