/*************************************************************************
 *
 *  $RCSfile: preview.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:36:20 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#ifndef _SD_PREVIEW_HXX
#define _SD_PREVIEW_HXX

#ifndef _SFXCTRLITEM_HXX //autogen
#include <bf_sfx2/ctrlitem.hxx>
#endif
#ifndef _SFXDOCKWIN_HXX //autogen
#include <bf_sfx2/dockwin.hxx>
#endif
#ifndef _SFXLSTNER_HXX
#include <svtools/lstner.hxx>
#endif
#ifndef INCLUDED_SVTOOLS_COLORCFG_HXX
#include <svtools/colorcfg.hxx>
#endif

#ifndef _SD_SDRESID_HXX
#include "sdresid.hxx"
#endif
#ifndef _SD_PREVCHLD_HXX
#include "prevchld.hxx"
#endif
namespace binfilter {

//STRIP001 class SdDrawDocument;
//STRIP001 class SdView;
//STRIP001 class FuSlideShow;
//STRIP001 class SdDrawView;
//STRIP001 class SdShowWindow;
//STRIP001 class FrameView;
//STRIP001 class SdrObject;
//STRIP001 
//STRIP001 #define SDPREVIEWWIN_MAGIC 0x456789AB
//STRIP001 
//STRIP001 #define PREVIEW_DRAWMODE_COLOR		(DRAWMODE_DEFAULT)
//STRIP001 #define PREVIEW_DRAWMODE_GRAYSCALE	(DRAWMODE_GRAYLINE | DRAWMODE_GRAYFILL | DRAWMODE_BLACKTEXT | DRAWMODE_GRAYBITMAP | DRAWMODE_GRAYGRADIENT)
//STRIP001 #define PREVIEW_DRAWMODE_BLACKWHITE	(DRAWMODE_BLACKLINE | DRAWMODE_BLACKTEXT | DRAWMODE_WHITEFILL | DRAWMODE_GRAYBITMAP | DRAWMODE_WHITEGRADIENT)
//STRIP001 #define PREVIEW_DRAWMODE_CONTRAST	(DRAWMODE_SETTINGSLINE | DRAWMODE_SETTINGSFILL | DRAWMODE_SETTINGSTEXT | DRAWMODE_SETTINGSGRADIENT)

//------------------------------------------------------------------------

//STRIP001 class SdPreviewWin : public SfxDockingWindow, public SfxControllerItem, public SfxListener
//STRIP001 {
//STRIP001  friend class SdPreviewChildWindow;
//STRIP001  friend class SdPreviewCtrlItem;
//STRIP001 
//STRIP001 private:
//STRIP001 	SdDrawDocument*		pDoc;
//STRIP001 	SdDrawView*         pView;
//STRIP001 	FuSlideShow*        pFuSlideShow;
//STRIP001 	SdShowWindow*       pShowWindow;
//STRIP001 	BOOL                bInAnimation;
//STRIP001 	Point               aDownPos;
//STRIP001 	ULONG               nMagic;
//STRIP001 
//STRIP001 	SfxBindings* 		pBindings;
//STRIP001 	SdPreviewCtrlItem*	pControllerItem;
//STRIP001 
//STRIP001 	bool				mbInitialFocus;
//STRIP001 	//DECL_LINK( ClickPreviewHdl, void * );
//STRIP001 
//STRIP001 	void updateViewSettings();
//STRIP001 
//STRIP001     ::svtools::ColorConfig    maColorConfig;
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual BOOL	Close();
//STRIP001 	virtual void	Resize();
//STRIP001 	virtual void SFX_NOTIFY(SfxBroadcaster& rBC, const TypeId& rBCType, const SfxHint& rHint, const TypeId& rHintType);
//STRIP001 
//STRIP001 public:
//STRIP001 			SdPreviewWin( SfxBindings* pBindings, SfxChildWindow *pCW,
//STRIP001 						Window* pParent, const SdResId& rSdResId );
//STRIP001 			~SdPreviewWin();
//STRIP001 
//STRIP001 	void    SetContext(SdDrawDocument* pDrawDoc, USHORT nSdPage,
//STRIP001 					   FrameView* pFrm);
//STRIP001 
//STRIP001 	void    PaintContents(const Rectangle& rRect);
//STRIP001 	void    KeyInputFromContents(const KeyEvent& rKEvt);
//STRIP001 	void    MouseMoveFromContents(const MouseEvent& rMEvt);
//STRIP001 	void    MouseButtonUpFromContents(const MouseEvent& rMEvt);
//STRIP001 	void    MouseButtonDownFromContents(const MouseEvent& rMEvt);
//STRIP001 
//STRIP001 	FuSlideShow*    GetSlideShow()   { return pFuSlideShow; }
//STRIP001 	SdDrawDocument* GetDoc()         { return pDoc; }
//STRIP001 
//STRIP001 	virtual void StateChanged( StateChangedType );
//STRIP001 
//STRIP001 	void    HideAndAnimateObject(SdrObject* pObject);
//STRIP001 	void    AnimatePage();
//STRIP001 	BOOL    IsInAnimation() const { return bInAnimation; }
//STRIP001 
//STRIP001 	SdShowWindow*	GetShowWindow() const { return pShowWindow; };
//STRIP001 
//STRIP001 	virtual void DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 
//STRIP001     virtual void        GetFocus();
//STRIP001 };

/*************************************************************************
|*
|* ControllerItem fuer Preview Window (Floating/Docking)
|*
\************************************************************************/

//STRIP001 class SdPreviewCtrlItem : public SfxControllerItem
//STRIP001 {
//STRIP001 	SdPreviewWin* pPreviewWin;
//STRIP001 	SfxStatusForwarder* pForwarder1;
//STRIP001 	SfxStatusForwarder* pForwarder2;
//STRIP001 	SfxStatusForwarder* pForwarder3;
//STRIP001 	SfxStatusForwarder* pForwarder4;
//STRIP001 
//STRIP001  protected:
//STRIP001 	virtual void StateChanged( USHORT nSId, SfxItemState eState,
//STRIP001 								const SfxPoolItem* pState );
//STRIP001 
//STRIP001  public:
//STRIP001 	SdPreviewCtrlItem( USHORT, SdPreviewWin*, SfxBindings* );
//STRIP001 	~SdPreviewCtrlItem();
//STRIP001 };

} //namespace binfilter
#endif		// _SD_PREVIEW_HXX

