/*************************************************************************
 *
 *  $RCSfile: sd_drviewsj.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:16:19 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _AEITEM_HXX //autogen
// auto strip #include <svtools/aeitem.hxx>
// auto strip #endif
#ifndef _SVXIDS_HRC //autogen
#include <bf_svx/svxids.hrc>
#endif
// auto strip #ifndef _GLOBL3D_HXX //autogen
// auto strip #include <bf_svx/globl3d.hxx>
// auto strip #endif
#ifndef _EEITEM_HXX //autogen
#include <bf_svx/eeitem.hxx>
#endif

// auto strip #ifndef _PSTM_HXX
// auto strip #include <tools/pstm.hxx>
// auto strip #endif

#ifndef _SFXPOOLITEM_HXX
#include <svtools/poolitem.hxx>
#endif

#ifndef _SVX_ITEMDATA_HXX
#include <bf_svx/itemdata.hxx>
#endif

#ifndef _DATE_HXX
#include <tools/date.hxx>
#endif

#ifndef _TOOLS_TIME_HXX
#include <tools/time.hxx>
#endif

#define ITEMID_FIELD    EE_FEATURE_FIELD
// auto strip #ifndef _FLDITEM_HXX
// auto strip #include <bf_svx/flditem.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOGRP_HXX //autogen
// auto strip #include <bf_svx/svdogrp.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOGRAF_HXX //autogen
// auto strip #include <bf_svx/svdograf.hxx>
// auto strip #endif
#ifndef _SVDOOLE2_HXX //autogen
#include <bf_svx/svdoole2.hxx>
#endif
// auto strip #ifndef _SXELDITM_HXX //autogen
// auto strip #include <bf_svx/sxelditm.hxx>
// auto strip #endif
#ifndef _SFXDISPATCH_HXX //autogen
#include <bf_sfx2/dispatch.hxx>
#endif
#ifndef _SFXREQUEST_HXX //autogen
#include <bf_sfx2/request.hxx>
#endif
// auto strip #ifndef _SVDOPATH_HXX //autogen
// auto strip #include <bf_svx/svdopath.hxx>
// auto strip #endif
// auto strip #ifndef _E3D_POLYSC3D_HXX //autogen
// auto strip #include <bf_svx/polysc3d.hxx>
// auto strip #endif
// auto strip #ifndef _E3D_OBJ3D_HXX //autogen
// auto strip #include <bf_svx/obj3d.hxx>
// auto strip #endif
#ifndef _SFXEVENT_HXX //autogen
#include <bf_sfx2/event.hxx>
#endif
// auto strip #ifndef _SFXDOCFILE_HXX //autogen
// auto strip #include <bf_sfx2/docfile.hxx>
// auto strip #endif
// auto strip #ifndef _RTL_USTRBUF_HXX_
// auto strip #include <rtl/ustrbuf.hxx>
// auto strip #endif

// auto strip #ifndef _IPOBJ_HXX 
// auto strip #include <so3/ipobj.hxx>
// auto strip #endif

#pragma hdrstop

#include "app.hrc"

// auto strip #include "sdoutl.hxx"
// auto strip #include "sdpage.hxx"
// auto strip #include "fupoor.hxx"
#include "fusel.hxx"
#include "drviewsh.hxx"
#include "drawdoc.hxx"
#include "docshell.hxx"
#include "drawview.hxx"
// auto strip #include "optsitem.hxx"
namespace binfilter {



/*************************************************************************
|*
|* Status (Enabled/Disabled) von Menue-SfxSlots setzen
|*
\************************************************************************/

/*N*/ void SdDrawViewShell::GetMenuStateSel( SfxItemSet &rSet )
/*N*/ {
/*N*/ 	// Status der Menueintraege, bzw. Buttons
/*N*/ 	// Einfachselektion
/*N*/ 
/*N*/ 	const SdrMarkList& rMarkList = pDrView->GetMarkList();
/*N*/ 	ULONG nMarkCount = rMarkList.GetMarkCount();
/*N*/ 
/*N*/ 	if ( nMarkCount == 1 )
/*N*/ 	{
/*?*/ 		if( SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_BEZIER_EDIT ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_UNGROUP ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_ENTER_GROUP ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_NAME_GROUP ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_ATTR_FILL_STYLE ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_CHANGEBEZIER ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_CHANGEPOLYGON ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_LINEEND_POLYGON ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( OBJ_TITLETEXT ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( OBJ_OUTLINETEXT ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_MEASURE_DLG ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_CONNECTION_DLG ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_CONNECTION_NEW_ROUTING ) ||
/*?*/ //			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_CONVERT_TO_3D_LATHE ) ||
/*?*/ //			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_CONVERT_TO_3D_LATHE_FAST ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OBJECT_SHEAR ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_CONVERT_TO_1BIT_THRESHOLD ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_CONVERT_TO_1BIT_MATRIX ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_CONVERT_TO_4BIT_GRAYS ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_CONVERT_TO_4BIT_COLORS ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_CONVERT_TO_8BIT_GRAYS ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_CONVERT_TO_8BIT_COLORS ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_CONVERT_TO_24BIT ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OBJECT_ALIGN_LEFT ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OBJECT_ALIGN_CENTER ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OBJECT_ALIGN_RIGHT ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OBJECT_ALIGN_UP ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OBJECT_ALIGN_MIDDLE ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OBJECT_ALIGN_DOWN ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_FRAME_TO_TOP ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_MOREFRONT ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_MOREBACK ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_FRAME_TO_BOTTOM ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_BEFORE_OBJ ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_BEHIND_OBJ ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_REVERSE_ORDER ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_ORIGINAL_SIZE ) )
/*?*/ 		{
/*?*/ 			DBG_BF_ASSERT(0, "STRIP"); //STRIP001 const SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001 /*?*/ 			UINT32 nInv = pObj->GetObjInventor();
//STRIP001 /*?*/ 			UINT16 nId = pObj->GetObjIdentifier();
//STRIP001 /*?*/ 			SdrObjTransformInfoRec aInfoRec;
//STRIP001 /*?*/ 			pObj->TakeObjInfo( aInfoRec );
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			// #91929#; don't show original size entry if not possible
//STRIP001 /*?*/ 			if ( pObj->ISA( SdrOle2Obj ) )
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/ 				SdrOle2Obj* pOleObj = PTR_CAST(SdrOle2Obj, pObj);
//STRIP001 /*?*/ 				if (pOleObj->GetObjRef().Is() && 
//STRIP001 /*?*/ 					((pOleObj->GetObjRef()->GetMiscStatus() & SVOBJ_MISCSTATUS_SERVERRESIZE) == SVOBJ_MISCSTATUS_SERVERRESIZE))
//STRIP001 /*?*/ 					rSet.DisableItem(SID_ORIGINAL_SIZE);
//STRIP001 /*?*/ 			}
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			// Wenn es sich um kein Gruppenobjekt oder 3D-Objekt handelt
//STRIP001 /*?*/ 			// wird "Gruppe betreten" disabled
//STRIP001 /*?*/ 			if( !( ( pObj->ISA( SdrObjGroup ) && nInv == SdrInventor ) ||
//STRIP001 /*?*/ 				(pObj->ISA (E3dPolyScene) || pObj->ISA (E3dScene) /*|| pObj->ISA (E3dCompoundObject) */) ) )
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/ 				rSet.DisableItem( SID_ENTER_GROUP );
//STRIP001 /*?*/ 			}
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			// Wenn es sich um kein Gruppenobjekt handelt
//STRIP001 /*?*/ 			// wird "Gruppierung aufheben" disabled
//STRIP001 /*?*/ 			if (!(pObj->ISA(SdrObjGroup) && nInv == SdrInventor))
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/ 				rSet.DisableItem(SID_UNGROUP);
//STRIP001 /*?*/ 			}
//STRIP001 /*
//STRIP001 			if (!pObj->ISA(SdrObjGroup) && !pObj->ISA(SdrGrafObj) && !pObj->ISA(SdrOle2Obj))
//STRIP001 			{
//STRIP001 				rSet.DisableItem( SID_NAME_GROUP );
//STRIP001 			}
//STRIP001 */
//STRIP001 /*?*/ 			if (!pObj->ISA(SdrGrafObj) ||
//STRIP001 /*?*/ 				((SdrGrafObj*) pObj)->GetGraphicType() != GRAPHIC_BITMAP ||
//STRIP001 /*?*/ 				((SdrGrafObj*) pObj)->IsLinkedGraphic())
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/ 				rSet.DisableItem(SID_CONVERT_TO_1BIT_THRESHOLD);
//STRIP001 /*?*/ 				rSet.DisableItem(SID_CONVERT_TO_1BIT_MATRIX);
//STRIP001 /*?*/ 				rSet.DisableItem(SID_CONVERT_TO_4BIT_GRAYS);
//STRIP001 /*?*/ 				rSet.DisableItem(SID_CONVERT_TO_4BIT_COLORS);
//STRIP001 /*?*/ 				rSet.DisableItem(SID_CONVERT_TO_8BIT_GRAYS);
//STRIP001 /*?*/ 				rSet.DisableItem(SID_CONVERT_TO_8BIT_COLORS);
//STRIP001 /*?*/ 				rSet.DisableItem(SID_CONVERT_TO_24BIT);
//STRIP001 /*?*/ 			}
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			if( nInv == SdrInventor &&
//STRIP001 /*?*/ 			   (nId == OBJ_LINE ||
//STRIP001 /*?*/ 				nId == OBJ_PLIN ||
//STRIP001 /*?*/ 				nId == OBJ_PATHLINE ||
//STRIP001 /*?*/ 				nId == OBJ_FREELINE ))
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/ 				//rSet.DisableItem( SID_ATTRIBUTES_AREA ); // wieder raus!
//STRIP001 /*?*/ 				rSet.DisableItem( SID_ATTR_FILL_STYLE );
//STRIP001 /*?*/ 			}
//STRIP001 /*?*/ 			if( !pObj->ISA( SdrPathObj ) &&
//STRIP001 /*?*/ 				!aInfoRec.bCanConvToPath ||
//STRIP001 /*?*/ 				pObj->ISA( SdrObjGroup ) ) // Solange es JOE fehlerhaft behandelt!
//STRIP001 /*?*/ 			{ // JOE: Ein Gruppenobjekt kann eben u.U. in ein PathObj gewandelt werden
//STRIP001 /*?*/ 				rSet.DisableItem( SID_LINEEND_POLYGON );
//STRIP001 /*?*/ 			}
//STRIP001 /*?*/ 			if(nInv == SdrInventor &&
//STRIP001 /*?*/ 			   (nId == OBJ_PATHFILL || nId == OBJ_PATHLINE || !aInfoRec.bCanConvToPath))
//STRIP001 /*?*/ 				rSet.DisableItem( SID_CHANGEBEZIER );
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			if( nInv == SdrInventor &&
//STRIP001 /*?*/ 				( nId == OBJ_POLY || nId == OBJ_PLIN || !aInfoRec.bCanConvToPoly ) &&
//STRIP001 /*?*/ 				!pView->IsVectorizeAllowed() )
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/ 				rSet.DisableItem( SID_CHANGEPOLYGON );
//STRIP001 /*?*/ 			}
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			if(nInv == SdrInventor &&
//STRIP001 /*?*/ 			   (nId == OBJ_TITLETEXT || nId == OBJ_OUTLINETEXT))
//STRIP001 /*?*/ 				rSet.DisableItem( SID_TEXTATTR_DLG );
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			if( nInv != SdrInventor || nId != OBJ_MEASURE )
//STRIP001 /*?*/ 				rSet.DisableItem( SID_MEASURE_DLG );
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			if( nInv != SdrInventor || nId != OBJ_EDGE )
//STRIP001 /*?*/ 				rSet.DisableItem( SID_CONNECTION_DLG );
//STRIP001 /*?*/ 			else
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/ 				BOOL bDisable = TRUE;
//STRIP001 /*?*/ 				SfxItemSet aAttrSet( pDoc->GetPool() );
//STRIP001 /*?*/ 				pView->GetAttributes( aAttrSet );
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 				if( aAttrSet.GetItemState( SDRATTR_EDGELINE1DELTA ) >= SFX_ITEM_AVAILABLE &&
//STRIP001 /*?*/ 					aAttrSet.GetItemState( SDRATTR_EDGELINE2DELTA ) >= SFX_ITEM_AVAILABLE &&
//STRIP001 /*?*/ 					aAttrSet.GetItemState( SDRATTR_EDGELINE3DELTA ) >= SFX_ITEM_AVAILABLE )
//STRIP001 /*?*/ 				{
//STRIP001 /*?*/ 					long nVal1 = ( ( const SdrEdgeLine1DeltaItem& ) aAttrSet.Get( SDRATTR_EDGELINE1DELTA ) ).GetValue();
//STRIP001 /*?*/ 					long nVal2 = ( ( const SdrEdgeLine2DeltaItem& ) aAttrSet.Get( SDRATTR_EDGELINE2DELTA ) ).GetValue();
//STRIP001 /*?*/ 					long nVal3 = ( ( const SdrEdgeLine3DeltaItem& ) aAttrSet.Get( SDRATTR_EDGELINE3DELTA ) ).GetValue();
//STRIP001 /*?*/ 					{
//STRIP001 /*?*/ 						if( nVal1 != 0 || nVal2 != 0 || nVal3 != 0 )
//STRIP001 /*?*/ 							bDisable = FALSE;
//STRIP001 /*?*/ 					}
//STRIP001 /*?*/ 				}
//STRIP001 /*?*/ 				if( bDisable )
//STRIP001 /*?*/ 					rSet.DisableItem( SID_CONNECTION_NEW_ROUTING );
//STRIP001 /*?*/ 			}
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			if ( nInv == E3dInventor                          ||
//STRIP001 /*?*/ 				 (!pDrView->IsConvertToPathObjPossible(FALSE) &&
//STRIP001 /*?*/ 				  !pDrView->IsShearAllowed()                  &&
//STRIP001 /*?*/ 				  !pDrView->IsDistortAllowed()) )
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/ 				rSet.DisableItem( SID_OBJECT_SHEAR );
//STRIP001 /*?*/ 			}
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			if(pObj->ISA(E3dCompoundObject))
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/ 				rSet.DisableItem( SID_OBJECT_ALIGN_LEFT );
//STRIP001 /*?*/ 				rSet.DisableItem( SID_OBJECT_ALIGN_CENTER );
//STRIP001 /*?*/ 				rSet.DisableItem( SID_OBJECT_ALIGN_RIGHT );
//STRIP001 /*?*/ 				rSet.DisableItem( SID_OBJECT_ALIGN_UP );
//STRIP001 /*?*/ 				rSet.DisableItem( SID_OBJECT_ALIGN_MIDDLE );
//STRIP001 /*?*/ 				rSet.DisableItem( SID_OBJECT_ALIGN_DOWN );
//STRIP001 /*?*/ 				rSet.DisableItem( SID_FRAME_TO_TOP );
//STRIP001 /*?*/ 				rSet.DisableItem( SID_MOREFRONT );
//STRIP001 /*?*/ 				rSet.DisableItem( SID_MOREBACK );
//STRIP001 /*?*/ 				rSet.DisableItem( SID_FRAME_TO_BOTTOM );
//STRIP001 /*?*/ 				rSet.DisableItem( SID_BEFORE_OBJ );
//STRIP001 /*?*/ 				rSet.DisableItem( SID_BEHIND_OBJ );
//STRIP001 /*?*/ 				rSet.DisableItem( SID_REVERSE_ORDER );
//STRIP001 /*?*/ 			}
/*?*/ 		}
/*?*/ 
/*?*/ 		if( SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_DISMANTLE ) ||
/*?*/ 			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_BREAK ) )
/*?*/ 		{
/*?*/ 			DBG_BF_ASSERT(0, "STRIP"); //STRIP001 if ( !pDrView->IsDismantlePossible(FALSE) )
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/ 				rSet.DisableItem( SID_DISMANTLE );
//STRIP001 /*?*/ 			}
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			if ( !pDrView->IsDismantlePossible(TRUE) &&
//STRIP001 /*?*/ 				 !pDrView->IsImportMtfPossible()     &&
//STRIP001 /*?*/ 				 !pDrView->IsBreak3DObjPossible() )
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/ 				rSet.DisableItem( SID_BREAK );
//STRIP001 /*?*/ 			}
/*?*/ 		}
/*?*/ 		if( SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_MODIFY_FIELD ) )
/*?*/ 		{
/*?*/ 			DBG_BF_ASSERT(0, "STRIP"); //STRIP001 OutlinerView* pOLV = pDrView->GetTextEditOutlinerView();
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			if( pOLV )
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/ 				const SvxFieldItem* pFldItem = pOLV->GetFieldAtSelection();
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 				if( !( pFldItem && (pFldItem->GetField()->ISA( SvxDateField ) ||
//STRIP001 /*?*/ 								 pFldItem->GetField()->ISA( SvxAuthorField ) ||
//STRIP001 /*?*/ 								 pFldItem->GetField()->ISA( SvxExtFileField ) ||
//STRIP001 /*?*/ 								 pFldItem->GetField()->ISA( SvxExtTimeField ) ) ) )
//STRIP001 /*?*/ 				{
//STRIP001 /*?*/ 					rSet.DisableItem( SID_MODIFY_FIELD );
//STRIP001 /*?*/ 				}
//STRIP001 /*?*/ 			}
//STRIP001 /*?*/ 			else
//STRIP001 /*?*/ 				rSet.DisableItem( SID_MODIFY_FIELD );
/*?*/ 		}
/*?*/ 
/*?*/ 		rSet.DisableItem( SID_GROUP );
/*?*/ 		rSet.DisableItem( SID_COMBINE );
/*?*/         rSet.DisableItem(SID_DISTRIBUTE_DLG);
/*?*/         rSet.DisableItem(SID_POLY_MERGE);
/*?*/         rSet.DisableItem(SID_POLY_SUBSTRACT);
/*?*/         rSet.DisableItem(SID_POLY_INTERSECT);
/*?*/ 		rSet.DisableItem( SID_CONNECT );
/*?*/ 	}
	// Mehrfachselektion
/*N*/ 	else if( nMarkCount > 1 )
/*N*/ 	{
/*?*/ 		DBG_BF_ASSERT(0, "STRIP"); //STRIP001 // distribure dialog for 3+n objects
//STRIP001 /*?*/ 		if(nMarkCount <= 2)
//STRIP001 			rSet.DisableItem(SID_DISTRIBUTE_DLG);
//STRIP001 
//STRIP001 //        rSet.ClearItem( SID_BEZIER_EDIT );
//STRIP001 //        rSet.DisableItem( SID_BEZIER_EDIT );
//STRIP001 		rSet.DisableItem( SID_LINEEND_POLYGON );
//STRIP001 		rSet.DisableItem( SID_ENTER_GROUP );
//STRIP001 		// Jetzt (28.10.96) muessen Namen fuer Objekte eindeutig sein
//STRIP001 		rSet.DisableItem( SID_NAME_GROUP );
//STRIP001 		rSet.DisableItem( SID_MODIFY_FIELD );
//STRIP001 
//STRIP001 		if( 1 )
//STRIP001 //		if( SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_ATTR_FILL_STYLE ) ||
//STRIP001 //			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_UNGROUP ) ||
//STRIP001 //			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_MEASURE_DLG ) ||
//STRIP001 //			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_CONNECTION_DLG ) ||
//STRIP001 //			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_COMBINE ) ||
//STRIP001 //            SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OBJECT_SHEAR ) ||
//STRIP001 //			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_TEXTATTR_DLG ) ||
//STRIP001 //			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_CONVERT_TO_3D_LATHE ) ||
//STRIP001 //			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_CONVERT_TO_3D_LATHE_FAST ) ||
//STRIP001 //			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OBJECT_ALIGN_LEFT ) ||
//STRIP001 //			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OBJECT_ALIGN_CENTER ) ||
//STRIP001 //			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OBJECT_ALIGN_RIGHT ) ||
//STRIP001 //			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OBJECT_ALIGN_UP ) ||
//STRIP001 //			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OBJECT_ALIGN_MIDDLE ) ||
//STRIP001 //			SFX_ITEM_AVAILABLE == rSet.GetItemState( SID_OBJECT_ALIGN_DOWN ) )
//STRIP001 		{
//STRIP001 			BOOL bText = FALSE;
//STRIP001 			BOOL bLine = FALSE;
//STRIP001 			BOOL bGroup = FALSE;
//STRIP001 			BOOL bGraf = FALSE;
//STRIP001 			BOOL bDrawObj = FALSE;
//STRIP001 			BOOL b3dObj = FALSE;
//STRIP001 			BOOL bTitOutText = FALSE;
//STRIP001 			BOOL bMeasureObj = FALSE;
//STRIP001 			BOOL bEdgeObj = FALSE; // Connector
//STRIP001 			BOOL bE3dCompoundObject = FALSE;
//STRIP001 
//STRIP001 			for( ULONG i = 0;
//STRIP001 				 i < nMarkCount && !bText && i < 50;
//STRIP001 				 i++ )
//STRIP001 			{
//STRIP001 				SdrObject* pObj = rMarkList.GetMark(i)->GetObj();
//STRIP001 				UINT32 nInv = pObj->GetObjInventor();
//STRIP001 				UINT16 nId = pObj->GetObjIdentifier();
//STRIP001 
//STRIP001 				if (nInv == SdrInventor)
//STRIP001 				{
//STRIP001 					switch (nId)
//STRIP001 					{
//STRIP001 						case OBJ_TEXT: bText = TRUE; break;
//STRIP001 
//STRIP001 						case OBJ_LINE: bLine = TRUE; break;
//STRIP001 
//STRIP001 						case OBJ_EDGE: bEdgeObj = TRUE; break;
//STRIP001 
//STRIP001 						case OBJ_MEASURE: bMeasureObj = TRUE; break;
//STRIP001 
//STRIP001 						case OBJ_RECT:
//STRIP001 						case OBJ_CIRC:
//STRIP001 						case OBJ_FREELINE:
//STRIP001 						case OBJ_FREEFILL:
//STRIP001 						case OBJ_PATHFILL:
//STRIP001 						case OBJ_PATHLINE:
//STRIP001 						case OBJ_SECT:
//STRIP001 						case OBJ_CARC:
//STRIP001 						case OBJ_CCUT: bDrawObj = TRUE; break;
//STRIP001 
//STRIP001 						case OBJ_GRUP: bGroup = TRUE; break;
//STRIP001 
//STRIP001 						case OBJ_GRAF: bGraf = TRUE; break;
//STRIP001 
//STRIP001 						case OBJ_TITLETEXT:
//STRIP001 						case OBJ_OUTLINETEXT: bTitOutText = TRUE; break;
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else if (nInv == E3dInventor)
//STRIP001 				{
//STRIP001 					if(pObj->ISA(E3dScene))
//STRIP001 						b3dObj = TRUE;
//STRIP001 					else if(pObj->ISA(E3dCompoundObject))
//STRIP001 						bE3dCompoundObject = TRUE;
//STRIP001 				}
//STRIP001 			}
//STRIP001 			/* Kann wohl raus, da jedes(?) Objekt Text enthalten kann
//STRIP001 			if( !bText )
//STRIP001 			{
//STRIP001 				rSet.DisableItem( SID_CHAR_DLG );
//STRIP001 				rSet.DisableItem( SID_PARA_DLG );
//STRIP001 				rSet.DisableItem( SID_BULLET );
//STRIP001 			}
//STRIP001 			*/
//STRIP001 			if( bLine && !bText && !bDrawObj &&!b3dObj)
//STRIP001 			{
//STRIP001 				//rSet.DisableItem( SID_ATTRIBUTES_AREA );
//STRIP001 				rSet.DisableItem( SID_ATTR_FILL_STYLE );
//STRIP001 			}
//STRIP001 			if( !bEdgeObj )
//STRIP001 				rSet.DisableItem( SID_CONNECTION_DLG );
//STRIP001 
//STRIP001 			if (b3dObj)
//STRIP001 			{
//STRIP001 				rSet.DisableItem( SID_COMBINE );
//STRIP001 				rSet.DisableItem(SID_POLY_MERGE);
//STRIP001 				rSet.DisableItem(SID_POLY_SUBSTRACT);
//STRIP001 				rSet.DisableItem(SID_POLY_INTERSECT);
//STRIP001 			}
//STRIP001 
//STRIP001 			if (b3dObj                                        ||
//STRIP001 				 (!pDrView->IsConvertToPathObjPossible(FALSE) &&
//STRIP001 				  !pDrView->IsShearAllowed()                  &&
//STRIP001 				  !pDrView->IsDistortAllowed()) )
//STRIP001 			{
//STRIP001 				rSet.DisableItem( SID_OBJECT_SHEAR );
//STRIP001 			}
//STRIP001 
//STRIP001 			if( !bGroup )
//STRIP001 			{
//STRIP001 				rSet.DisableItem( SID_UNGROUP );
//STRIP001 			}
//STRIP001 			if( bTitOutText )
//STRIP001 				rSet.DisableItem( SID_TEXTATTR_DLG );
//STRIP001 
//STRIP001 			if( !bMeasureObj )
//STRIP001 				rSet.DisableItem( SID_MEASURE_DLG );
//STRIP001 
//STRIP001 			if (!bGraf)
//STRIP001 			{
//STRIP001 				rSet.DisableItem(SID_CONVERT_TO_1BIT_THRESHOLD);
//STRIP001 				rSet.DisableItem(SID_CONVERT_TO_1BIT_MATRIX);
//STRIP001 				rSet.DisableItem(SID_CONVERT_TO_4BIT_GRAYS);
//STRIP001 				rSet.DisableItem(SID_CONVERT_TO_4BIT_COLORS);
//STRIP001 				rSet.DisableItem(SID_CONVERT_TO_8BIT_GRAYS);
//STRIP001 				rSet.DisableItem(SID_CONVERT_TO_8BIT_COLORS);
//STRIP001 				rSet.DisableItem(SID_CONVERT_TO_24BIT);
//STRIP001 			}
//STRIP001 
//STRIP001 			if(bE3dCompoundObject)
//STRIP001 			{
//STRIP001 				rSet.DisableItem( SID_OBJECT_ALIGN_LEFT );
//STRIP001 				rSet.DisableItem( SID_OBJECT_ALIGN_CENTER );
//STRIP001 				rSet.DisableItem( SID_OBJECT_ALIGN_RIGHT );
//STRIP001 				rSet.DisableItem( SID_OBJECT_ALIGN_UP );
//STRIP001 				rSet.DisableItem( SID_OBJECT_ALIGN_MIDDLE );
//STRIP001 				rSet.DisableItem( SID_OBJECT_ALIGN_DOWN );
//STRIP001 				rSet.DisableItem( SID_FRAME_TO_TOP );
//STRIP001 				rSet.DisableItem( SID_MOREFRONT );
//STRIP001 				rSet.DisableItem( SID_MOREBACK );
//STRIP001 				rSet.DisableItem( SID_FRAME_TO_BOTTOM );
//STRIP001 				rSet.DisableItem( SID_BEFORE_OBJ );
//STRIP001 				rSet.DisableItem( SID_BEHIND_OBJ );
//STRIP001 				rSet.DisableItem( SID_REVERSE_ORDER );
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		if ( !pDrView->IsDismantlePossible(FALSE) )
//STRIP001 		{
//STRIP001 			rSet.DisableItem( SID_DISMANTLE );
//STRIP001 		}
//STRIP001 		if ( !pDrView->IsDismantlePossible(TRUE) &&
//STRIP001 			 !pDrView->IsImportMtfPossible()     &&
//STRIP001 			 !pDrView->IsBreak3DObjPossible() )
//STRIP001 		{
//STRIP001 			rSet.DisableItem( SID_BREAK );
//STRIP001 		}
//STRIP001 		if ( !pDrView->IsCombinePossible(FALSE) )
//STRIP001 		{
//STRIP001 			rSet.DisableItem( SID_COMBINE );
//STRIP001 			rSet.DisableItem(SID_POLY_MERGE);
//STRIP001 			rSet.DisableItem(SID_POLY_SUBSTRACT);
//STRIP001 			rSet.DisableItem(SID_POLY_INTERSECT);
//STRIP001 		}
//STRIP001 		if ( !pDrView->IsCombinePossible(TRUE) )
//STRIP001 		{
//STRIP001 			rSet.DisableItem( SID_CONNECT );
//STRIP001 		}
//STRIP001 		if ( !pDrView->IsGroupPossible() )
//STRIP001 		{
//STRIP001 			rSet.DisableItem( SID_GROUP );
//STRIP001 		}
//STRIP001 		if ( !pDrView->IsUnGroupPossible() )
//STRIP001 		{
//STRIP001 			rSet.DisableItem( SID_UNGROUP );
//STRIP001 		}
/*N*/ 	}
	// kein Objekt selektiert
/*N*/ 	else
/*N*/ 	{
//        rSet.ClearItem( SID_BEZIER_EDIT );

/*N*/ 		rSet.DisableItem( SID_ENTER_GROUP );
/*N*/ 		rSet.DisableItem( SID_CUT );
/*N*/ 		rSet.DisableItem( SID_COPY );
/*N*/ 		rSet.DisableItem( SID_DELETE );
/*N*/ 		rSet.DisableItem( SID_ATTR_TRANSFORM );

/*N*/ 		rSet.DisableItem( SID_OBJECT_ALIGN_LEFT );
/*N*/ 		rSet.DisableItem( SID_OBJECT_ALIGN_CENTER );
/*N*/ 		rSet.DisableItem( SID_OBJECT_ALIGN_RIGHT );
/*N*/ 		rSet.DisableItem( SID_OBJECT_ALIGN_UP );
/*N*/ 		rSet.DisableItem( SID_OBJECT_ALIGN_MIDDLE );
/*N*/ 		rSet.DisableItem( SID_OBJECT_ALIGN_DOWN );

/*N*/ 		rSet.DisableItem( SID_FRAME_TO_TOP );
/*N*/ 		rSet.DisableItem( SID_MOREFRONT );
/*N*/ 		rSet.DisableItem( SID_MOREBACK );
/*N*/ 		rSet.DisableItem( SID_FRAME_TO_BOTTOM );
/*N*/ 		rSet.DisableItem( SID_BEFORE_OBJ );
/*N*/ 		rSet.DisableItem( SID_BEHIND_OBJ );
/*N*/ 		rSet.DisableItem( SID_CONVERT );

//		rSet.DisableItem( SID_BEZIER_EDIT );
/*N*/ 		rSet.DisableItem( SID_SIZE_OPTIMAL );
/*N*/ 		rSet.DisableItem( SID_LINEEND_POLYGON );
/*N*/ 		rSet.DisableItem( SID_COPYOBJECTS );
/*N*/ 		rSet.DisableItem( SID_HORIZONTAL );
/*N*/ 		rSet.DisableItem( SID_VERTICAL );
/*N*/ 		rSet.DisableItem( SID_GROUP );
/*N*/ 		rSet.DisableItem( SID_UNGROUP );
/*N*/ 		rSet.DisableItem( SID_NAME_GROUP );
/*N*/ 		rSet.DisableItem( SID_DISMANTLE );
/*N*/ 		rSet.DisableItem( SID_BREAK );
/*N*/ 		rSet.DisableItem( SID_COMBINE );
/*N*/         rSet.DisableItem(SID_DISTRIBUTE_DLG);
/*N*/         rSet.DisableItem(SID_POLY_MERGE);
/*N*/         rSet.DisableItem(SID_POLY_SUBSTRACT);
/*N*/         rSet.DisableItem(SID_POLY_INTERSECT);
/*N*/ 		rSet.DisableItem( SID_CONNECT );
/*N*/ 		rSet.DisableItem( SID_ANIMATION_EFFECTS );
/*N*/ 		rSet.DisableItem( SID_MODIFY_FIELD );
/*N*/ 		rSet.DisableItem (SID_OBJECT_SHEAR);
/*N*/ 	}

/*N*/ }

/*************************************************************************
|*
|* Notify
|*
\************************************************************************/

/*N*/ void SdDrawViewShell::SFX_NOTIFY(SfxBroadcaster& rBC, const TypeId& rBCType,
/*N*/ 								 const SfxHint& rHint, const TypeId& rHintType)
/*N*/ {
/*N*/ 	BOOL bOK = FALSE;
/*N*/ 
/*N*/ 	// Zuerst die Basisklasse
/*N*/ 	SdViewShell::SFX_NOTIFY(rBC, rBCType, rHint, rHintType);
/*N*/ 
/*N*/ 	SfxSimpleHint* pSimple = PTR_CAST(SfxSimpleHint, &rHint);
/*N*/ 	ULONG nId = pSimple == NULL ? 0 : pSimple->GetId();
/*N*/ 
/*N*/ 	if (nId == SFX_HINT_MODECHANGED)
/*N*/ 	{
/*N*/ 		if (pDocSh->IsReadOnly() && pFuActual && !pFuActual->ISA(FuSelection))
/*N*/ 		{
			// Aktuelle Funktion beenden und Selektion aktivieren
/*?*/ 			SfxRequest aReq(SID_OBJECT_SELECT, 0, pDoc->GetItemPool());
/*?*/ 			FuPermanent(aReq);
/*?*/ 			bOK = TRUE;
/*?*/ 		}

/*N*/ 		if (pDocSh->IsReadOnly() != bReadOnly )
/*?*/ 		{
/*?*/ 			bReadOnly = pDocSh->IsReadOnly();

/*?*/ 			SfxBoolItem aItem( SID_FM_DESIGN_MODE, !bReadOnly );
/*?*/ 			GetViewFrame()->GetDispatcher()->Execute( SID_FM_DESIGN_MODE,
/*?*/ 					  SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD, &aItem, 0L );
/*?*/ 		}
/*?*/ 	}

/*?*/ 	if( rHint.IsA(TYPE(SfxEventHint)) )
/*?*/ 	{
/*?*/ 		if( ((SfxEventHint&)rHint).GetEventId() == SFX_EVENT_OPENDOC )
/*?*/ 		{
/*?*/ 			DBG_BF_ASSERT(0, "STRIP"); //STRIP001 if( pDoc && pDoc->IsStartWithPresentation() )
//STRIP001 /*?*/ 			{
//STRIP001 /*?*/ 				if( GetViewFrame() )
//STRIP001 /*?*/ 				{
//STRIP001 /*?*/ 					pDoc->SetStartWithPresentation( false );
//STRIP001 /*?*/ 					GetViewFrame()->GetDispatcher()->Execute( SID_PRESENTATION, SFX_CALLMODE_ASYNCHRON );
//STRIP001 /*?*/ 				}
//STRIP001 /*?*/ 			}
/*?*/ 		}
/*?*/ 	}
/*N*/ }


}
