/*************************************************************************
 *
 *  $RCSfile: saxnamespacefilter.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:22:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef INCLUDED_SFX_SAXNAMESPACEFILTER_HXX_
#define INCLUDED_SFX_SAXNAMESPACEFILTER_HXX_

// auto strip #ifndef _COM_SUN_STAR_XML_SAX_XDOCUMENTHANDLER_HPP_
// auto strip #include <com/sun/star/xml/sax/XDocumentHandler.hpp>
// auto strip #endif

// auto strip #ifndef __FRAMEWORK_CLASSES_XMLNAMESPACES_HXX_
// auto strip #include <xmlnamespaces.hxx>
// auto strip #endif

#ifndef _RTL_USTRING_
#include <rtl/ustring>
#endif

// auto strip #ifndef _SV_MENU_HXX
// auto strip #include <vcl/menu.hxx>
// auto strip #endif

// auto strip #ifndef _CPPUHELPER_WEAK_HXX_
// auto strip #include <cppuhelper/weak.hxx>
// auto strip #endif

#include <stack>
namespace binfilter {

//_________________________________________________________________________________________________________________
//	namespace
//_________________________________________________________________________________________________________________

//STRIP001 class SaxNamespaceFilter : public ::com::sun::star::xml::sax::XDocumentHandler,
//STRIP001 						   public ::cppu::OWeakObject
//STRIP001 {
//STRIP001 	public:
//STRIP001 		SaxNamespaceFilter( ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XDocumentHandler >& rSax1DocumentHandler );
//STRIP001 		virtual ~SaxNamespaceFilter();
//STRIP001 
//STRIP001 		// XInterface
//STRIP001 		virtual void SAL_CALL acquire() throw()
//STRIP001 			{ OWeakObject::acquire(); }
//STRIP001 		virtual void SAL_CALL release() throw()
//STRIP001 			{ OWeakObject::release(); }
//STRIP001 		virtual ::com::sun::star::uno::Any SAL_CALL queryInterface( 
//STRIP001 			const ::com::sun::star::uno::Type & rType ) throw( ::com::sun::star::uno::RuntimeException );
//STRIP001 
//STRIP001 		// XDocumentHandler
//STRIP001 		virtual void SAL_CALL startDocument(void)
//STRIP001 		throw (	::com::sun::star::xml::sax::SAXException, 
//STRIP001 				::com::sun::star::uno::RuntimeException );
//STRIP001 		
//STRIP001 		virtual void SAL_CALL endDocument(void)
//STRIP001 		throw(	::com::sun::star::xml::sax::SAXException, 
//STRIP001 				::com::sun::star::uno::RuntimeException );
//STRIP001 		
//STRIP001 		virtual void SAL_CALL startElement(
//STRIP001 			const ::rtl::OUString& aName,
//STRIP001 			const ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XAttributeList > &xAttribs)
//STRIP001 		throw(	::com::sun::star::xml::sax::SAXException, 
//STRIP001 				::com::sun::star::uno::RuntimeException );
//STRIP001 		
//STRIP001 		virtual void SAL_CALL endElement(const ::rtl::OUString& aName)
//STRIP001 		throw(	::com::sun::star::xml::sax::SAXException, 
//STRIP001 				::com::sun::star::uno::RuntimeException );
//STRIP001 		
//STRIP001 		virtual void SAL_CALL characters(const ::rtl::OUString& aChars)
//STRIP001 		throw(	::com::sun::star::xml::sax::SAXException, 
//STRIP001 				::com::sun::star::uno::RuntimeException );
//STRIP001 
//STRIP001 		virtual void SAL_CALL ignorableWhitespace(const ::rtl::OUString& aWhitespaces)
//STRIP001 		throw(	::com::sun::star::xml::sax::SAXException, 
//STRIP001 				::com::sun::star::uno::RuntimeException );
//STRIP001 
//STRIP001 		virtual void SAL_CALL processingInstruction(const ::rtl::OUString& aTarget,
//STRIP001 													const ::rtl::OUString& aData)
//STRIP001 		throw(	::com::sun::star::xml::sax::SAXException, 
//STRIP001 				::com::sun::star::uno::RuntimeException );
//STRIP001 		
//STRIP001 		virtual void SAL_CALL setDocumentLocator( 
//STRIP001 			const ::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XLocator > &xLocator)
//STRIP001 		throw(	::com::sun::star::xml::sax::SAXException,
//STRIP001 				::com::sun::star::uno::RuntimeException );
//STRIP001 
//STRIP001 	protected:
//STRIP001 		typedef ::std::stack< XMLNamespaces > NamespaceStack;
//STRIP001 
//STRIP001 		::rtl::OUString getErrorLineString();
//STRIP001 		
//STRIP001 		::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XLocator > m_xLocator;
//STRIP001 		::com::sun::star::uno::Reference< ::com::sun::star::xml::sax::XDocumentHandler> xDocumentHandler;
//STRIP001 		NamespaceStack	m_aNamespaceStack;
//STRIP001 		sal_Int32		m_nDepth;
//STRIP001 };

}//end of namespace binfilter
#endif // INCLUDED_SFX_SAXNAMESPACEFILTER_HXX_
