/*************************************************************************
 *
 *  $RCSfile: sfx2_bstritem.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:38:18 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
// INCLUDE ---------------------------------------------------------------

#pragma hdrstop

#include "bstritem.hxx"
#include "segmentc.hxx"
namespace binfilter {

// STATIC DATA -----------------------------------------------------------

//STRIP001 SEG_EOFGLOBALS()
//STRIP001 
//STRIP001 // ------------------------------------------------------------------------
//STRIP001 // SfxBoolStringItem
//STRIP001 
//STRIP001 #pragma SEG_FUNCDEF(bstritem_01)
//STRIP001 
//STRIP001 BOOL SfxBoolStringItem::SetStringValue( const String & rVal)
//STRIP001 {
//STRIP001 	aVal = rVal;
//STRIP001 	return TRUE;
//STRIP001 }
//STRIP001 
//STRIP001 #pragma SEG_FUNCDEF(bstritem_02)
//STRIP001 
//STRIP001 SfxPoolItem*    SfxBoolStringItem::Clone() const
//STRIP001 {
//STRIP001 	return new SfxBoolStringItem(*this);
//STRIP001 }
//STRIP001 
//STRIP001 #pragma SEG_FUNCDEF(bstritem_03)
//STRIP001 
//STRIP001 SfxItemType 	SfxBoolStringItem::Type() const
//STRIP001 {
//STRIP001 	return (SfxItemType )SFX_TYPE_BOOL_STRING;
//STRIP001 }
//STRIP001 
//STRIP001 #pragma SEG_FUNCDEF(bstritem_04)
//STRIP001 
//STRIP001 int SfxBoolStringItem::operator==( const SfxPoolItem& rCmp) const
//STRIP001 {
//STRIP001 	return rCmp.Type() == Type() &&
//STRIP001 		aVal == ((const SfxBoolStringItem &)rCmp).aVal &&
//STRIP001 		SfxBoolItem::operator==(rCmp);
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 // CTOR / DTOR -----------------------------------------------------------
//STRIP001 #pragma SEG_FUNCDEF(bstritem_05)
//STRIP001 
//STRIP001 SfxBoolStringItem::SfxBoolStringItem( USHORT nWhich, BOOL bValue) :
//STRIP001 	SfxBoolItem(nWhich, bValue)
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 #pragma SEG_FUNCDEF(bstritem_06)
//STRIP001 
//STRIP001 SfxBoolStringItem::SfxBoolStringItem( USHORT nWhich, BOOL bValue, const String &rStr) :
//STRIP001 	SfxBoolItem(nWhich, bValue),
//STRIP001 	aVal(rStr)
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 #pragma SEG_FUNCDEF(bstritem_07)
//STRIP001 
//STRIP001 SfxBoolStringItem::SfxBoolStringItem( const SfxBoolStringItem& rCopy) :
//STRIP001 	SfxBoolItem(rCopy),
//STRIP001 	aVal(rCopy.aVal)
//STRIP001 {
//STRIP001 }

//STRIP001 #pragma SEG_EOFMODULE


}
