/*************************************************************************
 *
 *  $RCSfile: sfx2_plugwin.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:34:02 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
// auto strip #include "plugwin.hxx"

// auto strip #include <vcl/svapp.hxx>
// auto strip #include <svtools/stritem.hxx>
// auto strip #include <svtools/intitem.hxx>
// auto strip #include <vcl/stdtext.hxx>
// auto strip #include <tools/urlobj.hxx>
// auto strip #ifndef _COM_SUN_STAR_FRAME_XCONTROLLER_HPP_
// auto strip #include <com/sun/star/frame/XController.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_FRAME_XFRAMEACTIONLISTENER_HPP_
// auto strip #include <com/sun/star/frame/XFrameActionListener.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_FRAME_XCOMPONENTLOADER_HPP_
// auto strip #include <com/sun/star/frame/XComponentLoader.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_FRAME_XFRAME_HPP_
// auto strip #include <com/sun/star/frame/XFrame.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_FRAME_FRAMEACTIONEVENT_HPP_
// auto strip #include <com/sun/star/frame/FrameActionEvent.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_FRAME_FRAMEACTION_HPP_
// auto strip #include <com/sun/star/frame/FrameAction.hpp>
// auto strip #endif
// auto strip #ifndef _UNOTOOLS_PROCESSFACTORY_HXX_
// auto strip #include <comphelper/processfactory.hxx>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_PLUGIN_PLUGINMODE_HPP_
// auto strip #include <com/sun/star/plugin/PluginMode.hpp>
// auto strip #endif

// auto strip #include <toolkit/helper/vclunohelper.hxx>

// auto strip #include "docfile.hxx"
// auto strip #include "docfilt.hxx"
// auto strip #include "request.hxx"
#include "sfxsids.hrc"

// auto strip #ifndef _LEGACYBINFILTERMGR_HXX
// auto strip #include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
// auto strip #endif
namespace binfilter {

//STRIP001 void SfxPlugWindow_Impl::Resize()
//STRIP001 {
//STRIP001 	if ( xControl.is() )
//STRIP001 	{
//STRIP001 		Size aSize( GetOutputSizePixel() );
//STRIP001 		::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow >  xWin( xControl, ::com::sun::star::uno::UNO_QUERY );
//STRIP001 		xWin->setPosSize( 0, 0, aSize.Width(), aSize.Height(), WINDOW_POSSIZE_ALL );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 SfxPlugWindow_Impl::SfxPlugWindow_Impl( Window *pParent )
//STRIP001 	: Window( pParent )
//STRIP001 	, nEventId( 0 )
//STRIP001 {
//STRIP001 //	nEventId = Application::PostUserEvent( LINK( this, SfxPlugWindow_Impl, StartPlugIn ), 0 );
//STRIP001 }
//STRIP001 
//STRIP001 SfxPlugWindow_Impl::~SfxPlugWindow_Impl()
//STRIP001 {
//STRIP001 	if ( xPlugin.is() )
//STRIP001 	{
//STRIP001 		::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent >  xComp( xPlugin, ::com::sun::star::uno::UNO_QUERY );
//STRIP001 		if ( xComp.is() )
//STRIP001 			xComp->dispose();
//STRIP001 		xPlugin = ::com::sun::star::uno::Reference< ::com::sun::star::plugin::XPlugin > ();
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( xControl.is() )
//STRIP001 	{
//STRIP001 		::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow >  xWin( xControl, ::com::sun::star::uno::UNO_QUERY );
//STRIP001 		xWin->dispose();
//STRIP001 	}
//STRIP001 
//STRIP001 	if( nEventId )
//STRIP001 	{
//STRIP001 		Application::RemoveUserEvent( nEventId );
//STRIP001 		nEventId = 0;
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void SfxPlugWindow_Impl::StartPlugin( const ::rtl::OUString& rURL, const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >& aArgs )
//STRIP001 {
//STRIP001     ::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >  xMan = ::legacy_binfilters::getLegacyProcessServiceFactory();
//STRIP001 	::com::sun::star::uno::Reference< ::com::sun::star::plugin::XPluginManager >  xPlugMgr( xMan->createInstance( DEFINE_CONST_UNICODE("com.sun.star.plugin.PluginManager") ), ::com::sun::star::uno::UNO_QUERY );
//STRIP001 #if SUPD>564
//STRIP001 	::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >  xFact( xMan->createInstance( DEFINE_CONST_UNICODE("com.sun.star.frame.DataSourceFactory") ), ::com::sun::star::uno::UNO_QUERY );
//STRIP001 #else
//STRIP001 	::com::sun::star::uno::Reference< ::com::sun::star::lang::XMultiServiceFactory >  xFact( xMan->createInstance( DEFINE_CONST_UNICODE("stardiv.one.frame.DataSourceFactory") ), ::com::sun::star::uno::UNO_QUERY );
//STRIP001 #endif
//STRIP001 	if ( xPlugMgr.is() && xFact.is() )
//STRIP001 	{
//STRIP001 		short nMode = ::com::sun::star::plugin::PluginMode::FULL;
//STRIP001 		::rtl::OUString aMimeType;
//STRIP001 		const ::com::sun::star::beans::PropertyValue* pProps = aArgs.getConstArray();
//STRIP001 		long nLen = aArgs.getLength();
//STRIP001 		long n;
//STRIP001 		for ( n=0; n<nLen; n++ )
//STRIP001 		{
//STRIP001 			if ( pProps[n].Name.compareToAscii("ContentType")==0 )
//STRIP001 				pProps[n].Value >>= aMimeType ;
//STRIP001 			else if ( pProps[n].Name.compareToAscii("PluginMode")==0 )
//STRIP001 				pProps[n].Value >>= nMode ;
//STRIP001 		}
//STRIP001 
//STRIP001 //		::com::sun::star::uno::Reference< ::com::sun::star::io::XActiveDataSource >  xSource = rMedium.GetDataSource();
//STRIP001 
//STRIP001 		String aURL( rURL );
//STRIP001 		::com::sun::star::uno::Sequence < ::com::sun::star::uno::Any > aArgs(1);
//STRIP001 		aArgs.getArray()[0] <<= rURL ;
//STRIP001 		String aProt( INetURLObject::GetScheme( INetURLObject( aURL ).GetProtocol() ) );
//STRIP001 		::com::sun::star::uno::Reference< ::com::sun::star::io::XActiveDataSource >  xSource( xFact->createInstanceWithArguments( aProt , aArgs ), ::com::sun::star::uno::UNO_QUERY );
//STRIP001 
//STRIP001 		::com::sun::star::uno::Reference< ::com::sun::star::plugin::XPluginContext >  xCtx = xPlugMgr->createPluginContext();
//STRIP001 		::com::sun::star::uno::Sequence< ::com::sun::star::plugin::PluginDescription > aDescr = xPlugMgr->getPluginDescriptions();
//STRIP001 		const ::com::sun::star::plugin::PluginDescription *pArr = aDescr.getConstArray();
//STRIP001 		nLen = aDescr.getLength();
//STRIP001 		for ( n=0; n<aDescr.getLength(); n++ )
//STRIP001 		{
//STRIP001 			::rtl::OUString aMime = pArr[n].Mimetype;
//STRIP001 			if ( aMimeType == aMime )
//STRIP001 			{
//STRIP001 				const ::com::sun::star::uno::Sequence < ::rtl::OUString> noargs;
//STRIP001 				xPlugin = xPlugMgr->createPlugin( xCtx, nMode, noargs, noargs, pArr[n] );
//STRIP001 				xControl = ::com::sun::star::uno::Reference< ::com::sun::star::awt::XControl > ( xPlugin, ::com::sun::star::uno::UNO_QUERY );
//STRIP001 #if SUPD > 582
//STRIP001 				::com::sun::star::uno::Reference < class ::com::sun::star::awt::XWindowPeer > xTmp ( VCLUnoHelper::GetInterface(this), ::com::sun::star::uno::UNO_QUERY );
//STRIP001 				xControl->createPeer( Application::GetVCLToolkit(), xTmp );
//STRIP001 #endif
//STRIP001 				::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow >  xWin( xControl, ::com::sun::star::uno::UNO_QUERY );
//STRIP001 				Resize();
//STRIP001 				xWin->setVisible( sal_True );
//STRIP001 				xPlugin->provideNewStream( aMime, xSource, rURL, 0l, 0l, sal_False );
//STRIP001 				break;
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		DBG_ASSERT( xPlugin.is(), "RegisterPlugin ging daneben" );
//STRIP001 	}
//STRIP001 	else
//STRIP001 		ShowServiceNotAvailableError( NULL, DEFINE_CONST_UNICODE("PluginManager"), sal_True );
//STRIP001 
//STRIP001 	// StatusText vom Plugin wieder loeschen
//STRIP001 	GetpApp()->HideStatusText();
//STRIP001 }
//STRIP001 
//STRIP001 IMPL_LINK( SfxAsyncServiceErrorHandler_Impl, TimerHdl, Timer*, pTimer )
//STRIP001 {
//STRIP001 	aTimer.Stop();
//STRIP001 	ShowServiceNotAvailableError( NULL, aService, sal_True );
//STRIP001 	delete this;
//STRIP001 	return 0L;
//STRIP001 }
//STRIP001 
//STRIP001 SFX_IMPL_XINTERFACE_1( PluginLoader, OWeakObject, ::com::sun::star::frame::XFrameLoader )
//STRIP001 SFX_IMPL_XTYPEPROVIDER_1( PluginLoader, ::com::sun::star::frame::XFrameLoader )
//STRIP001 SFX_IMPL_XSERVICEINFO( PluginLoader, "com.sun.star.frame.FrameLoader", "com.sun.star.comp.sfx2.PluginLoader" )
//STRIP001 SFX_IMPL_SINGLEFACTORY( PluginLoader )
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 PluginLoader::PluginLoader( ::com::sun::star::uno::Reference < ::com::sun::star::lang::XMultiServiceFactory > const & )
//STRIP001 {
//STRIP001 	DBG_ERRORFILE( "NIJ" );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 PluginLoader::~PluginLoader()
//STRIP001 {}
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 void PluginLoader::load (	const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > &					rFrame		,
//STRIP001 								const ::rtl::OUString&						rURL		,
//STRIP001 								const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >&	rArgs		,
//STRIP001 								const ::com::sun::star::uno::Reference< ::com::sun::star::frame::XLoadEventListener > &		rListener	) throw ( ::com::sun::star::uno::RuntimeException )
//STRIP001 {
//STRIP001 	::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow >  aWindow = rFrame->getContainerWindow () ;
//STRIP001 	if ( aWindow.is() )
//STRIP001 	{
//STRIP001 		SfxPlugWindow_Impl* pWindow = new SfxPlugWindow_Impl( VCLUnoHelper::GetWindow(aWindow) );
//STRIP001         rFrame->setComponent( ::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow > ( pWindow->GetComponentInterface(), ::com::sun::star::uno::UNO_QUERY ), ::com::sun::star::uno::Reference< ::com::sun::star::frame::XController > () );
//STRIP001 		rFrame->setComponent( aWindow, ::com::sun::star::uno::Reference< ::com::sun::star::frame::XController >() );
//STRIP001 		pWindow->StartPlugin( rURL, rArgs );
//STRIP001 		if ( rListener.is() )
//STRIP001 			rListener->loadFinished( this );
//STRIP001 	}
//STRIP001 	else if ( rListener.is() )
//STRIP001 		rListener->loadCancelled( this );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 void PluginLoader::cancel(void) throw ( ::com::sun::star::uno::RuntimeException )
//STRIP001 {
//STRIP001 }
}
