/*************************************************************************
 *
 *  $RCSfile: infodlgs.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:57:20 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _INFODLGS_HXX
#define _INFODLGS_HXX

// includes ******************************************************************


// auto strip #ifndef _SV_BUTTON_HXX //autogen
// auto strip #include <vcl/button.hxx>
// auto strip #endif
// auto strip #ifndef _SV_FIXED_HXX //autogen
// auto strip #include <vcl/fixed.hxx>
// auto strip #endif
// auto strip #ifndef _SV_DIALOG_HXX //autogen
// auto strip #include <vcl/dialog.hxx>
// auto strip #endif
// auto strip #ifndef _SV_EDIT_HXX //autogen
// auto strip #include <vcl/edit.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
namespace binfilter {

//****************************************************************************
// SfxShortFixedText_Impl
//****************************************************************************

/*
  [Beschreibung]
  Instanzen dieser Klasse pruefen, ob der ueber den Ctor spezifizierte Text in
  das Textfeld passt. Ist dies nicht der Fall, so wird selbiger gekuerzt und
  eine Hilfe wird angezeigt, wenn der Benutzer mit der Maus ueber dem Feld
  steht.
  */

//STRIP001 class SfxShortFixedText_Impl : public FixedText
//STRIP001 {
//STRIP001 
//STRIP001 	String       _aQuickHelpText;
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	virtual void RequestHelp( const HelpEvent& rEvt );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 				 SfxShortFixedText_Impl( Window* pParent, USHORT,
//STRIP001 										 const String& rText );
//STRIP001 				 SfxShortFixedText_Impl( Window* pParent,
//STRIP001 										 const ResId& rResId );
//STRIP001 
//STRIP001 	void         SetText( const String& rText );
//STRIP001 
//STRIP001 };

//****************************************************************************
// SfxQueryDeleteDlg_Impl
//****************************************************************************

enum SfxQueryDeleteResult_Impl
{
	SFX_QUERYDELETE_YES = 0,
	SFX_QUERYDELETE_NO,
	SFX_QUERYDELETE_ALL,
	SFX_QUERYDELETE_CANCEL
};

//STRIP001 class SfxQueryDeleteDlg_Impl : public ModalDialog
//STRIP001 {
//STRIP001 	FixedText                 _aEntryLabel;
//STRIP001 	SfxShortFixedText_Impl    _aEntry;
//STRIP001 
//STRIP001 	FixedText                 _aQueryMsg;
//STRIP001 
//STRIP001 	PushButton                _aYesButton;
//STRIP001 	PushButton                _aAllButton;
//STRIP001 	PushButton                _aNoButton;
//STRIP001 	CancelButton              _aCancelButton;
//STRIP001 
//STRIP001 	SfxQueryDeleteResult_Impl _eResult;
//STRIP001 
//STRIP001 private:
//STRIP001 
//STRIP001 	DECL_STATIC_LINK( SfxQueryDeleteDlg_Impl, ClickLink, PushButton* );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 							  SfxQueryDeleteDlg_Impl( Window* pParent,
//STRIP001 													  const String& rLabel,
//STRIP001 													  const String& rName,
//STRIP001 													  const String& rMsg,
//STRIP001 													  BOOL bWithAll = FALSE );
//STRIP001 
//STRIP001 	SfxQueryDeleteResult_Impl GetResult() const
//STRIP001 							  {
//STRIP001 								  return _eResult;
//STRIP001 							  }
//STRIP001 };

//****************************************************************************
// SfxQueryOverwriteDlg_Impl
//****************************************************************************

#ifndef RET_ALL
#define RET_ALL (RET_RETRY)
#endif

}//end of namespace binfilter
#endif

