/*************************************************************************
 *
 *  $RCSfile: hyphen.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 15:17:43 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_HYPHEN_HXX
#define _SVX_HYPHEN_HXX

// include ---------------------------------------------------------------

// auto strip #ifndef _SV_EDIT_HXX
// auto strip #include <vcl/edit.hxx>
// auto strip #endif
// auto strip #ifndef _SV_BUTTON_HXX
// auto strip #include <vcl/button.hxx>
// auto strip #endif
// auto strip #ifndef _SV_FIXED_HXX
// auto strip #include <vcl/fixed.hxx>
// auto strip #endif
// auto strip #ifndef _BASEDLGS_HXX
// auto strip #include <bf_sfx2/basedlgs.hxx>
// auto strip #endif

// auto strip #ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
// auto strip #include <com/sun/star/uno/Reference.hxx>
// auto strip #endif
// forward ---------------------------------------------------------------

namespace com{namespace sun{namespace star{
namespace linguistic2{
	class XHyphenator;
	class XPossibleHyphens;
}}}}
namespace binfilter {

//STRIP001 class SvxSpellWrapper;

// class SvxHyphenEdit ---------------------------------------------------

//STRIP001 class SvxHyphenEdit : public Edit
//STRIP001 {
//STRIP001 public:
//STRIP001 	SvxHyphenEdit( Window* pParent, const ResId& rResId );
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void 	KeyInput( const KeyEvent &rKEvt );
//STRIP001 };

// class SvxHyphenWordDialog ---------------------------------------------

//STRIP001 class SvxHyphenWordDialog : public SfxModalDialog
//STRIP001 {
//STRIP001 public:
//STRIP001 	SvxHyphenWordDialog( const String &rWord, LanguageType nLang,
//STRIP001 						 Window* pParent,
//STRIP001 						 ::com::sun::star::uno::Reference<
//STRIP001 						 	::com::sun::star::linguistic2::XHyphenator >  &xHyphen,
//STRIP001 						 SvxSpellWrapper* pWrapper );
//STRIP001 
//STRIP001 	void			SelLeft();
//STRIP001 	void			SelRight();
//STRIP001 
//STRIP001 private:
//STRIP001     FixedText           aWordFT;
//STRIP001 	SvxHyphenEdit		aWordEdit;
//STRIP001 	ImageButton			aLeftBtn;
//STRIP001 	ImageButton			aRightBtn;
//STRIP001 	OKButton			aOkBtn;
//STRIP001 	CancelButton		aCancelBtn;
//STRIP001 	PushButton			aContBtn;
//STRIP001 	PushButton			aDelBtn;
//STRIP001 	HelpButton			aHelpBtn;
//STRIP001 	String				aLabel;
//STRIP001 	SvxSpellWrapper* 	pHyphWrapper;
//STRIP001 	::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::linguistic2::XHyphenator > 		xHyphenator;
//STRIP001 	::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::linguistic2::XPossibleHyphens > 	xPossHyph;
//STRIP001 	String				aActWord;		// actual (to be displayed) word
//STRIP001 	LanguageType		nActLanguage;	// and language
//STRIP001 	sal_uInt16				nMaxHyphenationPos;	// right most valid hyphenation pos
//STRIP001 	sal_uInt16 				nHyphPos;
//STRIP001 	sal_uInt16 				nOldPos;
//STRIP001 	sal_Bool				bBusy;
//STRIP001 
//STRIP001 #ifdef _SVX_HYPHEN_CXX
//STRIP001 	void			EnableLRBtn_Impl();
//STRIP001 	//void			EnableCutBtn_Impl();
//STRIP001 	void			SetLabel_Impl( LanguageType nLang );
//STRIP001 	String 			EraseUnusableHyphens_Impl(
//STRIP001 						::com::sun::star::uno::Reference<
//STRIP001 							::com::sun::star::linguistic2::XPossibleHyphens >  &rxPossHyph,
//STRIP001 						sal_uInt16 nMaxHyphenationPos );
//STRIP001 
//STRIP001 	void			InitControls_Impl();
//STRIP001 	void			ContinueHyph_Impl( sal_uInt16 nInsPos = 0 );
//STRIP001 	sal_uInt16 			GetHyphIndex_Impl();
//STRIP001 
//STRIP001 	DECL_LINK( CutHdl_Impl, Button* );
//STRIP001 	DECL_LINK( DeleteHdl_Impl, Button* );
//STRIP001 	DECL_LINK( ContinueHdl_Impl, Button* );
//STRIP001 	DECL_LINK( CancelHdl_Impl, Button* );
//STRIP001 	DECL_LINK( Left_Impl, Button* );
//STRIP001 	DECL_LINK( Right_Impl, Button* );
//STRIP001 	DECL_LINK( GetFocusHdl_Impl, Edit* );
//STRIP001 	DECL_LINK( LangError_Impl, void* );
//STRIP001 #endif
//STRIP001 };


}//end of namespace binfilter
#endif

