/*************************************************************************
 *
 *  $RCSfile: svx_simptabl.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:42:35 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// INCLUDE -------------------------------------------------------------------

#include "simptabl.hxx"
#include <vcl/svapp.hxx>

#ifndef _UNOTOOLS_PROCESSFACTORY_HXX
#include <comphelper/processfactory.hxx>
#endif
#ifndef _UNOTOOLS_INTLWRAPPER_HXX
#include <unotools/intlwrapper.hxx>
#endif

#ifndef _LEGACYBINFILTERMGR_HXX
#include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
#endif
namespace binfilter {

// SvxSimpTblContainer  ------------------------------------------------------

//STRIP001 SvxSimpTblContainer::SvxSimpTblContainer( Window* pParent, WinBits nWinStyle):
//STRIP001 		Control(pParent,nWinStyle)
//STRIP001 {
//STRIP001 	//Do Nothing;
//STRIP001 }

//STRIP001 SvxSimpTblContainer::SvxSimpTblContainer( Window* pParent, const ResId& rResId):
//STRIP001 		Control(pParent,rResId)
//STRIP001 {
//STRIP001 	//Do Nothing;
//STRIP001 }

//STRIP001 long SvxSimpTblContainer::PreNotify( NotifyEvent& rNEvt )
//STRIP001 {
//STRIP001 	long nResult=TRUE;
//STRIP001 
//STRIP001 	USHORT nSwitch=rNEvt.GetType();
//STRIP001 	if(nSwitch==EVENT_KEYINPUT)
//STRIP001 	{
//STRIP001 		const KeyCode& aKeyCode=rNEvt.GetKeyEvent()->GetKeyCode();
//STRIP001 		USHORT nKey=aKeyCode.GetCode();
//STRIP001 		if(nKey==KEY_TAB)
//STRIP001 		{
//STRIP001 			GetParent()->Notify(rNEvt);
//STRIP001 		}
//STRIP001 		else
//STRIP001 			nResult=Control::PreNotify(rNEvt);
//STRIP001 	}
//STRIP001 	else
//STRIP001 		nResult=Control::PreNotify(rNEvt);
//STRIP001 
//STRIP001 	return nResult;
//STRIP001 }


// SvxSimpleTable ------------------------------------------------------------

//STRIP001 SvxSimpleTable::SvxSimpleTable( Window* pParent,WinBits nBits ):
//STRIP001 		SvTabListBox(pParent,WB_CLIPCHILDREN | WB_HSCROLL | WB_TABSTOP),
//STRIP001 		aPrivContainer(pParent,nBits|WB_DIALOGCONTROL),
//STRIP001 		aHeaderBar(pParent,WB_BUTTONSTYLE | WB_BORDER | WB_TABSTOP),
//STRIP001 		bResizeFlag(FALSE),
//STRIP001 		bPaintFlag(TRUE),
//STRIP001 		nHeaderItemId(1)
//STRIP001 {
//STRIP001 	bSortDirection=TRUE;
//STRIP001 	nSortCol=0xFFFF;
//STRIP001 	nOldPos=0;
//STRIP001 
//STRIP001 	SetParent(&aPrivContainer);
//STRIP001 	aHeaderBar.SetParent(&aPrivContainer);
//STRIP001 
//STRIP001 	aHeaderBar.SetStartDragHdl(LINK( this, SvxSimpleTable, StartDragHdl));
//STRIP001 	aHeaderBar.SetDragHdl(LINK( this, SvxSimpleTable, DragHdl));
//STRIP001 	aHeaderBar.SetEndDragHdl(LINK( this, SvxSimpleTable, EndDragHdl));
//STRIP001 	aHeaderBar.SetSelectHdl(LINK( this, SvxSimpleTable, HeaderBarClick));
//STRIP001 	aHeaderBar.SetDoubleClickHdl(LINK( this, SvxSimpleTable, HeaderBarDblClick));
//STRIP001 
//STRIP001 	aHeaderBar.Show();
//STRIP001 	SvTabListBox::Show();
//STRIP001 }


//STRIP001 SvxSimpleTable::SvxSimpleTable( Window* pParent,const ResId& rResId):
//STRIP001 		SvTabListBox(pParent,WB_CLIPCHILDREN | WB_HSCROLL | WB_TABSTOP),
//STRIP001 		aPrivContainer(pParent,rResId),
//STRIP001 		aHeaderBar(pParent,WB_BUTTONSTYLE | WB_BORDER  | WB_TABSTOP),
//STRIP001 		bResizeFlag(TRUE),
//STRIP001 		bPaintFlag(TRUE),
//STRIP001 		nHeaderItemId(1)
//STRIP001 {
//STRIP001 
//STRIP001 	bSortDirection=TRUE;
//STRIP001 	nOldPos=0;
//STRIP001 	nSortCol=0xFFFF;
//STRIP001 
//STRIP001 	pMyParentWin=pParent;
//STRIP001 	SetParent(&aPrivContainer);
//STRIP001 	aHeaderBar.SetParent(&aPrivContainer);
//STRIP001 
//STRIP001 	WinBits nBits=aPrivContainer.GetStyle()|WB_DIALOGCONTROL;
//STRIP001 	aPrivContainer.SetStyle(nBits);
//STRIP001 
//STRIP001 	aHeaderBar.SetStartDragHdl(LINK( this, SvxSimpleTable, StartDragHdl));
//STRIP001 	aHeaderBar.SetDragHdl(LINK( this, SvxSimpleTable, DragHdl));
//STRIP001 	aHeaderBar.SetEndDragHdl(LINK( this, SvxSimpleTable, EndDragHdl));
//STRIP001 	aHeaderBar.SetSelectHdl(LINK( this, SvxSimpleTable, HeaderBarClick));
//STRIP001 	aHeaderBar.SetDoubleClickHdl(LINK( this, SvxSimpleTable, HeaderBarDblClick));
//STRIP001 
//STRIP001 	Size theWinSize=aPrivContainer.GetOutputSizePixel();
//STRIP001 	Size HbSize=aHeaderBar.GetSizePixel();
//STRIP001 
//STRIP001 	HbSize.Width()=theWinSize.Width();
//STRIP001 	theWinSize.Height()-=HbSize.Height();
//STRIP001 	Point	thePos(0,0);
//STRIP001 
//STRIP001 	aHeaderBar.SetPosPixel(thePos);
//STRIP001 	aHeaderBar.SetSizePixel(HbSize);
//STRIP001 
//STRIP001 	thePos.Y()+=HbSize.Height();
//STRIP001 	SvTabListBox::SetPosPixel(thePos);
//STRIP001 	SvTabListBox::SetSizePixel(theWinSize);
//STRIP001 	aHeaderBar.Show();
//STRIP001 	SetWindowBits(WB_CLIPCHILDREN | WB_HSCROLL);
//STRIP001 	SvTabListBox::Show();
//STRIP001 }

//STRIP001 SvxSimpleTable::~SvxSimpleTable()
//STRIP001 {
//STRIP001 	SetParent(pMyParentWin);
//STRIP001 	aPrivContainer.SetParent(this);
//STRIP001 	aHeaderBar.SetParent(this);
//STRIP001 }


//STRIP001 void SvxSimpleTable::UpdateViewSize()
//STRIP001 {
//STRIP001 	Size theWinSize=aPrivContainer.GetOutputSizePixel();
//STRIP001 	Size HbSize=aHeaderBar.GetSizePixel();
//STRIP001 
//STRIP001 	HbSize.Width()=theWinSize.Width();
//STRIP001 	theWinSize.Height()-=HbSize.Height();
//STRIP001 	Point	thePos(0,0);
//STRIP001 
//STRIP001 	aHeaderBar.SetPosPixel(thePos);
//STRIP001 	aHeaderBar.SetSizePixel(HbSize);
//STRIP001 
//STRIP001 	thePos.Y()+=HbSize.Height();
//STRIP001 	SvTabListBox::SetPosPixel(thePos);
//STRIP001 	SvTabListBox::SetSizePixel(theWinSize);
//STRIP001 	Invalidate();
//STRIP001 }

//STRIP001 void SvxSimpleTable::NotifyScrolled()
//STRIP001 {
//STRIP001 	long nOffset=-GetXOffset();
//STRIP001 	if(nOldPos!=nOffset)
//STRIP001 	{
//STRIP001 		aHeaderBar.SetOffset(nOffset);
//STRIP001 		aHeaderBar.Invalidate();
//STRIP001 		aHeaderBar.Update();
//STRIP001 		nOldPos=nOffset;
//STRIP001 	}
//STRIP001 	SvTabListBox::NotifyScrolled();
//STRIP001 }

//STRIP001 void SvxSimpleTable::SetTabs()
//STRIP001 {
//STRIP001 	SvTabListBox::SetTabs();
//STRIP001 
//STRIP001 	USHORT nPrivTabCount = TabCount();
//STRIP001 	if ( nPrivTabCount )
//STRIP001 	{
//STRIP001 		if ( nPrivTabCount > aHeaderBar.GetItemCount() )
//STRIP001 			nPrivTabCount = aHeaderBar.GetItemCount();
//STRIP001 
//STRIP001 		USHORT i, nNewSize = (USHORT)GetTab(0), nPos = 0;
//STRIP001 		for ( i = 1; i < nPrivTabCount; ++i )
//STRIP001 		{
//STRIP001 			nNewSize = GetTab(i) - nPos;
//STRIP001 			aHeaderBar.SetItemSize( i, nNewSize );
//STRIP001 			nPos = (USHORT)GetTab(i);
//STRIP001 		}
//STRIP001 
//STRIP001 		aHeaderBar.SetItemSize( i, HEADERBAR_FULLSIZE ); // because no tab for last entry
//STRIP001 	}
//STRIP001 }

//STRIP001 void SvxSimpleTable::SetTabs( long* pTabs, MapUnit eMapUnit)
//STRIP001 {
//STRIP001 	SvTabListBox::SetTabs(pTabs,eMapUnit);
//STRIP001 }

//STRIP001 void SvxSimpleTable::Paint( const Rectangle& rRect )
//STRIP001 {
//STRIP001 	SvTabListBox::Paint(rRect );
//STRIP001 
//STRIP001 	USHORT nPrivTabCount = TabCount();
//STRIP001 	USHORT nPos = 0;
//STRIP001 	USHORT nNewSize = ( nPrivTabCount > 0 ) ? (USHORT)GetTab(0) : 0;
//STRIP001 
//STRIP001 	long nOffset=-GetXOffset();
//STRIP001 	nOldPos=nOffset;
//STRIP001 
//STRIP001 	aHeaderBar.SetOffset(nOffset);
//STRIP001 	aHeaderBar.Invalidate();
//STRIP001 
//STRIP001 	if(nPrivTabCount && bPaintFlag)
//STRIP001 	{
//STRIP001 		if(nPrivTabCount>aHeaderBar.GetItemCount())
//STRIP001 				nPrivTabCount=aHeaderBar.GetItemCount();
//STRIP001 
//STRIP001 		for(USHORT i=1;i<nPrivTabCount;i++)
//STRIP001 		{
//STRIP001 			nNewSize=GetTab(i)-nPos;
//STRIP001 			aHeaderBar.SetItemSize(i,nNewSize );
//STRIP001 			nPos=(USHORT) GetTab(i);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	bPaintFlag=TRUE;
//STRIP001 }
//STRIP001 void SvxSimpleTable::InsertHeaderEntry(const XubString& rText,USHORT nCol,
//STRIP001 									   HeaderBarItemBits nBits)
//STRIP001 {
//STRIP001 	xub_StrLen nEnd = rText.Search( sal_Unicode( '\t' ) );
//STRIP001 	if( nEnd == STRING_NOTFOUND )
//STRIP001 	{
//STRIP001 		aHeaderBar.InsertItem(nHeaderItemId++, rText, 0, nBits, nCol);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		xub_StrLen nCount = rText.GetTokenCount( sal_Unicode( '\t' ) );
//STRIP001 
//STRIP001 		for( xub_StrLen i=0; i<nCount; i++ )
//STRIP001 		{
//STRIP001 			String	aString=rText.GetToken(i, sal_Unicode( '\t' ) );
//STRIP001 			aHeaderBar.InsertItem(nHeaderItemId++, aString, 0, nBits, nCol);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	SetTabs();
//STRIP001 }

//STRIP001 void SvxSimpleTable::ClearAll()
//STRIP001 {
//STRIP001 	aHeaderBar.Clear();
//STRIP001 	Clear();
//STRIP001 }
//STRIP001 void SvxSimpleTable::ClearHeader()
//STRIP001 {
//STRIP001 	aHeaderBar.Clear();
//STRIP001 }

//STRIP001 void SvxSimpleTable::Show()
//STRIP001 {
//STRIP001 	aPrivContainer.Show();
//STRIP001 }

//STRIP001 void SvxSimpleTable::Hide()
//STRIP001 {
//STRIP001 	aPrivContainer.Show();
//STRIP001 }

//STRIP001 BOOL SvxSimpleTable::IsVisible() const
//STRIP001 {
//STRIP001 	return aPrivContainer.IsVisible();
//STRIP001 }

//STRIP001 void SvxSimpleTable::Enable()
//STRIP001 {
//STRIP001 	aPrivContainer.Enable();
//STRIP001 }

//STRIP001 void SvxSimpleTable::Disable()
//STRIP001 {
//STRIP001 	aPrivContainer.Disable();
//STRIP001 }

//STRIP001 BOOL SvxSimpleTable::IsEnabled() const
//STRIP001 {
//STRIP001 	return aPrivContainer.IsEnabled();
//STRIP001 }

//STRIP001 void SvxSimpleTable::ToTop()
//STRIP001 {
//STRIP001 	aPrivContainer.ToTop();
//STRIP001 }

//STRIP001 void SvxSimpleTable::SetPosPixel( const Point& rNewPos )
//STRIP001 {
//STRIP001 	aPrivContainer.SetPosPixel(rNewPos);
//STRIP001 }

//STRIP001 Point SvxSimpleTable::GetPosPixel() const
//STRIP001 {
//STRIP001 	return aPrivContainer.GetPosPixel();
//STRIP001 }

//STRIP001 void SvxSimpleTable::SetPosSizePixel( const Point& rNewPos, Size& rNewSize )
//STRIP001 {
//STRIP001 	aPrivContainer.SetPosPixel(rNewPos);
//STRIP001 	aPrivContainer.SetSizePixel(rNewSize);
//STRIP001 }

//STRIP001 void SvxSimpleTable::SetPosSize( const Point& rNewPos, const Size& rNewSize )
//STRIP001 {
//STRIP001 	aPrivContainer.SetPosPixel(rNewPos);
//STRIP001 	SvTabListBox::SetPosSizePixel(rNewPos,rNewSize);
//STRIP001 }

//STRIP001 Size SvxSimpleTable::GetSizePixel() const
//STRIP001 {
//STRIP001 	return aPrivContainer.GetSizePixel();
//STRIP001 }

//STRIP001 Size SvxSimpleTable::GetOutputSizePixel() const
//STRIP001 {
//STRIP001 	return aPrivContainer.GetOutputSizePixel();
//STRIP001 }

//STRIP001 void SvxSimpleTable::SetSizePixel(const Size& rNewSize )
//STRIP001 {
//STRIP001 	aPrivContainer.SetSizePixel(rNewSize);
//STRIP001 	UpdateViewSize();
//STRIP001 }

//STRIP001 void SvxSimpleTable::SetOutputSizePixel(const Size& rNewSize )
//STRIP001 {
//STRIP001 	aPrivContainer.SetOutputSizePixel(rNewSize);
//STRIP001 	UpdateViewSize();
//STRIP001 }

//STRIP001 USHORT SvxSimpleTable::GetSelectedCol()
//STRIP001 {
//STRIP001 	return (aHeaderBar.GetCurItemId()-1);
//STRIP001 }

//STRIP001 void SvxSimpleTable::SortByCol(USHORT nCol,BOOL bDir)
//STRIP001 {
//STRIP001 	bSortDirection=bDir;
//STRIP001 	if(nSortCol!=0xFFFF)
//STRIP001 		aHeaderBar.SetItemBits(nSortCol+1,HIB_STDSTYLE);
//STRIP001 
//STRIP001 	if (nCol != 0xFFFF)
//STRIP001 	{
//STRIP001 		if(bDir)
//STRIP001 		{
//STRIP001 			aHeaderBar.SetItemBits( nCol+1, HIB_STDSTYLE | HIB_DOWNARROW);
//STRIP001 			GetModel()->SetSortMode(SortAscending);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aHeaderBar.SetItemBits( nCol+1, HIB_STDSTYLE | HIB_UPARROW);
//STRIP001 			GetModel()->SetSortMode(SortDescending);
//STRIP001 		}
//STRIP001 		nSortCol=nCol;
//STRIP001 		GetModel()->SetCompareHdl( LINK( this, SvxSimpleTable, CompareHdl));
//STRIP001 		GetModel()->Resort();
//STRIP001 	}
//STRIP001 	else
//STRIP001 		GetModel()->SetSortMode(SortNone);
//STRIP001 	nSortCol=nCol;
//STRIP001 }

//STRIP001 void SvxSimpleTable::HBarClick()
//STRIP001 {
//STRIP001 	USHORT nId=aHeaderBar.GetCurItemId();
//STRIP001 
//STRIP001 	if (aHeaderBar.GetItemBits(nId) & HIB_CLICKABLE)
//STRIP001 	{
//STRIP001 		if(nId==nSortCol+1)
//STRIP001 		{
//STRIP001 			SortByCol(nId-1,!bSortDirection);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			SortByCol(nId-1,bSortDirection);
//STRIP001 		}
//STRIP001 
//STRIP001 		aHeaderBarClickLink.Call(this);
//STRIP001 	}
//STRIP001 }

//STRIP001 void SvxSimpleTable::HBarDblClick()
//STRIP001 {
//STRIP001 	aHeaderBarDblClickLink.Call(this);
//STRIP001 }

//STRIP001 void SvxSimpleTable::HBarStartDrag()
//STRIP001 {
//STRIP001 	if(!aHeaderBar.IsItemMode())
//STRIP001 	{
//STRIP001 		Rectangle aSizeRect(Point(0,0),
//STRIP001 			SvTabListBox::GetOutputSizePixel());
//STRIP001 		aSizeRect.Left()=-GetXOffset()+aHeaderBar.GetDragPos();
//STRIP001 		aSizeRect.Right()=-GetXOffset()+aHeaderBar.GetDragPos();
//STRIP001 		ShowTracking( aSizeRect, SHOWTRACK_SPLIT );
//STRIP001 	}
//STRIP001 }
//STRIP001 void SvxSimpleTable::HBarDrag()
//STRIP001 {
//STRIP001 	HideTracking();
//STRIP001 	if(!aHeaderBar.IsItemMode())
//STRIP001 	{
//STRIP001 		Rectangle aSizeRect(Point(0,0),
//STRIP001 			SvTabListBox::GetOutputSizePixel());
//STRIP001 		aSizeRect.Left()=-GetXOffset()+aHeaderBar.GetDragPos();
//STRIP001 		aSizeRect.Right()=-GetXOffset()+aHeaderBar.GetDragPos();
//STRIP001 		ShowTracking( aSizeRect, SHOWTRACK_SPLIT );
//STRIP001 	}
//STRIP001 }
//STRIP001 void SvxSimpleTable::HBarEndDrag()
//STRIP001 {
//STRIP001 	HideTracking();
//STRIP001 	USHORT nPrivTabCount=TabCount();
//STRIP001 	USHORT nPos=0;
//STRIP001 	USHORT nNewSize=0;
//STRIP001 
//STRIP001 	if(nPrivTabCount)
//STRIP001 	{
//STRIP001 		if(nPrivTabCount>aHeaderBar.GetItemCount())
//STRIP001 				nPrivTabCount=aHeaderBar.GetItemCount();
//STRIP001 
//STRIP001 		//for(USHORT i=1;i<=nPrivTabCount;i++)
//STRIP001 		for(USHORT i=1;i<nPrivTabCount;i++)
//STRIP001 		{
//STRIP001 			nNewSize=aHeaderBar.GetItemSize(i)+nPos;
//STRIP001 			SetTab(i,nNewSize,MAP_PIXEL);
//STRIP001 			nPos=nNewSize;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	bPaintFlag=FALSE;
//STRIP001 	Invalidate();
//STRIP001 	Update();
//STRIP001 }

//STRIP001 CommandEvent SvxSimpleTable::GetCommandEvent() const
//STRIP001 {
//STRIP001 	return aCEvt;
//STRIP001 }

//STRIP001 void SvxSimpleTable::Command( const CommandEvent& rCEvt )
//STRIP001 {
//STRIP001 	aCEvt=rCEvt;
//STRIP001 	aCommandLink.Call(this);
//STRIP001 	SvTabListBox::Command(rCEvt);
//STRIP001 }

//STRIP001 IMPL_LINK( SvxSimpleTable, StartDragHdl, HeaderBar*, pCtr)
//STRIP001 {
//STRIP001 	if(pCtr==&aHeaderBar)
//STRIP001 	{
//STRIP001 		HBarStartDrag();
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

//STRIP001 IMPL_LINK( SvxSimpleTable, DragHdl, HeaderBar*, pCtr)
//STRIP001 {
//STRIP001 	if(pCtr==&aHeaderBar)
//STRIP001 	{
//STRIP001 		HBarDrag();
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

//STRIP001 IMPL_LINK( SvxSimpleTable, EndDragHdl, HeaderBar*, pCtr)
//STRIP001 {
//STRIP001 	if(pCtr==&aHeaderBar)
//STRIP001 	{
//STRIP001 		HBarEndDrag();
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

//STRIP001 IMPL_LINK( SvxSimpleTable, HeaderBarClick, HeaderBar*, pCtr)
//STRIP001 {
//STRIP001 	if(pCtr==&aHeaderBar)
//STRIP001 	{
//STRIP001 		HBarClick();
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

//STRIP001 IMPL_LINK( SvxSimpleTable, HeaderBarDblClick, HeaderBar*, pCtr)
//STRIP001 {
//STRIP001 	if(pCtr==&aHeaderBar)
//STRIP001 	{
//STRIP001 		HBarDblClick();
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

//STRIP001 SvLBoxItem* SvxSimpleTable::GetEntryAtPos( SvLBoxEntry* pEntry, USHORT nPos ) const
//STRIP001 {
//STRIP001 	DBG_ASSERT(pEntry,"GetEntryText:Invalid Entry");
//STRIP001 	SvLBoxItem* pItem = NULL;
//STRIP001 
//STRIP001 	if( pEntry )
//STRIP001 	{
//STRIP001 		USHORT nCount = pEntry->ItemCount();
//STRIP001 
//STRIP001 		nPos++;
//STRIP001 
//STRIP001 		if( nTreeFlags & TREEFLAG_CHKBTN ) nPos++;
//STRIP001 
//STRIP001 		if( nPos < nCount )
//STRIP001 		{
//STRIP001 			pItem = pEntry->GetItem( nPos);
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return pItem;
//STRIP001 }

//STRIP001 StringCompare SvxSimpleTable::ColCompare(SvLBoxEntry* pLeft,SvLBoxEntry* pRight)
//STRIP001 {
//STRIP001 	StringCompare eCompare=COMPARE_EQUAL;
//STRIP001 
//STRIP001 	SvLBoxItem* pLeftItem = GetEntryAtPos( pLeft, nSortCol);
//STRIP001 	SvLBoxItem* pRightItem = GetEntryAtPos( pRight, nSortCol);
//STRIP001 
//STRIP001 
//STRIP001 	if(pLeftItem != NULL && pRightItem != NULL)
//STRIP001 	{
//STRIP001 		USHORT nLeftKind=pLeftItem->IsA();
//STRIP001 		USHORT nRightKind=pRightItem->IsA();
//STRIP001 
//STRIP001 		if(nRightKind == SV_ITEM_ID_LBOXSTRING &&
//STRIP001 			nLeftKind == SV_ITEM_ID_LBOXSTRING )
//STRIP001 		{
//STRIP001 			IntlWrapper aIntlWrapper( ::legacy_binfilters::getLegacyProcessServiceFactory(), Application::GetSettings().GetLocale() );
//STRIP001 			const CollatorWrapper* pCollator = aIntlWrapper.getCaseCollator();
//STRIP001 
//STRIP001 			eCompare=(StringCompare)pCollator->compareString( ((SvLBoxString*)pLeftItem)->GetText(),
//STRIP001 									((SvLBoxString*)pRightItem)->GetText());
//STRIP001 
//STRIP001 			if(eCompare==COMPARE_EQUAL) eCompare=COMPARE_LESS;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return eCompare;
//STRIP001 }

//STRIP001 IMPL_LINK( SvxSimpleTable, CompareHdl, SvSortData*, pData)
//STRIP001 {
//STRIP001 	SvLBoxEntry* pLeft = (SvLBoxEntry*)(pData->pLeft );
//STRIP001 	SvLBoxEntry* pRight = (SvLBoxEntry*)(pData->pRight );
//STRIP001 	return (long) ColCompare(pLeft,pRight);
//STRIP001 }


}
