/*************************************************************************
 *
 *  $RCSfile: svx_codec.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 15:53:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #include <tools/stream.hxx>
// auto strip #include <tools/zcodec.hxx>
// auto strip #include "codec.hxx"
namespace binfilter {

// ----------------
// - GalleryCodec -
// ----------------

//STRIP001 GalleryCodec::GalleryCodec( SvStream& rIOStm ) : 
//STRIP001     rStm( rIOStm )
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 GalleryCodec::~GalleryCodec()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 BOOL GalleryCodec::IsCoded( SvStream& rStm, UINT32& rVersion )
//STRIP001 {
//STRIP001 	const ULONG	nPos = rStm.Tell();
//STRIP001 	BOOL		bRet;
//STRIP001 	BYTE		cByte1, cByte2, cByte3, cByte4, cByte5, cByte6;
//STRIP001 
//STRIP001 	rStm >> cByte1 >> cByte2 >> cByte3 >> cByte4 >> cByte5 >> cByte6;
//STRIP001 
//STRIP001 	if ( cByte1 == 'S' && cByte2 == 'V' && cByte3 == 'R' && cByte4 == 'L' && cByte5 == 'E' && ( cByte6 == '1' || cByte6 == '2' ) )
//STRIP001 	{
//STRIP001         rVersion = ( ( cByte6 == '1' ) ? 1 : 2 );
//STRIP001 		bRet = TRUE;
//STRIP001 	}
//STRIP001     else
//STRIP001     {
//STRIP001         rVersion = 0;
//STRIP001 		bRet = FALSE;
//STRIP001     }
//STRIP001 
//STRIP001 	rStm.Seek( nPos );
//STRIP001 
//STRIP001 	return bRet;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void GalleryCodec::Write( SvStream& rStmToWrite )
//STRIP001 {
//STRIP001 	UINT32 nPos, nCompSize;
//STRIP001 	
//STRIP001     rStmToWrite.Seek( STREAM_SEEK_TO_END );
//STRIP001 	const UINT32 nSize = rStmToWrite.Tell();
//STRIP001 	rStmToWrite.Seek( 0UL );
//STRIP001 
//STRIP001 	rStm << 'S' << 'V' << 'R' << 'L' << 'E' << '2';
//STRIP001 	rStm << nSize;
//STRIP001 
//STRIP001 	nPos = rStm.Tell();
//STRIP001 	rStm.SeekRel( 4UL );
//STRIP001 
//STRIP001     ZCodec aCodec;
//STRIP001     aCodec.BeginCompression();
//STRIP001     aCodec.Compress( rStmToWrite, rStm );
//STRIP001     aCodec.EndCompression();
//STRIP001 
//STRIP001 	nCompSize = rStm.Tell() - nPos - 4UL;
//STRIP001 	rStm.Seek( nPos );
//STRIP001 	rStm << nCompSize;
//STRIP001 	rStm.Seek( STREAM_SEEK_TO_END );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 void GalleryCodec::Read( SvStream& rStmToRead )
//STRIP001 {
//STRIP001 	UINT32 nVersion = 0;
//STRIP001 
//STRIP001 	if( IsCoded( rStm, nVersion ) )
//STRIP001 	{
//STRIP001         BYTE*   pUnCompressedBuffer = NULL;
//STRIP001 		UINT32	nCompressedSize, nUnCompressedSize;
//STRIP001 
//STRIP001 		rStm.SeekRel( 6 );
//STRIP001 		rStm >> nUnCompressedSize >> nCompressedSize;
//STRIP001 
//STRIP001 		// decompress
//STRIP001         if( 1 == nVersion )
//STRIP001         {
//STRIP001             BYTE*   pCompressedBuffer = new BYTE[ nCompressedSize ]; rStm.Read( pCompressedBuffer, nCompressedSize );
//STRIP001 	        BYTE*	pInBuf = pCompressedBuffer;
//STRIP001 	        BYTE*	pOutBuf = new BYTE[ nUnCompressedSize ];
//STRIP001 	        BYTE*	pTmpBuf = pOutBuf;
//STRIP001 	        BYTE*	pLast = pOutBuf + nUnCompressedSize - 1;
//STRIP001 	        ULONG   nIndex = 0UL, nCountByte, nRunByte;
//STRIP001 	        BOOL    bEndDecoding = FALSE;
//STRIP001 
//STRIP001 	        do
//STRIP001 	        {
//STRIP001 		        nCountByte = *pInBuf++;
//STRIP001 
//STRIP001 		        if ( !nCountByte )
//STRIP001 		        {
//STRIP001 			        nRunByte = *pInBuf++;
//STRIP001 
//STRIP001 			        if ( nRunByte > 2 )
//STRIP001 			        {
//STRIP001 				        // absolutes Fuellen
//STRIP001 				        memcpy( &pTmpBuf[ nIndex ], pInBuf, nRunByte );
//STRIP001 				        pInBuf += nRunByte;
//STRIP001 				        nIndex += nRunByte;
//STRIP001 
//STRIP001 				        // WORD-Alignment beachten
//STRIP001 				        if ( nRunByte & 1 )
//STRIP001 					        pInBuf++;
//STRIP001 			        }
//STRIP001 			        else if ( nRunByte == 1 )   // Ende des Bildes
//STRIP001 				        bEndDecoding = TRUE;
//STRIP001 		        }
//STRIP001 		        else
//STRIP001 		        {
//STRIP001 			        const BYTE cVal = *pInBuf++;
//STRIP001 
//STRIP001 			        memset( &pTmpBuf[ nIndex ], cVal, nCountByte );
//STRIP001 			        nIndex += nCountByte;
//STRIP001 		        }
//STRIP001 	        }
//STRIP001 	        while ( !bEndDecoding && ( pTmpBuf <= pLast ) );
//STRIP001 
//STRIP001    		    rStmToRead.Write( pOutBuf, nUnCompressedSize );
//STRIP001             
//STRIP001             delete[] pOutBuf;
//STRIP001             delete[] pCompressedBuffer;
//STRIP001         }
//STRIP001         else if( 2 == nVersion )
//STRIP001         {
//STRIP001 	        ZCodec aCodec;
//STRIP001 
//STRIP001             aCodec.BeginCompression();
//STRIP001             aCodec.Decompress( rStm, rStmToRead );
//STRIP001             aCodec.EndCompression();
//STRIP001         }
//STRIP001 	}
//STRIP001 }
}
