/*************************************************************************
 *
 *  $RCSfile: svx_optaccessibility.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:45:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#ifndef _SVX_OPTACCESSIBILITY_HXX
#include <optaccessibility.hxx>
#endif
#include <optaccessibility.hrc>
#include <dialmgr.hxx>
#include "dialogs.hrc"
#ifndef INCLUDED_SVTOOLS_ACCESSIBILITYOPTIONS_HXX
#include <svtools/accessibilityoptions.hxx>
#endif
#ifndef _SV_SETTINGS_HXX
#include <vcl/settings.hxx>
#endif
#ifndef _SV_SVAPP_HXX
#include <vcl/svapp.hxx>
#endif
namespace binfilter {

//STRIP001 static void MovePosY( Window& _rWin, long _nDelta )
//STRIP001 {
//STRIP001 	Point	aPoint = _rWin.GetPosPixel();
//STRIP001 	aPoint.Y() += _nDelta;
//STRIP001 	
//STRIP001 	_rWin.SetPosPixel( aPoint );
//STRIP001 }
//STRIP001 
//STRIP001 struct SvxAccessibilityOptionsTabPage_Impl
//STRIP001 {
//STRIP001 	SvtAccessibilityOptions 	m_aConfig;
//STRIP001 	SvxAccessibilityOptionsTabPage_Impl()
//STRIP001 			: m_aConfig(){}
//STRIP001 };
//STRIP001 
//STRIP001 SvxAccessibilityOptionsTabPage::SvxAccessibilityOptionsTabPage( Window* pParent, const SfxItemSet& rSet )
//STRIP001 	:SfxTabPage(pParent, ResId( RID_SVXPAGE_ACCESSIBILITYCONFIG, DIALOG_MGR() ), rSet)
//STRIP001 	,m_aMiscellaneousLabel		(this, ResId(FL_MISCELLANEOUS		))
//STRIP001 	,m_aAccessibilityTool		(this, ResId(CB_ACCESSIBILITY_TOOL	))
//STRIP001     ,m_aTextSelectionInReadonly	(this, ResId(CB_TEXTSELECTION		))
//STRIP001 	,m_aSystemFont				(this, ResId(CB_SYSTEM_FONT			))
//STRIP001 	,m_aAnimatedGraphics		(this, ResId(CB_ANIMATED_GRAPHICS	))
//STRIP001 	,m_aAnimatedTexts			(this, ResId(CB_ANIMATED_TEXTS		))
//STRIP001 	,m_aTipHelpCB				(this, ResId(CB_TIPHELP				))
//STRIP001 	,m_aTipHelpNF				(this, ResId(NF_TIPHELP				))
//STRIP001 	,m_aTipHelpFT				(this, ResId(FT_TIPHELP				))
//STRIP001 	,m_aHCOptionsLabel			(this, ResId(FL_HC_OPTIONS			))
//STRIP001 	,m_aAutoDetectHC			(this, ResId(CB_AUTO_DETECT_HC		))
//STRIP001 	,m_aAutomaticFontColor		(this, ResId(CB_AUTOMATIC_FONT_COLOR))
//STRIP001     ,m_aPagePreviews			(this, ResId(CB_PAGE_PREVIEWS       ))
//STRIP001 	,m_pImpl(new SvxAccessibilityOptionsTabPage_Impl)
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 	m_aTipHelpCB.SetClickHdl(LINK(this, SvxAccessibilityOptionsTabPage, TipHelpHdl));
//STRIP001 
//STRIP001 	long nHeightDelta = 0;		// to correct positions _under_ m_aAccessibilityTool
//STRIP001 
//STRIP001 #ifdef UNX
//STRIP001 	{
//STRIP001 		// UNIX: read the gconf2 setting instead to use the checkbox
//STRIP001 		m_aAccessibilityTool.Hide();
//STRIP001 		nHeightDelta = -( ROWA_2 - ROWA_1 );
//STRIP001 	}
//STRIP001 #else
//STRIP001 	// calculate the height of the checkbox. Do we need two (default in resource) or only one line
//STRIP001 	String aText = m_aAccessibilityTool.GetText();
//STRIP001 	long nWidth = m_aAccessibilityTool.GetTextWidth( aText );
//STRIP001 	long nCtrlWidth = m_aAccessibilityTool.GetSizePixel().Width() - ( COL2 - COL1 );
//STRIP001 	if ( nWidth > nCtrlWidth )
//STRIP001 	{
//STRIP001 		long nDelta = 2 * RSC_CD_FIXEDLINE_HEIGHT + LINESPACE - RSC_CD_CHECKBOX_HEIGHT;
//STRIP001 		nHeightDelta = nDelta;
//STRIP001 		Size aSize = m_aAccessibilityTool.LogicToPixel( Size( 0, nDelta ), MAP_APPFONT );
//STRIP001 		nDelta = aSize.Height();
//STRIP001 		aSize = m_aAccessibilityTool.GetSizePixel();
//STRIP001 		aSize.Height() += nDelta;
//STRIP001 		m_aAccessibilityTool.SetSizePixel( aSize );
//STRIP001 	}
//STRIP001 #endif
//STRIP001 
//STRIP001 	if( nHeightDelta )
//STRIP001 	{	//adjust positions of controls under m_aAccessibilityTool
//STRIP001 		Size aSize = m_aAccessibilityTool.LogicToPixel( Size( 0, nHeightDelta ), MAP_APPFONT );
//STRIP001 		nHeightDelta = aSize.Height();
//STRIP001 
//STRIP001 		MovePosY( m_aTextSelectionInReadonly, nHeightDelta );
//STRIP001 		MovePosY( m_aSystemFont, nHeightDelta );
//STRIP001 		MovePosY( m_aAnimatedGraphics, nHeightDelta );
//STRIP001 		MovePosY( m_aAnimatedTexts, nHeightDelta );
//STRIP001 		MovePosY( m_aTipHelpCB, nHeightDelta );
//STRIP001 		MovePosY( m_aTipHelpNF, nHeightDelta );
//STRIP001 		MovePosY( m_aTipHelpFT, nHeightDelta );
//STRIP001 		MovePosY( m_aHCOptionsLabel, nHeightDelta );
//STRIP001 		MovePosY( m_aAutoDetectHC, nHeightDelta );
//STRIP001 		MovePosY( m_aAutomaticFontColor, nHeightDelta );
//STRIP001 		MovePosY( m_aPagePreviews, nHeightDelta );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 SvxAccessibilityOptionsTabPage::~SvxAccessibilityOptionsTabPage()
//STRIP001 {
//STRIP001 	delete m_pImpl;
//STRIP001 }
//STRIP001 
//STRIP001 SfxTabPage*	SvxAccessibilityOptionsTabPage::Create( Window* pParent, const SfxItemSet& rAttrSet )
//STRIP001 {
//STRIP001 	return new SvxAccessibilityOptionsTabPage(pParent, rAttrSet);
//STRIP001 }
//STRIP001 
//STRIP001 BOOL SvxAccessibilityOptionsTabPage::FillItemSet( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	//aConfig.Set... from controls
//STRIP001 
//STRIP001     m_pImpl->m_aConfig.SetIsForPagePreviews( m_aPagePreviews.IsChecked() );
//STRIP001 	m_pImpl->m_aConfig.SetIsHelpTipsDisappear( m_aTipHelpCB.IsChecked() );
//STRIP001 	m_pImpl->m_aConfig.SetHelpTipSeconds( (short)m_aTipHelpNF.GetValue() );
//STRIP001 	m_pImpl->m_aConfig.SetIsAllowAnimatedGraphics( m_aAnimatedGraphics.IsChecked() );
//STRIP001 	m_pImpl->m_aConfig.SetIsAllowAnimatedText( m_aAnimatedTexts.IsChecked() );
//STRIP001 	m_pImpl->m_aConfig.SetIsAutomaticFontColor(	m_aAutomaticFontColor.IsChecked() );
//STRIP001 	m_pImpl->m_aConfig.SetIsSystemFont( m_aSystemFont.IsChecked() );
//STRIP001     m_pImpl->m_aConfig.SetSelectionInReadonly( m_aTextSelectionInReadonly.IsChecked());
//STRIP001     m_pImpl->m_aConfig.SetAutoDetectSystemHC( m_aAutoDetectHC.IsChecked());
//STRIP001 
//STRIP001 	if(m_pImpl->m_aConfig.IsModified())
//STRIP001 		m_pImpl->m_aConfig.Commit();
//STRIP001 
//STRIP001 #ifndef UNX
//STRIP001     AllSettings aAllSettings = Application::GetSettings();
//STRIP001     MiscSettings aMiscSettings = aAllSettings.GetMiscSettings();
//STRIP001     aMiscSettings.SetEnableATToolSupport( m_aAccessibilityTool.IsChecked() );
//STRIP001     aAllSettings.SetMiscSettings(aMiscSettings);
//STRIP001     Application::SetSettings(aAllSettings);
//STRIP001     Application::MergeSystemSettings( aAllSettings );
//STRIP001 #endif
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }
//STRIP001 
//STRIP001 void SvxAccessibilityOptionsTabPage::Reset( const SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	//set controls from aConfig.Get...
//STRIP001 
//STRIP001     m_aPagePreviews.Check(			  m_pImpl->m_aConfig.GetIsForPagePreviews() );
//STRIP001 	EnableTipHelp(					  m_pImpl->m_aConfig.GetIsHelpTipsDisappear() );
//STRIP001 	m_aTipHelpNF.SetValue(			  m_pImpl->m_aConfig.GetHelpTipSeconds() );
//STRIP001 	m_aAnimatedGraphics.Check(		  m_pImpl->m_aConfig.GetIsAllowAnimatedGraphics() );
//STRIP001 	m_aAnimatedTexts.Check(			  m_pImpl->m_aConfig.GetIsAllowAnimatedText() );
//STRIP001 	m_aAutomaticFontColor.Check(	  m_pImpl->m_aConfig.GetIsAutomaticFontColor() );
//STRIP001 	m_aSystemFont.Check(			  m_pImpl->m_aConfig.GetIsSystemFont() );
//STRIP001     m_aTextSelectionInReadonly.Check( m_pImpl->m_aConfig.IsSelectionInReadonly() );
//STRIP001     m_aAutoDetectHC.Check(			  m_pImpl->m_aConfig.GetAutoDetectSystemHC() );
//STRIP001 
//STRIP001 
//STRIP001     AllSettings aAllSettings = Application::GetSettings();
//STRIP001     MiscSettings aMiscSettings = aAllSettings.GetMiscSettings();
//STRIP001     m_aAccessibilityTool.Check( aMiscSettings.GetEnableATToolSupport() );
//STRIP001 }
//STRIP001 
//STRIP001 IMPL_LINK(SvxAccessibilityOptionsTabPage, TipHelpHdl, CheckBox*, pBox)
//STRIP001 {
//STRIP001 	sal_Bool bChecked = pBox->IsChecked();
//STRIP001 	m_aTipHelpNF.Enable(bChecked);
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 void SvxAccessibilityOptionsTabPage::EnableTipHelp(sal_Bool bCheck)
//STRIP001 {
//STRIP001 	m_aTipHelpCB.Check(bCheck);
//STRIP001 	m_aTipHelpNF.Enable(bCheck);
//STRIP001 }
}
