/*************************************************************************
 *
 *  $RCSfile: sw_edtox.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 17:22:47 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _COM_SUN_STAR_UTIL_SEARCHOPTIONS_HPP_
// auto strip #include <com/sun/star/util/SearchOptions.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_UTIL_SEARCHFLAGS_HPP_
// auto strip #include <com/sun/star/util/SearchFlags.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_LANG_LOCALE_HPP_
// auto strip #include <com/sun/star/lang/Locale.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_I18N_TRANSLITERATIONMODULES_HPP_
// auto strip #include <com/sun/star/i18n/TransliterationModules.hpp>
// auto strip #endif


#pragma hdrstop

// auto strip #ifndef _URLOBJ_HXX
// auto strip #include <tools/urlobj.hxx>
// auto strip #endif
// auto strip #ifndef _TXTCMP_HXX
// auto strip #include <svtools/txtcmp.hxx>
// auto strip #endif
// auto strip #ifndef SVTOOLS_FSTATHELPER_HXX
// auto strip #include <svtools/fstathelper.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDOCFILE_HXX
// auto strip #include <bf_sfx2/docfile.hxx>
// auto strip #endif

// auto strip #ifndef _SWTYPES_HXX
// auto strip #include <swtypes.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

#ifndef _EDITSH_HXX
#include <editsh.hxx>
#endif
#ifndef _DOC_HXX
#include <doc.hxx>
#endif
#ifndef _PAM_HXX
#include <pam.hxx>
#endif
// auto strip #ifndef _VIEWOPT_HXX
// auto strip #include <viewopt.hxx>
// auto strip #endif
// auto strip #ifndef _NDTXT_HXX
// auto strip #include <ndtxt.hxx>
// auto strip #endif
// auto strip #ifndef _ERRHDL_HXX
// auto strip #include <errhdl.hxx>
// auto strip #endif
// auto strip #ifndef _SWUNDO_HXX
// auto strip #include <swundo.hxx>
// auto strip #endif
// auto strip #ifndef _TXTTXMRK_HXX //autogen
// auto strip #include <txttxmrk.hxx>
// auto strip #endif
// auto strip #ifndef _EDIMP_HXX
// auto strip #include <edimp.hxx>
// auto strip #endif
// auto strip #ifndef _TOX_HXX
// auto strip #include <tox.hxx>
// auto strip #endif
// auto strip #ifndef _DOCTXM_HXX
// auto strip #include <doctxm.hxx>
// auto strip #endif
// auto strip #ifndef _DOCARY_HXX
// auto strip #include <docary.hxx>
// auto strip #endif
// auto strip #ifndef _MDIEXP_HXX
// auto strip #include <mdiexp.hxx>
// auto strip #endif
#ifndef _STATSTR_HRC
#include <statstr.hrc>
#endif
namespace binfilter {

using namespace ::com::sun::star::i18n;
using namespace ::com::sun::star::lang;
using namespace ::com::sun::star::util;

/*--------------------------------------------------------------------
	 Beschreibung: Verzeichnismarkierung ins Dokument einfuegen/loeschen
 --------------------------------------------------------------------*/


//STRIP001 void SwEditShell::Insert(const SwTOXMark& rMark)
//STRIP001 {
//STRIP001 	BOOL bInsAtPos = rMark.IsAlternativeText();
//STRIP001 	StartAllAction();
//STRIP001 	FOREACHPAM_START(this)
//STRIP001 
//STRIP001 		const SwPosition *pStt = PCURCRSR->Start(),
//STRIP001 						 *pEnd = PCURCRSR->End();
//STRIP001 		if( bInsAtPos )
//STRIP001 		{
//STRIP001 			SwPaM aTmp( *pStt );
//STRIP001 			GetDoc()->Insert( aTmp, rMark, 0 );
//STRIP001 		}
//STRIP001 		else if( *pEnd != *pStt )
//STRIP001 			GetDoc()->Insert( *PCURCRSR, rMark, SETATTR_DONTEXPAND );
//STRIP001 
//STRIP001 	FOREACHPAM_END()
//STRIP001 	EndAllAction();
//STRIP001 }



//STRIP001 void SwEditShell::DeleteTOXMark( SwTOXMark* pMark )
//STRIP001 {
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 	StartAllAction();
//STRIP001 
//STRIP001 	pDoc->Delete( pMark );
//STRIP001 
//STRIP001 	EndAllAction();
//STRIP001 }


/*--------------------------------------------------------------------
	 Beschreibung: Alle Verzeichnismarkierungen am SPoint zusammensuchen
 --------------------------------------------------------------------*/

/*N*/ USHORT SwEditShell::GetCurTOXMarks(SwTOXMarks& rMarks) const
/*N*/ {
/*N*/ 	return GetDoc()->GetCurTOXMark( *GetCrsr()->Start(), rMarks );
/*N*/ }
/* -----------------01.09.99 16:05-------------------

 --------------------------------------------------*/
//STRIP001 const SwAttrSet& SwEditShell::GetTOXBaseAttrSet(const SwTOXBase& rTOXBase) const
//STRIP001 {
//STRIP001 	return GetDoc()->GetTOXBaseAttrSet(rTOXBase);
//STRIP001 }
/* -----------------01.09.99 16:05-------------------

 --------------------------------------------------*/
//STRIP001 BOOL SwEditShell::IsTOXBaseReadonly(const SwTOXBase& rTOXBase) const
//STRIP001 {
//STRIP001 	ASSERT( rTOXBase.ISA( SwTOXBaseSection ), "no TOXBaseSection!" );
//STRIP001 	const SwTOXBaseSection& rTOXSect = (const SwTOXBaseSection&)rTOXBase;
//STRIP001 	return 	rTOXSect.IsProtect();
//STRIP001 }
/* -----------------18.10.99 15:53-------------------

 --------------------------------------------------*/
//STRIP001 void SwEditShell::SetTOXBaseReadonly(const SwTOXBase& rTOXBase, BOOL bReadonly)
//STRIP001 {
//STRIP001 	ASSERT( rTOXBase.ISA( SwTOXBaseSection ), "no TOXBaseSection!" );
//STRIP001 	const SwTOXBaseSection& rTOXSect = (const SwTOXBaseSection&)rTOXBase;
//STRIP001 	((SwTOXBase&)rTOXBase).SetProtected(bReadonly);
//STRIP001 	ASSERT( rTOXSect.SwSection::GetType() == TOX_CONTENT_SECTION, "not a TOXContentSection" );
//STRIP001 
//STRIP001 	SwSection aSect(TOX_CONTENT_SECTION, rTOXSect.GetName());
//STRIP001 	aSect = rTOXSect;
//STRIP001 	aSect.SetProtect(bReadonly);
//STRIP001 	ChgSection( GetSectionFmtPos( *rTOXSect.GetFmt()  ), aSect, 0 );
//STRIP001 }

/* -----------------02.09.99 07:47-------------------

 --------------------------------------------------*/
//STRIP001 const SwTOXBase* 	SwEditShell::GetDefaultTOXBase( TOXTypes eTyp, BOOL bCreate )
//STRIP001 {
//STRIP001 	return GetDoc()->GetDefaultTOXBase( eTyp, bCreate );
//STRIP001 }
/* -----------------02.09.99 08:05-------------------

 --------------------------------------------------*/
//STRIP001 void	SwEditShell::SetDefaultTOXBase(const SwTOXBase& rBase)
//STRIP001 {
//STRIP001 	GetDoc()->SetDefaultTOXBase(rBase);
//STRIP001 }

/*--------------------------------------------------------------------
	 Beschreibung: Verzeichnis einfuegen, und Inhalt erzeugen
 --------------------------------------------------------------------*/

//STRIP001 void SwEditShell::InsertTableOf( const SwTOXBase& rTOX, const SfxItemSet* pSet )
//STRIP001 {
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 	StartAllAction();
//STRIP001 
//STRIP001 	SwDocShell* pDocSh = GetDoc()->GetDocShell();
//STRIP001 	::StartProgress( STR_STATSTR_TOX_INSERT, 0, 0, pDocSh );
//STRIP001 	::SetProgressText( STR_STATSTR_TOX_INSERT, pDocSh );
//STRIP001 
//STRIP001 	// Einfuegen des Verzeichnisses
//STRIP001 	const SwTOXBaseSection* pTOX = pDoc->InsertTableOf(
//STRIP001 										*GetCrsr()->GetPoint(), rTOX, pSet, TRUE );
//STRIP001 	ASSERT(pTOX, "Kein aktuelles Verzeichnis");
//STRIP001 
//STRIP001 	// Formatierung anstossen
//STRIP001 	CalcLayout();
//STRIP001 
//STRIP001 	// Seitennummern eintragen
//STRIP001 	((SwTOXBaseSection*)pTOX)->UpdatePageNum();
//STRIP001 
//STRIP001 	pTOX->SetPosAtStartEnd( *GetCrsr()->GetPoint() );
//STRIP001 
//STRIP001 	// Fix fuer leere Verzeichnisse
//STRIP001 	InvalidateWindows( aVisArea );
//STRIP001 	::EndProgress( pDocSh );
//STRIP001 	EndAllAction();
//STRIP001 }

/*--------------------------------------------------------------------
	 Beschreibung: Verzeichnisinhalt erneuern
 --------------------------------------------------------------------*/

//STRIP001 BOOL SwEditShell::UpdateTableOf( const SwTOXBase& rTOX, const SfxItemSet* pSet )
//STRIP001 {
//STRIP001 	BOOL bRet = FALSE;
//STRIP001 
//STRIP001 	ASSERT( rTOX.ISA( SwTOXBaseSection ),  "keine TOXBaseSection!" );
//STRIP001 	SwTOXBaseSection* pTOX = (SwTOXBaseSection*)&rTOX;
//STRIP001 	ASSERT(pTOX, "Keine aktuelles Verzeichnis");
//STRIP001 	const SwSectionNode* pSectNd;
//STRIP001 	if( pTOX && 0 != ( pSectNd = pTOX->GetFmt()->GetSectionNode() ) )
//STRIP001 	{
//STRIP001 		SwDoc* pDoc = GetDoc();
//STRIP001 		SwDocShell* pDocSh = pDoc->GetDocShell();
//STRIP001 
//STRIP001 		BOOL bInIndex = pTOX == GetCurTOX();
//STRIP001 		SET_CURR_SHELL( this );
//STRIP001 		StartAllAction();
//STRIP001 
//STRIP001 		::StartProgress( STR_STATSTR_TOX_UPDATE, 0, 0, pDocSh );
//STRIP001 		::SetProgressText( STR_STATSTR_TOX_UPDATE, pDocSh );
//STRIP001 
//STRIP001 		BOOL bWasUndo = pDoc->DoesUndo();
//STRIP001 		pDoc->DoUndo( FALSE );
//STRIP001 
//STRIP001 		// Verzeichnisrumpf erzeugen
//STRIP001 		pTOX->Update(pSet);
//STRIP001 
//STRIP001 		// Cursor korrigieren
//STRIP001 		if( bInIndex )
//STRIP001 			pTOX->SetPosAtStartEnd( *GetCrsr()->GetPoint() );
//STRIP001 
//STRIP001 		// Formatierung anstossen
//STRIP001 		CalcLayout();
//STRIP001 
//STRIP001 		// Seitennummern eintragen
//STRIP001 		pTOX->UpdatePageNum();
//STRIP001 
//STRIP001 		pDoc->DoUndo( bWasUndo );
//STRIP001 
//STRIP001 		//JP erstmal ein Hack, solange keine Verzeichnisse Undofaehig sind
//STRIP001 		if( bWasUndo )
//STRIP001 			pDoc->DelAllUndoObj();
//STRIP001 
//STRIP001 		::EndProgress( pDocSh );
//STRIP001 		EndAllAction();
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }

/*--------------------------------------------------------------------
	 Beschreibung: Aktuelles Verzeichnis vor oder in dem der Cursor
								   steht
 --------------------------------------------------------------------*/

/*N*/ const SwTOXBase* SwEditShell::GetCurTOX() const
/*N*/ {
/*N*/ 	return GetDoc()->GetCurTOX( *GetCrsr()->GetPoint() );
/*N*/ }

//STRIP001 BOOL SwEditShell::DeleteTOX( const SwTOXBase& rTOXBase, BOOL bDelNodes )
//STRIP001 {
//STRIP001 	return GetDoc()->DeleteTOX( (SwTOXBase&)rTOXBase, bDelNodes );
//STRIP001 }

//STRIP001 BOOL SwEditShell::DeleteCurTOX()
//STRIP001 {
//STRIP001 	SwTOXBase* pTOX = (SwTOXBase*)GetDoc()->GetCurTOX(*GetCrsr()->GetPoint());
//STRIP001 	return pTOX ? GetDoc()->DeleteTOX( *pTOX, TRUE ) : FALSE;
//STRIP001 }

/*--------------------------------------------------------------------
	 Beschreibung: Typen der Verzeichnisse verwalten
 --------------------------------------------------------------------*/

//STRIP001 const SwTOXType* SwEditShell::GetTOXType(TOXTypes eTyp, USHORT nId) const
//STRIP001 {
//STRIP001 	return pDoc->GetTOXType(eTyp, nId);
//STRIP001 }

/*--------------------------------------------------------------------
	 Beschreibung: Schluessel fuer Stichwortverzeichnisse verwalten
 --------------------------------------------------------------------*/

//STRIP001 USHORT SwEditShell::GetTOIKeys( SwTOIKeyType eTyp, SvStringsSort& rArr ) const
//STRIP001 {
//STRIP001 	return GetDoc()->GetTOIKeys( eTyp, rArr );
//STRIP001 }


//STRIP001 USHORT SwEditShell::GetTOXCount() const
//STRIP001 {
//STRIP001 	const SwSectionFmts& rFmts = GetDoc()->GetSections();
//STRIP001 	USHORT nRet = 0;
//STRIP001 	for( USHORT n = rFmts.Count(); n; )
//STRIP001 	{
//STRIP001 		const SwSection* pSect = rFmts[ --n ]->GetSection();
//STRIP001 		if( TOX_CONTENT_SECTION == pSect->GetType() &&
//STRIP001 			pSect->GetFmt()->GetSectionNode() )
//STRIP001 			++nRet;
//STRIP001 	}
//STRIP001 	return nRet;
//STRIP001 }


//STRIP001 const SwTOXBase* SwEditShell::GetTOX( USHORT nPos ) const
//STRIP001 {
//STRIP001 	const SwSectionFmts& rFmts = GetDoc()->GetSections();
//STRIP001 	for( USHORT n = 0, nCnt = 0; n < rFmts.Count(); ++n )
//STRIP001 	{
//STRIP001 		const SwSection* pSect = rFmts[ n ]->GetSection();
//STRIP001 		if( TOX_CONTENT_SECTION == pSect->GetType() &&
//STRIP001 			pSect->GetFmt()->GetSectionNode() &&
//STRIP001 			nCnt++ == nPos )
//STRIP001 		{
//STRIP001 			ASSERT( pSect->ISA( SwTOXBaseSection ), "keine TOXBaseSection!" );
//STRIP001 			return (SwTOXBaseSection*)pSect;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }


	// nach einlesen einer Datei alle Verzeichnisse updaten
//STRIP001 void SwEditShell::SetUpdateTOX( BOOL bFlag )
//STRIP001 {
//STRIP001 	GetDoc()->SetUpdateTOX( bFlag );
//STRIP001 }


//STRIP001 BOOL SwEditShell::IsUpdateTOX() const
//STRIP001 {
//STRIP001 	return GetDoc()->IsUpdateTOX();
//STRIP001 }
/*--------------------------------------------------------------------

 --------------------------------------------------------------------*/
//STRIP001 String SwEditShell::GetUniqueTOXBaseName( const SwTOXType& rType,
//STRIP001 								const String* pChkStr ) const
//STRIP001 {
//STRIP001 	return GetDoc()->GetUniqueTOXBaseName( rType, pChkStr );
//STRIP001 }
/*--------------------------------------------------------------------

 --------------------------------------------------------------------*/
//STRIP001 BOOL SwEditShell::SetTOXBaseName(const SwTOXBase& rTOXBase, const String& rName)
//STRIP001 {
//STRIP001 	return GetDoc()->SetTOXBaseName(rTOXBase, rName);
//STRIP001 }
/*--------------------------------------------------------------------

 --------------------------------------------------------------------*/
//STRIP001 void SwEditShell::SetTOXBaseProtection(const SwTOXBase& rTOXBase, BOOL bProtect)
//STRIP001 {
//STRIP001 	GetDoc()->SetTOXBaseProtection(rTOXBase, bProtect);
//STRIP001 }
/* -----------------26.08.99 13:49-------------------

 --------------------------------------------------*/
//STRIP001 const String&	SwEditShell::GetTOIAutoMarkURL() const
//STRIP001 {
//STRIP001 	return GetDoc()->GetTOIAutoMarkURL();
//STRIP001 }
/* -----------------26.08.99 13:49-------------------

 --------------------------------------------------*/
//STRIP001 void SwEditShell::SetTOIAutoMarkURL(const String& rSet)
//STRIP001 {
//STRIP001 	GetDoc()->SetTOIAutoMarkURL(rSet);
//STRIP001 }
/* -----------------26.08.99 09:29-------------------

 --------------------------------------------------*/
//STRIP001 void SwEditShell::ApplyAutoMark()
//STRIP001 {
//STRIP001 	StartAllAction();
//STRIP001 	BOOL bDoesUndo = DoesUndo();
//STRIP001 	DoUndo(FALSE);
//STRIP001 	//1. remove all automatic generated index entries if AutoMarkURL has a
//STRIP001 	//	 length and the file exists
//STRIP001 	//2. load file
//STRIP001 	//3. select all occurrences of the searched words
//STRIP001 	//4. apply index entries
//STRIP001 
//STRIP001 	String sAutoMarkURL(GetDoc()->GetTOIAutoMarkURL());
//STRIP001 	if( sAutoMarkURL.Len() && FStatHelper::IsDocument( sAutoMarkURL ))
//STRIP001 	{
//STRIP001 		//1.
//STRIP001 		const SwTOXType* pTOXType = GetTOXType(TOX_INDEX, 0);
//STRIP001 		SwClientIter aIter(*(SwTOXType*)pTOXType);
//STRIP001 		SwTOXMark* pMark = (SwTOXMark*)aIter.First(TYPE(SwTOXMark));
//STRIP001 		while( pMark )
//STRIP001 		{
//STRIP001 			if(pMark->IsAutoGenerated() && pMark->GetTxtTOXMark())
//STRIP001 				DeleteTOXMark(pMark);
//STRIP001 			pMark = (SwTOXMark*)aIter.Next();
//STRIP001 		}
//STRIP001 
//STRIP001 		//2.
//STRIP001 		SfxMedium aMedium( sAutoMarkURL, STREAM_STD_READ, TRUE );
//STRIP001 		SvStream& rStrm = *aMedium.GetInStream();
//STRIP001 		const String sZero('0');
//STRIP001 		Push();
//STRIP001 		rtl_TextEncoding eChrSet = ::gsl_getSystemTextEncoding();
//STRIP001 
//STRIP001 		//
//STRIP001 		// SearchOptions to be used in loop below
//STRIP001 		//
//STRIP001 		//SearchAlgorithms eSrchType	= SearchAlgorithms_ABSOLUTE;
//STRIP001 		//OUString aSrchStr	= rText;
//STRIP001 		BOOL bCaseSensitive	= TRUE;
//STRIP001 		BOOL bWordOnly		= FALSE;
//STRIP001 		BOOL bSrchInSel		= FALSE;
//STRIP001 		BOOL bLEV_Relaxed	= TRUE;
//STRIP001 		INT32 nLEV_Other	= 2;	//  -> changedChars;
//STRIP001 		INT32 nLEV_Longer	= 3;	//! -> deletedChars;
//STRIP001 		INT32 nLEV_Shorter	= 1;	//!	-> insertedChars;
//STRIP001 		INT32 nTransliterationFlags = 0;
//STRIP001 		//
//STRIP001 		INT32 nSrchFlags = 0;
//STRIP001 		if (!bCaseSensitive)
//STRIP001 		{
//STRIP001 			nSrchFlags |= SearchFlags::ALL_IGNORE_CASE;
//STRIP001 			nTransliterationFlags |= TransliterationModules_IGNORE_CASE;
//STRIP001 		}
//STRIP001 		if ( bWordOnly)
//STRIP001 			nSrchFlags |= SearchFlags::NORM_WORD_ONLY;
//STRIP001 		if ( bLEV_Relaxed)
//STRIP001 			nSrchFlags |= SearchFlags::LEV_RELAXED;
//STRIP001 		if ( bSrchInSel)
//STRIP001 			nSrchFlags |= (SearchFlags::REG_NOT_BEGINOFLINE |
//STRIP001 							SearchFlags::REG_NOT_ENDOFLINE );
//STRIP001 		//
//STRIP001 		::rtl::OUString sEmpty;
//STRIP001 		SearchOptions aSearchOpt(
//STRIP001 							SearchAlgorithms_ABSOLUTE, nSrchFlags,
//STRIP001 							sEmpty, sEmpty,
//STRIP001 							CreateLocale( LANGUAGE_SYSTEM ),
//STRIP001 							nLEV_Other, nLEV_Longer, nLEV_Shorter,
//STRIP001 							nTransliterationFlags );
//STRIP001 
//STRIP001 		while( !rStrm.GetError() && !rStrm.IsEof() )
//STRIP001 		{
//STRIP001 			ByteString aRdLine;
//STRIP001 			rStrm.ReadLine( aRdLine );
//STRIP001 
//STRIP001 			// # -> comment
//STRIP001 			// ; -> delimiter between entries ->
//STRIP001 			// Format: TextToSearchFor;AlternativeString;PrimaryKey;SecondaryKey;CaseSensitive;WordOnly
//STRIP001 			// Leading and trailing blanks are ignored
//STRIP001 			if( aRdLine.Len() && '#' != aRdLine.GetChar(0) )
//STRIP001 			{
//STRIP001 				String sLine( aRdLine, eChrSet );
//STRIP001 
//STRIP001 				xub_StrLen nTokenPos = 0;
//STRIP001 				String sToSelect( sLine.GetToken(0, ';', nTokenPos ) );
//STRIP001 				if( sToSelect.Len() )
//STRIP001 				{
//STRIP001 					String sAlternative = sLine.GetToken(0, ';', nTokenPos);
//STRIP001 					String sPrimary 	= sLine.GetToken(0, ';', nTokenPos);
//STRIP001 					String sSecondary 	= sLine.GetToken(0, ';', nTokenPos);
//STRIP001 					String sCase        = sLine.GetToken(0, ';', nTokenPos);
//STRIP001 					String sWordOnly 	= sLine.GetToken(0, ';', nTokenPos);
//STRIP001 
//STRIP001 					//3.
//STRIP001 					bCaseSensitive	= sCase.Len() && sCase != sZero;
//STRIP001 					bWordOnly		= sWordOnly.Len() && sWordOnly != sZero;
//STRIP001 					//
//STRIP001 					if (!bCaseSensitive)
//STRIP001 					{
//STRIP001 						//nSrchFlags |= SearchFlags::ALL_IGNORE_CASE;
//STRIP001 						aSearchOpt.transliterateFlags |=
//STRIP001 									 TransliterationModules_IGNORE_CASE;
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 						//aSearchOpt.searchFlag &= ~SearchFlags::ALL_IGNORE_CASE;
//STRIP001 						aSearchOpt.transliterateFlags &=
//STRIP001 									~TransliterationModules_IGNORE_CASE;
//STRIP001 					}
//STRIP001 					if ( bWordOnly)
//STRIP001 						aSearchOpt.searchFlag |=  SearchFlags::NORM_WORD_ONLY;
//STRIP001 					else
//STRIP001 						aSearchOpt.searchFlag &= ~SearchFlags::NORM_WORD_ONLY;
//STRIP001 					//
//STRIP001 					aSearchOpt.searchString = sToSelect;
//STRIP001 
//STRIP001 					KillPams();
//STRIP001                     BOOL bCancel;
//STRIP001                     ULONG nRet = Find( aSearchOpt,  DOCPOS_START, DOCPOS_END, bCancel,
//STRIP001 									(FindRanges)(FND_IN_SELALL|FND_IN_BODYONLY),
//STRIP001 									FALSE );
//STRIP001 
//STRIP001 					if(nRet)
//STRIP001 					{
//STRIP001 						SwTOXMark* pMark = new SwTOXMark(pTOXType);
//STRIP001 						if( sPrimary.Len() )
//STRIP001 						{
//STRIP001 							pMark->SetPrimaryKey( sPrimary );
//STRIP001 							if( sSecondary.Len() )
//STRIP001 								pMark->SetSecondaryKey( sSecondary );
//STRIP001 						}
//STRIP001 						if(sAlternative.Len())
//STRIP001 							pMark->SetAlternativeText(sAlternative);
//STRIP001 						pMark->SetMainEntry(FALSE);
//STRIP001 						pMark->SetAutoGenerated(TRUE);
//STRIP001 						//4.
//STRIP001 						SwEditShell::Insert(*pMark);
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		KillPams();
//STRIP001 		Pop(FALSE);
//STRIP001 	}
//STRIP001 	DoUndo(bDoesUndo);
//STRIP001 	EndAllAction();
//STRIP001 }



}
