/*************************************************************************
 *
 *  $RCSfile: sw_frmdlg.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:54:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #ifndef _HINTIDS_HXX
//STRIP001 #include <hintids.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _UIPARAM_HXX
//STRIP001 #include <uiparam.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _LIST_HXX //autogen
//STRIP001 #include <tools/list.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFXVIEWFRM_HXX //autogen
//STRIP001 #include <bf_sfx2/viewfrm.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SVX_HTMLMODE_HXX
//STRIP001 #include <bf_svx/htmlmode.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SVX_BORDER_HXX
//STRIP001 #include <bf_svx/border.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SVX_BACKGRND_HXX //autogen
//STRIP001 #include <bf_svx/backgrnd.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SVX_GRFPAGE_HXX //autogen
//STRIP001 #include <bf_svx/grfpage.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _OFA_HTMLCFG_HXX //autogen
//STRIP001 #include <bf_offmgr/htmlcfg.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _OFF_APP_HXX //autogen
//STRIP001 #include <bf_offmgr/app.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 
//STRIP001 #ifndef _FMTFSIZE_HXX //autogen
//STRIP001 #include <fmtfsize.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _WRTSH_HXX
//STRIP001 #include <wrtsh.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _VIEW_HXX
//STRIP001 #include <view.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _VIEWOPT_HXX
//STRIP001 #include <viewopt.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FRMDLG_HXX
//STRIP001 #include <frmdlg.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _FRMPAGE_HXX
//STRIP001 #include <frmpage.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _WRAP_HXX
//STRIP001 #include <wrap.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _COLUMN_HXX
//STRIP001 #include <column.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _MACASSGN_HXX
//STRIP001 #include <macassgn.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #ifndef _FRMUI_HRC
//STRIP001 #include <frmui.hrc>
//STRIP001 #endif
//STRIP001 #ifndef _GLOBALS_HRC
//STRIP001 #include <globals.hrc>
//STRIP001 #endif
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:	Der Traeger des Dialoges
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 SwFrmDlg::SwFrmDlg( SfxViewFrame*		pFrame,
//STRIP001 					Window*				pParent,
//STRIP001 					const SfxItemSet& 	rCoreSet,
//STRIP001 					BOOL 				bNewFrm,
//STRIP001 					USHORT				nResType,
//STRIP001 					BOOL				bFmt,
//STRIP001 					UINT16				nDefPage,
//STRIP001 					const String* 		pStr) :
//STRIP001 
//STRIP001 	SfxTabDialog(pFrame, pParent, SW_RES(nResType), &rCoreSet, pStr != 0),
//STRIP001 	bNew(bNewFrm),
//STRIP001 	bFormat(bFmt),
//STRIP001 	rSet(rCoreSet),
//STRIP001 	nDlgType(nResType),
//STRIP001 	pWrtShell(((SwView*)pFrame->GetViewShell())->GetWrtShellPtr())
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 	USHORT nHtmlMode = ::binfilter::GetHtmlMode(pWrtShell->GetView().GetDocShell());
//STRIP001     bHTMLMode = nHtmlMode & HTMLMODE_ON;
//STRIP001 
//STRIP001 	// BspFont fuer beide Bsp-TabPages
//STRIP001 	//
//STRIP001 	if(pStr)
//STRIP001 	{
//STRIP001 		String aTmp( GetText() );
//STRIP001 		aTmp += SW_RESSTR(STR_COLL_HEADER);
//STRIP001 		aTmp += *pStr;
//STRIP001 		aTmp += ')';
//STRIP001 	}
//STRIP001 	AddTabPage(TP_FRM_STD,	SwFrmPage::Create, 0);
//STRIP001 	AddTabPage(TP_FRM_ADD,	SwFrmAddPage::Create, 0);
//STRIP001 	AddTabPage(TP_FRM_WRAP,	SwWrapTabPage::Create, 0);
//STRIP001 	AddTabPage(TP_FRM_URL,	SwFrmURLPage::Create, 0);
//STRIP001 	if(nDlgType == DLG_FRM_GRF)
//STRIP001 	{
//STRIP001 		AddTabPage( TP_GRF_EXT,	SwGrfExtPage::Create, 0 );
//STRIP001 		AddTabPage( RID_SVXPAGE_GRFCROP, SvxGrfCropPage::Create, 0 );
//STRIP001 	}
//STRIP001 	if (nDlgType == DLG_FRM_STD)
//STRIP001 	{
//STRIP001 		AddTabPage(TP_COLUMN,	SwColumnPage::Create,  	 0);
//STRIP001 	}
//STRIP001 	AddTabPage(TP_BACKGROUND,SvxBackgroundTabPage::Create, 	0);
//STRIP001 	AddTabPage( TP_MACRO_ASSIGN, SfxMacroTabPage::Create, 0);
//STRIP001 	AddTabPage( TP_BORDER,	 SvxBorderTabPage::Create,	 	0);
//STRIP001 
//STRIP001     if(bHTMLMode)
//STRIP001 	{
//STRIP001 		switch( nDlgType )
//STRIP001 		{
//STRIP001 		case DLG_FRM_STD:
//STRIP001 				if(0  == (nHtmlMode & HTMLMODE_SOME_ABS_POS))
//STRIP001 					RemoveTabPage(TP_BORDER);
//STRIP001 				RemoveTabPage(TP_COLUMN);
//STRIP001 			// kein break
//STRIP001 		case DLG_FRM_OLE:
//STRIP001 				RemoveTabPage(TP_FRM_URL);
//STRIP001 				RemoveTabPage(TP_MACRO_ASSIGN);
//STRIP001 			break;
//STRIP001 		case DLG_FRM_GRF:
//STRIP001 				RemoveTabPage(RID_SVXPAGE_GRFCROP);
//STRIP001 			break;
//STRIP001 		}
//STRIP001 		if( 0  == (nHtmlMode & HTMLMODE_SOME_ABS_POS) ||
//STRIP001 			nDlgType != DLG_FRM_STD )
//STRIP001 			RemoveTabPage(TP_BACKGROUND);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (bNew)
//STRIP001 		SetCurPageId(TP_FRM_STD);
//STRIP001 
//STRIP001 	if (nDefPage)
//STRIP001 		SetCurPageId(nDefPage);
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------------------------
//STRIP001 	Beschreibung:
//STRIP001  --------------------------------------------------------------------*/
//STRIP001 
//STRIP001 SwFrmDlg::~SwFrmDlg()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 void SwFrmDlg::PageCreated( USHORT nId, SfxTabPage &rPage )
//STRIP001 {
//STRIP001 	switch ( nId )
//STRIP001 	{
//STRIP001 	case TP_FRM_STD:
//STRIP001 		((SwFrmPage&)rPage).SetNewFrame(bNew);
//STRIP001 		((SwFrmPage&)rPage).SetFormatUsed(bFormat);
//STRIP001 		((SwFrmPage&)rPage).SetFrmType(nDlgType);
//STRIP001 		break;
//STRIP001 
//STRIP001 	case TP_FRM_ADD:
//STRIP001 		((SwFrmAddPage&)rPage).SetFormatUsed(bFormat);
//STRIP001 		((SwFrmAddPage&)rPage).SetFrmType(nDlgType);
//STRIP001 		((SwFrmAddPage&)rPage).SetNewFrame(bNew);
//STRIP001 		((SwFrmAddPage&)rPage).SetShell(pWrtShell);
//STRIP001 		break;
//STRIP001 
//STRIP001 	case TP_FRM_WRAP:
//STRIP001 		((SwWrapTabPage&)rPage).SetNewFrame(bNew);
//STRIP001 		((SwWrapTabPage&)rPage).SetFormatUsed(bFormat, FALSE);
//STRIP001 		((SwWrapTabPage&)rPage).SetShell(pWrtShell);
//STRIP001 		break;
//STRIP001 
//STRIP001 	case TP_COLUMN:
//STRIP001 		{
//STRIP001 			((SwColumnPage&)rPage).SetFrmMode(TRUE);
//STRIP001 			((SwColumnPage&)rPage).SetFormatUsed(bFormat);
//STRIP001 
//STRIP001 			const SwFmtFrmSize& rSize = (const SwFmtFrmSize&)
//STRIP001 												rSet.Get( RES_FRM_SIZE );
//STRIP001 			((SwColumnPage&)rPage).SetPageWidth( rSize.GetWidth() );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 	case TP_MACRO_ASSIGN:
//STRIP001 		SwMacroAssignDlg::AddEvents( (SfxMacroTabPage&)rPage,
//STRIP001 			DLG_FRM_GRF == nDlgType ? MACASSGN_GRAPHIC
//STRIP001 							: DLG_FRM_OLE == nDlgType ? MACASSGN_OLE
//STRIP001 													  : MACASSGN_FRMURL );
//STRIP001 		break;
//STRIP001 
//STRIP001 	case TP_BACKGROUND:
//STRIP001 		if( DLG_FRM_STD == nDlgType )
//STRIP001         {
//STRIP001 			((SvxBackgroundTabPage&)rPage).ShowSelector();
//STRIP001             if(!bHTMLMode)
//STRIP001                 ((SvxBackgroundTabPage&)rPage).EnableTransparency(TRUE, TRUE);
//STRIP001         }
//STRIP001 		break;
//STRIP001 
//STRIP001 	case TP_BORDER:
//STRIP001 		((SvxBorderTabPage&) rPage).SetSWMode(SW_BORDER_MODE_FRAME);
//STRIP001 		break;
//STRIP001 	}
//STRIP001 }
}
