/*************************************************************************
 *
 *  $RCSfile: colex.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:54:56 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _COLEX_HXX
#define _COLEX_HXX

#ifndef _SVX_PAGECTRL_HXX //autogen
#include <bf_svx/pagectrl.hxx>
#endif
#ifndef _FMTCLDS_HXX //autogen
#include <fmtclds.hxx>
#endif

#include "frmatr.hxx"
class SfxItemSet; 
namespace binfilter {

class SwColMgr;


/* -----------------------------08.02.2002 11:32------------------------------

 ---------------------------------------------------------------------------*/
//STRIP001 class SwPageExample : public SvxPageWindow
//STRIP001 {
//STRIP001 public:
//STRIP001     SwPageExample(Window* pPar, const ResId& rResId ) :
//STRIP001                                 SvxPageWindow(pPar, rResId )
//STRIP001                                 {SetSize(Size(11907, 16433));/*DIN A4*/}
//STRIP001 
//STRIP001     void UpdateExample( const SfxItemSet& rSet );
//STRIP001 };
/* -----------------------------08.02.2002 11:34------------------------------

 ---------------------------------------------------------------------------*/
//STRIP001 class SwTextGridItem;
//STRIP001 class SwPageGridExample : public SwPageExample
//STRIP001 {
//STRIP001     SwTextGridItem*     pGridItem;
//STRIP001     sal_Bool            m_bVertical;
//STRIP001 protected:
//STRIP001 	virtual void DrawPage( const Point& rPoint,
//STRIP001 						   const BOOL bSecond,
//STRIP001 						   const BOOL bEnabled );
//STRIP001 public:
//STRIP001     SwPageGridExample(Window* pPar, const ResId& rResId ) :
//STRIP001                                 SwPageExample(pPar, rResId ),
//STRIP001                                 pGridItem(0),
//STRIP001                                 m_bVertical(sal_False){}
//STRIP001     ~SwPageGridExample();
//STRIP001     void UpdateExample( const SfxItemSet& rSet );
//STRIP001 };
/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 class SwColExample : public SwPageExample
//STRIP001 {
//STRIP001 	SwColMgr* 	pColMgr;
//STRIP001 protected:
//STRIP001 	virtual void DrawPage( const Point& rPoint,
//STRIP001 						   const BOOL bSecond,
//STRIP001 						   const BOOL bEnabled );
//STRIP001 
//STRIP001 public:
//STRIP001         SwColExample(Window* pPar, const ResId& rResId ) :
//STRIP001                                 SwPageExample(pPar, rResId ),
//STRIP001                                 pColMgr(0){}
//STRIP001 
//STRIP001     void UpdateExample( const SfxItemSet& rSet, SwColMgr* pMgr  )
//STRIP001         {   pColMgr = pMgr;
//STRIP001             SwPageExample::UpdateExample(rSet);
//STRIP001         }
//STRIP001 };

/*-----------------25.10.96 08.23-------------------

--------------------------------------------------*/
//STRIP001 class SwColumnOnlyExample : public Window
//STRIP001 {
//STRIP001 private:
//STRIP001 	Size 		aWinSize;
//STRIP001 
//STRIP001 	Size		aFrmSize;
//STRIP001 	SwFmtCol   	aCols;
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void Paint( const Rectangle& rRect );
//STRIP001 
//STRIP001 public:
//STRIP001 	SwColumnOnlyExample( Window* , const ResId& );
//STRIP001 
//STRIP001     void        SetColumns(const SwFmtCol& rCol);
//STRIP001 
//STRIP001 };

} //namespace binfilter
#endif // _COLEX_HXX
