/*************************************************************************
 *
 *  $RCSfile: dialog.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:27:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef DIALOG_HXX
#define DIALOG_HXX

#ifndef _SV_DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif
#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
#ifndef _SV_IMAGE_HXX
#include <vcl/image.hxx>
#endif
#ifndef _SFXTABDLG_HXX //autogen
#include <bf_sfx2/tabdlg.hxx>
#endif
#ifndef _SV_COMBOBOX_HXX //autogen
#include <vcl/combobox.hxx>
#endif
#ifndef _SVX_CHARMAP_HXX
#include <bf_svx/charmap.hxx>
#endif
#ifndef _SVX_OPTGENRL_HXX //autogen
#include <bf_svx/optgenrl.hxx>
#endif
#ifndef _BASEDLGS_HXX //autogen
#include <bf_sfx2/basedlgs.hxx>
#endif
#ifndef _SV_FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
#ifndef _SV_MENUBTN_HXX //autogen
#include <vcl/menubtn.hxx>
#endif
#ifndef _SV_SCRBAR_HXX //autogen
#include <vcl/scrbar.hxx>
#endif
#ifndef _SV_CTRL_HXX //autogen
#include <vcl/ctrl.hxx>
#endif
#ifndef _SV_MENU_HXX //autogen
#include <vcl/menu.hxx>
#endif
#ifndef _CTRLBOX_HXX //autogen
#include <svtools/ctrlbox.hxx>
#endif
#ifndef _CTRLTOOL_HXX //autogen
#include <svtools/ctrltool.hxx>
#endif

#ifndef UTILITY_HXX
#include "utility.hxx"
#endif
#ifndef FORMAT_HXX
#include "format.hxx"
#endif
#ifndef SYMBOL_HXX
#include "symbol.hxx"
#endif
namespace binfilter {


#define CATEGORY_NONE	0xFFFF

/**************************************************************************/

//STRIP001 const XubString	GetFontStyleName(const Font &rFont);
//STRIP001 void			SetFontStyle(const XubString &rStyleName, Font &rFont);

/**************************************************************************/

//STRIP001 class SmAboutDialog : public ModalDialog
//STRIP001 {
//STRIP001 	FixedText 	aFixedText1;
//STRIP001 	FixedText 	aFixedText2;
//STRIP001 	FixedText 	aFixedText3;
//STRIP001 	FixedText 	aFixedText4;
//STRIP001 	FixedText 	aFixedText5;
//STRIP001 	FixedText 	aFixedText6;
//STRIP001 	FixedText 	aReleaseText;
//STRIP001 	FixedBitmap	aFixedBitmap1;
//STRIP001 	OKButton 	aOKButton1;
//STRIP001 
//STRIP001 public:
//STRIP001 	SmAboutDialog(Window *pParent, BOOL bFreeRes = TRUE);
//STRIP001 };

/**************************************************************************/

//STRIP001 class SmPrintOptionsTabPage : public SfxTabPage
//STRIP001 {
//STRIP001     FixedLine       aFixedLine1;
//STRIP001 	CheckBox		aTitle;
//STRIP001 	CheckBox		aText;
//STRIP001 	CheckBox		aFrame;
//STRIP001     FixedLine       aFixedLine2;
//STRIP001 	RadioButton 	aSizeNormal;
//STRIP001 	RadioButton 	aSizeScaled;
//STRIP001 	RadioButton 	aSizeZoomed;
//STRIP001 	MetricField 	aZoom;
//STRIP001     FixedLine       aFixedLine3;
//STRIP001 	CheckBox		aNoRightSpaces;
//STRIP001 
//STRIP001 	DECL_LINK(SizeButtonClickHdl, Button *);
//STRIP001 
//STRIP001 	virtual BOOL	FillItemSet(SfxItemSet& rSet);
//STRIP001 	virtual void	Reset(const SfxItemSet& rSet);
//STRIP001 
//STRIP001 public:
//STRIP001 	static SfxTabPage* Create(Window *pWindow, const SfxItemSet &rSet);
//STRIP001 
//STRIP001 	SmPrintOptionsTabPage(Window *pParent, const SfxItemSet &rOptions);
//STRIP001 };

/**************************************************************************/

//STRIP001 class SmShowFont : public Control
//STRIP001 {
//STRIP001 	virtual void	Paint(const Rectangle&);
//STRIP001 
//STRIP001 public:
//STRIP001 	SmShowFont(Window *pParent, const ResId& rResId) :
//STRIP001 		Control(pParent, rResId)
//STRIP001 	{
//STRIP001 	}
//STRIP001 
//STRIP001 	void SetFont(const Font& rFont);
//STRIP001 };

//STRIP001 class SmFontDialog : public ModalDialog
//STRIP001 {
//STRIP001 	FixedText 		aFixedText1;
//STRIP001 	ComboBox 		aFontBox;
//STRIP001 	CheckBox 		aBoldCheckBox;
//STRIP001 	CheckBox 		aItalicCheckBox;
//STRIP001 	OKButton 		aOKButton1;
//STRIP001 	CancelButton 	aCancelButton1;
//STRIP001 	SmShowFont 		aShowFont;
//STRIP001     FixedText       aFixedText2;
//STRIP001 
//STRIP001 	Font	Face;
//STRIP001 
//STRIP001 	DECL_LINK(FontSelectHdl, ComboBox *);
//STRIP001 	DECL_LINK(FontModifyHdl, ComboBox *);
//STRIP001 	DECL_LINK(AttrChangeHdl, CheckBox *);
//STRIP001 
//STRIP001     void            InitColor_Impl();
//STRIP001 
//STRIP001     virtual void    DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 
//STRIP001 public:
//STRIP001 	SmFontDialog(Window * pParent, BOOL bFreeRes = TRUE);
//STRIP001 
//STRIP001 	const Font&	GetFont() const { return Face; }
//STRIP001 	void		SetFont(const Font &rFont);
//STRIP001 };

/**************************************************************************/

//STRIP001 class SmFontSizeDialog : public ModalDialog
//STRIP001 {
//STRIP001 	FixedText 		aFixedText1;
//STRIP001 	MetricField 	aBaseSize;
//STRIP001 	FixedText 		aFixedText4;
//STRIP001 	MetricField 	aTextSize;
//STRIP001 	FixedText 		aFixedText5;
//STRIP001 	MetricField 	aIndexSize;
//STRIP001 	FixedText 		aFixedText6;
//STRIP001 	MetricField 	aFunctionSize;
//STRIP001 	FixedText 		aFixedText7;
//STRIP001 	MetricField 	aOperatorSize;
//STRIP001 	FixedText 		aFixedText8;
//STRIP001 	MetricField 	aBorderSize;
//STRIP001     FixedLine       aFixedLine1;
//STRIP001 	OKButton 		aOKButton1;
//STRIP001 	CancelButton 	aCancelButton1;
//STRIP001 	PushButton 		aDefaultButton;
//STRIP001 
//STRIP001 	DECL_LINK(DefaultButtonClickHdl, Button *);
//STRIP001 
//STRIP001 public:
//STRIP001 	SmFontSizeDialog(Window *pParent, BOOL bFreeRes = TRUE);
//STRIP001 
//STRIP001 	void ReadFrom(const SmFormat &rFormat);
//STRIP001 	void WriteTo (SmFormat &rFormat) const;
//STRIP001 };

/**************************************************************************/

//STRIP001 class SmFontTypeDialog : public ModalDialog
//STRIP001 {
//STRIP001 	FixedText 			aFixedText1;
//STRIP001 	SmFontPickListBox 	aVariableFont;
//STRIP001 	FixedText 			aFixedText2;
//STRIP001 	SmFontPickListBox 	aFunctionFont;
//STRIP001 	FixedText 			aFixedText3;
//STRIP001 	SmFontPickListBox 	aNumberFont;
//STRIP001 	FixedText 			aFixedText4;
//STRIP001 	SmFontPickListBox 	aTextFont;
//STRIP001 	FixedText 			aFixedText5;
//STRIP001 	SmFontPickListBox 	aSerifFont;
//STRIP001 	FixedText 			aFixedText6;
//STRIP001 	SmFontPickListBox 	aSansFont;
//STRIP001 	FixedText 			aFixedText7;
//STRIP001 	SmFontPickListBox 	aFixedFont;
//STRIP001     FixedLine           aFixedLine1;
//STRIP001     FixedLine           aFixedLine2;
//STRIP001 	OKButton 			aOKButton1;
//STRIP001 	CancelButton 		aCancelButton1;
//STRIP001 	MenuButton 			aMenuButton;
//STRIP001 	PushButton 			aDefaultButton;
//STRIP001 
//STRIP001 	DECL_LINK(MenuSelectHdl, Menu *);
//STRIP001 	DECL_LINK(DefaultButtonClickHdl, Button *);
//STRIP001 
//STRIP001 public:
//STRIP001 	SmFontTypeDialog(Window *pParent, BOOL bFreeRes = TRUE);
//STRIP001 
//STRIP001 	void ReadFrom(const SmFormat &rFormat);
//STRIP001 	void WriteTo (SmFormat &rFormat) const;
//STRIP001 };

/**************************************************************************/

#define NOCATEGORIES	10

//STRIP001 class SmCategoryDesc : public Resource
//STRIP001 {
//STRIP001     XubString       Name;
//STRIP001 	XubString	   *Strings[4];
//STRIP001     Bitmap         *Graphics[4];    /* regular bitmaps */
//STRIP001     Bitmap         *GraphicsH[4];   /* high contrast bitmaps */
//STRIP001     USHORT          Minimum[4];
//STRIP001     USHORT          Maximum[4];
//STRIP001     USHORT          Value[4];
//STRIP001     BOOL            bIsHighContrast;
//STRIP001 
//STRIP001 public:
//STRIP001 	SmCategoryDesc(const ResId &rResId, USHORT nCategoryIdx);
//STRIP001 	~SmCategoryDesc();
//STRIP001 
//STRIP001 	const XubString &	GetName() const				   	{ return Name; }
//STRIP001 	const XubString *	GetString(USHORT Index) const  	{ return Strings[Index];  }
//STRIP001 	USHORT			GetMinimum(USHORT Index) 		{ return Minimum[Index]; }
//STRIP001 	USHORT			GetMaximum(USHORT Index) 		{ return Maximum[Index]; }
//STRIP001 	USHORT	   		GetValue(USHORT Index) const 	{ return Value[Index]; }
//STRIP001 	void			SetValue(USHORT Index, USHORT nVal) { Value[Index] = nVal;}
//STRIP001 
//STRIP001     void            SetHighContrast( BOOL bVal )    { bIsHighContrast = bVal; }
//STRIP001     const Bitmap *  GetGraphic(USHORT Index) const
//STRIP001     {
//STRIP001         return bIsHighContrast ? GraphicsH[Index] : Graphics[Index];
//STRIP001     }
//STRIP001 };


//STRIP001 class SmDistanceDialog : public ModalDialog
//STRIP001 {
//STRIP001 	FixedText		aFixedText1;
//STRIP001 	MetricField 	aMetricField1;
//STRIP001 	FixedText		aFixedText2;
//STRIP001 	MetricField 	aMetricField2;
//STRIP001 	FixedText		aFixedText3;
//STRIP001 	MetricField 	aMetricField3;
//STRIP001 	CheckBox		aCheckBox1;
//STRIP001 	FixedText		aFixedText4;
//STRIP001 	MetricField 	aMetricField4;
//STRIP001 	OKButton		aOKButton1;
//STRIP001 	CancelButton	aCancelButton1;
//STRIP001 	MenuButton		aMenuButton;
//STRIP001 	PushButton		aDefaultButton;
//STRIP001 	FixedBitmap 	aBitmap;
//STRIP001     FixedLine       aFixedLine;
//STRIP001 
//STRIP001 	SmCategoryDesc *Categories[NOCATEGORIES];
//STRIP001 	USHORT			nActiveCategory;
//STRIP001 	BOOL			bScaleAllBrackets;
//STRIP001 
//STRIP001 	DECL_LINK(GetFocusHdl, Control *);
//STRIP001 	DECL_LINK(MenuSelectHdl, Menu *);
//STRIP001 	DECL_LINK(DefaultButtonClickHdl, Button *);
//STRIP001 	DECL_LINK(CheckBoxClickHdl, CheckBox *);
//STRIP001 
//STRIP001 	void	SetHelpId(MetricField &rField, ULONG nHelpId);
//STRIP001 	void	SetCategory(USHORT Category);
//STRIP001 
//STRIP001     void    ApplyImages();
//STRIP001 
//STRIP001 public:
//STRIP001 	SmDistanceDialog(Window *pParent, BOOL bFreeRes = TRUE);
//STRIP001 	~SmDistanceDialog();
//STRIP001 
//STRIP001 	void ReadFrom(const SmFormat &rFormat);
//STRIP001 	void WriteTo (SmFormat &rFormat) /*const*/;
//STRIP001 
//STRIP001     // Window
//STRIP001     virtual void    DataChanged( const DataChangedEvent &rEvt );
//STRIP001 };


/**************************************************************************/


//STRIP001 class SmAlignDialog : public ModalDialog
//STRIP001 {
//STRIP001 	RadioButton  aLeft;
//STRIP001 	RadioButton  aCenter;
//STRIP001 	RadioButton  aRight;
//STRIP001     FixedLine    aFixedLine1;
//STRIP001 	OKButton	 aOKButton1;
//STRIP001 	CancelButton aCancelButton1;
//STRIP001 	PushButton	 aDefaultButton;
//STRIP001 
//STRIP001 	DECL_LINK(DefaultButtonClickHdl, Button *);
//STRIP001 
//STRIP001 public:
//STRIP001 	SmAlignDialog(Window *pParent, BOOL bFreeRes = TRUE);
//STRIP001 
//STRIP001 	void ReadFrom(const SmFormat &rFormat);
//STRIP001 	void WriteTo (SmFormat &rFormat) const;
//STRIP001 };

/**************************************************************************/

//STRIP001 class SmShowSymbolSet : public Control
//STRIP001 {
//STRIP001 	SmSymSet   	aSymbolSet;
//STRIP001 	ScrollBar	aVScrollBar;
//STRIP001 	Size		aOutputSize;
//STRIP001 	Link		aSelectHdlLink;
//STRIP001 	Link		aDblClickHdlLink;
//STRIP001 	USHORT		nLen;
//STRIP001 	USHORT		nRows, nColumns;
//STRIP001 	USHORT		nSelectSymbol;
//STRIP001 
//STRIP001 	virtual void	Paint(const Rectangle&);
//STRIP001 	virtual void	MouseButtonDown(const MouseEvent& rMEvt);
//STRIP001 	virtual void 	KeyInput(const KeyEvent& rKEvt);
//STRIP001 
//STRIP001 	DECL_LINK( ScrollHdl, ScrollBar* );
//STRIP001 
//STRIP001 public:
//STRIP001 	SmShowSymbolSet(Window *pParent, const ResId& rResId);
//STRIP001 
//STRIP001 	void	SetSymbolSet(const SmSymSet& rSymbolSet);
//STRIP001 
//STRIP001 	void	SelectSymbol(USHORT nSymbol);
//STRIP001 	USHORT	GetSelectSymbol() const { return nSelectSymbol; }
//STRIP001 
//STRIP001 	void SetSelectHdl(const Link& rLink)   { aSelectHdlLink = rLink; }
//STRIP001 	void SetDblClickHdl(const Link& rLink) { aDblClickHdlLink = rLink; }
//STRIP001 };

////////////////////////////////////////////////////////////////////////////////

//STRIP001 class SmShowSymbol : public Control
//STRIP001 {
//STRIP001 	Link  aDblClickHdlLink;
//STRIP001 
//STRIP001 	virtual void	Paint(const Rectangle&);
//STRIP001 	virtual void	MouseButtonDown(const MouseEvent& rMEvt);
//STRIP001 
//STRIP001 public:
//STRIP001 	SmShowSymbol(Window *pParent, const ResId& rResId) :
//STRIP001 		Control(pParent, rResId) {}
//STRIP001 
//STRIP001 	void	SetSymbol(const SmSym *pSymbol);
//STRIP001 	void	SetDblClickHdl(const Link &rLink) { aDblClickHdlLink = rLink; }
//STRIP001 };

////////////////////////////////////////////////////////////////////////////////

//STRIP001 class SmSymDefineDialog;

//STRIP001 class SmSymbolDialog : public ModalDialog
//STRIP001 {
//STRIP001 	FixedText		aSymbolSetText;
//STRIP001 	ListBox 		aSymbolSets;
//STRIP001 	SmShowSymbolSet aSymbolSetDisplay;
//STRIP001 	FixedText		aSymbolName;
//STRIP001 	SmShowSymbol	aSymbolDisplay;
//STRIP001 	PushButton		aGetBtn;
//STRIP001 	PushButton		aCloseBtn;
//STRIP001 	PushButton		aEditBtn;
//STRIP001 
//STRIP001 	SmSymSetManager    &rSymSetMgr;
//STRIP001 	const SmSymSet	   *pSymSet;
//STRIP001 
//STRIP001 	DECL_LINK(SymbolSetChangeHdl, ListBox *);
//STRIP001 	DECL_LINK(SymbolChangeHdl, SmShowSymbolSet *);
//STRIP001 	DECL_LINK(SymbolDblClickHdl, SmShowSymbolSet *);
//STRIP001 	DECL_LINK(CloseClickHdl, Button *);
//STRIP001 	DECL_LINK(EditClickHdl, Button *);
//STRIP001 	DECL_LINK(GetClickHdl, Button *);
//STRIP001 
//STRIP001 	void			FillSymbolSets(BOOL bDeleteText = TRUE);
//STRIP001 	void 			SetSymbolSetManager(SmSymSetManager &rMgr);
//STRIP001 	const SmSym    *GetSymbol() const;
//STRIP001     void            InitColor_Impl();
//STRIP001 
//STRIP001     virtual void    DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 
//STRIP001 public:
//STRIP001 	SmSymbolDialog(Window * pParent, SmSymSetManager &rSymSetMgr, BOOL bFreeRes = TRUE);
//STRIP001     virtual ~SmSymbolDialog();
//STRIP001 
//STRIP001 	BOOL	SelectSymbolSet(const XubString &rSymbolSetName);
//STRIP001     void    SelectSymbol(USHORT nSymbolPos);
//STRIP001     USHORT  GetSelectedSymbol() const   { return aSymbolSetDisplay.GetSelectSymbol(); }
//STRIP001 };

////////////////////////////////////////////////////////////////////////////////

//STRIP001 class SmShowChar : public Control
//STRIP001 {
//STRIP001 	virtual void	Paint(const Rectangle&);
//STRIP001 
//STRIP001 public:
//STRIP001 	SmShowChar(Window *pParent, const ResId& rResId)
//STRIP001 	: Control(pParent, rResId)
//STRIP001 	{
//STRIP001 	}
//STRIP001 
//STRIP001 	void	SetChar(xub_Unicode aChar);
//STRIP001 	void	SetFont(const Font &rFont);
//STRIP001 };

////////////////////////////////////////////////////////////////////////////////

//STRIP001 class SmSymDefineDialog : public ModalDialog
//STRIP001 {
//STRIP001     FixedText       aOldSymbolText;
//STRIP001     ComboBox        aOldSymbols;
//STRIP001     FixedText       aOldSymbolSetText;
//STRIP001     ComboBox        aOldSymbolSets;
//STRIP001     SvxShowCharSet  aCharsetDisplay;
//STRIP001     FixedText       aSymbolText;
//STRIP001     ComboBox        aSymbols;
//STRIP001     FixedText       aSymbolSetText;
//STRIP001     ComboBox        aSymbolSets;
//STRIP001     FixedText       aFontText;
//STRIP001     ListBox         aFonts;
//STRIP001     FixedText       aFontsSubsetFT;
//STRIP001     ListBox         aFontsSubsetLB;
//STRIP001     FixedText       aStyleText;
//STRIP001     FontStyleBox    aStyles;
//STRIP001     FixedText       aOldSymbolName;
//STRIP001     SmShowChar      aOldSymbolDisplay;
//STRIP001     FixedText       aOldSymbolSetName;
//STRIP001     FixedText       aSymbolName;
//STRIP001     SmShowChar      aSymbolDisplay;
//STRIP001     FixedText       aSymbolSetName;
//STRIP001     OKButton        aOkBtn;
//STRIP001     CancelButton    aCancelBtn;
//STRIP001     PushButton      aAddBtn;
//STRIP001     PushButton      aChangeBtn;
//STRIP001     PushButton      aDeleteBtn;
//STRIP001     FixedImage      aRightArrow;
//STRIP001 
//STRIP001 	SmSymSetManager    	aSymSetMgrCopy,
//STRIP001 					   &rSymSetMgr;
//STRIP001 	const SmSym		   *pOrigSymbol;
//STRIP001 
//STRIP001 	FontList	  	   *pFontList;
//STRIP001     const SubsetMap    *pSubsetMap;
//STRIP001 
//STRIP001 	DECL_LINK(OldSymbolChangeHdl, ComboBox *);
//STRIP001 	DECL_LINK(OldSymbolSetChangeHdl, ComboBox *);
//STRIP001 	DECL_LINK(ModifyHdl, ComboBox *);
//STRIP001 	DECL_LINK(FontChangeHdl, ListBox *);
//STRIP001     DECL_LINK(SubsetChangeHdl, ListBox*);
//STRIP001 	DECL_LINK(StyleChangeHdl, ComboBox *);
//STRIP001     DECL_LINK(CharHighlightHdl, Control* pControl);
//STRIP001 	DECL_LINK(AddClickHdl, Button *);
//STRIP001 	DECL_LINK(ChangeClickHdl, Button *);
//STRIP001 	DECL_LINK(DeleteClickHdl, Button *);
//STRIP001 
//STRIP001 	void	FillSymbols(ComboBox &rComboBox, BOOL bDeleteText = TRUE);
//STRIP001 	void	FillSymbolSets(ComboBox &rComboBox, BOOL bDeleteText = TRUE);
//STRIP001 	void	FillFonts(BOOL bDeleteText = TRUE);
//STRIP001 	void	FillStyles(BOOL bDeleteText = TRUE);
//STRIP001 
//STRIP001 	void 	SetSymbolSetManager(const SmSymSetManager &rMgr);
//STRIP001 	void	SetFont(const XubString &rFontName, const XubString &rStyleName);
//STRIP001 	void	SetOrigSymbol(const SmSym *pSymbol, const XubString &rSymbolSetName);
//STRIP001 	void	UpdateButtons();
//STRIP001 
//STRIP001 	BOOL	SelectSymbolSet(ComboBox &rComboBox, const XubString &rSymbolSetName,
//STRIP001 							BOOL bDeleteText);
//STRIP001 	BOOL	SelectSymbol(ComboBox &rComboBox, const XubString &rSymbolName,
//STRIP001 							BOOL bDeleteText);
//STRIP001 	BOOL	SelectFont(const XubString &rFontName, BOOL bApplyFont);
//STRIP001 	BOOL	SelectStyle(const XubString &rStyleName, BOOL bApplyFont);
//STRIP001 
//STRIP001 
//STRIP001     SmSymSet              *GetSymbolSet(const ComboBox &rComboBox);
//STRIP001 	inline const SmSymSet *GetSymbolSet(const ComboBox &rComboBox) const;
//STRIP001     SmSym                 *GetSymbol(const ComboBox &rComboBox);
//STRIP001 	inline const SmSym    *GetSymbol(const ComboBox &rComboBox) const;
//STRIP001 
//STRIP001     void            InitColor_Impl();
//STRIP001 
//STRIP001     virtual void    DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 
//STRIP001 public:
//STRIP001 	SmSymDefineDialog(Window *pParent, SmSymSetManager &rMgr, BOOL bFreeRes = TRUE);
//STRIP001 	~SmSymDefineDialog();
//STRIP001 
//STRIP001 	// Dialog
//STRIP001 	virtual short	Execute();
//STRIP001 
//STRIP001 	inline BOOL	SelectOldSymbolSet(const XubString &rSymbolSetName);
//STRIP001 	inline BOOL	SelectOldSymbol(const XubString &rSymbolName);
//STRIP001 	inline BOOL	SelectSymbolSet(const XubString &rSymbolSetName);
//STRIP001 	inline BOOL	SelectSymbol(const XubString &rSymbolName);
//STRIP001 	BOOL		SelectFont(const XubString &rFontName)   { return SelectFont(rFontName, TRUE); }
//STRIP001 	BOOL		SelectStyle(const XubString &rStyleName) { return SelectStyle(rStyleName, TRUE); };
//STRIP001 	void		SelectChar(xub_Unicode cChar);
//STRIP001 };

//STRIP001 inline const SmSymSet * SmSymDefineDialog::GetSymbolSet(const ComboBox &rComboBox) const
//STRIP001 {
//STRIP001 	return ((SmSymDefineDialog *) this)->GetSymbolSet(rComboBox);
//STRIP001 }

//STRIP001 inline const SmSym * SmSymDefineDialog::GetSymbol(const ComboBox &rComboBox) const
//STRIP001 {
//STRIP001 	return ((SmSymDefineDialog *) this)->GetSymbol(rComboBox);
//STRIP001 }

//STRIP001 inline BOOL	SmSymDefineDialog::SelectOldSymbolSet(const XubString &rSymbolSetName)
//STRIP001 {
//STRIP001 	return SelectSymbolSet(aOldSymbolSets, rSymbolSetName, FALSE);
//STRIP001 }

//STRIP001 inline BOOL	SmSymDefineDialog::SelectOldSymbol(const XubString &rSymbolName)
//STRIP001 {
//STRIP001 	return SelectSymbol(aOldSymbols, rSymbolName, FALSE);
//STRIP001 }

//STRIP001 inline BOOL	SmSymDefineDialog::SelectSymbolSet(const XubString &rSymbolSetName)
//STRIP001 {
//STRIP001 	return SelectSymbolSet(aSymbolSets, rSymbolSetName, FALSE);
//STRIP001 }

//STRIP001 inline BOOL	SmSymDefineDialog::SelectSymbol(const XubString &rSymbolName)
//STRIP001 {
//STRIP001 	return SelectSymbol(aSymbols, rSymbolName, FALSE);
//STRIP001 }


} //namespace binfilter
#endif

