/*************************************************************************
 *
 *  $RCSfile: optpath.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:23:35 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_OPTPATH_HXX
#define _SVX_OPTPATH_HXX

// include ---------------------------------------------------------------

// auto strip #ifndef _SFXTABDLG_HXX //autogen
// auto strip #include <bf_sfx2/tabdlg.hxx>
// auto strip #endif
// auto strip #ifndef _FIXED_HXX //autogen
// auto strip #include <vcl/fixed.hxx>
// auto strip #endif
// auto strip #ifndef _GROUP_HXX //autogen
// auto strip #include <vcl/group.hxx>
// auto strip #endif

#ifdef _SVX_OPTPATH_CXX
// auto strip #ifndef _HEADBAR_HXX //autogen
// auto strip #include <svtools/headbar.hxx>
// auto strip #endif
#else
namespace binfilter {
//STRIP001 class HeaderBar;
#endif

// forward ---------------------------------------------------------------

//STRIP001 class SvTabListBox;
//STRIP001 class OptHeaderTabListBox;
//STRIP001 struct OptPath_Impl;

// define ----------------------------------------------------------------

//STRIP001 #define SfxPathTabPage SvxPathTabPage

// class SvxPathControl_Impl ---------------------------------------------

//STRIP001 class SvxPathControl_Impl : public Control
//STRIP001 {
//STRIP001 private:
//STRIP001 	Control*		m_pFocusCtrl;
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxPathControl_Impl( Window* pParent, const ResId& rId ) :
//STRIP001 		Control( pParent, rId ), m_pFocusCtrl( NULL ) {}
//STRIP001 
//STRIP001 	void			SetFocusControl( Control* pCtrl ) { m_pFocusCtrl = pCtrl; }
//STRIP001 
//STRIP001 	virtual long	Notify( NotifyEvent& rNEvt );
//STRIP001 };

// class SvxPathTabPage --------------------------------------------------

//STRIP001 class SvxPathTabPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	FixedText			aTypeText;
//STRIP001 	FixedText			aPathText;
//STRIP001 	SvxPathControl_Impl	aPathCtrl;
//STRIP001 	PushButton			aStandardBtn;
//STRIP001 	PushButton      	aPathBtn;
//STRIP001     FixedLine           aStdBox;
//STRIP001 
//STRIP001 	HeaderBar*				pHeaderBar;
//STRIP001 	OptHeaderTabListBox*	pPathBox;
//STRIP001 	OptPath_Impl*			pImpl;
//STRIP001 
//STRIP001 #ifdef _SVX_OPTPATH_CXX
//STRIP001 	DECL_LINK( PathHdl_Impl, PushButton * );
//STRIP001 	DECL_LINK( StandardHdl_Impl, PushButton * );
//STRIP001 
//STRIP001 	DECL_LINK( PathSelect_Impl, OptHeaderTabListBox * );
//STRIP001 	DECL_LINK( HeaderSelect_Impl, HeaderBar * );
//STRIP001 	DECL_LINK( HeaderEndDrag_Impl, HeaderBar * );
//STRIP001 #endif
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxPathTabPage( Window* pParent, const SfxItemSet& rSet );
//STRIP001 	~SvxPathTabPage();
//STRIP001 
//STRIP001 	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& rSet );
//STRIP001 	static USHORT*		GetRanges();
//STRIP001 
//STRIP001 	virtual	BOOL 		FillItemSet( SfxItemSet& rSet );
//STRIP001 	virtual	void 		Reset( const SfxItemSet& rSet );
//STRIP001 	virtual void        FillUserData();
//STRIP001 };

}//end of namespace binfilter
#endif

