/*************************************************************************
 *
 *  $RCSfile: sc_pvfundlg.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:43:27 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif


// auto strip #ifndef PCH
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif

// auto strip #include "scresid.hxx"
// auto strip #include "pivot.hxx"
#include "pvfundlg.hrc"
// auto strip #include "pvfundlg.hxx"
namespace binfilter {

//========================================================================

//STRIP001 ScDPFunctionDlg::ScDPFunctionDlg(   Window*         pParent,
//STRIP001                                     BOOL            bSubTotalFunc,
//STRIP001                                     const String&   rName,
//STRIP001                                     USHORT          nFunctions,
//STRIP001                                     BOOL            bIsShowAll )
//STRIP001 
//STRIP001 	:	ModalDialog	( pParent, ScResId( RID_SCDLG_PIVOTSUBT ) ),
//STRIP001 		aBtnOk		( this, ScResId( BTN_OK ) ),
//STRIP001 		aBtnCancel	( this, ScResId( BTN_CANCEL ) ),
//STRIP001 		aBtnHelp	( this, ScResId( BTN_HELP ) ),
//STRIP001 		aBtnNone	( this, ScResId( BTN_NONE ) ),
//STRIP001 		aBtnAuto	( this, ScResId( BTN_AUTO ) ),
//STRIP001 		aBtnUser	( this, ScResId( BTN_USER ) ),
//STRIP001         aFlFunc     ( this, ScResId( FL_FUNC ) ),
//STRIP001 		aCbShowAll	( this, ScResId( CB_SHOWALL ) ),
//STRIP001 		aFtNameLabel( this, ScResId( FT_NAMELABEL ) ),
//STRIP001 		aFtName		( this, ScResId( FT_NAME ) ),
//STRIP001 		aLbFunc		( this, ScResId( LB_FUNC ) ),
//STRIP001 		nFuncMask	( nFunctions )
//STRIP001 {
//STRIP001 	aFtName.SetText( rName );
//STRIP001 	SetUI( bSubTotalFunc );
//STRIP001 	InitFuncLb( nFunctions );
//STRIP001 	if ( bSubTotalFunc )					// hidden in SetUI otherwise
//STRIP001 		aCbShowAll.Check( bIsShowAll );
//STRIP001 	FreeResource();
//STRIP001 }

//------------------------------------------------------------------------

//STRIP001 __EXPORT ScDPFunctionDlg::~ScDPFunctionDlg()
//STRIP001 {
//STRIP001 	USHORT	nEntryCount = aLbFunc.GetEntryCount();
//STRIP001 
//STRIP001 	for ( USHORT i=0; i<nEntryCount; i++ )
//STRIP001 	{
//STRIP001 		delete (USHORT*)aLbFunc.GetEntryData( i );
//STRIP001 		aLbFunc.SetEntryData( i, NULL );
//STRIP001 	}
//STRIP001 }

//------------------------------------------------------------------------

//STRIP001 BOOL ScDPFunctionDlg::GetShowAll() const
//STRIP001 {
//STRIP001 	return aCbShowAll.IsChecked();
//STRIP001 }

//------------------------------------------------------------------------

#define FUNC_SET(f) ( (nFunctions & (f)) == (f) )


//STRIP001 void ScDPFunctionDlg::InitFuncLb( USHORT nFunctions )
//STRIP001 {
//STRIP001 	aLbFunc.SetEntryData(  0, new USHORT(PIVOT_FUNC_SUM) );
//STRIP001 	aLbFunc.SetEntryData(  1, new USHORT(PIVOT_FUNC_COUNT) );
//STRIP001 	aLbFunc.SetEntryData(  2, new USHORT(PIVOT_FUNC_AVERAGE) );
//STRIP001 	aLbFunc.SetEntryData(  3, new USHORT(PIVOT_FUNC_MAX) );
//STRIP001 	aLbFunc.SetEntryData(  4, new USHORT(PIVOT_FUNC_MIN) );
//STRIP001 	aLbFunc.SetEntryData(  5, new USHORT(PIVOT_FUNC_PRODUCT) );
//STRIP001 	aLbFunc.SetEntryData(  6, new USHORT(PIVOT_FUNC_COUNT_NUM) );
//STRIP001 	aLbFunc.SetEntryData(  7, new USHORT(PIVOT_FUNC_STD_DEV) );
//STRIP001 	aLbFunc.SetEntryData(  8, new USHORT(PIVOT_FUNC_STD_DEVP) );
//STRIP001 	aLbFunc.SetEntryData(  9, new USHORT(PIVOT_FUNC_STD_VAR) );
//STRIP001 	aLbFunc.SetEntryData( 10, new USHORT(PIVOT_FUNC_STD_VARP) );
//STRIP001 
//STRIP001 	if (    nFunctions == PIVOT_FUNC_NONE
//STRIP001 		 || nFunctions == PIVOT_FUNC_AUTO )
//STRIP001 	{
//STRIP001 		aLbFunc.SetNoSelection();
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aLbFunc.SelectEntryPos(  0, FUNC_SET( PIVOT_FUNC_SUM 		) );
//STRIP001 		aLbFunc.SelectEntryPos(  1, FUNC_SET( PIVOT_FUNC_COUNT 		) );
//STRIP001 		aLbFunc.SelectEntryPos(  2, FUNC_SET( PIVOT_FUNC_AVERAGE 	) );
//STRIP001 		aLbFunc.SelectEntryPos(  3, FUNC_SET( PIVOT_FUNC_MAX 		) );
//STRIP001 		aLbFunc.SelectEntryPos(  4, FUNC_SET( PIVOT_FUNC_MIN 		) );
//STRIP001 		aLbFunc.SelectEntryPos(  5, FUNC_SET( PIVOT_FUNC_PRODUCT 	) );
//STRIP001 		aLbFunc.SelectEntryPos(  6, FUNC_SET( PIVOT_FUNC_COUNT_NUM 	) );
//STRIP001 		aLbFunc.SelectEntryPos(  7, FUNC_SET( PIVOT_FUNC_STD_DEV 	) );
//STRIP001 		aLbFunc.SelectEntryPos(  8, FUNC_SET( PIVOT_FUNC_STD_DEVP	) );
//STRIP001 		aLbFunc.SelectEntryPos(  9, FUNC_SET( PIVOT_FUNC_STD_VAR	) );
//STRIP001 		aLbFunc.SelectEntryPos( 10, FUNC_SET( PIVOT_FUNC_STD_VARP	) );
//STRIP001 	}
//STRIP001     aLbFunc.SetDoubleClickHdl( LINK( this, ScDPFunctionDlg, DblClickHdl ) );
//STRIP001 }

#undef FUNC_SET

//------------------------------------------------------------------------

//STRIP001 void ScDPFunctionDlg::SetUI( BOOL bSubTotals )
//STRIP001 {
//STRIP001     aBtnOk.SetClickHdl  ( LINK( this, ScDPFunctionDlg, ClickHdl ) );
//STRIP001 
//STRIP001 	if ( bSubTotals )
//STRIP001 	{
//STRIP001         aFlFunc.SetText( ScResId( STR_SUBTOTALS ) );
//STRIP001 
//STRIP001         aBtnNone.SetClickHdl    ( LINK( this, ScDPFunctionDlg, RadioClickHdl ) );
//STRIP001         aBtnAuto.SetClickHdl    ( LINK( this, ScDPFunctionDlg, RadioClickHdl ) );
//STRIP001         aBtnUser.SetClickHdl    ( LINK( this, ScDPFunctionDlg, RadioClickHdl ) );
//STRIP001 
//STRIP001 		if ( nFuncMask == PIVOT_FUNC_NONE )
//STRIP001 		{
//STRIP001 			aBtnNone.Check( nFuncMask == PIVOT_FUNC_NONE );
//STRIP001 			aLbFunc.Disable();
//STRIP001 		}
//STRIP001 		else if ( nFuncMask == PIVOT_FUNC_AUTO )
//STRIP001 		{
//STRIP001 			aBtnAuto.Check();
//STRIP001 			aLbFunc.Disable();
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aBtnUser.Check();
//STRIP001 			aLbFunc.Enable();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001         aFlFunc.SetText( ScResId( STR_DATAFUNC ) );
//STRIP001 
//STRIP001         Size    aSize( aFlFunc.GetSizePixel() );
//STRIP001 		Point	aPos1( aFtNameLabel.GetPosPixel() );
//STRIP001 		Point	aPos2( aFtName.GetPosPixel() );
//STRIP001 		long	nYDiff =  aBtnUser.GetPosPixel().Y()
//STRIP001 						- aBtnNone.GetPosPixel().Y()
//STRIP001 						+ aBtnNone.GetSizePixel().Height()
//STRIP001 						+ LogicToPixel( Point(5,0), MAP_APPFONT ).X();
//STRIP001 
//STRIP001 		aPos1.Y() 		-= nYDiff;
//STRIP001 		aPos2.Y() 		-= nYDiff;
//STRIP001 
//STRIP001 		aLbFunc		.SetPosPixel( aBtnNone.GetPosPixel() );
//STRIP001 		aFtNameLabel.SetPosPixel( aPos1 );
//STRIP001 		aFtName		.SetPosPixel( aPos2 );
//STRIP001 
//STRIP001 		aLbFunc.Enable();
//STRIP001 		aBtnNone.Hide();
//STRIP001 		aBtnAuto.Hide();
//STRIP001 		aBtnUser.Hide();
//STRIP001 		aBtnUser.Check();
//STRIP001 
//STRIP001 		aCbShowAll.Disable();
//STRIP001 		aCbShowAll.Hide();
//STRIP001 
//STRIP001 		aSize = GetSizePixel();
//STRIP001 		aSize.Height() -= nYDiff;
//STRIP001 		SetSizePixel( aSize );
//STRIP001 	}
//STRIP001 }

//------------------------------------------------------------------------
// Handler:

//STRIP001 IMPL_LINK( ScDPFunctionDlg, RadioClickHdl, RadioButton *, pBtn )
//STRIP001 {
//STRIP001 	if ( pBtn == &aBtnNone || pBtn == &aBtnAuto )
//STRIP001 	{
//STRIP001 		aLbFunc.Disable();
//STRIP001 	}
//STRIP001 	else if ( pBtn == &aBtnUser )
//STRIP001 	{
//STRIP001 		aLbFunc.Enable();
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }


//------------------------------------------------------------------------

//STRIP001 IMPL_LINK_INLINE_START( ScDPFunctionDlg, DblClickHdl, MultiListBox *, EMPTYARG )
//STRIP001 {
//STRIP001 	ClickHdl( &aBtnOk );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 IMPL_LINK_INLINE_END( ScDPFunctionDlg, DblClickHdl, MultiListBox *, EMPTYARG )

//------------------------------------------------------------------------

//STRIP001 IMPL_LINK( ScDPFunctionDlg, ClickHdl, PushButton *, pBtn )
//STRIP001 {
//STRIP001 	if ( pBtn == &aBtnOk )
//STRIP001 	{
//STRIP001 		if ( aBtnNone.IsChecked() )
//STRIP001 			nFuncMask = PIVOT_FUNC_NONE;
//STRIP001 		else if ( aBtnAuto.IsChecked() )
//STRIP001 			nFuncMask = PIVOT_FUNC_AUTO;
//STRIP001 		else if ( aBtnUser.IsChecked() )
//STRIP001 		{
//STRIP001 			USHORT	nPos		= 0;
//STRIP001 			USHORT	nSelCount	= aLbFunc.GetSelectEntryCount();
//STRIP001 
//STRIP001 			nFuncMask = PIVOT_FUNC_NONE;
//STRIP001 
//STRIP001 			for ( USHORT i=0; i<nSelCount; i++ )
//STRIP001 			{
//STRIP001 				nPos = aLbFunc.GetSelectEntryPos( i );
//STRIP001 				nFuncMask = ( nFuncMask | *((USHORT*)aLbFunc.GetEntryData( nPos )) );
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		EndDialog( RET_OK );
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }
}
