/*************************************************************************
 *
 *  $RCSfile: sc_funcpage.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 11:56:30 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

//----------------------------------------------------------------------------

// auto strip #include "scitems.hxx"
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #include <bf_sfx2/docfile.hxx>
// auto strip #include <bf_sfx2/objsh.hxx>
// auto strip #include <svtools/zforlist.hxx>

// auto strip #ifndef _SFXSTRITEM_HXX //autogen
// auto strip #include <svtools/stritem.hxx>
// auto strip #endif

#include "funcpage.hxx"
#include "formdlgs.hrc"
// auto strip #include "formdata.hxx"
#include "globstr.hrc"
// auto strip #include "scresid.hxx"
// auto strip #include "reffact.hxx"
// auto strip #include "document.hxx"
// auto strip #include "cell.hxx"
// auto strip #include "scmod.hxx"
// auto strip #include "inputhdl.hxx"
// auto strip #include "tabvwsh.hxx"
// auto strip #include "appoptio.hxx"
namespace binfilter {

//============================================================================

//STRIP001 ScListBox::ScListBox( Window* pParent, WinBits nWinStyle):
//STRIP001 	ListBox(pParent,nWinStyle)
//STRIP001 {}

//STRIP001 ScListBox::ScListBox( Window* pParent, const ResId& rResId ):
//STRIP001 	ListBox(pParent,rResId)
//STRIP001 {}

//STRIP001 void ScListBox::KeyInput( const KeyEvent& rKEvt )
//STRIP001 {
//STRIP001 	KeyEvent aKEvt=rKEvt;
//STRIP001 	//ListBox::KeyInput(rKEvt);
//STRIP001 
//STRIP001 	if(aKEvt.GetCharCode()==' ')
//STRIP001 		DoubleClick();
//STRIP001 }

//STRIP001 long ScListBox::PreNotify( NotifyEvent& rNEvt )
//STRIP001 {
//STRIP001 	NotifyEvent aNotifyEvt=rNEvt;
//STRIP001 
//STRIP001 	long nResult=ListBox::PreNotify(rNEvt);
//STRIP001 
//STRIP001 	USHORT nSwitch=aNotifyEvt.GetType();
//STRIP001 	if(nSwitch==EVENT_KEYINPUT)
//STRIP001 	{
//STRIP001 		KeyInput(*aNotifyEvt.GetKeyEvent());
//STRIP001 	}
//STRIP001 	return nResult;
//STRIP001 }



//============================================================================

//STRIP001 inline USHORT Lb2Cat( USHORT nLbPos )
//STRIP001 {
//STRIP001 	// Kategorie 0 == LRU, sonst Categories == LbPos-1
//STRIP001 	if ( nLbPos > 0 )
//STRIP001 		nLbPos -= 1;
//STRIP001 
//STRIP001 	return nLbPos;
//STRIP001 }

//============================================================================

//STRIP001 ScFuncPage::ScFuncPage(Window* pParent):
//STRIP001 	TabPage(pParent,ScResId(RID_SCTAB_FUNCTION)),
//STRIP001 	//
//STRIP001 	aFtCategory		( this, ScResId( FT_CATEGORY ) ),
//STRIP001 	aLbCategory		( this, ScResId( LB_CATEGORY ) ),
//STRIP001 	aFtFunction		( this, ScResId( FT_FUNCTION ) ),
//STRIP001 	aLbFunction		( this, ScResId( LB_FUNCTION ) ),
//STRIP001 	aIBFunction		( this, ScResId( IB_FUNCTION ) )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 	InitLRUList();
//STRIP001 	aLbCategory.SelectEntryPos(1);
//STRIP001 	UpdateFunctionList();
//STRIP001 	aLbCategory.SetSelectHdl( LINK( this, ScFuncPage, SelHdl ) );
//STRIP001 	aLbFunction.SetSelectHdl( LINK( this, ScFuncPage, SelHdl ) );
//STRIP001 	aLbFunction.SetDoubleClickHdl( LINK( this, ScFuncPage, DblClkHdl ) );
//STRIP001 	aIBFunction.SetClickHdl( LINK( this, ScFuncPage, DblClkHdl ) );
//STRIP001 }

//STRIP001 void ScFuncPage::UpdateFunctionList()
//STRIP001 {
//STRIP001 	USHORT	nSelPos	  = aLbCategory.GetSelectEntryPos();
//STRIP001 	USHORT	nCategory = ( LISTBOX_ENTRY_NOTFOUND != nSelPos )
//STRIP001 							? Lb2Cat( nSelPos ) : 0;
//STRIP001 
//STRIP001 	aLbFunction.Clear();
//STRIP001 	aLbFunction.SetUpdateMode( FALSE );
//STRIP001 	//------------------------------------------------------
//STRIP001 
//STRIP001 	if ( nSelPos > 0 )
//STRIP001 	{
//STRIP001 		ScFunctionMgr* pFuncMgr = ScGlobal::GetStarCalcFunctionMgr();
//STRIP001 
//STRIP001 		ScFuncDesc*	pDesc = pFuncMgr->First( nCategory );
//STRIP001 		while ( pDesc )
//STRIP001 		{
//STRIP001 			aLbFunction.SetEntryData(
//STRIP001 				aLbFunction.InsertEntry(*(pDesc->pFuncName) ),pDesc );
//STRIP001 			pDesc = pFuncMgr->Next();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else // LRU-Liste
//STRIP001 	{
//STRIP001 		for ( USHORT i=0; i<LRU_MAX && aLRUList[i]; i++ )
//STRIP001 		{
//STRIP001 			ScFuncDesc*	pDesc = aLRUList[i];
//STRIP001 			aLbFunction.SetEntryData(
//STRIP001 				aLbFunction.InsertEntry( *(pDesc->pFuncName) ),pDesc );
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	//------------------------------------------------------
//STRIP001 	aLbFunction.SetUpdateMode( TRUE );
//STRIP001 	aLbFunction.SelectEntryPos(0);
//STRIP001 
//STRIP001 	if(IsVisible())	SelHdl(&aLbFunction);
//STRIP001 }

//STRIP001 IMPL_LINK( ScFuncPage, SelHdl, ListBox*, pLb )
//STRIP001 {
//STRIP001 	if(pLb==&aLbFunction)
//STRIP001 	{
//STRIP001 		aSelectionLink.Call(this);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		UpdateFunctionList();
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

//STRIP001 IMPL_LINK( ScFuncPage, DblClkHdl, ListBox*, pLb )
//STRIP001 {
//STRIP001 	aDoubleClickLink.Call(this);
//STRIP001 	return 0;
//STRIP001 }

//STRIP001 void ScFuncPage::SetCategory(USHORT nCat)
//STRIP001 {
//STRIP001 	aLbCategory.SelectEntryPos(nCat);
//STRIP001 	UpdateFunctionList();
//STRIP001 }

//STRIP001 void ScFuncPage::SetFunction(USHORT nFunc)
//STRIP001 {
//STRIP001 	aLbFunction.SelectEntryPos(nFunc);
//STRIP001 }

//STRIP001 void ScFuncPage::SetFocus()
//STRIP001 {
//STRIP001 	aLbFunction.GrabFocus();
//STRIP001 }

//STRIP001 USHORT ScFuncPage::GetCategory()
//STRIP001 {
//STRIP001 	return aLbCategory.GetSelectEntryPos();
//STRIP001 }

//STRIP001 USHORT ScFuncPage::GetFunction()
//STRIP001 {
//STRIP001 	return aLbFunction.GetSelectEntryPos();
//STRIP001 }

//STRIP001 USHORT ScFuncPage::GetFunctionEntryCount()
//STRIP001 {
//STRIP001 	return aLbFunction.GetSelectEntryCount();
//STRIP001 }

//STRIP001 ScFuncDesc*	ScFuncPage::GetFuncDesc( USHORT nPos ) const
//STRIP001 {
//STRIP001 	// nicht schoen, aber hoffentlich selten
//STRIP001 	return (ScFuncDesc*) aLbFunction.GetEntryData(nPos);
//STRIP001 }

//STRIP001 USHORT ScFuncPage::GetFuncPos(ScFuncDesc* pFuncDesc)
//STRIP001 {
//STRIP001 	if(pFuncDesc!=NULL && pFuncDesc->pFuncName!=NULL)
//STRIP001 	{
//STRIP001 		return aLbFunction.GetEntryPos(*(pFuncDesc->pFuncName));
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		return LISTBOX_ENTRY_NOTFOUND;
//STRIP001 	}
//STRIP001 }
//STRIP001 String ScFuncPage::GetSelFunctionName() const
//STRIP001 {
//STRIP001 	return aLbFunction.GetSelectEntry();
//STRIP001 }

//STRIP001 void ScFuncPage::InitLRUList()
//STRIP001 {
//STRIP001 	const ScAppOptions& rAppOpt = SC_MOD()->GetAppOptions();
//STRIP001 	USHORT nLRUFuncCount = Min( rAppOpt.GetLRUFuncListCount(), (USHORT)LRU_MAX );
//STRIP001 	USHORT*	pLRUListIds = rAppOpt.GetLRUFuncList();
//STRIP001 
//STRIP001 	USHORT i;
//STRIP001 	for ( i=0; i<LRU_MAX; i++ )
//STRIP001 		aLRUList[i] = NULL;
//STRIP001 
//STRIP001 	if ( pLRUListIds )
//STRIP001 	{
//STRIP001 		ScFunctionMgr* pFuncMgr = ScGlobal::GetStarCalcFunctionMgr();
//STRIP001 		for ( i=0; i<nLRUFuncCount; i++ )
//STRIP001 			aLRUList[i] = pFuncMgr->Get( pLRUListIds[i] );
//STRIP001 	}
//STRIP001 }




}
