/*************************************************************************
 *
 *  $RCSfile: funcutl.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:01:26 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef SC_FUNCUTL_HXX
#define SC_FUNCUTL_HXX

#ifndef _SCRBAR_HXX //autogen
#include <vcl/scrbar.hxx>
#endif
#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif

#ifndef _SVEDIT_HXX //autogen
#include <svtools/svmedit.hxx>
#endif

// auto strip #ifndef SC_ANYREFDG_HXX
// auto strip #include "anyrefdg.hxx"		// ScRefButton
// auto strip #endif
namespace binfilter {


//============================================================================
// class ValWnd

//STRIP001 class ValWnd : public Window
//STRIP001 {
//STRIP001 public:
//STRIP001 			ValWnd( Window* pParent, const ResId& rId );
//STRIP001 
//STRIP001 	void	SetValue( const String& rStrVal );
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void	Paint( const Rectangle& rRect );
//STRIP001 
//STRIP001 private:
//STRIP001 	String		aStrValue;
//STRIP001 	Rectangle	aRectOut;
//STRIP001 };
//STRIP001 
//STRIP001 
//STRIP001 //============================================================================
//STRIP001 // class ScEditBox
//STRIP001 
//STRIP001 class ScEditBox : public Control
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001 	MultiLineEdit*	pMEdit;
//STRIP001 	Link			aSelChangedLink;
//STRIP001 	Selection		aOldSel;
//STRIP001 	BOOL			bMouseFlag;
//STRIP001 					DECL_LINK( ChangedHdl, ScEditBox* );
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	virtual long	PreNotify( NotifyEvent& rNEvt );
//STRIP001 	virtual void	SelectionChanged();
//STRIP001 	virtual void	Resize();
//STRIP001 	virtual void	GetFocus();
//STRIP001 
//STRIP001 
//STRIP001 public:
//STRIP001 					ScEditBox( Window* pParent,
//STRIP001 								WinBits nWinStyle = WB_LEFT | WB_BORDER );
//STRIP001 					ScEditBox( Window* pParent, const ResId& rResId );
//STRIP001 
//STRIP001 					~ScEditBox();
//STRIP001 
//STRIP001 	MultiLineEdit*	GetEdit() {return pMEdit;}
//STRIP001 
//STRIP001 	void            SetSelChangedHdl( const Link& rLink ) { aSelChangedLink = rLink; }
//STRIP001 	const Link&     GetSelChangedHdl() const { return aSelChangedLink; }
//STRIP001 
//STRIP001 	void			UpdateOldSel();
//STRIP001 };
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 //============================================================================
//STRIP001 // class ArgEdit
//STRIP001 
//STRIP001 class ArgEdit : public ScRefEdit
//STRIP001 {
//STRIP001 public:
//STRIP001 			ArgEdit( Window* pParent, WinBits nWinStyle = WB_LEFT | WB_BORDER );
//STRIP001 			ArgEdit( Window* pParent, const ResId& rResId );
//STRIP001 
//STRIP001 	void	Init( ArgEdit* pPrevEdit, ArgEdit* pNextEdit,
//STRIP001 				  ScrollBar& rArgSlider, USHORT nArgCount );
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void	KeyInput( const KeyEvent& rKEvt );
//STRIP001 
//STRIP001 private:
//STRIP001 	ArgEdit*	pEdPrev;
//STRIP001 	ArgEdit*	pEdNext;
//STRIP001 	ScrollBar*	pSlider;
//STRIP001 	USHORT		nArgs;
//STRIP001 };
//STRIP001 
//STRIP001 
//STRIP001 //============================================================================
//STRIP001 // class ArgInput
//STRIP001 
//STRIP001 class ArgInput
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001 	Link			aFxClickLink;
//STRIP001 	Link			aRefClickLink;
//STRIP001 	Link			aFxFocusLink;
//STRIP001 	Link			aRefFocusLink;
//STRIP001 	Link			aEdFocusLink;
//STRIP001 	Link			aEdModifyLink;
//STRIP001 
//STRIP001 	FixedText*		pFtArg;
//STRIP001 	ImageButton*	pBtnFx;
//STRIP001 	ArgEdit*		pEdArg;
//STRIP001 	ScRefButton*	pRefBtn;
//STRIP001 
//STRIP001 	DECL_LINK(	FxBtnClickHdl, ImageButton* );
//STRIP001 	DECL_LINK(	RefBtnClickHdl,ScRefButton* );
//STRIP001 	DECL_LINK(	FxBtnFocusHdl, ImageButton* );
//STRIP001 	DECL_LINK(	RefBtnFocusHdl,ScRefButton* );
//STRIP001 	DECL_LINK(	EdFocusHdl, ArgEdit* );
//STRIP001 	DECL_LINK(	EdModifyHdl,ArgEdit* );
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	virtual void	FxClick();
//STRIP001 	virtual void	RefClick();
//STRIP001 	virtual void	FxFocus();
//STRIP001 	virtual void	RefFocus();
//STRIP001 	virtual void	EdFocus();
//STRIP001 	virtual void	EdModify();
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	ArgInput();
//STRIP001 
//STRIP001 	void		InitArgInput (	FixedText*		pftArg,
//STRIP001 								ImageButton*	pbtnFx,
//STRIP001 								ArgEdit*		pedArg,
//STRIP001 								ScRefButton*	prefBtn);
//STRIP001 
//STRIP001 	void		SetArgName(const String &aArg);
//STRIP001 	String		GetArgName();
//STRIP001 	void		SetArgNameFont(const Font&);
//STRIP001 
//STRIP001 	void		SetArgVal(const String &aVal);
//STRIP001 	String		GetArgVal();
//STRIP001 
//STRIP001 	void		SetArgSelection	(const Selection& rSel );
//STRIP001 	void		ReplaceSelOfArg	(const String& rStr );
//STRIP001 
//STRIP001 	Selection	GetArgSelection();
//STRIP001 
//STRIP001 
//STRIP001 	ArgEdit*	GetArgEdPtr() {return pEdArg;}
//STRIP001 
//STRIP001 
//STRIP001 	void            SetFxClickHdl( const Link& rLink ) { aFxClickLink = rLink; }
//STRIP001 	const Link&     GetFxClickHdl() const { return aFxClickLink; }
//STRIP001 
//STRIP001 	void            SetRefClickHdl( const Link& rLink ) { aRefClickLink = rLink; }
//STRIP001 	const Link&     GetRefClickHdl() const { return aRefClickLink; }
//STRIP001 
//STRIP001 	void            SetFxFocusHdl( const Link& rLink ) { aFxFocusLink = rLink; }
//STRIP001 	const Link&     GetFxFocusHdl() const { return aFxFocusLink; }
//STRIP001 
//STRIP001 	void            SetRefFocusHdl( const Link& rLink ) { aRefFocusLink = rLink; }
//STRIP001 	const Link&     GetRefFocusHdl() const { return aRefFocusLink; }
//STRIP001 
//STRIP001 	void            SetEdFocusHdl( const Link& rLink ) { aEdFocusLink = rLink; }
//STRIP001 	const Link&     GetEdFocusHdl() const { return aEdFocusLink; }
//STRIP001 
//STRIP001 	void            SetEdModifyHdl( const Link& rLink ) { aEdModifyLink = rLink; }
//STRIP001 	const Link&     GetEdModifyHdl() const { return aEdModifyLink; }
//STRIP001 
//STRIP001 	void Hide();
//STRIP001 	void Show();
//STRIP001 
//STRIP001 };


} //namespace binfilter
#endif
