/*************************************************************************
 *
 *  $RCSfile: sc_areasave.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:15:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// -----------------------------------------------------------------------

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

// INCLUDE ---------------------------------------------------------------

// auto strip #include <bf_svx/linkmgr.hxx>
// auto strip #include <tools/debug.hxx>

// auto strip #include "areasave.hxx"
// auto strip #include "arealink.hxx"
// auto strip #include "document.hxx"
namespace binfilter {

// -----------------------------------------------------------------------

//STRIP001 ScAreaLinkSaver::ScAreaLinkSaver( const ScAreaLink& rSource ) :
//STRIP001 	aFileName	( rSource.GetFile() ),
//STRIP001 	aFilterName	( rSource.GetFilter() ),
//STRIP001 	aOptions	( rSource.GetOptions() ),
//STRIP001 	aSourceArea	( rSource.GetSource() ),
//STRIP001 	aDestArea	( rSource.GetDestArea() )
//STRIP001 {
//STRIP001 }

//STRIP001 ScAreaLinkSaver::ScAreaLinkSaver( const ScAreaLinkSaver& rCopy ) :
//STRIP001 	aFileName	( rCopy.aFileName ),
//STRIP001 	aFilterName	( rCopy.aFilterName ),
//STRIP001 	aOptions	( rCopy.aOptions ),
//STRIP001 	aSourceArea	( rCopy.aSourceArea ),
//STRIP001 	aDestArea	( rCopy.aDestArea )
//STRIP001 {
//STRIP001 }

//STRIP001 ScAreaLinkSaver::~ScAreaLinkSaver()
//STRIP001 {
//STRIP001 }

//STRIP001 DataObject*	ScAreaLinkSaver::Clone() const
//STRIP001 {
//STRIP001 	return new ScAreaLinkSaver( *this );
//STRIP001 }

//STRIP001 BOOL ScAreaLinkSaver::IsEqualSource( const ScAreaLink& rCompare ) const
//STRIP001 {
//STRIP001 	return ( aFileName	 == rCompare.GetFile() &&
//STRIP001 			 aFilterName == rCompare.GetFilter() &&
//STRIP001 			 aOptions	 == rCompare.GetOptions() &&
//STRIP001 			 aSourceArea == rCompare.GetSource() );
//STRIP001 }

//STRIP001 BOOL ScAreaLinkSaver::IsEqual( const ScAreaLink& rCompare ) const
//STRIP001 {
//STRIP001 	return ( IsEqualSource( rCompare ) &&
//STRIP001 			 aDestArea == rCompare.GetDestArea() );
//STRIP001 }

//STRIP001 void ScAreaLinkSaver::WriteToLink( ScAreaLink& rLink ) const
//STRIP001 {
//STRIP001 	rLink.SetDestArea( aDestArea );
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 ScAreaLinkSaveCollection::ScAreaLinkSaveCollection()
//STRIP001 {
//STRIP001 }

//STRIP001 ScAreaLinkSaveCollection::ScAreaLinkSaveCollection( const ScAreaLinkSaveCollection& rCopy ) :
//STRIP001 	Collection( rCopy )
//STRIP001 {
//STRIP001 }

//STRIP001 ScAreaLinkSaveCollection::~ScAreaLinkSaveCollection()
//STRIP001 {
//STRIP001 }

//STRIP001 DataObject*	ScAreaLinkSaveCollection::Clone() const
//STRIP001 {
//STRIP001 	return new ScAreaLinkSaveCollection( *this );
//STRIP001 }

//STRIP001 BOOL ScAreaLinkSaveCollection::IsEqual( const ScDocument* pDoc ) const
//STRIP001 {
//STRIP001 	SvxLinkManager* pLinkManager = const_cast<ScDocument*>(pDoc)->GetLinkManager();
//STRIP001 	if (pLinkManager)
//STRIP001 	{
//STRIP001 		USHORT nPos = 0;
//STRIP001 		const ::so3::SvBaseLinks& rLinks = pLinkManager->GetLinks();
//STRIP001 		USHORT nLinkCount = rLinks.Count();
//STRIP001 		for (USHORT i=0; i<nLinkCount; i++)
//STRIP001 		{
//STRIP001 			::so3::SvBaseLink* pBase = *rLinks[i];
//STRIP001 			if (pBase->ISA(ScAreaLink))
//STRIP001 			{
//STRIP001 				if ( nPos >= GetCount() || !(*this)[nPos]->IsEqual( *(ScAreaLink*)pBase ) )
//STRIP001 					return FALSE;
//STRIP001 
//STRIP001 				++nPos;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }

//STRIP001 void ScAreaLinkSaveCollection::Restore( ScDocument* pDoc ) const
//STRIP001 {
//STRIP001 	BOOL bError = FALSE;
//STRIP001 	SvxLinkManager* pLinkManager = pDoc->GetLinkManager();
//STRIP001 	if (pLinkManager)
//STRIP001 	{
//STRIP001 		USHORT nPos = 0;
//STRIP001 		const ::so3::SvBaseLinks& rLinks = pLinkManager->GetLinks();
//STRIP001 		USHORT nLinkCount = rLinks.Count();
//STRIP001 		for (USHORT i=0; i<nLinkCount; i++)
//STRIP001 		{
//STRIP001 			::so3::SvBaseLink* pBase = *rLinks[i];
//STRIP001 			if (pBase->ISA(ScAreaLink))
//STRIP001 			{
//STRIP001 				ScAreaLink* pLink = (ScAreaLink*)pBase;
//STRIP001 				if ( nPos < GetCount() )
//STRIP001 				{
//STRIP001 					ScAreaLinkSaver* pSaver = (*this)[nPos];
//STRIP001 					if ( pSaver->IsEqualSource( *pLink ) )
//STRIP001 						pSaver->WriteToLink( *pLink );
//STRIP001 					else
//STRIP001 						bError = TRUE;
//STRIP001 				}
//STRIP001 				else
//STRIP001 					bError = TRUE;
//STRIP001 
//STRIP001 				++nPos;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	DBG_ASSERT( !bError, "ScAreaLinkSaveCollection: wrong links" );
//STRIP001 }

// static
//STRIP001 ScAreaLinkSaveCollection* ScAreaLinkSaveCollection::CreateFromDoc( const ScDocument* pDoc )
//STRIP001 {
//STRIP001 	ScAreaLinkSaveCollection* pColl = NULL;
//STRIP001 
//STRIP001 	SvxLinkManager* pLinkManager = const_cast<ScDocument*>(pDoc)->GetLinkManager();
//STRIP001 	if (pLinkManager)
//STRIP001 	{
//STRIP001 		const ::so3::SvBaseLinks& rLinks = pLinkManager->GetLinks();
//STRIP001 		USHORT nLinkCount = rLinks.Count();
//STRIP001 		for (USHORT i=0; i<nLinkCount; i++)
//STRIP001 		{
//STRIP001 			::so3::SvBaseLink* pBase = *rLinks[i];
//STRIP001 			if (pBase->ISA(ScAreaLink))
//STRIP001 			{
//STRIP001 				if (!pColl)
//STRIP001 					pColl = new ScAreaLinkSaveCollection;
//STRIP001 
//STRIP001 				ScAreaLinkSaver* pSaver = new ScAreaLinkSaver( *(ScAreaLink*)pBase );
//STRIP001 				if (!pColl->Insert(pSaver))
//STRIP001 					delete pSaver;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return pColl;
//STRIP001 }

}
