/*************************************************************************
 *
 *  $RCSfile: sc_notemark.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:31:29 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

// INCLUDE ---------------------------------------------------------------

// auto strip #include <bf_svx/svdoutl.hxx>
// auto strip #include <bf_svx/svdmodel.hxx>
// auto strip #include <bf_svx/svdobj.hxx>
// auto strip #include <bf_svx/xoutx.hxx>
// auto strip #include <bf_sfx2/printer.hxx>
// auto strip #include <svtools/pathoptions.hxx>
#include <svtools/itempool.hxx>
// auto strip #include <vcl/svapp.hxx>

// auto strip #include "notemark.hxx"
// auto strip #include "document.hxx"
// auto strip #include "detfunc.hxx"
namespace binfilter {

#define SC_NOTEMARK_TIME	800
#define SC_NOTEMARK_SHORT	70

// STATIC DATA -----------------------------------------------------------

// -----------------------------------------------------------------------

//STRIP001 ScNoteMarker::ScNoteMarker( Window* pWin, Window* pRight, Window* pBottom, Window* pDiagonal,
//STRIP001 							ScDocument* pD, ScAddress aPos, const String& rUser,
//STRIP001 							const MapMode& rMap, BOOL bLeftEdge, BOOL bForce, BOOL bKeyboard ) :
//STRIP001 	pWindow( pWin ),
//STRIP001 	pRightWin( pRight ),
//STRIP001 	pBottomWin( pBottom ),
//STRIP001 	pDiagWin( pDiagonal ),
//STRIP001 	pDoc( pD ),
//STRIP001 	aDocPos( aPos ),
//STRIP001 	aUserText( rUser ),
//STRIP001 	aMapMode( rMap ),
//STRIP001 	bLeft( bLeftEdge ),
//STRIP001 	bByKeyboard( bKeyboard ),
//STRIP001 	bVisible( FALSE ),
//STRIP001 	pModel( NULL ),
//STRIP001 	pObject( NULL )
//STRIP001 {
//STRIP001 	aTimer.SetTimeoutHdl( LINK( this, ScNoteMarker, TimeHdl ) );
//STRIP001 	aTimer.SetTimeout( bForce ? SC_NOTEMARK_SHORT : SC_NOTEMARK_TIME );
//STRIP001 	aTimer.Start();
//STRIP001 }

//STRIP001 ScNoteMarker::~ScNoteMarker()
//STRIP001 {
//STRIP001 	InvalidateWin();
//STRIP001 
//STRIP001 	delete pModel;
//STRIP001 }

//STRIP001 IMPL_LINK( ScNoteMarker, TimeHdl, Timer*, pTimer )
//STRIP001 {
//STRIP001 	if (!bVisible)
//STRIP001 	{
//STRIP001 		SvtPathOptions aPathOpt;
//STRIP001 		String aPath = aPathOpt.GetPalettePath();
//STRIP001 		pModel = new SdrModel(aPath);
//STRIP001 		pModel->SetScaleUnit(MAP_100TH_MM);
//STRIP001 		SfxItemPool& rPool = pModel->GetItemPool();
//STRIP001 		rPool.SetDefaultMetric(SFX_MAPUNIT_100TH_MM);
//STRIP001 		rPool.FreezeIdRanges();
//STRIP001 
//STRIP001 		Printer* pPrinter = pDoc->GetPrinter();
//STRIP001 		if (pPrinter)
//STRIP001 		{
//STRIP001 			//	Am Outliner des Draw-Model ist auch der Drucker als RefDevice gesetzt,
//STRIP001 			//	und es soll einheitlich aussehen.
//STRIP001 			Outliner& rOutliner = pModel->GetDrawOutliner();
//STRIP001 			rOutliner.SetRefDevice(pPrinter);
//STRIP001 		}
//STRIP001 
//STRIP001 		SdrPage* pPage = pModel->AllocPage(FALSE);
//STRIP001 
//STRIP001 		Size aSizePixel = pWindow->GetOutputSizePixel();
//STRIP001 		Rectangle aVisPixel( Point(0,0), aSizePixel );
//STRIP001 		Rectangle aVisible = pWindow->PixelToLogic( aVisPixel, aMapMode );
//STRIP001 
//STRIP001 		USHORT nCol = aDocPos.Col();
//STRIP001 		USHORT nRow = aDocPos.Row();
//STRIP001 		USHORT nTab = aDocPos.Tab();
//STRIP001 		pObject = ScDetectiveFunc( pDoc,nTab ).
//STRIP001 					ShowCommentUser( nCol, nRow, aUserText, aVisible, bLeft, FALSE, pPage );
//STRIP001 
//STRIP001 		if (pObject)
//STRIP001 			aRect = pObject->GetBoundRect();
//STRIP001 
//STRIP001 		// #39351# Page einfuegen damit das Model sie kennt und auch deleted
//STRIP001 		pModel->InsertPage( pPage );
//STRIP001 
//STRIP001 		bVisible = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	Draw();
//STRIP001 	return 0;
//STRIP001 }

//STRIP001 void lcl_DrawWin( SdrObject* pObject, Window* pWindow, const MapMode& rMap )
//STRIP001 {
//STRIP001 	MapMode aOld = pWindow->GetMapMode();
//STRIP001 	pWindow->SetMapMode( rMap );
//STRIP001 
//STRIP001 	ULONG nOldDrawMode = pWindow->GetDrawMode();
//STRIP001 	if ( Application::GetSettings().GetStyleSettings().GetHighContrastMode() )
//STRIP001 	{
//STRIP001 		pWindow->SetDrawMode( nOldDrawMode | DRAWMODE_SETTINGSLINE | DRAWMODE_SETTINGSFILL |
//STRIP001 							DRAWMODE_SETTINGSTEXT | DRAWMODE_SETTINGSGRADIENT );
//STRIP001 	}
//STRIP001 
//STRIP001 	ExtOutputDevice* pXOut = new ExtOutputDevice( pWindow );
//STRIP001 	pXOut->SetOutDev( pWindow );
//STRIP001 	SdrPaintInfoRec aInfoRec;
//STRIP001 	pObject->Paint( *pXOut, aInfoRec );
//STRIP001 	delete pXOut;
//STRIP001 
//STRIP001 	pWindow->SetDrawMode( nOldDrawMode );
//STRIP001 	pWindow->SetMapMode( aOld );
//STRIP001 }

//STRIP001 MapMode lcl_MoveMapMode( const MapMode& rMap, const Size& rMove )
//STRIP001 {
//STRIP001 	MapMode aNew = rMap;
//STRIP001 	Point aOrigin = aNew.GetOrigin();
//STRIP001 	aOrigin.X() -= rMove.Width();
//STRIP001 	aOrigin.Y() -= rMove.Height();
//STRIP001 	aNew.SetOrigin(aOrigin);
//STRIP001 	return aNew;
//STRIP001 }

//STRIP001 void ScNoteMarker::Draw()
//STRIP001 {
//STRIP001 	if ( pObject && bVisible )
//STRIP001 	{
//STRIP001 		lcl_DrawWin( pObject, pWindow, aMapMode );
//STRIP001 
//STRIP001 		if ( pRightWin || pBottomWin )
//STRIP001 		{
//STRIP001 			Size aWinSize = pWindow->PixelToLogic( pWindow->GetOutputSizePixel(), aMapMode );
//STRIP001 			if ( pRightWin )
//STRIP001 				lcl_DrawWin( pObject, pRightWin,
//STRIP001 								lcl_MoveMapMode( aMapMode, Size( aWinSize.Width(), 0 ) ) );
//STRIP001 			if ( pBottomWin )
//STRIP001 				lcl_DrawWin( pObject, pBottomWin,
//STRIP001 								lcl_MoveMapMode( aMapMode, Size( 0, aWinSize.Height() ) ) );
//STRIP001 			if ( pDiagWin )
//STRIP001 				lcl_DrawWin( pObject, pDiagWin, lcl_MoveMapMode( aMapMode, aWinSize ) );
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

//STRIP001 void ScNoteMarker::InvalidateWin()
//STRIP001 {
//STRIP001 	if (bVisible)
//STRIP001 	{
//STRIP001 		pWindow->Invalidate( pWindow->LogicToLogic(aRect, aMapMode, pWindow->GetMapMode()) );
//STRIP001 
//STRIP001 		if ( pRightWin || pBottomWin )
//STRIP001 		{
//STRIP001 			Size aWinSize = pWindow->PixelToLogic( pWindow->GetOutputSizePixel(), aMapMode );
//STRIP001 			if ( pRightWin )
//STRIP001 				pRightWin->Invalidate( pRightWin->LogicToLogic(aRect,
//STRIP001 										lcl_MoveMapMode( aMapMode, Size( aWinSize.Width(), 0 ) ),
//STRIP001 										pRightWin->GetMapMode()) );
//STRIP001 			if ( pBottomWin )
//STRIP001 				pBottomWin->Invalidate( pBottomWin->LogicToLogic(aRect,
//STRIP001 										lcl_MoveMapMode( aMapMode, Size( 0, aWinSize.Height() ) ),
//STRIP001 										pBottomWin->GetMapMode()) );
//STRIP001 			if ( pDiagWin )
//STRIP001 				pDiagWin->Invalidate( pDiagWin->LogicToLogic(aRect,
//STRIP001 										lcl_MoveMapMode( aMapMode, aWinSize ),
//STRIP001 										pDiagWin->GetMapMode()) );
//STRIP001 		}
//STRIP001 	}
//STRIP001 }




}
