/*************************************************************************
 *
 *  $RCSfile: sch_fu3d.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:55:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


// auto strip #ifndef _VIEWPT3D_HXX //autogen
// auto strip #include <bf_svx/viewpt3d.hxx>
// auto strip #endif


#pragma hdrstop
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif

#include <bf_svx/svxids.hrc>

// auto strip #include "viewshel.hxx"
// auto strip #include "schview.hxx"
// auto strip #include "chwindow.hxx"
#include "app.hrc"
// auto strip #include "schresid.hxx"
#include "strings.hrc"
// auto strip #ifndef _CHTMODEL_HXX
// auto strip #include "chtmodel.hxx"
// auto strip #endif
// auto strip #include "un3dview.hxx"
// auto strip #include "chtscene.hxx"
// auto strip #include <bf_svx/camera3d.hxx>
// auto strip #include "fu3d.hxx"
// auto strip #include "viewdlg.hxx"

// auto strip #ifndef _E3D_UNDO_HXX
// auto strip #include "bf_svx/e3dundo.hxx"
// auto strip #endif
namespace binfilter {

/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/
//STRIP001 #define RAD2DDEG(fAngle) ( (long)(((fAngle)*1800.0/F_PI)+3600.0)%3600 )
//STRIP001 #define DDEG2RAD(fAngle) (  (double)(fAngle)*F_PI/1800.0 )

//STRIP001 SchFu3D::SchFu3D(SchViewShell     *pViewSh,
//STRIP001 				 SchWindow        *pWin,
//STRIP001 				 SchView          *pView,
//STRIP001 				 ChartModel *pDoc,
//STRIP001 				 SfxRequest       &rReq)
//STRIP001 	: SchFuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	short nXOld, nYOld, nZOld;
//STRIP001 
//STRIP001 	pDoc->GetAngles (nXOld, nYOld, nZOld);
//STRIP001 
//STRIP001 
//STRIP001 	ChartScene* pScene = pDoc->GetScene();
//STRIP001 	Matrix4D aSceneMatrix = pScene->GetTransform();
//STRIP001 	Vector3D aVRot,aVTrans,aVShear,aVScale;
//STRIP001 	aSceneMatrix.Decompose(aVScale,aVTrans,aVRot,aVShear);
//STRIP001 	nXOld=RAD2DDEG(aVRot.X());
//STRIP001 	nYOld=RAD2DDEG(aVRot.Y());
//STRIP001 	nZOld=RAD2DDEG(aVRot.Z());
//STRIP001 
//STRIP001 
//STRIP001 //      FG: Mit dieser Zeile erhaelt man keinen modalen Dialog => Absturz falls ein Resize im Chart
//STRIP001 //      stattfindet waehrend dieser Dialog geoeffnet ist.
//STRIP001 //    SchView3DDlg* pDlg = new SchView3DDlg(&(pViewSh->GetViewFrame()->GetWindow()), nXOld, nYOld, nZOld);
//STRIP001 	SchView3DDlg* pDlg = new SchView3DDlg(NULL, nXOld, nYOld, nZOld);
//STRIP001 
//STRIP001 	//if (pDoc->ChartStyle() == CHSTYLE_3D_PIE)
//STRIP001 	if(!pDoc->IsReal3D())
//STRIP001 	{
//STRIP001 //        pDlg->SetMax(850, 3600, 900);
//STRIP001 		pDlg->SetMax(3600, 3600,3600);
//STRIP001 		pDlg->SetMin(0, 0, 0);
//STRIP001 		pDlg->DisableOnPie ();
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 //        pDlg->SetMax(900, 900, 900);
//STRIP001 		pDlg->SetMax(3600, 3600,3600);
//STRIP001 		pDlg->SetMin(0, 0, 0);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pDlg->Execute() == RET_OK)
//STRIP001 	{
//STRIP001 		if( pViewShell )
//STRIP001 			pViewShell->GetViewFrame()->GetDispatcher()->Execute(
//STRIP001 				SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON );
//STRIP001 
//STRIP001 		short nXAngle = pDlg->GetXAngle();
//STRIP001 		short nYAngle = pDlg->GetYAngle();
//STRIP001 		short nZAngle = pDlg->GetZAngle();
//STRIP001 		ChartScene* pScene = pDoc->GetScene();
//STRIP001 
//STRIP001 		if(pScene)
//STRIP001 		{
//STRIP001 			Matrix4D aOldTrans = pScene->GetTransform();
//STRIP001 			pScene->ResetTransform();
//STRIP001 			pScene->FitSnapRectToBoundVol();
//STRIP001 			pScene->SetRectsDirty();
//STRIP001 			E3dRotateUndoAction* pUndo = new E3dRotateUndoAction(
//STRIP001 				pDoc,
//STRIP001 				pScene,
//STRIP001 				aOldTrans,
//STRIP001 				pScene->GetTransform());
//STRIP001 			pViewSh->GetViewFrame()->GetObjectShell()->GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 		}
//STRIP001 
//STRIP001 		if (nXAngle != nXOld || nYAngle != nYOld || nZAngle != nZOld)
//STRIP001 		{
//STRIP001 			pDoc->SetAngles(nXAngle, nYAngle, nZAngle);
//STRIP001 
//STRIP001 			if(pDoc->IsReal3D())
//STRIP001 			{
//STRIP001 				Rectangle& rRect = pDoc->GetChartRect();
//STRIP001 				long	nW = rRect.GetWidth();
//STRIP001 				long	nH = rRect.GetHeight();
//STRIP001 
//STRIP001 				Camera3D aCam(pScene->GetCamera());
//STRIP001 				aCam.SetViewWindow(-nW/2, -nH/2, nW, nH);
//STRIP001 				aCam.Reset();
//STRIP001 				aCam.SetProjection(pDoc->GetProjection());
//STRIP001 				aCam.RotateAroundLookAt(DEG2RAD((double)nYAngle / (double)10),
//STRIP001 										DEG2RAD((double)nXAngle / (double)10));
//STRIP001 				aCam.SetBankAngle(DEG2RAD(-(double)nZAngle / (double)10));
//STRIP001 				pScene->SetCamera(aCam);
//STRIP001 /*				Matrix4D aMatrix;
//STRIP001 				aMatrix.RotateX(DDEG2RAD(nXAngle));
//STRIP001 				aMatrix.RotateY(DDEG2RAD(nYAngle));
//STRIP001 				aMatrix.RotateZ(DDEG2RAD(nZAngle));
//STRIP001 				pScene->SetTransform(aMatrix);*/
//STRIP001 			}
//STRIP001 
//STRIP001 			pDoc->SetChanged();
//STRIP001 
//STRIP001 			if(	!pDoc->IsReal3D()/*(pDoc->ChartStyle() == CHSTYLE_3D_PIE)*/ ||pDoc->ShowXAxisTitle() ||  pDoc->ShowYAxisTitle() || pDoc->ShowZAxisTitle())
//STRIP001 			{
//STRIP001 				pDoc->BuildChart(FALSE);
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				pWindow->Invalidate();
//STRIP001 			}
//STRIP001 
//STRIP001 			SchUndo3DView* pUndo = new SchUndo3DView(*pDoc, nXOld, nYOld, nZOld,
//STRIP001 													 nXAngle, nYAngle, nZAngle);
//STRIP001 			pUndo->SetComment(String(SchResId(STR_UNDO_3D_VIEW)));
//STRIP001 
//STRIP001 			pViewSh->GetViewFrame()->GetObjectShell()->GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	RemarkObject ();
//STRIP001 	delete pDlg;
//STRIP001 	rReq.Done();
//STRIP001 }

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

//STRIP001 SchFu3D::~SchFu3D()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchFu3D::Activate()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchFu3D::Deactivate()
//STRIP001 {
//STRIP001 }



}
