/*************************************************************************
 *
 *  $RCSfile: sch_fufloor.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 12:58:12 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif


// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif

#pragma hdrstop

#include <bf_svx/svxids.hrc>

#include "app.hrc"
// auto strip #include "schresid.hxx"
#include "strings.hrc"
// auto strip #include "viewshel.hxx"
// auto strip #include "schview.hxx"
// auto strip #include "chwindow.hxx"
// auto strip #ifndef _CHTMODEL_HXX
// auto strip #include "chtmodel.hxx"
// auto strip #endif
#include "attrib.hrc"
// auto strip #include "attrib.hxx"
// auto strip #include "unfloor.hxx"
// auto strip #include "fufloor.hxx"
namespace binfilter {

//STRIP001 TYPEINIT1(SchFuDiagramFloor, SchFuPoor);


/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

//STRIP001 SchFuDiagramFloor::SchFuDiagramFloor(SchViewShell* pViewSh, SchWindow* pWin,
//STRIP001 									 SchView* pView, ChartModel* pDoc,
//STRIP001 									 SfxRequest& rReq)
//STRIP001 	: SchFuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 
//STRIP001 	if (!pArgs)
//STRIP001 	{
//STRIP001 //      FG: Mit dieser Zeile erhaelt man keinen modalen Dialog => Absturz falls ein Resize im Chart
//STRIP001 //      stattfindet waehrend dieser Dialog geoeffnet ist.
//STRIP001 //		SchAttribTabDlg* pDlg =	new SchAttribTabDlg(&pViewSh->GetViewFrame()->GetWindow(),
//STRIP001 //							                    	ATTR_DIAGRAM_FLOOR,	&pDoc->GetDiagramFloorAttr(),
//STRIP001 //								                    pDoc->GetObjectShell(), pDoc, 0, pDoc->ChartStyle());
//STRIP001 		SchAttribTabDlg* pDlg =	new SchAttribTabDlg(NULL,
//STRIP001 													ATTR_DIAGRAM_FLOOR,	&pDoc->GetDiagramFloorAttr(),
//STRIP001 													pDoc->GetObjectShell(), pDoc, 0, pDoc->ChartStyle());
//STRIP001 
//STRIP001 		if (pDlg->Execute() == RET_OK)
//STRIP001 		{
//STRIP001 			rReq.Done(*pDlg->GetOutputItemSet());
//STRIP001 			pArgs = rReq.GetArgs();
//STRIP001 			delete pDlg;
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			delete pDlg;
//STRIP001 			return;
//STRIP001 		}
//STRIP001 
//STRIP001 		pChDoc->CanRebuild (TRUE);
//STRIP001 	}
//STRIP001 	else pChDoc->CanRebuild (FALSE);
//STRIP001 
//STRIP001 	pViewSh->GetViewFrame()->GetDispatcher()->Execute(SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON);
//STRIP001 
//STRIP001 	SfxItemSet aOldAttr ( pDoc->GetDiagramFloorAttr());
//STRIP001 
//STRIP001 	pDoc->ChangeDiagramFloorAttr(*pArgs, NULL);
//STRIP001 	SchUndoDiagramFloor* pUndo = new SchUndoDiagramFloor(*pDoc, aOldAttr, *pArgs);
//STRIP001 	pUndo->SetComment(String(SchResId(STR_UNDO_DIAGRAM_FLOOR)));
//STRIP001 	pViewSh->GetViewFrame()->GetObjectShell()->GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 	RemarkObject ();
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchFuDiagramFloor::Activate()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchFuDiagramFloor::Deactivate()
//STRIP001 {
//STRIP001 }



}
