/*************************************************************************
 *
 *  $RCSfile: sch_futext.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:33:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/



//#define SI_NOITEMS
//STRIP001 #define SI_NODRW
//STRIP001 #define _SI_NOSBXCONTROLS
//STRIP001 #define _SI_NOOTHERFORMS
//STRIP001 #define _SI_NOCONTROL
//STRIP001 #define _SI_NOSBXCONTROLS

//svdraw.hxx
//STRIP001 #define _SDR_NOITEMS
//STRIP001 #define _SDR_NOTOUCH
//STRIP001 #define _SDR_NOTRANSFORM
//STRIP001 #define _SDR_NOVIEWMARKER
//STRIP001 #define _SDR_NODRAGMETHODS
//STRIP001 #define _SDR_NOUNDO
//STRIP001 #define _SDR_NOXOUTDEV
//STRIP001 

//STRIP001 #pragma hdrstop

//STRIP001 #ifndef _SV_MSGBOX_HXX //autogen
//STRIP001 #include <vcl/msgbox.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #include <bf_svx/flstitem.hxx>
//STRIP001 
//STRIP001 #ifndef _CTRLTOOL_HXX //autogen
//STRIP001 #include <svtools/ctrltool.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFX_BINDINGS_HXX //autogen
//STRIP001 #include <bf_sfx2/bindings.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFXDISPATCH_HXX //autogen
//STRIP001 #include <bf_sfx2/dispatch.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFXVIEWFRM_HXX //autogen
//STRIP001 #include <bf_sfx2/viewfrm.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFX_PRINTER_HXX
//STRIP001 #include <bf_sfx2/printer.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SVDOUTL_HXX
//STRIP001 #include <bf_svx/svdoutl.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #include <bf_svx/svdetc.hxx>
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 #include "chwindow.hxx"
//STRIP001 #include "app.hrc"
//STRIP001 #include "strings.hrc"
//STRIP001 #include "schresid.hxx"
//STRIP001 #include "eetext.hxx"
//STRIP001 #include "unedtit.hxx"
//STRIP001 #include "uninstit.hxx"
//STRIP001 #include "futext.hxx"
//STRIP001 #include "viewshel.hxx"
//STRIP001 #include "schview.hxx"
//STRIP001 #include "objid.hxx"
//STRIP001 
//STRIP001 TYPEINIT1(SchFuText, SchFuDraw);


/*************************************************************************
|*
|* Basisklasse fuer Textfunktionen
|*
\************************************************************************/

//STRIP001 SchFuText::SchFuText(SchViewShell* pViewSh, SchWindow* pWin, SchView* pView,
//STRIP001 					 ChartModel* pDoc, SfxRequest& rReq) :
//STRIP001 	SchFuDraw(pViewSh, pWin, pView, pDoc, rReq),
//STRIP001 	pTextObj(NULL),
//STRIP001 	pOutlinerParaObject(NULL)
//STRIP001 {
//STRIP001 	StartEditMode();
//STRIP001 }

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

//STRIP001 SchFuText::~SchFuText()
//STRIP001 {
//STRIP001 	EndEditMode();
//STRIP001 }

/*************************************************************************
|*
|* Tastaturereignisse bearbeiten
|*
|* Wird ein KeyEvent bearbeitet, so ist der Return-Wert TRUE, andernfalls
|* FALSE.
|*
\************************************************************************/

//STRIP001 BOOL SchFuText::KeyInput(const KeyEvent& rKEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 
//STRIP001 	KeyCode nCode = rKEvt.GetKeyCode();
//STRIP001 	BOOL bShift = nCode.IsShift();
//STRIP001 
//STRIP001 	USHORT nKey = nCode.GetCode();
//STRIP001 	KeyCode aKeyCode (nKey, bShift, nCode.IsMod1(), nCode.IsMod2());
//STRIP001 	KeyEvent aKEvt(rKEvt.GetCharCode(), aKeyCode);
//STRIP001 
//STRIP001 	if (pView->KeyInput(aKEvt, pWindow))
//STRIP001 	{
//STRIP001 		bReturn = TRUE;
//STRIP001 
//STRIP001 		SfxBindings& rBindings = pViewShell->GetViewFrame()->GetBindings();
//STRIP001 
//STRIP001 		rBindings.Invalidate(SID_CUT);
//STRIP001 		rBindings.Invalidate(SID_COPY);
//STRIP001 	}
//STRIP001 	else if (rKEvt.GetKeyCode().GetCode() == KEY_ESCAPE &&
//STRIP001 			 EndEditMode())
//STRIP001 	{
//STRIP001 		ForcePointer();
//STRIP001 		pViewShell->GetViewFrame()->GetDispatcher()->Execute(
//STRIP001 			SID_TOOL_SELECT, SFX_CALLMODE_ASYNCHRON );
//STRIP001 		bReturn = TRUE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		bReturn = SchFuDraw::KeyInput(aKEvt);
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }

/*************************************************************************
|*
|* MouseButtonDown-event
|*
\************************************************************************/

//STRIP001 BOOL SchFuText::MouseButtonDown(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	bMBDown = TRUE;
//STRIP001 
//STRIP001 	BOOL bReturn = SchFuDraw::MouseButtonDown(rMEvt);
//STRIP001 
//STRIP001 	// Fuer PopupMenu (vorher DrawViewShell)
//STRIP001 	if ((rMEvt.GetButtons() == MOUSE_RIGHT) &&
//STRIP001 		 rMEvt.GetClicks() == 1 && pView->IsTextEdit())
//STRIP001 		return TRUE;
//STRIP001 
//STRIP001 	if (pView->MouseButtonDown(rMEvt, pWindow))
//STRIP001 		return TRUE;				   // Event von der SdrView ausgewertet
//STRIP001 
//STRIP001 	// clicked in outer region
//STRIP001 	EndEditMode();
//STRIP001 	pViewShell->GetViewFrame()->GetDispatcher()->Execute( SID_TOOL_SELECT, SFX_CALLMODE_ASYNCHRON );
//STRIP001 
//STRIP001 	ForcePointer(&rMEvt);
//STRIP001 
//STRIP001 	SfxBindings& rBindings = pViewShell->GetViewFrame()->GetBindings();
//STRIP001 
//STRIP001 	rBindings.Invalidate(SID_CUT);
//STRIP001 	rBindings.Invalidate(SID_COPY);
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }

/*************************************************************************
|*
|* MouseMove-event
|*
\************************************************************************/

//STRIP001 BOOL SchFuText::MouseMove(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = SchFuDraw::MouseMove(rMEvt);
//STRIP001 
//STRIP001 	if (pView->MouseMove(rMEvt, pWindow))
//STRIP001 		// Event von der SdrView ausgewertet
//STRIP001 		bReturn = TRUE;
//STRIP001 
//STRIP001 	ForcePointer(&rMEvt);
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }

/*************************************************************************
|*
|* MouseButtonUp-event
|*
\************************************************************************/

//STRIP001 BOOL SchFuText::MouseButtonUp(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	SfxBindings& rBindings = pViewShell->GetViewFrame()->GetBindings();
//STRIP001 
//STRIP001 	rBindings.Invalidate(SID_CUT);
//STRIP001 	rBindings.Invalidate(SID_COPY);
//STRIP001 
//STRIP001 	if (pView->MouseButtonUp(rMEvt, pWindow))
//STRIP001 		return TRUE; // Event von der SdrView ausgewertet
//STRIP001 
//STRIP001 	pWindow->ReleaseMouse();
//STRIP001 
//STRIP001 	if (rMEvt.GetClicks() == 2 && rMEvt.IsLeft() && bMBDown &&
//STRIP001 		!rMEvt.IsMod1() && !rMEvt.IsMod2() && !rMEvt.IsShift())
//STRIP001 		DoubleClick();
//STRIP001 
//STRIP001 	bMBDown = FALSE;
//STRIP001 
//STRIP001 	return SchFuDraw::MouseButtonUp(rMEvt);
//STRIP001 }

/*************************************************************************
|*
|* Command-event
|*
\************************************************************************/

//STRIP001 BOOL SchFuText::Command(const CommandEvent& rCEvt)
//STRIP001 {
//STRIP001 	return SchFuPoor::Command( rCEvt );
//STRIP001 }

/*************************************************************************
|*
|* Funktion aktivieren
|*
\************************************************************************/

//STRIP001 void SchFuText::Activate()
//STRIP001 {
//STRIP001 	OutlinerView* pOLV = pView->GetTextEditOutlinerView();
//STRIP001 
//STRIP001 	if (pOLV)
//STRIP001 		pOLV->ShowCursor();
//STRIP001 
//STRIP001 	SchFuDraw::Activate();
//STRIP001 }

/*************************************************************************
|*
|* Funktion deaktivieren
|*
\************************************************************************/

//STRIP001 void SchFuText::Deactivate()
//STRIP001 {
//STRIP001 	OutlinerView* pOLV = pView->GetTextEditOutlinerView();
//STRIP001 
//STRIP001 	if (pOLV)
//STRIP001 		pOLV->HideCursor();
//STRIP001 
//STRIP001 	EndEditMode ();
//STRIP001 
//STRIP001 	SchFuDraw::Deactivate();
//STRIP001 }

/*************************************************************************
|*
|* Maus-Pointer umschalten
|*
\************************************************************************/

//STRIP001 void SchFuText::ForcePointer(const MouseEvent* pMEvt)
//STRIP001 {
//STRIP001 	if (pView->IsTextEdit())
//STRIP001 	{
//STRIP001 		Point aPnt;
//STRIP001 
//STRIP001 		if (pMEvt)
//STRIP001 			aPnt = pWindow->PixelToLogic(pMEvt->GetPosPixel());
//STRIP001 		else
//STRIP001 			aPnt = pWindow->PixelToLogic(pWindow->GetPointerPosPixel());
//STRIP001 
//STRIP001 		if (pTextObj->GetBoundRect().IsInside(aPnt))
//STRIP001 		{
//STRIP001 			pWindow->SetPointer(pView->GetPreferedPointer(aPnt, pWindow));
//STRIP001 			return;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	pWindow->SetPointer(aOldPointer);
//STRIP001 }

/*************************************************************************
|*
|* Edit-Mode starten
|* Liefert TRUE, wenn der Editiermodus gestartet wurde
|*
\************************************************************************/

//STRIP001 BOOL SchFuText::StartEditMode()
//STRIP001 {
//STRIP001 	if (!pView->IsTextEdit())
//STRIP001 	{
//STRIP001 		pTextObj = NULL;
//STRIP001 
//STRIP001 		if (pView->HasMarkedObj())
//STRIP001 		{
//STRIP001 			const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 
//STRIP001 			if (rMarkList.GetMarkCount() == 1)
//STRIP001 			{
//STRIP001 				SdrMark* pMark = rMarkList.GetMark(0);
//STRIP001 				SdrObject* pObj = pMark->GetObj();
//STRIP001 
//STRIP001 				SchObjectId* pObjId = GetObjectId(*pObj);
//STRIP001 
//STRIP001 				if (pObjId)
//STRIP001 				{
//STRIP001 					USHORT nId = pObjId->GetObjId();
//STRIP001 
//STRIP001 					switch (nId)
//STRIP001 					{
//STRIP001 						case CHOBJID_TITLE_MAIN:
//STRIP001 						case CHOBJID_TITLE_SUB:
//STRIP001 						case CHOBJID_DIAGRAM_TITLE_X_AXIS:
//STRIP001 						case CHOBJID_DIAGRAM_TITLE_Y_AXIS:
//STRIP001 						case CHOBJID_DIAGRAM_TITLE_Z_AXIS:
//STRIP001 							if (pObj->HasTextEdit())
//STRIP001 							{
//STRIP001 								pTextObj = (SdrTextObj*)pObj;
//STRIP001 								pChDoc->PrepareEdit(*pTextObj);
//STRIP001 
//STRIP001 								aTextRect = pObj->GetLogicRect();
//STRIP001 
//STRIP001 								// neuen Outliner machen; gehoert der SdrObjEditView
//STRIP001 
//STRIP001 								SdrOutliner* pOutliner = SdrMakeOutliner( OUTLINERMODE_TEXTOBJECT, pChDoc );
//STRIP001 
//STRIP001 								pOutliner->SetRefDevice(
//STRIP001                                     static_cast< SchChartDocShell * >( pChDoc->GetObjectShell() )->GetRefDevice() );
//STRIP001 
//STRIP001 								pOutliner->SetStyleSheetPool((SfxStyleSheetPool*)
//STRIP001 												 pChDoc->GetStyleSheetPool());
//STRIP001 
//STRIP001 								if (pView->BegTextEdit
//STRIP001 										(pTextObj, pView->GetPageViewPvNum(0),
//STRIP001 										 pWindow, TRUE, pOutliner))//NULL
//STRIP001 									pView->SetEditMode();
//STRIP001 							}
//STRIP001 							break;
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		return TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }

/*************************************************************************
|*
|* Edit-Mode beenden
|* Liefert TRUE, wenn der Editiermodus beendet wurde
|*
\************************************************************************/

//STRIP001 BOOL SchFuText::EndEditMode()
//STRIP001 {
//STRIP001 	BOOL bReturn;
//STRIP001 
//STRIP001 	if (pView->IsTextEdit())
//STRIP001 	{
//STRIP001 		BOOL bAuto=pChDoc->SetAttrAutoStorage(FALSE);
//STRIP001 		pView->EndTextEdit();
//STRIP001 		pChDoc->SetAttrAutoStorage(bAuto);
//STRIP001 		bReturn = TRUE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		bReturn = FALSE;
//STRIP001 
//STRIP001 	if (pTextObj)
//STRIP001 	{
//STRIP001 		SdrOutliner* pOutliner = pChDoc->GetOutliner();
//STRIP001 
//STRIP001 		// the OutlinerParaObject may by NULL if an empty text has been entered
//STRIP001 		OutlinerParaObject* pParaObj = pTextObj->GetOutlinerParaObject();
//STRIP001 		if( pParaObj )
//STRIP001 			pOutliner->SetText( *pParaObj );
//STRIP001 
//STRIP001 		String aString =
//STRIP001 			pOutliner->GetText(pOutliner->GetParagraph( 0 ),
//STRIP001 							   pOutliner->GetParagraphCount());
//STRIP001 		pOutliner->Clear();
//STRIP001 
//STRIP001 		SchObjectId* pObjId = GetObjectId(*pTextObj);
//STRIP001 
//STRIP001 		if( pObjId )
//STRIP001 		{
//STRIP001 			USHORT nId = pObjId->GetObjId();
//STRIP001 
//STRIP001 			String aOldMain		= pChDoc->MainTitle();
//STRIP001 			String aOldSub		= pChDoc->SubTitle();
//STRIP001 			String aOldXAxis	= pChDoc->XAxisTitle();
//STRIP001 			String aOldYAxis	= pChDoc->YAxisTitle();
//STRIP001 			String aOldZAxis	= pChDoc->ZAxisTitle();
//STRIP001 
//STRIP001 			String aNewMain		= aOldMain;
//STRIP001 			String aNewSub		= aOldSub;
//STRIP001 			String aNewXAxis	= aOldXAxis;
//STRIP001 			String aNewYAxis	= aOldYAxis;
//STRIP001 			String aNewZAxis	= aOldZAxis;
//STRIP001 
//STRIP001 			BOOL bOldShowMain	= pChDoc->ShowMainTitle();
//STRIP001 			BOOL bOldShowSub 	= pChDoc->ShowSubTitle();
//STRIP001 			BOOL bOldShowXAxis	= pChDoc->ShowXAxisTitle();
//STRIP001 			BOOL bOldShowYAxis	= pChDoc->ShowYAxisTitle();
//STRIP001 			BOOL bOldShowZAxis	= pChDoc->ShowZAxisTitle();
//STRIP001 
//STRIP001 			BOOL bNewShowMain	= bOldShowMain;
//STRIP001 			BOOL bNewShowSub	= bOldShowSub;
//STRIP001 			BOOL bNewShowXAxis	= bOldShowXAxis;
//STRIP001 			BOOL bNewShowYAxis	= bOldShowYAxis;
//STRIP001 			BOOL bNewShowZAxis	= bOldShowZAxis;
//STRIP001 
//STRIP001 			BOOL bStringEmpty	= (aString.Len() == 0);
//STRIP001 
//STRIP001 			if( ! bStringEmpty )
//STRIP001 			{
//STRIP001                 // #102159# SetItemSet will result in setting the Title member
//STRIP001                 // of the ChartModel from the outliner content if auto-storage
//STRIP001                 // is true
//STRIP001                 BOOL bOldAutoStorage = pChDoc->SetAttrAutoStorage( FALSE );
//STRIP001 
//STRIP001                 BOOL bAutoGrowHeight = pTextObj->IsAutoGrowHeight();
//STRIP001 				SfxItemSet aAttr(pChDoc->GetPool(), SDRATTR_TEXT_AUTOGROWHEIGHT,
//STRIP001 								 SDRATTR_TEXT_AUTOGROWHEIGHT);
//STRIP001 				aAttr.Put(SdrTextAutoGrowHeightItem(FALSE));
//STRIP001                 pTextObj->SetItemSet(aAttr);
//STRIP001 
//STRIP001                 pTextObj->NbcSetLogicRect(aTextRect);
//STRIP001 				aAttr.Put(SdrTextAutoGrowHeightItem(bAutoGrowHeight));
//STRIP001                 pTextObj->SetItemSet(aAttr);
//STRIP001 
//STRIP001                 pChDoc->SetAttrAutoStorage( bOldAutoStorage );
//STRIP001 			}
//STRIP001 
//STRIP001 			switch( nId )
//STRIP001 			{
//STRIP001 				case CHOBJID_TITLE_MAIN:
//STRIP001 					if( bStringEmpty )
//STRIP001 						bNewShowMain = FALSE;
//STRIP001 					else
//STRIP001 						aNewMain = aString;
//STRIP001 					break;
//STRIP001 				case CHOBJID_TITLE_SUB:
//STRIP001 					if( bStringEmpty )
//STRIP001 						bNewShowSub = FALSE;
//STRIP001 					else
//STRIP001 						aNewSub = aString;
//STRIP001 					break;
//STRIP001 				case CHOBJID_DIAGRAM_TITLE_X_AXIS:
//STRIP001 					if( bStringEmpty )
//STRIP001 						bNewShowXAxis = FALSE;
//STRIP001 					else
//STRIP001 						aNewXAxis = aString;
//STRIP001 					break;
//STRIP001 				case CHOBJID_DIAGRAM_TITLE_Y_AXIS:
//STRIP001 					if( bStringEmpty )
//STRIP001 						bNewShowYAxis = FALSE;
//STRIP001 					else
//STRIP001 						aNewYAxis = aString;
//STRIP001 					break;
//STRIP001 				case CHOBJID_DIAGRAM_TITLE_Z_AXIS:
//STRIP001 					if( bStringEmpty )
//STRIP001 						bNewShowZAxis = FALSE;
//STRIP001 					else
//STRIP001 						aNewZAxis = aString;
//STRIP001 					break;
//STRIP001 			}
//STRIP001 
//STRIP001 			if( pChDoc->ChangeTitle( bNewShowMain,	aNewMain,
//STRIP001 									 bNewShowSub,	aNewSub,
//STRIP001 									 bNewShowXAxis,	aNewXAxis,
//STRIP001 									 bNewShowYAxis,	aNewYAxis,
//STRIP001 									 bNewShowZAxis,	aNewZAxis ))
//STRIP001 			{
//STRIP001 				SchUndoAction* pUndo;
//STRIP001 
//STRIP001 				if( bStringEmpty )
//STRIP001 				{
//STRIP001 					// give the old strings as new strings. This way when activating
//STRIP001 					// the title again the string last used is taken
//STRIP001 					pUndo = new SchUndoInsertTitle(
//STRIP001 						*pChDoc,
//STRIP001 						bOldShowMain,  aOldMain,	bOldShowSub,   aOldSub,
//STRIP001 						bOldShowXAxis, aOldXAxis,	bOldShowYAxis, aOldYAxis,
//STRIP001 						bOldShowZAxis, aOldZAxis,
//STRIP001 						bNewShowMain,  aOldMain,	bNewShowSub,   aOldSub,
//STRIP001 						bNewShowXAxis, aOldXAxis,	bNewShowYAxis, aOldYAxis,
//STRIP001 						bNewShowZAxis, aOldZAxis );
//STRIP001 
//STRIP001 					pUndo->SetComment( String( SchResId( STR_UNDO_INSERT_TITLE )));
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					pUndo = new SchUndoEditTitle(
//STRIP001 						*pChDoc,
//STRIP001 						aOldMain, aOldSub, aOldXAxis, aOldYAxis, aOldZAxis,
//STRIP001 						aNewMain, aNewSub, aNewXAxis, aNewYAxis, aNewZAxis );
//STRIP001 
//STRIP001 					pUndo->SetComment( String( SchResId( STR_UNDO_EDIT_TITLE )));
//STRIP001 				}
//STRIP001 
//STRIP001 				pViewShell->GetViewFrame()->GetObjectShell()->
//STRIP001 					GetUndoManager()->AddUndoAction( pUndo );
//STRIP001 			}
//STRIP001 			else
//STRIP001 				pChDoc->CommitEdit( *pTextObj );
//STRIP001 		}
//STRIP001 
//STRIP001 		pTextObj = NULL;
//STRIP001 
//STRIP001 		// die RequestHandler der benutzten Outliner zuruecksetzen auf den
//STRIP001 		// Handler am Dokument
//STRIP001 
//STRIP001 		pOutliner = pView->GetTextEditOutliner();
//STRIP001 		if (pOutliner)
//STRIP001 			pOutliner->SetStyleSheetPool
//STRIP001 				((SfxStyleSheetPool*)pChDoc->GetStyleSheetPool());
//STRIP001 	}
//STRIP001 
//STRIP001 	return bReturn;
//STRIP001 }



