/*************************************************************************
 *
 *  $RCSfile: sch_futitle.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:00:09 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SCHATTR_HXX
#include "schattr.hxx"
#endif
#define ITEMID_CHARTTEXTORIENT	SCHATTR_TEXT_ORIENT

#pragma hdrstop
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX //autogen
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif

#include <bf_svx/svxids.hrc>

// auto strip #include "chtmodel.hxx"
#include "attrib.hrc"
// auto strip #include "../inc/attrib.hxx"
#include "app.hrc"
// auto strip #include "schresid.hxx"
#include "strings.hrc"
// auto strip #include "viewshel.hxx"
// auto strip #include "schview.hxx"
// auto strip #include "chwindow.hxx"
// auto strip #ifndef _CHTMODEL_HXX
// auto strip #include "chtmodel.hxx"
// auto strip #endif
// auto strip #include "objid.hxx"
// auto strip #include "untitle.hxx"
// auto strip #include "futitle.hxx"

// auto strip #include <bf_svx/eeitem.hxx>

#ifndef _SVX_CHRTITEM_HXX //autogen
#define ITEMID_DOUBLE	        0
#define ITEMID_CHARTTEXTORDER   SCHATTR_TEXT_ORDER
#define ITEMID_CHARTDATADESCR	SCHATTR_DATADESCR_DESCR

#ifndef _SFXENUMITEM_HXX
#include <svtools/eitem.hxx>
#endif

// auto strip #include <bf_svx/chrtitem.hxx>
#endif
// auto strip #include "globfunc.hxx"
namespace binfilter {

//STRIP001 TYPEINIT1(SchFuTitle, SchFuPoor);


/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

//STRIP001 SchFuTitle::SchFuTitle(SchViewShell* pViewSh, SchWindow* pWin,
//STRIP001 					   SchView* pView, ChartModel* pDoc,
//STRIP001 					   SfxRequest& rReq, Point &rMDPos)
//STRIP001 	: SchFuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	aMDPos = rMDPos;
//STRIP001 
//STRIP001 	UINT16           nTitleId   = 0;
//STRIP001 	SdrTextObj       *pTitleObj = NULL;
//STRIP001 	const SfxItemSet *pArgs     = rReq.GetArgs();
//STRIP001 
//STRIP001 	SdrPage* pPage = pDoc->GetPage(0);
//STRIP001 
//STRIP001 	if (!pPage) return;
//STRIP001 	else
//STRIP001 	{
//STRIP001 		switch (rReq.GetSlot ())
//STRIP001 		{
//STRIP001 			case SID_DIAGRAM_TITLE_MAIN :
//STRIP001 				nTitleId  = CHOBJID_TITLE_MAIN;
//STRIP001 				pTitleObj = (SdrTextObj*) GetObjWithId(nTitleId, *pPage);
//STRIP001 				break;
//STRIP001 
//STRIP001 			case SID_DIAGRAM_TITLE_SUB :
//STRIP001 				nTitleId  = CHOBJID_TITLE_SUB;
//STRIP001 				pTitleObj = (SdrTextObj*) GetObjWithId(nTitleId, *pPage);
//STRIP001 				break;
//STRIP001 
//STRIP001 			case SID_DIAGRAM_TITLE_X :
//STRIP001 				nTitleId  = CHOBJID_DIAGRAM_TITLE_X_AXIS;                //TVMNEW: DEEP is unoetig
//STRIP001 				pTitleObj = (SdrTextObj*) GetObjWithId(nTitleId, *pPage);//, 0, IM_DEEPWITHGROUPS);
//STRIP001 				break;
//STRIP001 
//STRIP001 			case SID_DIAGRAM_TITLE_Y :
//STRIP001 				nTitleId  = CHOBJID_DIAGRAM_TITLE_Y_AXIS;
//STRIP001 				pTitleObj = (SdrTextObj*) GetObjWithId(nTitleId, *pPage);//, 0, IM_DEEPWITHGROUPS);
//STRIP001 				break;
//STRIP001 
//STRIP001 			case SID_DIAGRAM_TITLE_Z :
//STRIP001 				nTitleId  = CHOBJID_DIAGRAM_TITLE_Z_AXIS;
//STRIP001 				pTitleObj = (SdrTextObj*) GetObjWithId(nTitleId, *pPage);//, 0, IM_DEEPWITHGROUPS);
//STRIP001 				break;
//STRIP001 
//STRIP001 			default :
//STRIP001 				;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	if( !pArgs )
//STRIP001 	{
//STRIP001 		SfxItemSet      aAttr = pDoc->GetFullTitleAttr(pTitleObj);
//STRIP001 		
//STRIP001 		//	If the text orientation is set to automatic, then calculate the
//STRIP001 		//	corresponding rotation angle.
//STRIP001 		SvxChartTextOrient eOrientation = ((const SvxChartTextOrientItem&)aAttr.Get(
//STRIP001 			SCHATTR_TEXT_ORIENT)).GetValue();
//STRIP001 		if (eOrientation == CHTXTORIENT_AUTOMATIC)
//STRIP001 		{
//STRIP001 			switch (nTitleId)
//STRIP001 			{
//STRIP001 				case	CHOBJID_DIAGRAM_TITLE_X_AXIS:
//STRIP001 					if (pDoc->IsXVertikal())
//STRIP001 						eOrientation = CHTXTORIENT_BOTTOMTOP;
//STRIP001 					else
//STRIP001 						eOrientation = CHTXTORIENT_STANDARD;
//STRIP001 					break;
//STRIP001 					
//STRIP001 				case	CHOBJID_DIAGRAM_TITLE_Y_AXIS:
//STRIP001 					if (pDoc->IsXVertikal())
//STRIP001 						eOrientation = CHTXTORIENT_STANDARD;
//STRIP001 					else
//STRIP001 						eOrientation = CHTXTORIENT_BOTTOMTOP;
//STRIP001 					break;
//STRIP001 					
//STRIP001 				default:
//STRIP001 					eOrientation = CHTXTORIENT_STANDARD;
//STRIP001 					break;
//STRIP001 			}
//STRIP001 			long nAngle = GetTextRotation (aAttr, eOrientation);
//STRIP001 			aAttr.Put (SfxInt32Item (SCHATTR_TEXT_DEGREES, nAngle));
//STRIP001 		}
//STRIP001 
//STRIP001 //      FG: Mit dieser Zeile erhaelt man keinen modalen Dialog => Absturz falls ein Resize im Chart
//STRIP001 //      stattfindet waehrend dieser Dialog geoeffnet ist.
//STRIP001 //        SchAttribTabDlg *pDlg =	new SchAttribTabDlg(&pViewSh->GetViewFrame()->GetWindow(), ATTR_TITLE,
//STRIP001 //                                                    &aAttr,	pDoc->GetObjectShell(), pDoc, nTitleId,
//STRIP001 //                                                    pDoc->ChartStyle());
//STRIP001 		SchAttribTabDlg *pDlg =	new SchAttribTabDlg(NULL, ATTR_TITLE,
//STRIP001 													&aAttr,	pDoc->GetObjectShell(), pDoc, nTitleId,
//STRIP001 													pDoc->ChartStyle());
//STRIP001 
//STRIP001 		if( pDlg->Execute() == RET_OK )
//STRIP001 		{
//STRIP001 			rReq.Done(*pDlg->GetOutputItemSet());
//STRIP001 			pArgs = rReq.GetArgs();
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			delete pDlg;
//STRIP001 			return;
//STRIP001 		}
//STRIP001 		delete pDlg;
//STRIP001 		eOrientation = ((const SvxChartTextOrientItem&)aAttr.Get(
//STRIP001 			SCHATTR_TEXT_ORIENT)).GetValue();
//STRIP001 
//STRIP001 		pChDoc->CanRebuild (TRUE);
//STRIP001 
//STRIP001 	}
//STRIP001 	else pChDoc->CanRebuild (FALSE);
//STRIP001 
//STRIP001 	SfxItemSet aOldAttr			= pDoc->GetTitleAttr(pTitleObj);
//STRIP001 	SfxItemSet aOldMainAttr		= pDoc->GetMainTitleAttr();
//STRIP001 	SfxItemSet aOldSubAttr		= pDoc->GetSubTitleAttr();
//STRIP001 	SfxItemSet aOldXAxisAttr	= pDoc->GetXAxisTitleAttr();
//STRIP001 	SfxItemSet aOldYAxisAttr	= pDoc->GetYAxisTitleAttr();
//STRIP001 	SfxItemSet aOldZAxisAttr	= pDoc->GetZAxisTitleAttr();
//STRIP001 
//STRIP001 	pViewSh->GetViewFrame()->GetDispatcher()->Execute(
//STRIP001 		SID_TOOL_SELECT, SFX_CALLMODE_SYNCHRON );
//STRIP001 	// pTitleObj wuerde danach auf eine Leiche zeigen, da ueber Execute
//STRIP001 	// ein ::BuildChart aufgerufen wird, in welchem die Textobjekte vernichtet
//STRIP001 	// werden -> also neuholen.
//STRIP001 
//STRIP001 	switch (rReq.GetSlot ())
//STRIP001 	{
//STRIP001 		case SID_DIAGRAM_TITLE_MAIN :
//STRIP001 			pTitleObj = (SdrTextObj*) GetObjWithId(CHOBJID_TITLE_MAIN, *pPage);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_DIAGRAM_TITLE_SUB :
//STRIP001 			pTitleObj = (SdrTextObj*) GetObjWithId(CHOBJID_TITLE_SUB, *pPage);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_DIAGRAM_TITLE_X :
//STRIP001 			pTitleObj = (SdrTextObj*) GetObjWithId(CHOBJID_DIAGRAM_TITLE_X_AXIS, *pPage);//, 0, IM_DEEPWITHGROUPS);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_DIAGRAM_TITLE_Y :
//STRIP001 			pTitleObj = (SdrTextObj*) GetObjWithId(CHOBJID_DIAGRAM_TITLE_Y_AXIS, *pPage);//, 0, IM_DEEPWITHGROUPS);
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_DIAGRAM_TITLE_Z :
//STRIP001 			pTitleObj = (SdrTextObj*) GetObjWithId(CHOBJID_DIAGRAM_TITLE_Z_AXIS, *pPage);//, 0, IM_DEEPWITHGROUPS);
//STRIP001 			break;
//STRIP001 
//STRIP001 		default :
//STRIP001 			pTitleObj = 0;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pDoc->ChangeTitleAttr(*pArgs, pTitleObj))
//STRIP001 	{
//STRIP001 		SchUndoTitle* pUndo = new SchUndoTitle(*pDoc, nTitleId, aOldMainAttr, aOldSubAttr,
//STRIP001 											   aOldXAxisAttr, aOldYAxisAttr, aOldZAxisAttr,
//STRIP001 											   aOldAttr, *pArgs);
//STRIP001 		pUndo->SetComment(String(SchResId(STR_UNDO_TITLE)));
//STRIP001 
//STRIP001 		pViewSh->GetViewFrame()->GetObjectShell()->GetUndoManager()->AddUndoAction(pUndo);
//STRIP001 	}
//STRIP001 
//STRIP001 	RemarkObject ();
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchFuTitle::Activate()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchFuTitle::Deactivate()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchFuTitle::RemarkObject()
//STRIP001 {
//STRIP001 	if (nMarkedID)
//STRIP001 	{
//STRIP001 		/*if (pChDoc->Is3DChart ()) aehnlich zu #48352#
//STRIP001 		{
//STRIP001 			((SchViewShell *) pViewShell)->SetRepaintPossible (FALSE);
//STRIP001 			pView->InitRedraw (pWindow, Region (Rectangle (pWindow->GetViewOrigin (),
//STRIP001 														   pWindow->GetViewSize ())));
//STRIP001 		}*/
//STRIP001 
//STRIP001 		SdrPage *pPage = pChDoc->GetPage(0);
//STRIP001 
//STRIP001 		if (pPage)
//STRIP001 		{
//STRIP001 			SdrObject *pObj = GetObjWithId (nMarkedID, *pPage, 0, IM_DEEPWITHGROUPS);
//STRIP001 
//STRIP001 			if (pObj)
//STRIP001 			{
//STRIP001 				SdrPageView* pPV = pView->GetPageViewPvNum (0);
//STRIP001 
//STRIP001 				pView->UnmarkAll ();
//STRIP001 				pView->LeaveAllGroup ();
//STRIP001 				pView->SetMarkHdlHidden(TRUE);
//STRIP001 				pView->PickObj (aMDPos, 50, pObj, pPV);
//STRIP001 				pView->MarkObj (pObj, pPV);
//STRIP001 
//STRIP001 				// TVMNEW: TITEL: hier hat sichs mitterweile ausge-entered,
//STRIP001 				// Titelobjekte sind ALLE gleichwertig!
//STRIP001 				/*
//STRIP001 				if ((nMarkedID == CHOBJID_DIAGRAM_TITLE_X_AXIS) ||
//STRIP001 					(nMarkedID == CHOBJID_DIAGRAM_TITLE_Y_AXIS) ||
//STRIP001 					(nMarkedID == CHOBJID_DIAGRAM_TITLE_Z_AXIS))
//STRIP001 				{
//STRIP001 					pView->EnterMarkedGroup();
//STRIP001 					pView->PickObj (aMDPos, 50, pObj, pPV);
//STRIP001 					pView->MarkObj (pObj, pPV);
//STRIP001 					pView->MarkLogicalGroup();
//STRIP001 				}
//STRIP001 				*/
//STRIP001 
//STRIP001 				pView->SetMarkHdlHidden(FALSE);
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }



}
