/*************************************************************************
 *
 *  $RCSfile: sd_sdpreslt.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:41:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

// auto strip #ifndef _SFXITEMSET_HXX //autogen
// auto strip #include <svtools/itemset.hxx>
// auto strip #endif
// auto strip #ifndef _SFXNEW_HXX //autogen
// auto strip #include <bf_sfx2/new.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif

#include "strings.hrc"
#include "res_bmp.hrc"
// auto strip #include "sdpreslt.hxx"
#include "sdpreslt.hrc"
// auto strip #include "sdattr.hxx"
// auto strip #include "sdresid.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "sdpage.hxx"
// auto strip #include "docshell.hxx"
// auto strip #include "viewshel.hxx"
namespace binfilter {

#define DOCUMENT_TOKEN (sal_Unicode('#'))

/*************************************************************************
|*
|* Konstruktor
|*
\************************************************************************/

//STRIP001 SdPresLayoutDlg::SdPresLayoutDlg( SdDrawDocShell* pDocShell, SdViewShell* pViewShell, Window* pWindow, const SfxItemSet& rInAttrs ):
//STRIP001 				ModalDialog         (pWindow, SdResId(DLG_PRESLT)),
//STRIP001 				pDocSh              ( pDocShell ),
//STRIP001 				pViewSh             ( pViewShell ),
//STRIP001 				aFtLayout           (this, SdResId(FT_LAYOUT)),
//STRIP001 				aVS                 (this, SdResId(VS_LAYOUT)),
//STRIP001 				aBtnOK              (this, SdResId(BTN_OK)),
//STRIP001 				aBtnCancel          (this, SdResId(BTN_CANCEL)),
//STRIP001 				aBtnHelp            (this, SdResId(BTN_HELP)),
//STRIP001 				aBtnLoad            (this, SdResId(BTN_LOAD)),
//STRIP001 				aCbxMasterPage		(this, SdResId(CBX_MASTER_PAGE)),
//STRIP001 				aCbxCheckMasters	(this, SdResId(CBX_CHECK_MASTERS)),
//STRIP001 				rOutAttrs           (rInAttrs),
//STRIP001 				aStrNone			( SdResId( STR_NULL ) )
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	pLayoutNames = new List;
//STRIP001 
//STRIP001 	aVS.SetDoubleClickHdl(LINK(this, SdPresLayoutDlg, ClickLayoutHdl));
//STRIP001 	aBtnLoad.SetClickHdl(LINK(this, SdPresLayoutDlg, ClickLoadHdl));
//STRIP001 
//STRIP001 	Reset();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	Dtor
//STRIP001 |*
//STRIP001 *************************************************************************/
//STRIP001 
//STRIP001 SdPresLayoutDlg::~SdPresLayoutDlg()
//STRIP001 {
//STRIP001 	String* pName = (String*)pLayoutNames->First();
//STRIP001 	while (pName)
//STRIP001 	{
//STRIP001 		delete pName;
//STRIP001 		pName = (String*)pLayoutNames->Next();
//STRIP001 	}
//STRIP001 
//STRIP001 	delete pLayoutNames;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	  Initialisierung
//STRIP001 |*
//STRIP001 *************************************************************************/
//STRIP001 
//STRIP001 void SdPresLayoutDlg::Reset()
//STRIP001 {
//STRIP001 	const SfxPoolItem *pPoolItem = NULL;
//STRIP001 
//STRIP001 	// MasterPage austauschen
//STRIP001 	if( rOutAttrs.GetItemState( ATTR_PRESLAYOUT_MASTER_PAGE, FALSE, &pPoolItem ) == SFX_ITEM_SET )
//STRIP001 	{
//STRIP001 		BOOL bMasterPage = ( (const SfxBoolItem*) pPoolItem)->GetValue();
//STRIP001 		aCbxMasterPage.Enable( !bMasterPage );
//STRIP001 		aCbxMasterPage.Check( bMasterPage );
//STRIP001 	}
//STRIP001 
//STRIP001 	// Nicht verwendete MasterPages entfernen
//STRIP001 	aCbxCheckMasters.Check(FALSE);
//STRIP001 
//STRIP001 	if(rOutAttrs.GetItemState(ATTR_PRESLAYOUT_NAME, TRUE, &pPoolItem) == SFX_ITEM_SET)
//STRIP001 		aName = ((const SfxStringItem*)pPoolItem)->GetValue();
//STRIP001 	else
//STRIP001 		aName.Erase();
//STRIP001 
//STRIP001 	FillValueSet();
//STRIP001 
//STRIP001 	nLayoutCount = pLayoutNames->Count();
//STRIP001 	for( long nName = 0; nName < nLayoutCount; nName++ )
//STRIP001 	{
//STRIP001 		if (*((String*)pLayoutNames->GetObject(nName)) == aName)
//STRIP001 			break;
//STRIP001 	}
//STRIP001 	DBG_ASSERT(nName < nLayoutCount, "Layout nicht gefunden")
//STRIP001 
//STRIP001 	aVS.SelectItem((USHORT)nName + 1);  // Inizes des ValueSets beginnen bei 1
//STRIP001 
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |*	  Fuellt uebergebenen Item-Set mit Dialogbox-Attributen
//STRIP001 |*
//STRIP001 *************************************************************************/
//STRIP001 
//STRIP001 void SdPresLayoutDlg::GetAttr(SfxItemSet& rOutAttrs)
//STRIP001 {
//STRIP001 	short nId = aVS.GetSelectItemId();
//STRIP001 	BOOL bLoad = nId > nLayoutCount;
//STRIP001 	rOutAttrs.Put( SfxBoolItem( ATTR_PRESLAYOUT_LOAD, bLoad ) );
//STRIP001 
//STRIP001 	String aLayoutName;
//STRIP001 
//STRIP001 	if( bLoad )
//STRIP001 	{
//STRIP001 		aLayoutName = aName;
//STRIP001 		aLayoutName.Append( DOCUMENT_TOKEN );
//STRIP001 		aLayoutName.Append( *(String*)pLayoutNames->GetObject( nId - 1 ) );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aLayoutName = *(String*)pLayoutNames->GetObject( nId - 1 );
//STRIP001 		if( aLayoutName == aStrNone )
//STRIP001 			aLayoutName.Erase(); //  so wird "- keine -" codiert (s.u.)
//STRIP001 	}
//STRIP001 
//STRIP001 	rOutAttrs.Put( SfxStringItem( ATTR_PRESLAYOUT_NAME, aLayoutName ) );
//STRIP001 	rOutAttrs.Put( SfxBoolItem( ATTR_PRESLAYOUT_MASTER_PAGE, aCbxMasterPage.IsChecked() ) );
//STRIP001 	rOutAttrs.Put( SfxBoolItem( ATTR_PRESLAYOUT_CHECK_MASTERS, aCbxCheckMasters.IsChecked() ) );
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Fuellt das ValueSet mit Bitmaps
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdPresLayoutDlg::FillValueSet()
//STRIP001 {
//STRIP001 	aVS.SetStyle(aVS.GetStyle() | WB_ITEMBORDER | WB_DOUBLEBORDER
//STRIP001 									  | WB_VSCROLL | WB_NAMEFIELD);
//STRIP001 
//STRIP001 	aVS.SetColCount(2);
//STRIP001 	aVS.SetLineCount(2);
//STRIP001 	aVS.SetExtraSpacing(2);
//STRIP001 
//STRIP001 	SdView* pView = pViewSh->GetView();
//STRIP001 	SdDrawDocument* pDoc = pDocSh->GetDoc();
//STRIP001 
//STRIP001 	USHORT nCount = pDoc->GetMasterPageCount();
//STRIP001 
//STRIP001 	for (USHORT nLayout = 0; nLayout < nCount; nLayout++)
//STRIP001 	{
//STRIP001 		SdPage* pMaster = (SdPage*)pDoc->GetMasterPage(nLayout);
//STRIP001 		if (pMaster->GetPageKind() == PK_STANDARD)
//STRIP001 		{
//STRIP001 			String aLayoutName(pMaster->GetLayoutName());
//STRIP001 			aLayoutName.Erase( aLayoutName.SearchAscii( SD_LT_SEPARATOR ) );
//STRIP001 			pLayoutNames->Insert(new String(aLayoutName), LIST_APPEND);
//STRIP001 
//STRIP001 			Bitmap aBitmap(pDocSh->GetPagePreviewBitmap(pMaster, 90));
//STRIP001 			aVS.InsertItem((USHORT)pLayoutNames->Count(), aBitmap, aLayoutName);
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	aVS.Show();
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Doppelklick-Handler
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK(SdPresLayoutDlg, ClickLayoutHdl, void *, p)
//STRIP001 {
//STRIP001 	EndDialog(RET_OK);
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Klick-Handler fuer Laden-Button
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 IMPL_LINK(SdPresLayoutDlg, ClickLoadHdl, void *, p)
//STRIP001 {
//STRIP001 	SfxNewFileDialog* pDlg = new SfxNewFileDialog(this, SFXWB_PREVIEW);
//STRIP001 	pDlg->SetText(String(SdResId(STR_LOAD_PRESENTATION_LAYOUT)));
//STRIP001 
//STRIP001 	if(!IsReallyVisible())
//STRIP001 	{
//STRIP001 		delete pDlg;
//STRIP001 		return 0;
//STRIP001 	}
//STRIP001 
//STRIP001 	USHORT nResult = pDlg->Execute();
//STRIP001 	// #96072# OJ: Inserted update to force repaint
//STRIP001 	Update();
//STRIP001 
//STRIP001 	String aFile;
//STRIP001 	BOOL   bCancel = FALSE;
//STRIP001 
//STRIP001 	switch (nResult)
//STRIP001 	{
//STRIP001 		case RET_OK:
//STRIP001 		{
//STRIP001 			if (pDlg->IsTemplate())
//STRIP001 			{
//STRIP001 				aName = pDlg->GetTemplateFileName();
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				// so wird "- keine -" codiert
//STRIP001 				aName.Erase();
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		default:
//STRIP001 			bCancel = TRUE;
//STRIP001 	}
//STRIP001 	delete pDlg;
//STRIP001 
//STRIP001 //    if (!bCancel)
//STRIP001 //        EndDialog(RET_OK);
//STRIP001 
//STRIP001 	if( !bCancel )
//STRIP001 	{
//STRIP001 		// Pruefen, ob Vorlage schon vorhanden
//STRIP001 		BOOL bExists = FALSE;
//STRIP001 		String* pName = (String*)pLayoutNames->First();
//STRIP001 		String aCompareStr( aName );
//STRIP001 		if( aName.Len() == 0 )
//STRIP001 			aCompareStr = aStrNone;
//STRIP001 
//STRIP001 		while( pName && !bExists )
//STRIP001 		{
//STRIP001 			if( aCompareStr == *pName )
//STRIP001 			{
//STRIP001 				bExists = TRUE;
//STRIP001 				// Vorlage selektieren
//STRIP001 				USHORT nId = (USHORT) pLayoutNames->GetCurPos() + 1;
//STRIP001 				aVS.SelectItem( nId );
//STRIP001 			}
//STRIP001 			pName = (String*)pLayoutNames->Next();
//STRIP001 		}
//STRIP001 
//STRIP001 		if( !bExists )
//STRIP001 		{
//STRIP001 			// Dokument laden um Preview-Bitmap zu ermitteln (wenn Vorlage ausgewaehlt)
//STRIP001 			if( aName.Len() )
//STRIP001 			{
//STRIP001 				// Dokument ermitteln, um OpenBookmarkDoc rufen zu koennen
//STRIP001 				SdDrawDocument* pDoc = pDocSh->GetDoc();
//STRIP001 				SdDrawDocument* pTemplDoc  = pDoc->OpenBookmarkDoc( aName );
//STRIP001 
//STRIP001 				if (pTemplDoc)
//STRIP001 				{
//STRIP001 					SdDrawDocShell*  pTemplDocSh= pTemplDoc->GetDocSh();
//STRIP001 
//STRIP001 /*					SdPage* pMaster = pTemplDoc->GetMasterSdPage( 0, PK_STANDARD );
//STRIP001 					pLayoutNames->Insert( new String( aName ), LIST_APPEND );
//STRIP001 
//STRIP001 					Bitmap aBitmap( pTemplDocSh->GetPagePreviewBitmap( pMaster, 90 ) );
//STRIP001 					aVS.InsertItem( (USHORT) pLayoutNames->Count(), aBitmap, aName);
//STRIP001 */
//STRIP001 					USHORT nCount = pTemplDoc->GetMasterPageCount();
//STRIP001 
//STRIP001 					for (USHORT nLayout = 0; nLayout < nCount; nLayout++)
//STRIP001 					{
//STRIP001 						SdPage* pMaster = (SdPage*) pTemplDoc->GetMasterPage(nLayout);
//STRIP001 						if (pMaster->GetPageKind() == PK_STANDARD)
//STRIP001 						{
//STRIP001 							String aLayoutName(pMaster->GetLayoutName());
//STRIP001 							aLayoutName.Erase( aLayoutName.SearchAscii( SD_LT_SEPARATOR ) );
//STRIP001 							pLayoutNames->Insert(new String(aLayoutName), LIST_APPEND);
//STRIP001 
//STRIP001 							Bitmap aBitmap(pTemplDocSh->GetPagePreviewBitmap(pMaster, 90));
//STRIP001 							aVS.InsertItem((USHORT)pLayoutNames->Count(), aBitmap, aLayoutName);
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					bCancel = TRUE;
//STRIP001 				}
//STRIP001 
//STRIP001 				pDoc->CloseBookmarkDoc();
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				// leeres Layout
//STRIP001 				pLayoutNames->Insert( new String( aStrNone ), LIST_APPEND );
//STRIP001 				aVS.InsertItem( (USHORT) pLayoutNames->Count(),
//STRIP001 						Bitmap( SdResId( BMP_FOIL_NONE ) ), aStrNone );
//STRIP001 			}
//STRIP001 
//STRIP001 			if (!bCancel)
//STRIP001 			{
//STRIP001 				// Vorlage selektieren
//STRIP001 				aVS.SelectItem( (USHORT) pLayoutNames->Count() );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return( 0 );
//STRIP001 }




}
