#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.3 $
#
#   last change: $Author: aw $ $Date: 2003/11/18 19:23:07 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..$/..$/..$/..
BFPRJ=..$/..$/..

PROJECTPCH=sd
PROJECTPCHSOURCE=$(BFPRJ)$/util\sd_sd

PRJNAME=binfilter
TARGET=sd_func

#GEN_HID=TRUE
#GEN_HID_OTHER=TRUE
NO_HIDS=TRUE

AUTOSEG=true

# --- Settings -----------------------------------------------------

#.INCLUDE :  sdpre.mk
.INCLUDE :  settings.mk
#.INCLUDE :  sd.mk
.INCLUDE :  sv.mk
.INCLUDE :  $(BFPRJ)$/util$/makefile.pmk
INC+= -I$(PRJ)$/inc$/bf_sd
# --- Files --------------------------------------------------------

CXXFILES = $(BFPRJ)$/util$/sd_sd.cxx \
		sd_undolayer.cxx	\
		sd_fupoor.cxx		\
		sd_fudraw.cxx		\
		sd_fusel.cxx		\
		sd_fuconstr.cxx	\
		sd_fuconrec.cxx	\
		sd_fuconuno.cxx	\
		sd_fuconbez.cxx	\
		sd_fuediglu.cxx	\
		sd_fuzoom.cxx		\
		sd_fuslid.cxx		\
		sd_fuslsel.cxx 	\
		sd_fuslshow.cxx	\
		sd_fuslshw2.cxx	\
		sd_fuslshw3.cxx	\
		sd_fuslshw4.cxx	\
		sd_fuslshw5.cxx	\
		sd_fuslshw6.cxx	\
		sd_fusldlg.cxx		\
		sd_fader.cxx		\
		sd_fader2.cxx		\
		sd_mover.cxx		\
		sd_fuslprms.cxx	\
		sd_fuscale.cxx 	\
		sd_fuslhide.cxx	\
		sd_futransf.cxx	\
		sd_futext.cxx		\
		sd_futext2.cxx		\
		sd_fuline.cxx		\
		sd_sdundo.cxx		\
		sd_sdundogr.cxx	\
		sd_unslprms.cxx	\
		sd_fuoaprms.cxx	\
		sd_unoaprms.cxx	\
		sd_fuarea.cxx		\
		sd_fuchar.cxx		\
		sd_fuconarc.cxx	\
		sd_fuparagr.cxx	\
		sd_fubullet.cxx	\
		sd_futempl.cxx 	\
		sd_fuoutl.cxx		\
		sd_fuoltext.cxx	\
		sd_fuinsert.cxx	\
		sd_fupage.cxx		\
		sd_undopage.cxx	\
		sd_fuprlout.cxx	\
		sd_fuprobjs.cxx	\
		sd_fulinend.cxx	\
		sd_fusnapln.cxx	\
		sd_fuolbull.cxx	\
		sd_fucopy.cxx		\
		sd_fulink.cxx		\
		sd_fuspell.cxx 	\
		sd_futhes.cxx		\
		sd_fusearch.cxx	\
		sd_fuinsfil.cxx	\
		sd_futxtatt.cxx	\
		sd_fumeasur.cxx	\
		sd_fuconnct.cxx	\
		sd_unprlout.cxx	\
		sd_fudspord.cxx	\
		sd_unmovss.cxx 	\
		sd_fucon3d.cxx 	\
		sd_fumorph.cxx		\
        sd_fuexpand.cxx	\
        sd_fusumry.cxx     \
		sd_sdmtf.cxx		\
		sd_sprite.cxx		\
		sd_outlinfo.cxx	\
		sd_fucushow.cxx	\
		sd_speedctl.cxx	\
		sd_fuvect.cxx      \
		sd_bulmaper.cxx    \
		sd_undoback.cxx    

EXCEPTIONSFILES= \
		$(SLO)$/sd_futext2.obj		\
		$(SLO)$/sd_fuinsfil.obj	\
		$(SLO)$/sd_fuinsert.obj	

SLOFILES = \
		$(SLO)$/sd_undolayer.obj	\
		$(SLO)$/sd_fupoor.obj		\
		$(SLO)$/sd_fudraw.obj		\
		$(SLO)$/sd_fuzoom.obj		\
		$(SLO)$/sd_fusel.obj		\
		$(SLO)$/sd_fuconstr.obj 	\
		$(SLO)$/sd_fuconrec.obj 	\
		$(SLO)$/sd_fuconuno.obj 	\
		$(SLO)$/sd_fuconbez.obj 	\
		$(SLO)$/sd_fuediglu.obj 	\
		$(SLO)$/sd_fuslid.obj		\
		$(SLO)$/sd_fuslsel.obj		\
		$(SLO)$/sd_fuslshow.obj 	\
		$(SLO)$/sd_fuslshw2.obj 	\
		$(SLO)$/sd_fuslshw3.obj 	\
		$(SLO)$/sd_fuslshw4.obj 	\
		$(SLO)$/sd_fuslshw5.obj 	\
		$(SLO)$/sd_fuslshw6.obj 	\
		$(SLO)$/sd_fusldlg.obj 	\
		$(SLO)$/sd_fader.obj		\
		$(SLO)$/sd_fader2.obj		\
		$(SLO)$/sd_mover.obj		\
		$(SLO)$/sd_fuslprms.obj 	\
		$(SLO)$/sd_fuscale.obj		\
		$(SLO)$/sd_fuslhide.obj 	\
		$(SLO)$/sd_futransf.obj 	\
		$(SLO)$/sd_futext.obj		\
		$(SLO)$/sd_futext2.obj		\
		$(SLO)$/sd_fuline.obj		\
		$(SLO)$/sd_sdundo.obj		\
		$(SLO)$/sd_sdundogr.obj 	\
		$(SLO)$/sd_unslprms.obj 	\
		$(SLO)$/sd_fuoaprms.obj 	\
		$(SLO)$/sd_unoaprms.obj 	\
		$(SLO)$/sd_fuarea.obj		\
		$(SLO)$/sd_fuchar.obj		\
		$(SLO)$/sd_fuconarc.obj 	\
		$(SLO)$/sd_fuparagr.obj 	\
		$(SLO)$/sd_fubullet.obj 	\
		$(SLO)$/sd_futempl.obj		\
		$(SLO)$/sd_fuoutl.obj		\
		$(SLO)$/sd_fuoltext.obj 	\
		$(SLO)$/sd_fuinsert.obj 	\
		$(SLO)$/sd_fupage.obj		\
		$(SLO)$/sd_undopage.obj 	\
		$(SLO)$/sd_fuprlout.obj 	\
		$(SLO)$/sd_fuprobjs.obj 	\
		$(SLO)$/sd_fulinend.obj 	\
		$(SLO)$/sd_fusnapln.obj 	\
		$(SLO)$/sd_fuolbull.obj 	\
		$(SLO)$/sd_fucopy.obj		\
		$(SLO)$/sd_fulink.obj		\
		$(SLO)$/sd_fuspell.obj		\
		$(SLO)$/sd_futhes.obj		\
		$(SLO)$/sd_fusearch.obj 	\
		$(SLO)$/sd_fuinsfil.obj 	\
		$(SLO)$/sd_futxtatt.obj 	\
		$(SLO)$/sd_fumeasur.obj 	\
		$(SLO)$/sd_fuconnct.obj 	\
		$(SLO)$/sd_unprlout.obj 	\
		$(SLO)$/sd_fudspord.obj 	\
		$(SLO)$/sd_unmovss.obj		\
		$(SLO)$/sd_fucon3d.obj		\
		$(SLO)$/sd_fumorph.obj		\
        $(SLO)$/sd_fuexpand.obj    \
        $(SLO)$/sd_fusumry.obj     \
		$(SLO)$/sd_sdmtf.obj		\
		$(SLO)$/sd_sprite.obj		\
		$(SLO)$/sd_outlinfo.obj	\
		$(SLO)$/sd_fucushow.obj	\
		$(SLO)$/sd_speedctl.obj	\
		$(SLO)$/sd_fuvect.obj		\
		$(SLO)$/sd_bulmaper.obj    \
		$(SLO)$/sd_undoback.obj    

.IF "$(GUI)" == "WNT"

NOOPTFILES=\
	$(SLO)$/sd_futext.obj

.ENDIF

# --- Tagets -------------------------------------------------------

.INCLUDE :  target.mk
