/*************************************************************************
 *
 *  $RCSfile: sd_fulinend.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:49:22 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #ifndef _XTABLE_HXX
// auto strip #include <bf_svx/xtable.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_DLG_NAME_HXX //autogen
// auto strip #include <bf_svx/dlgname.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOBJ_HXX //autogen
// auto strip #include <bf_svx/svdobj.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOPATH_HXX //autogen
// auto strip #include <bf_svx/svdopath.hxx>
// auto strip #endif
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif

#include "strings.hrc"

// auto strip #ifndef _SD_VIEWSHEL_HXX
// auto strip #include "viewshel.hxx"
// auto strip #endif


#include "helpids.h"
// auto strip #include "sdresid.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "sdview.hxx"
// auto strip #include "sdwindow.hxx"
// auto strip #include "fulinend.hxx"
namespace binfilter {

#define BITMAP_WIDTH  32
#define BITMAP_HEIGHT 12

//STRIP001 TYPEINIT1( FuLineEnd, FuPoor );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuLineEnd::FuLineEnd(SdViewShell* pViewSh, SdWindow* pWin, SdView* pView,
//STRIP001 					SdDrawDocument* pDoc, SfxRequest& rReq)
//STRIP001 	: FuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 
//STRIP001 	if( rMarkList.GetMarkCount() == 1 )
//STRIP001 	{
//STRIP001 		const SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001 		const SdrObject* pNewObj;
//STRIP001 		SdrObject* pConvPolyObj = NULL;
//STRIP001 
//STRIP001 		if( pObj->ISA( SdrPathObj ) )
//STRIP001 		{
//STRIP001 			pNewObj = pObj;
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			SdrObjTransformInfoRec aInfoRec;
//STRIP001 			pObj->TakeObjInfo( aInfoRec );
//STRIP001 
//STRIP001 			if( aInfoRec.bCanConvToPath &&
//STRIP001 				pObj->GetObjInventor() == SdrInventor &&
//STRIP001 				pObj->GetObjIdentifier() != OBJ_GRUP )
//STRIP001 				// bCanConvToPath ist bei Gruppenobjekten TRUE,
//STRIP001 				// stuerzt aber bei ConvertToPathObj() ab !
//STRIP001 			{
//STRIP001 				pNewObj = pConvPolyObj = pObj->ConvertToPolyObj( TRUE, FALSE );
//STRIP001 
//STRIP001 				if( !pNewObj || !pNewObj->ISA( SdrPathObj ) )
//STRIP001 					return; // Abbruch, zusaetzliche Sicherheit, die bei
//STRIP001 							// Gruppenobjekten aber nichts bringt.
//STRIP001 			}
//STRIP001 			else return; // Abbruch
//STRIP001 		}
//STRIP001 
//STRIP001 		const XPolygon aXPoly = ( (SdrPathObj*) pNewObj )->GetPathPoly().GetObject( 0 );
//STRIP001 
//STRIP001 		// Loeschen des angelegten PolyObjektes
//STRIP001 		if( pConvPolyObj )
//STRIP001 			delete pConvPolyObj;
//STRIP001 
//STRIP001 		XLineEndList* pLineEndList = pDoc->GetLineEndList();
//STRIP001 		XLineEndEntry* pEntry;
//STRIP001 
//STRIP001 		String aNewName( SdResId( STR_LINEEND ) );
//STRIP001 		String aDesc( SdResId( STR_DESC_LINEEND ) );
//STRIP001 		String aName;
//STRIP001 
//STRIP001 		long nCount = pLineEndList->Count();
//STRIP001 		long j = 1;
//STRIP001 		BOOL bDifferent = FALSE;
//STRIP001 
//STRIP001 		while( !bDifferent )
//STRIP001 		{
//STRIP001 			aName = aNewName;
//STRIP001 			aName.Append( sal_Unicode(' ') );
//STRIP001 			aName.Append( UniString::CreateFromInt32( j++ ) );
//STRIP001 			bDifferent = TRUE;
//STRIP001 			for( long i = 0; i < nCount && bDifferent; i++ )
//STRIP001 			{
//STRIP001 				if( aName == pLineEndList->Get( i )->GetName() )
//STRIP001 					bDifferent = FALSE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 
//STRIP001 		SvxNameDialog* pDlg = new SvxNameDialog( NULL, aName, aDesc );
//STRIP001 		pDlg->SetEditHelpId( HID_SD_NAMEDIALOG_LINEEND );
//STRIP001 
//STRIP001 		if( pDlg->Execute() == RET_OK )
//STRIP001 		{
//STRIP001 			pDlg->GetName( aName );
//STRIP001 			bDifferent = TRUE;
//STRIP001 
//STRIP001 			for( long i = 0; i < nCount && bDifferent; i++ )
//STRIP001 			{
//STRIP001 				if( aName == pLineEndList->Get( i )->GetName() )
//STRIP001 					bDifferent = FALSE;
//STRIP001 			}
//STRIP001 
//STRIP001 			if( bDifferent )
//STRIP001 			{
//STRIP001 			/*
//STRIP001 				XOutdevItemPool* pItemPool = (XOutdevItemPool*) &pViewSh->GetPool();
//STRIP001 				XLineAttrSetItem aXLSet( pItemPool );
//STRIP001 				XFillAttrSetItem aXFSet( pItemPool );
//STRIP001 				VirtualDevice	 aTmpVD ( *pWindow );
//STRIP001 				XOutputDevice	 aTmpXOut( &aTmpVD, pItemPool );
//STRIP001 
//STRIP001 				aTmpVD.ChangeMapMode( MAP_100TH_MM );
//STRIP001 				aTmpVD.SetOutputSize( aTmpVD.PixelToLogic( Size( BITMAP_WIDTH * 2, BITMAP_HEIGHT ) ) );
//STRIP001 				aXLSet.GetItemSet().Put( XLineStartWidthItem( aTmpVD.GetOutputSize().Height() ) );
//STRIP001 				aXLSet.GetItemSet().Put( XLineEndWidthItem( aTmpVD.GetOutputSize().Height() ) );
//STRIP001 				aXFSet.GetItemSet().Put( XFillColorItem( String(), Color( COL_WHITE ) ) );
//STRIP001 				aXFSet.GetItemSet().Put( XFillStyleItem( XFILL_SOLID ) );
//STRIP001 				aXLSet.GetItemSet().Put( XLineStyleItem( XLINE_NONE ) );
//STRIP001 
//STRIP001 				aTmpXOut.SetLineAttr( ( const XLineAttrSetItem& ) pItemPool->Put( aXLSet ) );
//STRIP001 				aTmpXOut.SetFillAttr( ( const XFillAttrSetItem& ) pItemPool->Put( aXFSet ) );
//STRIP001 				aTmpXOut.DrawRect( Rectangle( Point(), aTmpVD.GetOutputSize() ) );
//STRIP001 
//STRIP001 				aXLSet.GetItemSet().Put( XLineStyleItem( XLINE_SOLID ) );
//STRIP001 				aXLSet.GetItemSet().Put( XLineStartItem( String(), aXPoly ) );
//STRIP001 				aXLSet.GetItemSet().Put( XLineEndItem( String(), aXPoly ) );
//STRIP001 
//STRIP001 				aTmpXOut.SetLineAttr( ( const XLineAttrSetItem& ) pItemPool->Put( aXLSet ) );
//STRIP001 				aTmpXOut.DrawLine( Point( 0, aTmpVD.GetOutputSize().Height() / 2 ),
//STRIP001 									Point( aTmpVD.GetOutputSize().Width(), aTmpVD.GetOutputSize().Height() / 2 ) );
//STRIP001 				Bitmap* pBitmap = new Bitmap( aTmpVD.GetBitmap( Point(), aTmpVD.GetOutputSize() ) );
//STRIP001 			*/
//STRIP001 				pEntry = new XLineEndEntry( aXPoly, aName );
//STRIP001 				pLineEndList->Insert( pEntry, LIST_APPEND);
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				String aStr(SdResId( STR_WARN_NAME_DUPLICATE ));
//STRIP001 				WarningBox aWarningBox( pWin, WinBits( WB_OK ),
//STRIP001 					 aStr );
//STRIP001 				aWarningBox.Execute();
//STRIP001 			}
//STRIP001 		}
//STRIP001 		delete pDlg;
//STRIP001 	}
//STRIP001 }


}
