/*************************************************************************
 *
 *  $RCSfile: sd_futransf.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:57:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#include <bf_svx/dialogs.hrc>
// auto strip #include <bf_svx/labdlg.hxx>
// auto strip #include <bf_svx/polysc3d.hxx>
// auto strip #ifndef _SV_MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif

// auto strip #ifndef _SVX_TRANSFRM_HXX //autogen
// auto strip #include <bf_svx/transfrm.hxx>
// auto strip #endif

#include "strings.hrc"
// auto strip #include "viewshel.hxx"
// auto strip #include "sdview.hxx"
// auto strip #include "sdresid.hxx"
// auto strip #include "futransf.hxx"
// auto strip #include "drawdoc.hxx"
namespace binfilter {

//STRIP001 TYPEINIT1( FuTransform, FuPoor );
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 FuTransform::FuTransform(SdViewShell* pViewSh, SdWindow* pWin, SdView* pView,
//STRIP001 						 SdDrawDocument* pDoc, SfxRequest& rReq)
//STRIP001 	: FuPoor(pViewSh, pWin, pView, pDoc, rReq)
//STRIP001 {
//STRIP001 	if( pView->HasMarkedObj() )
//STRIP001 	/*	( pView->IsResizeAllowed() ||
//STRIP001 		  pView->IsMoveAllowed() ||
//STRIP001 		  pView->IsRotateAllowed() ) ) */
//STRIP001 	{
//STRIP001 		// Undo
//STRIP001 		String aString( pView->GetMarkDescription() );
//STRIP001 		aString.Append( sal_Unicode(' ') );
//STRIP001 		aString.Append( String( SdResId( STR_TRANSFORM ) ) );
//STRIP001 		pView->BegUndo( aString );
//STRIP001 
//STRIP001 		const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 
//STRIP001 		if( !pArgs )
//STRIP001 		{
//STRIP001 			// --------- Itemset fuer Groesse und Position --------
//STRIP001 			SfxItemSet aSet( pView->GetGeoAttrFromMarked() );
//STRIP001 
//STRIP001 			const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 			SdrObject* pObj = rMarkList.GetMark(0)->GetObj();
//STRIP001 			if( rMarkList.GetMarkCount() == 1 &&
//STRIP001 				pObj->GetObjInventor() == SdrInventor &&
//STRIP001 				pObj->GetObjIdentifier() == OBJ_CAPTION )
//STRIP001 			{
//STRIP001 				// --------- Itemset fuer Caption --------
//STRIP001 				SfxItemSet aNewAttr( pDoc->GetPool() );
//STRIP001 				pView->GetAttributes( aNewAttr );
//STRIP001 
//STRIP001 				SvxCaptionTabDialog* pDlg = new SvxCaptionTabDialog( NULL, pView);
//STRIP001 
//STRIP001 				const USHORT* pRange = pDlg->GetInputRanges( *aNewAttr.GetPool() );
//STRIP001 				SfxItemSet aCombSet( *aNewAttr.GetPool(), pRange );
//STRIP001 				aCombSet.Put( aNewAttr );
//STRIP001 				aCombSet.Put( aSet );
//STRIP001 				pDlg->SetInputSet( &aCombSet );
//STRIP001 
//STRIP001 				if( pDlg->Execute() == RET_OK )
//STRIP001 				{
//STRIP001 					rReq.Done( *( pDlg->GetOutputItemSet() ) );
//STRIP001 					pArgs = rReq.GetArgs();
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					delete pDlg;
//STRIP001 					pView->EndUndo();
//STRIP001 					return; // Abbruch
//STRIP001 				}
//STRIP001 				delete( pDlg );
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				SvxTransformTabDialog* pDlg = new SvxTransformTabDialog( NULL, &aSet, pView );
//STRIP001 
//STRIP001 				if( pDlg->Execute() == RET_OK )
//STRIP001 				{
//STRIP001 					rReq.Done( *( pDlg->GetOutputItemSet() ) );
//STRIP001 					pArgs = rReq.GetArgs();
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					delete pDlg;
//STRIP001 					pView->EndUndo();
//STRIP001 					return; // Abbruch
//STRIP001 				}
//STRIP001 				delete( pDlg );
//STRIP001 			}
//STRIP001 		}
//STRIP001 		pView->SetGeoAttrToMarked( *pArgs );
//STRIP001 		pView->SetAttributes( *pArgs );
//STRIP001 
//STRIP001 		/**********************************************************************
//STRIP001 		* An der E3dView muss demnaechst SetGeoAttrToMarked() mit folgendem
//STRIP001 		* Code ueberladen werden:
//STRIP001 		**********************************************************************/
//STRIP001 		const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 		ULONG nCount = rMarkList.GetMarkCount();
//STRIP001 
//STRIP001 		for (ULONG nMark = 0; nMark < nCount; nMark++)
//STRIP001 		{
//STRIP001 			SdrObject* pObj = rMarkList.GetMark(nMark)->GetObj();
//STRIP001 
//STRIP001 			if (pObj->ISA(E3dPolyScene))
//STRIP001 			{
//STRIP001 				((E3dPolyScene*) pObj)->FitSnapRectToBoundVol();
//STRIP001 			}
//STRIP001 		}
//STRIP001 		//********************************************************************
//STRIP001 
//STRIP001 
//STRIP001 		pView->EndUndo();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function aktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuTransform::Activate()
//STRIP001 {
//STRIP001 	FuPoor::Activate();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function deaktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void FuTransform::Deactivate()
//STRIP001 {
//STRIP001 	FuPoor::Deactivate();
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function ResizeObject
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 Point FuTransform::GetPoint( Rectangle aRect, RECT_POINT eRP )
//STRIP001 {
//STRIP001 
//STRIP001 	switch( eRP )
//STRIP001 	{
//STRIP001 		case RP_LT: return( Point( aRect.Left(), aRect.Top() ) );
//STRIP001 			break;
//STRIP001 		case RP_MT: return( Point( aRect.Center().X(), aRect.Top() ) );
//STRIP001 			break;
//STRIP001 		case RP_RT: return( Point( aRect.Right(), aRect.Top() ) );
//STRIP001 			break;
//STRIP001 		case RP_LM: return( Point( aRect.Left(), aRect.Center().Y() ) );
//STRIP001 			break;
//STRIP001 		case RP_MM: return( Point( aRect.Center().X(), aRect.Center().Y() ) );
//STRIP001 			break;
//STRIP001 		case RP_RM: return( Point( aRect.Right(), aRect.Center().Y() ) );
//STRIP001 			break;
//STRIP001 		case RP_LB: return( Point( aRect.Left(), aRect.Bottom() ) );
//STRIP001 			break;
//STRIP001 		case RP_MB: return( Point( aRect.Center().X(), aRect.Bottom() ) );
//STRIP001 			break;
//STRIP001 		case RP_RB: return( Point( aRect.Right(), aRect.Bottom() ) );
//STRIP001 			break;
//STRIP001 	}
//STRIP001 	return( Point ( 0, 0 ) ); // Sollte nicht vorkommen !
//STRIP001 }


}
