/*************************************************************************
 *
 *  $RCSfile: sd_undopage.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 13:59:59 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#pragma hdrstop

#include <bf_svx/svxids.hrc>
// auto strip #ifndef _SFX_BINDINGS_HXX //autogen
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif

// auto strip #include "sdpage.hxx"
// auto strip #include "drviewsh.hxx"
// auto strip #include "drawview.hxx"
// auto strip #include "undopage.hxx"

// auto strip #ifndef _SVDPAGV_HXX //autogen
// auto strip #include <bf_svx/svdpagv.hxx>
// auto strip #endif
namespace binfilter {


//STRIP001 TYPEINIT1(SdPageFormatUndoAction, SdUndoAction);
//STRIP001 TYPEINIT1(SdPageLRUndoAction, SdUndoAction);
//STRIP001 TYPEINIT1(SdPageULUndoAction, SdUndoAction);
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdPageFormatUndoAction::~SdPageFormatUndoAction()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Undo()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdPageFormatUndoAction::Undo()
//STRIP001 {
//STRIP001 	Rectangle aOldBorderRect(nOldLeft, nOldUpper, nOldRight, nOldLower);
//STRIP001 	pPage->ScaleObjects(aOldSize, aOldBorderRect, bNewScale);
//STRIP001 	pPage->SetSize(aOldSize);
//STRIP001 	pPage->SetLftBorder(nOldLeft);
//STRIP001 	pPage->SetRgtBorder(nOldRight);
//STRIP001 	pPage->SetUppBorder(nOldUpper);
//STRIP001 	pPage->SetLwrBorder(nOldLower);
//STRIP001 	pPage->SetOrientation(eOldOrientation);
//STRIP001 	pPage->SetPaperBin( nOldPaperBin );
//STRIP001 
//STRIP001 	pPage->SetBackgroundFullSize( bOldFullSize );
//STRIP001 	if( !pPage->IsMasterPage() )
//STRIP001 		( (SdPage*) pPage->GetMasterPage(0) )->SetBackgroundFullSize( bOldFullSize );
//STRIP001 
//STRIP001 	SfxViewShell* pViewShell = SfxViewShell::Current();
//STRIP001 
//STRIP001 	if ( pViewShell->ISA(SdDrawViewShell) )
//STRIP001 	{
//STRIP001 		SdDrawViewShell* pDrViewShell = (SdDrawViewShell*) pViewShell;
//STRIP001 		long nWidth = pPage->GetSize().Width();
//STRIP001 		long nHeight = pPage->GetSize().Height();
//STRIP001 
//STRIP001 		Point aPageOrg = Point(nWidth, nHeight / 2);
//STRIP001 		Size aViewSize = Size(nWidth * 3, nHeight * 2);
//STRIP001 
//STRIP001 		pDrViewShell->InitWindows(aPageOrg, aViewSize, Point(-1, -1), TRUE);
//STRIP001 		pDrViewShell->GetView()->SetWorkArea(Rectangle(Point(0,0) - aPageOrg, aViewSize));
//STRIP001 
//STRIP001 		pDrViewShell->UpdateScrollBars();
//STRIP001 		pDrViewShell->GetView()->GetPageViewPvNum(0)->SetPageOrigin(Point(0,0));
//STRIP001 		pViewShell->GetViewFrame()->GetBindings().Invalidate(SID_RULER_NULL_OFFSET);
//STRIP001 		pViewShell->GetViewFrame()->GetDispatcher()->Execute(SID_SIZE_PAGE, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD);
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Redo()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdPageFormatUndoAction::Redo()
//STRIP001 {
//STRIP001 	Rectangle aNewBorderRect(nNewLeft, nNewUpper, nNewRight, nNewLower);
//STRIP001 	pPage->ScaleObjects(aNewSize, aNewBorderRect, bNewScale);
//STRIP001 	pPage->SetSize(aNewSize);
//STRIP001 	pPage->SetLftBorder(nNewLeft);
//STRIP001 	pPage->SetRgtBorder(nNewRight);
//STRIP001 	pPage->SetUppBorder(nNewUpper);
//STRIP001 	pPage->SetLwrBorder(nNewLower);
//STRIP001 	pPage->SetOrientation(eNewOrientation);
//STRIP001 	pPage->SetPaperBin( nNewPaperBin );
//STRIP001 
//STRIP001 	pPage->SetBackgroundFullSize( bNewFullSize );
//STRIP001 	if( !pPage->IsMasterPage() )
//STRIP001 		( (SdPage*) pPage->GetMasterPage(0) )->SetBackgroundFullSize( bNewFullSize );
//STRIP001 
//STRIP001 	SfxViewShell* pViewShell = SfxViewShell::Current();
//STRIP001 
//STRIP001 	if ( pViewShell->ISA(SdDrawViewShell) )
//STRIP001 	{
//STRIP001 		SdDrawViewShell* pDrViewShell = (SdDrawViewShell*) pViewShell;
//STRIP001 		long nWidth = pPage->GetSize().Width();
//STRIP001 		long nHeight = pPage->GetSize().Height();
//STRIP001 
//STRIP001 		Point aPageOrg = Point(nWidth, nHeight / 2);
//STRIP001 		Size aViewSize = Size(nWidth * 3, nHeight * 2);
//STRIP001 
//STRIP001 		pDrViewShell->InitWindows(aPageOrg, aViewSize, Point(-1, -1), TRUE);
//STRIP001 		pDrViewShell->GetView()->SetWorkArea(Rectangle(Point(0,0) - aPageOrg, aViewSize));
//STRIP001 
//STRIP001 		pDrViewShell->UpdateScrollBars();
//STRIP001 		pDrViewShell->GetView()->GetPageViewPvNum(0)->SetPageOrigin(Point(0,0));
//STRIP001 		pViewShell->GetViewFrame()->GetBindings().Invalidate(SID_RULER_NULL_OFFSET);
//STRIP001 		pViewShell->GetViewFrame()->GetDispatcher()->Execute(SID_SIZE_PAGE, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD);
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Repeat()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdPageFormatUndoAction::Repeat()
//STRIP001 {
//STRIP001 	Redo();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* LR-Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdPageLRUndoAction::~SdPageLRUndoAction()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* LR-Undo()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdPageLRUndoAction::Undo()
//STRIP001 {
//STRIP001 	pPage->SetLftBorder(nOldLeft);
//STRIP001 	pPage->SetRgtBorder(nOldRight);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* LR-Redo()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdPageLRUndoAction::Redo()
//STRIP001 {
//STRIP001 	pPage->SetLftBorder(nNewLeft);
//STRIP001 	pPage->SetRgtBorder(nNewRight);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* LR-Repeat()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdPageLRUndoAction::Repeat()
//STRIP001 {
//STRIP001 	Redo();
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* UL-Destruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 SdPageULUndoAction::~SdPageULUndoAction()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* UL-Undo()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdPageULUndoAction::Undo()
//STRIP001 {
//STRIP001 	pPage->SetUppBorder(nOldUpper);
//STRIP001 	pPage->SetLwrBorder(nOldLower);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* UL-Redo()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdPageULUndoAction::Redo()
//STRIP001 {
//STRIP001 	pPage->SetUppBorder(nNewUpper);
//STRIP001 	pPage->SetLwrBorder(nNewLower);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* UL-Repeat()
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdPageULUndoAction::Repeat()
//STRIP001 {
//STRIP001 	Redo();
//STRIP001 }



}
