/*************************************************************************
 *
 *  $RCSfile: custsdlg.hxx,v $
 *
 *  $Revision: 1.1.1.1 $
 *
 *  last change: $Author: hjs $ $Date: 2003/10/01 12:19:38 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


//STRIP001 #ifndef _SD_CUSTSDLG_HXX
//STRIP001 #define _SD_CUSTSDLG_HXX
//STRIP001 
//STRIP001 #ifndef _BUTTON_HXX //autogen
//STRIP001 #include <vcl/button.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SV_LSTBOX_HXX //autogen
//STRIP001 #include <vcl/lstbox.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SV_FIXED_HXX //autogen
//STRIP001 #include <vcl/fixed.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SV_EDIT_HXX //autogen
//STRIP001 #include <vcl/edit.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SVTREEBOX_HXX //autogen
//STRIP001 #include <svtools/svtreebx.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SV_DIALOG_HXX //autogen
//STRIP001 #include <vcl/dialog.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 class SdDrawDocument;
//STRIP001 class SdCustomShow;
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 class SdCustomShowDlg : public ModalDialog
//STRIP001 {
//STRIP001 private:
//STRIP001 	ListBox 		aLbCustomShows;
//STRIP001 	CheckBox		aCbxUseCustomShow;
//STRIP001 	PushButton		aBtnNew;
//STRIP001 	PushButton		aBtnEdit;
//STRIP001 	PushButton		aBtnRemove;
//STRIP001 	PushButton		aBtnCopy;
//STRIP001 	HelpButton		aBtnHelp;
//STRIP001 	PushButton  	aBtnStartShow;
//STRIP001 	OKButton		aBtnOK;
//STRIP001 
//STRIP001 	SdDrawDocument&	rDoc;
//STRIP001 	List*			pCustomShowList;
//STRIP001 	SdCustomShow*	pCustomShow;
//STRIP001 	BOOL			bModified;
//STRIP001 
//STRIP001 	void			CheckState();
//STRIP001 
//STRIP001 	DECL_LINK( ClickButtonHdl, void * );
//STRIP001 	DECL_LINK( StartShowHdl, Button* );
//STRIP001 
//STRIP001 public:
//STRIP001 				SdCustomShowDlg( Window* pWindow, SdDrawDocument& rDrawDoc );
//STRIP001 				~SdCustomShowDlg();
//STRIP001 
//STRIP001 	BOOL		IsModified() const { return( bModified ); }
//STRIP001 	BOOL		IsCustomShow() const;
//STRIP001 };
//STRIP001 
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 class SdDefineCustomShowDlg : public ModalDialog
//STRIP001 {
//STRIP001 private:
//STRIP001 	FixedText		aFtName;
//STRIP001 	Edit			aEdtName;
//STRIP001 	FixedText		aFtPages;
//STRIP001 	MultiListBox	aLbPages;
//STRIP001 	PushButton		aBtnAdd;
//STRIP001 	PushButton		aBtnRemove;
//STRIP001 	FixedText		aFtCustomPages;
//STRIP001 	SvTreeListBox	aLbCustomPages;
//STRIP001 	OKButton		aBtnOK;
//STRIP001 	CancelButton 	aBtnCancel;
//STRIP001 	HelpButton		aBtnHelp;
//STRIP001 
//STRIP001 	SdDrawDocument&	rDoc;
//STRIP001 	SdCustomShow*&	rpCustomShow;
//STRIP001 	BOOL			bModified;
//STRIP001 	String			aOldName;
//STRIP001 
//STRIP001 	void			CheckState();
//STRIP001 	void			CheckCustomShow();
//STRIP001 
//STRIP001 	DECL_LINK( ClickButtonHdl, void * );
//STRIP001 	DECL_LINK( OKHdl, Button* );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 					SdDefineCustomShowDlg( Window* pWindow,
//STRIP001 							SdDrawDocument& rDrawDoc, SdCustomShow*& rpCS );
//STRIP001 					~SdDefineCustomShowDlg();
//STRIP001 
//STRIP001 	BOOL			IsModified() const { return( bModified ); }
//STRIP001 };
//STRIP001 
//STRIP001 #endif // _SD_CUSTSDLG_HXX

