/*************************************************************************
 *
 *  $RCSfile: sd_drviewsh.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:15:47 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #ifndef _AEITEM_HXX //autogen
// auto strip #include <svtools/aeitem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXITEMSET_HXX //autogen
// auto strip #include <svtools/itemset.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
#ifndef _SVXIDS_HRC
#include <bf_svx/svxids.hrc>
#endif

#pragma hdrstop

// auto strip #ifndef _SVX_FMSHELL_HXX			// XXX nur temp (dg)
// auto strip #include <bf_svx/fmshell.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDISPATCH_HXX //autogen
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif

#include "app.hrc"
#include "strings.hrc"
// auto strip #include "sdpage.hxx"
// auto strip #include "frmview.hxx"
// auto strip #include "sdresid.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "docshell.hxx"
// auto strip #include "sdwindow.hxx"
// auto strip #include "drviewsh.hxx"
// auto strip #include "grviewsh.hxx"
// auto strip #include "drawview.hxx"
namespace binfilter {

#define TABCONTROL_INITIAL_SIZE 	500

/*************************************************************************
|*
|* Sprung zu Bookmark
|*
\************************************************************************/

//STRIP001 BOOL SdDrawViewShell::GotoBookmark(const String& rBookmark)
//STRIP001 {
//STRIP001 	return (pDocSh->GotoBookmark(rBookmark));
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Bereich sichtbar machen (Bildausschnitt scrollen)
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void SdDrawViewShell::MakeVisible(const Rectangle& rRect, Window& rWin)
//STRIP001 {
//STRIP001 	// #98568# In older versions, if in X or Y the size of the object was smaller than the
//STRIP001 	// visible area, the user-defined zoom was changed. This was decided to be a bug for 6.x,
//STRIP001 	// thus I developed a version which instead handles X/Y bigger/smaller and visibility
//STRIP001 	// questions seperately. The new behaviour is triggered with the bZoomAllowed parameter
//STRIP001 	// which for old behaviour should be set to sal_True. I looked at all uses of MakeVisible()
//STRIP001 	// in the application and found no valid reason for really changing the zoom factor, thus 
//STRIP001 	// I decided to NOT expand (incompatible) this virtual method to get one more parameter. If
//STRIP001 	// this is wanted in later versions, feel free to add that bool to the parameter list.
//STRIP001 	sal_Bool bZoomAllowed(sal_False);
//STRIP001 	Size aLogicSize(rRect.GetSize());
//STRIP001 
//STRIP001 	// Sichtbarer Bereich
//STRIP001 	Size aVisSizePixel(rWin.GetOutputSizePixel());
//STRIP001 	Rectangle aVisArea(rWin.PixelToLogic(Rectangle(Point(0,0), aVisSizePixel)));
//STRIP001 	Size aVisAreaSize(aVisArea.GetSize());
//STRIP001 
//STRIP001 	if(!aVisArea.IsInside(rRect) && !pFuSlideShow)
//STRIP001 	{
//STRIP001 		// Objekt liegt nicht komplett im sichtbaren Bereich
//STRIP001 		sal_Int32 nFreeSpaceX(aVisAreaSize.Width() - aLogicSize.Width());
//STRIP001 		sal_Int32 nFreeSpaceY(aVisAreaSize.Height() - aLogicSize.Height());
//STRIP001 
//STRIP001 		if(bZoomAllowed && (nFreeSpaceX < 0 || nFreeSpaceY < 0))
//STRIP001 		{
//STRIP001 			// Objekt passt nicht in sichtbaren Bereich -> auf Objektgroesse zoomen
//STRIP001 			SetZoomRect(rRect);
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			// #98568# allow a mode for move-only visibility without zooming.
//STRIP001 			const sal_Int32 nPercentBorder(30);
//STRIP001 			const Rectangle aInnerRectangle(
//STRIP001 				aVisArea.Left() + ((aVisAreaSize.Width() * nPercentBorder) / 200),
//STRIP001 				aVisArea.Top() + ((aVisAreaSize.Height() * nPercentBorder) / 200),
//STRIP001 				aVisArea.Right() - ((aVisAreaSize.Width() * nPercentBorder) / 200),
//STRIP001 				aVisArea.Bottom() - ((aVisAreaSize.Height() * nPercentBorder) / 200)
//STRIP001 				);
//STRIP001 			Point aNewPos(aVisArea.TopLeft());
//STRIP001 
//STRIP001 			if(nFreeSpaceX < 0)
//STRIP001 			{
//STRIP001 				if(aInnerRectangle.Left() > rRect.Right())
//STRIP001 				{
//STRIP001 					// object moves out to the left
//STRIP001 					aNewPos.X() -= aVisAreaSize.Width() / 2;
//STRIP001 				}
//STRIP001 
//STRIP001 				if(aInnerRectangle.Right() < rRect.Left())
//STRIP001 				{
//STRIP001 					// object moves out to the right
//STRIP001 					aNewPos.X() += aVisAreaSize.Width() / 2;
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				if(nFreeSpaceX > rRect.GetWidth())
//STRIP001 					nFreeSpaceX = rRect.GetWidth();
//STRIP001 
//STRIP001 				while(rRect.Right() > aNewPos.X() + aVisAreaSize.Width())
//STRIP001 					aNewPos.X() += nFreeSpaceX;
//STRIP001 				
//STRIP001 				while(rRect.Left() < aNewPos.X())
//STRIP001 					aNewPos.X() -= nFreeSpaceX;
//STRIP001 			}
//STRIP001 
//STRIP001 			if(nFreeSpaceY < 0)
//STRIP001 			{
//STRIP001 				if(aInnerRectangle.Top() > rRect.Bottom())
//STRIP001 				{
//STRIP001 					// object moves out to the top
//STRIP001 					aNewPos.Y() -= aVisAreaSize.Height() / 2;
//STRIP001 				}
//STRIP001 
//STRIP001 				if(aInnerRectangle.Bottom() < rRect.Top())
//STRIP001 				{
//STRIP001 					// object moves out to the right
//STRIP001 					aNewPos.Y() += aVisAreaSize.Height() / 2;
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				if(nFreeSpaceY > rRect.GetHeight())
//STRIP001 					nFreeSpaceY = rRect.GetHeight();
//STRIP001 
//STRIP001 				while(rRect.Bottom() > aNewPos.Y() + aVisAreaSize.Height())
//STRIP001 					aNewPos.Y() += nFreeSpaceY;
//STRIP001 				
//STRIP001 				while(rRect.Top() < aNewPos.Y())
//STRIP001 					aNewPos.Y() -= nFreeSpaceY;
//STRIP001 			}
//STRIP001 
//STRIP001 			// did position change? Does it need to be set?
//STRIP001 			if(aNewPos != aVisArea.TopLeft())
//STRIP001 			{
//STRIP001 				aVisArea.SetPos(aNewPos);
//STRIP001 				SetZoomRect(aVisArea);
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }


}
