/*************************************************************************
 *
 *  $RCSfile: sfx2_styledlg.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 14:47:35 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

// auto strip #ifndef _SFX_WHITER_HXX //autogen
// auto strip #include <svtools/whiter.hxx>
// auto strip #endif
// auto strip #ifndef _SFXSTYLE_HXX //autogen
// auto strip #include <svtools/style.hxx>
// auto strip #endif
// auto strip #ifndef _MSGBOX_HXX //autogen
// auto strip #include <vcl/msgbox.hxx>
// auto strip #endif
#pragma hdrstop

// auto strip #include "styledlg.hxx"
// auto strip #include "mgetempl.hxx"
// auto strip #include "sfxresid.hxx"
// auto strip #include "sfxuno.hxx"

#include "dialog.hrc"
namespace binfilter {

// class SfxStyleDialog --------------------------------------------------

//STRIP001 #if SUP <= 372

//STRIP001 SfxStyleDialog::SfxStyleDialog
//STRIP001 (
//STRIP001 	Window* pParent,			// Parent
//STRIP001 	const ResId& rResId,		// ResId
//STRIP001 	SfxStyleSheetBase& rStyle,	// zu bearbeitendes StyleSheet
//STRIP001 	BOOL bFreeRes				// Flag Resourcen freigeben
//STRIP001 ) :
//STRIP001 
//STRIP001 /*	[Beschreibung]
//STRIP001 
//STRIP001 	Konstruktor: Verwalten-TabPage zuf"ugen, ExampleSet vom Style setzen.
//STRIP001 */
//STRIP001 
//STRIP001 	SfxTabDialog( pParent, rResId,
//STRIP001 				  rStyle.GetItemSet().Clone(),
//STRIP001 				  // auch ohne ParentSupport TRUE "ubergeben, aber erweitert
//STRIP001 				  // um den StandardButton zu unterdr"ucken
//STRIP001 				  rStyle.HasParentSupport() ? TRUE : 2 ),
//STRIP001 
//STRIP001 	pStyle( &rStyle )
//STRIP001 
//STRIP001 {
//STRIP001 	AddTabPage( ID_TABPAGE_MANAGESTYLES,
//STRIP001 				String( SfxResId( STR_TABPAGE_MANAGESTYLES ) ),
//STRIP001 				SfxManageStyleSheetPage::Create, 0, FALSE, 0 );
//STRIP001 
//STRIP001 	// bei neuer Vorlage immer die Verwaltungsseite als aktuelle
//STRIP001 	// Seite setzen
//STRIP001 
//STRIP001 	if( !rStyle.GetName().Len() )
//STRIP001 		SetCurPageId( ID_TABPAGE_MANAGESTYLES );
//STRIP001 	else
//STRIP001 	{
//STRIP001 		String sTxt( GetText() );
//STRIP001 		sTxt += DEFINE_CONST_UNICODE(": ");
//STRIP001 		sTxt += rStyle.GetName();
//STRIP001 		SetText( sTxt );
//STRIP001 	}
//STRIP001 	delete pExampleSet;	// im SfxTabDialog::Ctor() schon angelegt
//STRIP001 	pExampleSet = &pStyle->GetItemSet();
//STRIP001 
//STRIP001 	if ( bFreeRes )
//STRIP001 		FreeResource();
//STRIP001 	GetCancelButton().SetClickHdl( LINK(this, SfxStyleDialog, CancelHdl) );
//STRIP001 }
//STRIP001 
//STRIP001 #endif
//STRIP001 
//STRIP001 SfxStyleDialog::SfxStyleDialog
//STRIP001 (
//STRIP001 	Window* pParent,			// Parent
//STRIP001 	const ResId& rResId,		// ResId
//STRIP001 	SfxStyleSheetBase& rStyle,	// zu bearbeitendes StyleSheet
//STRIP001 	BOOL bFreeRes,				// Flag Resourcen freigeben
//STRIP001 	const String* pUserBtnTxt
//STRIP001 ) :
//STRIP001 
//STRIP001 /*	[Beschreibung]
//STRIP001 
//STRIP001 	Konstruktor: Verwalten-TabPage zuf"ugen, ExampleSet vom Style setzen.
//STRIP001 */
//STRIP001 
//STRIP001 	SfxTabDialog( pParent, rResId,
//STRIP001 				  rStyle.GetItemSet().Clone(),
//STRIP001 				  // auch ohne ParentSupport TRUE "ubergeben, aber erweitert
//STRIP001 				  // um den StandardButton zu unterdr"ucken
//STRIP001 				  rStyle.HasParentSupport() ? TRUE : 2,
//STRIP001 				  pUserBtnTxt ),
//STRIP001 
//STRIP001 	pStyle( &rStyle )
//STRIP001 
//STRIP001 {
//STRIP001 	AddTabPage( ID_TABPAGE_MANAGESTYLES,
//STRIP001 				String( SfxResId( STR_TABPAGE_MANAGESTYLES ) ),
//STRIP001 				SfxManageStyleSheetPage::Create, 0, FALSE, 0 );
//STRIP001 
//STRIP001 	// bei neuer Vorlage immer die Verwaltungsseite als aktuelle
//STRIP001 	// Seite setzen
//STRIP001 
//STRIP001 	if( !rStyle.GetName().Len() )
//STRIP001 		SetCurPageId( ID_TABPAGE_MANAGESTYLES );
//STRIP001 	else
//STRIP001 	{
//STRIP001 		String sTxt( GetText() );
//STRIP001 		sTxt += DEFINE_CONST_UNICODE(": ") ;
//STRIP001 		sTxt += rStyle.GetName();
//STRIP001 		SetText( sTxt );
//STRIP001 	}
//STRIP001 	delete pExampleSet;	// im SfxTabDialog::Ctor() schon angelegt
//STRIP001 	pExampleSet = &pStyle->GetItemSet();
//STRIP001 
//STRIP001 	if ( bFreeRes )
//STRIP001 		FreeResource();
//STRIP001 	GetCancelButton().SetClickHdl( LINK(this, SfxStyleDialog, CancelHdl) );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxStyleDialog::~SfxStyleDialog()
//STRIP001 
//STRIP001 /*	[Beschreibung]
//STRIP001 
//STRIP001 	Destruktor: ExampleSet auf NULL setzen, damit der SfxTabDialog nicht den
//STRIP001 	Set vom Style l"oscht.
//STRIP001 */
//STRIP001 
//STRIP001 {
//STRIP001 	pExampleSet = 0;
//STRIP001 	pStyle = 0;
//STRIP001 	delete GetInputSetImpl();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 const SfxItemSet* SfxStyleDialog::GetRefreshedSet()
//STRIP001 
//STRIP001 /*  [Beschreibung]
//STRIP001 
//STRIP001 	Diese wird gerufen, wenn <SfxTabPage::DeactivatePage(SfxItemSet *)>
//STRIP001 	<SfxTabPage::REFRESH_SET> liefert.
//STRIP001 */
//STRIP001 
//STRIP001 {
//STRIP001 	return GetInputSetImpl();
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 short SfxStyleDialog::Ok()
//STRIP001 
//STRIP001 /*  [Beschreibung]
//STRIP001 
//STRIP001 	"Uberladen, damit immer RET_OK zur"uckgegeben wird.
//STRIP001 */
//STRIP001 
//STRIP001 {
//STRIP001 	SfxTabDialog::Ok();
//STRIP001 	return RET_OK;
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------
//STRIP001 
//STRIP001 IMPL_LINK( SfxStyleDialog, CancelHdl, Button *, pButton )
//STRIP001 
//STRIP001 /*  [Beschreibung]
//STRIP001 
//STRIP001 	Wenn der Dialog abgebrochen wurde, m"ussen alle schon eingestellten
//STRIP001 	Attribute wieder zur"uckgesetzt werden.
//STRIP001 */
//STRIP001 
//STRIP001 {
//STRIP001 	SfxTabPage* pPage = GetTabPage( ID_TABPAGE_MANAGESTYLES );
//STRIP001 
//STRIP001 	const SfxItemSet* pInSet = GetInputSetImpl();
//STRIP001 	SfxWhichIter aIter( *pInSet );
//STRIP001 	USHORT nWhich = aIter.FirstWhich();
//STRIP001 
//STRIP001 	while ( nWhich )
//STRIP001 	{
//STRIP001 		SfxItemState eState = pInSet->GetItemState( nWhich, FALSE );
//STRIP001 
//STRIP001 		if ( SFX_ITEM_DEFAULT == eState )
//STRIP001 			pExampleSet->ClearItem( nWhich );
//STRIP001 		else
//STRIP001 			pExampleSet->Put( pInSet->Get( nWhich ) );
//STRIP001 		nWhich = aIter.NextWhich();
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( pPage )
//STRIP001 		pPage->Reset( *GetInputSetImpl() );
//STRIP001 	EndDialog( RET_CANCEL );
//STRIP001 	return 0;
//STRIP001 }


}
