/*************************************************************************
 *
 *  $RCSfile: galbrws1.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 15:51:43 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// auto strip #include <vcl/lstbox.hxx>
// auto strip #include <vcl/button.hxx>
// auto strip #include <vcl/menu.hxx>
// auto strip #include <svtools/lstner.hxx>
#include <vector>
// auto strip #include "galbrws.hxx"
namespace binfilter {

// -----------------
// - GalleryButton -
// -----------------

//STRIP001 class GalleryButton : public PushButton
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001 	virtual void	KeyInput( const KeyEvent& rKEvt );
//STRIP001 
//STRIP001 public:
//STRIP001                     
//STRIP001                     GalleryButton( GalleryBrowser1* pParent, WinBits nWinBits );
//STRIP001                     ~GalleryButton();
//STRIP001 };

// -----------------------
// - GalleryThemeListBox -
// -----------------------

//STRIP001 class GalleryThemeListBox : public ListBox
//STRIP001 {
//STRIP001 protected:
//STRIP001 
//STRIP001     void            InitSettings();
//STRIP001 
//STRIP001     virtual void    DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 	virtual long	PreNotify( NotifyEvent& rNEvt );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 					GalleryThemeListBox( GalleryBrowser1* pParent, WinBits nWinBits );
//STRIP001 					~GalleryThemeListBox();
//STRIP001 };

// -------------------
// - GalleryBrowser1 -
// -------------------

class Gallery;
class GalleryThemeEntry;
class GalleryTheme;
struct ExchangeData;

//STRIP001 class GalleryBrowser1 : public Control, SfxListener
//STRIP001 {
//STRIP001 	friend class GalleryBrowser;
//STRIP001 	friend class GalleryThemeListBox;
//STRIP001 
//STRIP001 private:
//STRIP001 
//STRIP001 	GalleryButton           maNewTheme;
//STRIP001 	GalleryThemeListBox*	mpThemes;
//STRIP001 	Gallery*				mpGallery;
//STRIP001 
//STRIP001 	void					ImplAdjustControls();
//STRIP001 	ULONG					ImplInsertThemeEntry( const GalleryThemeEntry* pEntry );
//STRIP001 	void					ImplFillExchangeData( const GalleryTheme* pThm, ExchangeData& rData );
//STRIP001     ::std::vector< USHORT > ImplGetExecuteVector();
//STRIP001     void                    ImplExecute( USHORT nId );
//STRIP001 						
//STRIP001 	// Control
//STRIP001 	virtual void			Resize();
//STRIP001 	virtual void			GetFocus();
//STRIP001 
//STRIP001 	// SfxListener
//STRIP001 	virtual void			Notify( SfxBroadcaster& rBC, const SfxHint& rHint );
//STRIP001 							
//STRIP001 							DECL_LINK( ClickNewThemeHdl, void* );
//STRIP001 							DECL_LINK( SelectThemeHdl, void* );
//STRIP001 							DECL_LINK( ShowContextMenuHdl, void* );
//STRIP001 							DECL_LINK( PopupMenuHdl, Menu* );
//STRIP001 
//STRIP001 public:						
//STRIP001 							
//STRIP001 							GalleryBrowser1( GalleryBrowser* pParent, const ResId& rResId, Gallery* pGallery );
//STRIP001 							~GalleryBrowser1();
//STRIP001 							
//STRIP001 	void					SelectTheme( const String& rThemeName ) { mpThemes->SelectEntry( rThemeName ); SelectThemeHdl( NULL ); }
//STRIP001 	void					SelectTheme( ULONG nThemePos ) { mpThemes->SelectEntryPos( (USHORT) nThemePos ); SelectThemeHdl( NULL ); }
//STRIP001 	String					GetSelectedTheme() { return mpThemes->GetEntryCount() ? mpThemes->GetEntry( mpThemes->GetSelectEntryPos() ) : String(); }
//STRIP001 
//STRIP001 	void					ShowContextMenu();
//STRIP001     BOOL                    KeyInput( const KeyEvent& rKEvt, Window* pWindow );
//STRIP001 };
}//end of namespace binfilter