/*************************************************************************
 *
 *  $RCSfile: svx_multifil.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:45:43 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

// include ---------------------------------------------------------------

#ifndef _SHL_HXX //autogen
#include <tools/shl.hxx>
#endif
#ifndef _SV_MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif

#ifndef _FILEDLGHELPER_HXX
#include <bf_sfx2/filedlghelper.hxx>
#endif

#include <tools/urlobj.hxx>
#pragma hdrstop

#include "multipat.hxx"
#include "multifil.hxx"
#include "dialmgr.hxx"

#include "multipat.hrc"
#include "dialogs.hrc"

// #97807# -------------
#ifndef _COM_SUN_STAR_UCB_XCONTENTPROVIDER_HPP_ 
#include <com/sun/star/ucb/XContentProvider.hpp>
#endif
#ifndef _UCBHELPER_CONTENTBROKER_HXX 
#include <ucbhelper/contentbroker.hxx>
#endif
namespace binfilter {

using namespace ::com::sun::star::ucb;
using namespace ::com::sun::star::uno;

// class SvxMultiFileDialog ----------------------------------------------

//STRIP001 IMPL_LINK( SvxMultiFileDialog, AddHdl_Impl, PushButton *, pBtn )
//STRIP001 {
//STRIP001     sfx2::FileDialogHelper aDlg( ::sfx2::FILEOPEN_SIMPLE, 0 );
//STRIP001 
//STRIP001 	if ( IsClassPathMode() )
//STRIP001 	{
//STRIP001 		aDlg.SetTitle( SVX_RES( RID_SVXSTR_ARCHIVE_TITLE ) );
//STRIP001 		aDlg.AddFilter( SVX_RES( RID_SVXSTR_ARCHIVE_HEADLINE ), String::CreateFromAscii("*.jar;*.zip") );
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( aDlg.Execute() == ERRCODE_NONE )
//STRIP001     {
//STRIP001 		// #97807# URL content comparison of entries -----------
//STRIP001 		INetURLObject aFile( aDlg.GetPath() );
//STRIP001 		String sInsFile = aFile.getFSysPath( INetURLObject::FSYS_DETECT );
//STRIP001 		::ucb::Content aContent( aFile.GetMainURL( INetURLObject::NO_DECODE ), Reference< XCommandEnvironment >() );
//STRIP001 		Reference< XContent > xContent = aContent.get();
//STRIP001 		OSL_ENSURE( xContent.is(), "AddHdl_Impl: invalid content interface!" );
//STRIP001 		Reference< XContentIdentifier > xID = xContent->getIdentifier();
//STRIP001 		OSL_ENSURE( xID.is(), "AddHdl_Impl: invalid ID interface!" );
//STRIP001 		// ensure the content of files are valid
//STRIP001 
//STRIP001 		USHORT nCount = aPathLB.GetEntryCount();
//STRIP001 		BOOL bDuplicated = FALSE;
//STRIP001 		try
//STRIP001 		{
//STRIP001 			if( nCount > 0 ) // start comparison
//STRIP001 			{
//STRIP001 				USHORT i;
//STRIP001 				::ucb::Content & VContent = aContent; // temporary Content reference
//STRIP001 				Reference< XContent > xVContent;
//STRIP001 				Reference< XContentIdentifier > xVID;
//STRIP001 				for( i = 0; i < nCount; i++ )
//STRIP001 				{
//STRIP001 					String sVFile = aPathLB.GetEntry( i );
//STRIP001 					std::map< String, ::ucb::Content >::iterator aCur = aFileContentMap.find( sVFile );
//STRIP001 					if( aCur == aFileContentMap.end() ) // look for File Content in aFileContentMap, but not find it.
//STRIP001 					{
//STRIP001 						INetURLObject aVFile( sVFile, INetURLObject::FSYS_DETECT );						
//STRIP001 						aFileContentMap[sVFile] = ::ucb::Content( aVFile.GetMainURL( INetURLObject::NO_DECODE ), Reference< XCommandEnvironment >() );
//STRIP001 						VContent = aFileContentMap.find( sVFile )->second;
//STRIP001 					}
//STRIP001 					else
//STRIP001 						VContent = aCur->second;
//STRIP001 					xVContent = VContent.get();
//STRIP001 					OSL_ENSURE( xVContent.is(), "AddHdl_Impl: invalid content interface!" );
//STRIP001 					xVID = xVContent->getIdentifier();
//STRIP001 					OSL_ENSURE( xVID.is(), "AddHdl_Impl: invalid ID interface!" );
//STRIP001 					if ( xID.is() && xVID.is() )
//STRIP001 					{
//STRIP001 						// get a generic content provider
//STRIP001 						::ucb::ContentBroker* pBroker = ::ucb::ContentBroker::get();
//STRIP001 						Reference< XContentProvider > xProvider;
//STRIP001 						if ( pBroker )
//STRIP001 							xProvider = pBroker->getContentProviderInterface();
//STRIP001 						if ( xProvider.is() )
//STRIP001 						{
//STRIP001 							if ( 0 == xProvider->compareContentIds( xID, xVID ) )
//STRIP001 							{
//STRIP001 								bDuplicated = TRUE;
//STRIP001 								break;
//STRIP001 							}
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 			} // end of if the entries are more than zero.
//STRIP001 		} // end of try(}
//STRIP001 		catch( const Exception& ) // catch every exception of comparison
//STRIP001    		{
//STRIP001 			OSL_ENSURE( sal_False, "AddHdl_Impl: caught an unexpected exception!" );
//STRIP001    		}
//STRIP001 
//STRIP001 		if ( bDuplicated ) // #97807# --------------------
//STRIP001 		{
//STRIP001 			String sMsg( SVX_RES( RID_SVXSTR_MULTIFILE_DBL_ERR ) );
//STRIP001 			sMsg.SearchAndReplaceAscii( "%1", sInsFile );
//STRIP001 			InfoBox( pBtn, sMsg ).Execute();
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			USHORT nPos = aPathLB.InsertEntry( sInsFile, LISTBOX_APPEND );
//STRIP001 			aPathLB.SetEntryData( nPos, (void*) new String( sInsFile ) );
//STRIP001 		}
//STRIP001 
//STRIP001 	} // end of if ( aDlg.Execute() == ERRCODE_NONE )
//STRIP001 	return 0;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 IMPL_LINK( SvxMultiFileDialog, DelHdl_Impl, PushButton *, EMPTYARG )
//STRIP001 {
//STRIP001 	USHORT nPos = aPathLB.GetSelectEntryPos();
//STRIP001 	aPathLB.RemoveEntry( nPos );
//STRIP001 	USHORT nCnt = aPathLB.GetEntryCount();
//STRIP001 
//STRIP001 	if ( nCnt )
//STRIP001 	{
//STRIP001 		nCnt--;
//STRIP001 
//STRIP001 		if ( nPos > nCnt )
//STRIP001 			nPos = nCnt;
//STRIP001 		aPathLB.SelectEntryPos( nPos );
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 SvxMultiFileDialog::SvxMultiFileDialog( Window* pParent, BOOL bEmptyAllowed ) :
//STRIP001 
//STRIP001 	SvxMultiPathDialog( pParent, bEmptyAllowed )
//STRIP001 
//STRIP001 {
//STRIP001 	aAddBtn.SetClickHdl( LINK( this, SvxMultiFileDialog, AddHdl_Impl ) );
//STRIP001 	aDelBtn.SetClickHdl( LINK( this, SvxMultiFileDialog, DelHdl_Impl ) );
//STRIP001 	SetText( SVX_RES( RID_SVXSTR_FILE_TITLE ) );
//STRIP001 	aPathGB.SetText( SVX_RES( RID_SVXSTR_FILE_HEADLINE ) );
//STRIP001 	aDelBtn.Enable();
//STRIP001 }

// -----------------------------------------------------------------------

//STRIP001 SvxMultiFileDialog::~SvxMultiFileDialog()
//STRIP001 {
//STRIP001 }


}
