/*************************************************************************
 *
 *  $RCSfile: sw_trvlfnfl.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 17:02:15 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #ifndef _SVDMODEL_HXX //autogen
// auto strip #include <bf_svx/svdmodel.hxx>
// auto strip #endif
// auto strip #ifndef _SVDPAGE_HXX //autogen
// auto strip #include <bf_svx/svdpage.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #ifndef _CRSRSH_HXX
// auto strip #include <crsrsh.hxx>
// auto strip #endif
// auto strip #ifndef _DOC_HXX
// auto strip #include <doc.hxx>
// auto strip #endif
// auto strip #ifndef _PAGEFRM_HXX
// auto strip #include <pagefrm.hxx>
// auto strip #endif
// auto strip #ifndef _CNTFRM_HXX
// auto strip #include <cntfrm.hxx>
// auto strip #endif
// auto strip #ifndef _ROOTFRM_HXX
// auto strip #include <rootfrm.hxx>
// auto strip #endif
// auto strip #ifndef _FTNBOSS_HXX
// auto strip #include <ftnboss.hxx>
// auto strip #endif
// auto strip #ifndef _FTNFRM_HXX
// auto strip #include <ftnfrm.hxx>
// auto strip #endif
#ifndef _VIEWIMP_HXX
#include <viewimp.hxx>
#endif
// auto strip #ifndef _SWCRSR_HXX
// auto strip #include <swcrsr.hxx>
// auto strip #endif
// auto strip #ifndef _DFLYOBJ_HXX
// auto strip #include <dflyobj.hxx>
// auto strip #endif
// auto strip #ifndef _NDTXT_HXX
// auto strip #include <ndtxt.hxx>
// auto strip #endif
// auto strip #ifndef _FLYFRM_HXX
// auto strip #include <flyfrm.hxx>
// auto strip #endif
// auto strip #ifndef _TXTFRM_HXX
// auto strip #include <txtfrm.hxx>
// auto strip #endif
// auto strip #ifndef _TXTFTN_HXX //autogen
// auto strip #include <txtftn.hxx>
// auto strip #endif
// auto strip #ifndef _FTNIDX_HXX //autogen
// auto strip #include <ftnidx.hxx>
// auto strip #endif
// auto strip #ifndef _VISCRS_HXX
// auto strip #include <viscrs.hxx>
// auto strip #endif
// auto strip #ifndef _CALLNK_HXX
// auto strip #include <callnk.hxx>
// auto strip #endif
namespace binfilter {

//STRIP001 FASTBOOL SwCrsrShell::CallCrsrFN( FNCrsr fnCrsr )
//STRIP001 {
//STRIP001 	SwCallLink aLk( *this );        // Crsr-Moves ueberwachen,
//STRIP001 	SwCursor* pCrsr = pTblCrsr ? pTblCrsr : pCurCrsr;
//STRIP001 	FASTBOOL bRet = (pCrsr->*fnCrsr)();
//STRIP001 	if( bRet )
//STRIP001 		UpdateCrsr( SwCrsrShell::SCROLLWIN | SwCrsrShell::CHKRANGE |
//STRIP001 					SwCrsrShell::READONLY );
//STRIP001 	return bRet;
//STRIP001 }

//STRIP001 FASTBOOL SwCursor::GotoFtnTxt()
//STRIP001 {
//STRIP001 	// springe aus dem Content zur Fussnote
//STRIP001 	FASTBOOL bRet = FALSE;
//STRIP001 	SwTxtAttr *pFtn;
//STRIP001 	SwTxtNode* pTxtNd = GetPoint()->nNode.GetNode().GetTxtNode();
//STRIP001 
//STRIP001 	if( pTxtNd && 0 != (
//STRIP001 		pFtn = pTxtNd->GetTxtAttr( GetPoint()->nContent, RES_TXTATR_FTN ) ))
//STRIP001 	{
//STRIP001 		SwCrsrSaveState aSaveState( *this );
//STRIP001 		GetPoint()->nNode = *((SwTxtFtn*)pFtn)->GetStartNode();
//STRIP001 
//STRIP001 		SwCntntNode* pCNd = GetDoc()->GetNodes().GoNextSection(
//STRIP001 											&GetPoint()->nNode,
//STRIP001 											TRUE, !IsReadOnlyAvailable() );
//STRIP001 		if( pCNd )
//STRIP001 		{
//STRIP001 			GetPoint()->nContent.Assign( pCNd, 0 );
//STRIP001 			bRet = !IsSelOvr( SELOVER_CHECKNODESSECTION | SELOVER_TOGGLE );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }

//STRIP001 FASTBOOL SwCrsrShell::GotoFtnTxt()
//STRIP001 {
//STRIP001     BOOL bRet = CallCrsrFN( &SwCursor::GotoFtnTxt );
//STRIP001     if( !bRet )
//STRIP001     {
//STRIP001         SwTxtNode* pTxtNd = _GetCrsr() ?
//STRIP001                    _GetCrsr()->GetPoint()->nNode.GetNode().GetTxtNode() : NULL;
//STRIP001         if( pTxtNd )
//STRIP001         {
//STRIP001             const SwFrm *pFrm = pTxtNd->GetFrm( &_GetCrsr()->GetSttPos(),
//STRIP001                                                  _GetCrsr()->Start() );
//STRIP001             const SwFtnBossFrm* pFtnBoss;
//STRIP001             sal_Bool bSkip = pFrm && pFrm->IsInFtn();
//STRIP001             while( pFrm && 0 != ( pFtnBoss = pFrm->FindFtnBossFrm() ) )
//STRIP001             {
//STRIP001                 if( 0 != ( pFrm = pFtnBoss->FindFtnCont() ) )
//STRIP001                 {
//STRIP001                     if( bSkip )
//STRIP001                         bSkip = sal_False;
//STRIP001                     else
//STRIP001                     {
//STRIP001                         const SwCntntFrm* pCnt = static_cast<const SwLayoutFrm*>
//STRIP001                                                         (pFrm)->ContainsCntnt();
//STRIP001                         if( pCnt )
//STRIP001                         {
//STRIP001                             const SwCntntNode* pNode = pCnt->GetNode();
//STRIP001                             _GetCrsr()->GetPoint()->nNode = *pNode;
//STRIP001                             _GetCrsr()->GetPoint()->nContent.Assign(
//STRIP001                                 const_cast<SwCntntNode*>(pNode),
//STRIP001                                 static_cast<const SwTxtFrm*>(pCnt)->GetOfst() );
//STRIP001                             UpdateCrsr( SwCrsrShell::SCROLLWIN |
//STRIP001                                 SwCrsrShell::CHKRANGE | SwCrsrShell::READONLY );
//STRIP001                             bRet = sal_True;
//STRIP001                             break;
//STRIP001                         }
//STRIP001                     }
//STRIP001                 }
//STRIP001                 if( pFtnBoss->GetNext() && !pFtnBoss->IsPageFrm() )
//STRIP001                     pFrm = pFtnBoss->GetNext();
//STRIP001                 else
//STRIP001                     pFrm = pFtnBoss->GetUpper();
//STRIP001             }
//STRIP001         }
//STRIP001     }
//STRIP001     return bRet;
//STRIP001 }


//STRIP001 FASTBOOL SwCursor::GotoFtnAnchor()
//STRIP001 {
//STRIP001 	// springe aus der Fussnote zum Anker
//STRIP001 	const SwNode* pSttNd = GetNode()->FindFootnoteStartNode();
//STRIP001 	if( pSttNd )
//STRIP001 	{
//STRIP001 		// durchsuche alle Fussnoten im Dokument nach diesem StartIndex
//STRIP001 		const SwTxtFtn* pTxtFtn;
//STRIP001 		const SwFtnIdxs& rFtnArr = pSttNd->GetDoc()->GetFtnIdxs();
//STRIP001 		for( USHORT n = 0; n < rFtnArr.Count(); ++n )
//STRIP001 			if( 0 != ( pTxtFtn = rFtnArr[ n ])->GetStartNode() &&
//STRIP001 				pSttNd == &pTxtFtn->GetStartNode()->GetNode() )
//STRIP001 			{
//STRIP001 				SwCrsrSaveState aSaveState( *this );
//STRIP001 
//STRIP001 				SwTxtNode& rTNd = (SwTxtNode&)pTxtFtn->GetTxtNode();
//STRIP001 
//STRIP001 				GetPoint()->nNode = rTNd;
//STRIP001 				GetPoint()->nContent.Assign( &rTNd, *pTxtFtn->GetStart() );
//STRIP001 
//STRIP001 				return !IsSelOvr( SELOVER_CHECKNODESSECTION | SELOVER_TOGGLE );
//STRIP001 			}
//STRIP001 	}
//STRIP001 	return FALSE;
//STRIP001 }

//STRIP001 FASTBOOL SwCrsrShell::GotoFtnAnchor()
//STRIP001 {
//STRIP001 	// springe aus der Fussnote zum Anker
//STRIP001 	SwCallLink aLk( *this );        // Crsr-Moves ueberwachen,
//STRIP001 	FASTBOOL bRet = pCurCrsr->GotoFtnAnchor();
//STRIP001 	if( bRet )
//STRIP001 	{
//STRIP001 		// BUG 5996: Tabellen-Kopfzeile sonderbehandeln
//STRIP001 		pCurCrsr->GetPtPos() = Point();
//STRIP001 		UpdateCrsr( SwCrsrShell::SCROLLWIN | SwCrsrShell::CHKRANGE |
//STRIP001 					SwCrsrShell::READONLY );
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }

//STRIP001 inline CmpLE( const SwTxtFtn& rFtn, ULONG nNd, xub_StrLen nCnt )
//STRIP001 {
//STRIP001 	ULONG nTNd = rFtn.GetTxtNode().GetIndex();
//STRIP001 	return nTNd < nNd || ( nTNd == nNd && *rFtn.GetStart() <= nCnt );
//STRIP001 }
//STRIP001 inline CmpL( const SwTxtFtn& rFtn, ULONG nNd, xub_StrLen nCnt )
//STRIP001 {
//STRIP001 	ULONG nTNd = rFtn.GetTxtNode().GetIndex();
//STRIP001 	return nTNd < nNd || ( nTNd == nNd && *rFtn.GetStart() < nCnt );
//STRIP001 }

//STRIP001 FASTBOOL SwCursor::GotoNextFtnAnchor()
//STRIP001 {
//STRIP001 	const SwFtnIdxs& rFtnArr = GetDoc()->GetFtnIdxs();
//STRIP001 	const SwTxtFtn* pTxtFtn = 0;
//STRIP001 	USHORT nPos;
//STRIP001 
//STRIP001 	if( rFtnArr.SeekEntry( GetPoint()->nNode, &nPos ))
//STRIP001 	{
//STRIP001 		// es gibt eine Fussnote mit dem Index, suche also die
//STRIP001 		// naechstgelegene
//STRIP001 		if( nPos < rFtnArr.Count() )
//STRIP001 		{
//STRIP001 			ULONG nNdPos = GetPoint()->nNode.GetIndex();
//STRIP001 			xub_StrLen nCntPos = GetPoint()->nContent.GetIndex();
//STRIP001 
//STRIP001 			pTxtFtn = rFtnArr[ nPos ];
//STRIP001 			// suche vorewaerts zur naechsten
//STRIP001 			if( CmpLE( *pTxtFtn, nNdPos, nCntPos ) )
//STRIP001 			{
//STRIP001 				pTxtFtn = 0;
//STRIP001 				for( ++nPos; nPos < rFtnArr.Count(); ++nPos )
//STRIP001 				{
//STRIP001 					pTxtFtn = rFtnArr[ nPos ];
//STRIP001 					if( !CmpLE( *pTxtFtn, nNdPos, nCntPos ) )
//STRIP001 						break;		// gefunden
//STRIP001 					pTxtFtn = 0;
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else if( nPos )
//STRIP001 			{
//STRIP001 				// suche rueckwaerts zur vorherigen
//STRIP001 				pTxtFtn = 0;
//STRIP001 				while( nPos )
//STRIP001 				{
//STRIP001 					pTxtFtn = rFtnArr[ --nPos ];
//STRIP001 					if( CmpLE( *pTxtFtn, nNdPos, nCntPos ) )
//STRIP001 					{
//STRIP001 						pTxtFtn = rFtnArr[ ++nPos ];
//STRIP001 						break;		// gefunden
//STRIP001 					}
//STRIP001 //					pTxtFtn = 0;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( nPos < rFtnArr.Count() )
//STRIP001 		pTxtFtn = rFtnArr[ nPos ];
//STRIP001 
//STRIP001 	FASTBOOL bRet = 0 != pTxtFtn;
//STRIP001 	if( bRet )
//STRIP001 	{
//STRIP001 		SwCrsrSaveState aSaveState( *this );
//STRIP001 
//STRIP001 		SwTxtNode& rTNd = (SwTxtNode&)pTxtFtn->GetTxtNode();
//STRIP001 		GetPoint()->nNode = rTNd;
//STRIP001 		GetPoint()->nContent.Assign( &rTNd, *pTxtFtn->GetStart() );
//STRIP001 		bRet = !IsSelOvr();
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }

//STRIP001 FASTBOOL SwCursor::GotoPrevFtnAnchor()
//STRIP001 {
//STRIP001 	const SwFtnIdxs& rFtnArr = GetDoc()->GetFtnIdxs();
//STRIP001 	const SwTxtFtn* pTxtFtn = 0;
//STRIP001 	USHORT nPos;
//STRIP001 
//STRIP001 	if( rFtnArr.SeekEntry( GetPoint()->nNode, &nPos ) )
//STRIP001 	{
//STRIP001 		// es gibt eine Fussnote mit dem Index, suche also die
//STRIP001 		// naechstgelegene
//STRIP001 		ULONG nNdPos = GetPoint()->nNode.GetIndex();
//STRIP001 		xub_StrLen nCntPos = GetPoint()->nContent.GetIndex();
//STRIP001 
//STRIP001 		pTxtFtn = rFtnArr[ nPos ];
//STRIP001 		// suche vorwaerts zur naechsten
//STRIP001 		if( CmpL( *pTxtFtn, nNdPos, nCntPos ))
//STRIP001 		{
//STRIP001 			for( ++nPos; nPos < rFtnArr.Count(); ++nPos )
//STRIP001 			{
//STRIP001 				pTxtFtn = rFtnArr[ nPos ];
//STRIP001 				if( !CmpL( *pTxtFtn, nNdPos, nCntPos ) )
//STRIP001 				{
//STRIP001 					pTxtFtn = rFtnArr[ nPos-1 ];
//STRIP001 					break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else if( nPos )
//STRIP001 		{
//STRIP001 			// suche rueckwaerts zur vorherigen
//STRIP001 			pTxtFtn = 0;
//STRIP001 			while( nPos )
//STRIP001 			{
//STRIP001 				pTxtFtn = rFtnArr[ --nPos ];
//STRIP001 				if( CmpL( *pTxtFtn, nNdPos, nCntPos ))
//STRIP001 					break;		// gefunden
//STRIP001 				pTxtFtn = 0;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 			pTxtFtn = 0;
//STRIP001 	}
//STRIP001 	else if( nPos )
//STRIP001 		pTxtFtn = rFtnArr[ nPos-1 ];
//STRIP001 
//STRIP001 	FASTBOOL bRet = 0 != pTxtFtn;
//STRIP001 	if( bRet )
//STRIP001 	{
//STRIP001 		SwCrsrSaveState aSaveState( *this );
//STRIP001 
//STRIP001 		SwTxtNode& rTNd = (SwTxtNode&)pTxtFtn->GetTxtNode();
//STRIP001 		GetPoint()->nNode = rTNd;
//STRIP001 		GetPoint()->nContent.Assign( &rTNd, *pTxtFtn->GetStart() );
//STRIP001 		bRet = !IsSelOvr();
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }

//STRIP001 FASTBOOL SwCursor::GotoNextFtnCntnt()
//STRIP001 {
//STRIP001 	SwCrsrSaveState aSaveState( *this );
//STRIP001 
//STRIP001 	const SwNode* pSttNd = GetNode()->FindFootnoteStartNode();
//STRIP001 	if( pSttNd )
//STRIP001 		GotoFtnAnchor();
//STRIP001 
//STRIP001 	SwTxtFtn *pFtn;
//STRIP001 	SwTxtNode* pTxtNd = GetPoint()->nNode.GetNode().GetTxtNode();
//STRIP001 
//STRIP001 	if( !pTxtNd || 0 == ( pFtn = (SwTxtFtn*)pTxtNd->GetTxtAttr(
//STRIP001 								GetPoint()->nContent, RES_TXTATR_FTN ) ))
//STRIP001 		return GotoNextFtnAnchor();
//STRIP001 
//STRIP001 	FASTBOOL bRet = FALSE;
//STRIP001 	const SwFtnIdxs& rFtnArr = GetDoc()->GetFtnIdxs();
//STRIP001 	USHORT nPos = rFtnArr.GetPos( pFtn );
//STRIP001 	if( nPos < rFtnArr.Count() - 1 )
//STRIP001 	{
//STRIP001 		pFtn = rFtnArr[ nPos + 1 ];
//STRIP001 		pTxtNd = (SwTxtNode*)&pFtn->GetTxtNode();
//STRIP001 		GetPoint()->nNode = *pTxtNd;
//STRIP001 		GetPoint()->nContent.Assign( pTxtNd, *pFtn->GetStart() );
//STRIP001 		bRet = !IsSelOvr();
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }

//STRIP001 FASTBOOL SwCursor::GotoPrevFtnCntnt()
//STRIP001 {
//STRIP001 	SwCrsrSaveState aSaveState( *this );
//STRIP001 	const SwNode* pSttNd = GetNode()->FindFootnoteStartNode();
//STRIP001 	if( pSttNd )
//STRIP001 		GotoFtnAnchor();
//STRIP001 
//STRIP001 	SwTxtFtn *pFtn;
//STRIP001 	SwTxtNode* pTxtNd = GetPoint()->nNode.GetNode().GetTxtNode();
//STRIP001 
//STRIP001 	if( !pTxtNd || 0 == ( pFtn = (SwTxtFtn*)pTxtNd->GetTxtAttr(
//STRIP001 								GetPoint()->nContent, RES_TXTATR_FTN ) ))
//STRIP001 		return GotoPrevFtnAnchor();
//STRIP001 
//STRIP001 	FASTBOOL bRet = FALSE;
//STRIP001 	const SwFtnIdxs& rFtnArr = GetDoc()->GetFtnIdxs();
//STRIP001 	USHORT nPos = rFtnArr.GetPos( pFtn );
//STRIP001 	if( nPos && USHRT_MAX != nPos )
//STRIP001 	{
//STRIP001 		pFtn = rFtnArr[ nPos - 1 ];
//STRIP001 		pTxtNd = (SwTxtNode*)&pFtn->GetTxtNode();
//STRIP001 		GetPoint()->nNode = *pTxtNd;
//STRIP001 		GetPoint()->nContent.Assign( pTxtNd, *pFtn->GetStart() );
//STRIP001 		bRet = !IsSelOvr();
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }

//STRIP001 FASTBOOL SwCrsrShell::GotoNextFtnAnchor()
//STRIP001 {
//STRIP001 	return CallCrsrFN( &SwCursor::GotoNextFtnAnchor );
//STRIP001 }

//STRIP001 FASTBOOL SwCrsrShell::GotoPrevFtnAnchor()
//STRIP001 {
//STRIP001 	return CallCrsrFN( &SwCursor::GotoPrevFtnAnchor );
//STRIP001 }

//STRIP001 FASTBOOL SwCrsrShell::GotoNextFtnCntnt()
//STRIP001 {
//STRIP001 	return CallCrsrFN( &SwCursor::GotoNextFtnCntnt );
//STRIP001 }

//STRIP001 FASTBOOL SwCrsrShell::GotoPrevFtnCntnt()
//STRIP001 {
//STRIP001 	return CallCrsrFN( &SwCursor::GotoPrevFtnCntnt );
//STRIP001 }

/*  */

// springe aus dem Content zum Rahmen

//STRIP001 FASTBOOL SwCrsrShell::GotoFlyTxt()
//STRIP001 {
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 
//STRIP001 	// alle DrawSeiten nach Objekten durchsuchen.
//STRIP001 	USHORT nMaxPages = GetDoc()->GetDrawModel() ?
//STRIP001 		GetDoc()->GetDrawModel()->GetPageCount() : 0;
//STRIP001 	if( !nMaxPages )
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	const SwFrm* pFrm = GetCurrFrm();
//STRIP001 	const SwLayoutFrm *pFndFly = 0;
//STRIP001 
//STRIP001 	Point aPt( pFrm->Frm().Pos() );
//STRIP001 	Point aNxtPt( LONG_MAX, LONG_MAX );
//STRIP001 
//STRIP001 	for( USHORT nPg = 0; nPg < nMaxPages; ++nPg )
//STRIP001 	{
//STRIP001 		SdrPage* pActPage = GetDoc()->GetDrawModel()->GetPage( nPg );
//STRIP001 		ASSERT( pActPage, "UUPs, keine Seite im Container" );
//STRIP001 
//STRIP001 		ULONG nObjs = pActPage->GetObjCount();
//STRIP001 		ASSERT( nObjs, "UUPs, was fuer Object auf der Seite" );
//STRIP001 
//STRIP001 		for( ULONG nObj = 0; nObj < nObjs; ++nObj )
//STRIP001 		{
//STRIP001 			SdrObject *pObj = pActPage->GetObj( nObj );
//STRIP001 			ASSERT( pObj ,
//STRIP001 					"UUPs, kein Object" );
//STRIP001 			SwVirtFlyDrawObj *pVirt = pObj->IsWriterFlyFrame() ?
//STRIP001 													(SwVirtFlyDrawObj*)pObj : 0;
//STRIP001 			if( pVirt && pVirt->GetFlyFrm()->Lower() &&
//STRIP001 				!pVirt->GetFlyFrm()->Lower()->IsNoTxtFrm() )
//STRIP001 			{
//STRIP001 
//STRIP001 				// Wie ist die Logik? Alle, die unterhalb des aktuellen Frames
//STRIP001 				// liegen (alle, die in den Frame hineinragen werden
//STRIP001 				// nicht beachtet !!)
//STRIP001 				Point aFlyPos( pVirt->GetFlyFrm()->Frm().Pos() );
//STRIP001 				aFlyPos += pVirt->GetFlyFrm()->Prt().Pos();
//STRIP001 				if( ( aFlyPos.Y() > aPt.Y() ||		// alle die unterhalb/daneben liegen,
//STRIP001 					( aFlyPos.Y() == aPt.Y() && aFlyPos.X() > aPt.X())) &&
//STRIP001 					( aFlyPos.Y() < aNxtPt.Y() ||	// Position kleiner
//STRIP001 					( aFlyPos.Y() == aNxtPt.Y() && aFlyPos.X() < aNxtPt.X() )) )
//STRIP001 				{
//STRIP001 					aNxtPt = aFlyPos;
//STRIP001 					pFndFly = pVirt->GetFlyFrm();
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	FASTBOOL bRet = FALSE;
//STRIP001 	if( pFndFly )
//STRIP001 	{
//STRIP001 		// Calc() ??
//STRIP001 		SwCallLink aLk( *this );        // Crsr-Moves ueberwachen,
//STRIP001 		SwCrsrSaveState aSaveState( *pCurCrsr );
//STRIP001 
//STRIP001 		aPt = pFndFly->Frm().Pos() + pFndFly->Prt().Pos();
//STRIP001 		pFndFly->GetCrsrOfst( pCurCrsr->GetPoint(), aPt );
//STRIP001 		bRet = !pCurCrsr->IsInProtectTable( TRUE ) && !pCurCrsr->IsSelOvr();
//STRIP001 		if( bRet )
//STRIP001 			UpdateCrsr( SwCrsrShell::SCROLLWIN | SwCrsrShell::CHKRANGE |
//STRIP001 						SwCrsrShell::READONLY );
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }

// springe aus dem Rahmen zum Anker


//STRIP001 FASTBOOL SwCrsrShell::GotoFlyAnchor()
//STRIP001 {
//STRIP001 	SET_CURR_SHELL( this );
//STRIP001 	const SwFrm* pFrm = GetCurrFrm();
//STRIP001 	do {
//STRIP001 		pFrm = pFrm->GetUpper();
//STRIP001 	} while( pFrm && !pFrm->IsFlyFrm() );
//STRIP001 
//STRIP001 	if( !pFrm )		// ist kein FlyFrame
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	SwCallLink aLk( *this );        // Crsr-Moves ueberwachen,
//STRIP001 	SwCrsrSaveState aSaveState( *pCurCrsr );
//STRIP001 
//STRIP001 	// springe in den BodyFrame, der am naechsten vom Fly liegt
//STRIP001 	SwRect aTmpRect( aCharRect );
//STRIP001 	if( !pFrm->Frm().IsInside( aTmpRect ))
//STRIP001 		aTmpRect = pFrm->Frm();
//STRIP001 	Point aPt( aTmpRect.Left(), aTmpRect.Top() +
//STRIP001 				( aTmpRect.Bottom() - aTmpRect.Top() ) / 2 );
//STRIP001 	aPt.X() = aPt.X() > (pFrm->Frm().Left() + (pFrm->Frm().SSize().Width() / 2 ))
//STRIP001 				? pFrm->Frm().Right()
//STRIP001 				: pFrm->Frm().Left();
//STRIP001 
//STRIP001 	const SwPageFrm* pPageFrm = pFrm->FindPageFrm();
//STRIP001 	const SwCntntFrm* pFndFrm = pPageFrm->GetCntntPos( aPt, FALSE, TRUE );
//STRIP001 	pFndFrm->GetCrsrOfst( pCurCrsr->GetPoint(), aPt );
//STRIP001 
//STRIP001 	FASTBOOL bRet = !pCurCrsr->IsInProtectTable() && !pCurCrsr->IsSelOvr();
//STRIP001 	if( bRet )
//STRIP001 		UpdateCrsr( SwCrsrShell::SCROLLWIN | SwCrsrShell::CHKRANGE |
//STRIP001 					SwCrsrShell::READONLY );
//STRIP001 	return bRet;
//STRIP001 }




}
