/*************************************************************************
 *
 *  $RCSfile: sw_docglbl.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/01/11 11:43:05 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #ifndef _HINTIDS_HXX
// auto strip #include <hintids.hxx>
// auto strip #endif

// auto strip #ifndef _UNOTOOLS_TEMPFILE_HXX
// auto strip #include <unotools/tempfile.hxx>
// auto strip #endif
// auto strip #ifndef SVTOOLS_URIHELPER_HXX
// auto strip #include <svtools/urihelper.hxx>
// auto strip #endif
// auto strip #ifndef _SFXSTRITEM_HXX
// auto strip #include <svtools/stritem.hxx>
// auto strip #endif
// auto strip #ifndef _SFXENUMITEM_HXX
// auto strip #include <svtools/eitem.hxx>
// auto strip #endif
// auto strip #ifndef _URLOBJ_HXX //autogen
// auto strip #include <tools/urlobj.hxx>
// auto strip #endif
// auto strip #ifndef _SFXAPP_HXX //autogen
// auto strip #include <bf_sfx2/app.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDOCINF_HXX
// auto strip #include <bf_sfx2/docinf.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDOCFILE_HXX
// auto strip #include <bf_sfx2/docfile.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_DOCFILT_HACK_HXX
// auto strip #include <bf_sfx2/docfilt.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_FCONTNR_HXX
// auto strip #include <bf_sfx2/fcontnr.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_BINDINGS_HXX
// auto strip #include <bf_sfx2/bindings.hxx>
// auto strip #endif
// auto strip #ifndef _SFXREQUEST_HXX
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
// auto strip #ifndef _FMTINFMT_HXX
// auto strip #include <fmtinfmt.hxx>
// auto strip #endif
// auto strip #ifndef _FMTANCHR_HXX
// auto strip #include <fmtanchr.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif
#ifndef _ERRHDL_HXX
#include <errhdl.hxx>
#endif

// auto strip #ifndef _DOC_HXX
// auto strip #include <doc.hxx>
// auto strip #endif
// auto strip #ifndef _DOCARY_HXX
// auto strip #include <docary.hxx>
// auto strip #endif
// auto strip #ifndef _PAM_HXX
// auto strip #include <pam.hxx>
// auto strip #endif
// auto strip #ifndef _NDTXT_HXX
// auto strip #include <ndtxt.hxx>
// auto strip #endif
// auto strip #ifndef _DOCSH_HXX
// auto strip #include <docsh.hxx>
// auto strip #endif
// auto strip #ifndef _GLOBDOC_HXX
// auto strip #include <globdoc.hxx>
// auto strip #endif
// auto strip #ifndef _SHELLIO_HXX
// auto strip #include <shellio.hxx>
// auto strip #endif
// auto strip #ifndef _SWUNDO_HXX
// auto strip #include <swundo.hxx>		// fuer die UndoIds
// auto strip #endif
// auto strip #ifndef _SECTION_HXX
// auto strip #include <section.hxx>
// auto strip #endif
// auto strip #ifndef _DOCTXM_HXX
// auto strip #include <doctxm.hxx>
// auto strip #endif
// auto strip #ifndef _POOLFMT_HXX
// auto strip #include <poolfmt.hxx>
// auto strip #endif
#include "so3/staticbaseurl.hxx"
namespace binfilter {

//STRIP001 enum SwSplitDocType
//STRIP001 {
//STRIP001 	SPLITDOC_TO_GLOBALDOC,
//STRIP001 	SPLITDOC_TO_HTML
//STRIP001 };

//STRIP001 BOOL SwDoc::GenerateGlobalDoc( const String& rPath,
//STRIP001 								const SwTxtFmtColl* pSplitColl )
//STRIP001 {
//STRIP001 	return SplitDoc( SPLITDOC_TO_GLOBALDOC, rPath, pSplitColl );
//STRIP001 }

//STRIP001 BOOL SwDoc::GenerateHTMLDoc( const String& rPath,
//STRIP001 								const SwTxtFmtColl* pSplitColl )
//STRIP001 {
//STRIP001 #ifdef JP_TEST
//STRIP001 	if( !pSplitColl )
//STRIP001 	{
//STRIP001 		BYTE nLvl = 1;
//STRIP001 		const SwTxtFmtColls& rFmtColls =*GetTxtFmtColls();
//STRIP001 		for( USHORT n = rFmtColls.Count(); n; )
//STRIP001 			if( nLvl == rFmtColls[ --n ]->GetOutlineLevel() )
//STRIP001 			{
//STRIP001 				pSplitColl = rFmtColls[ n ];
//STRIP001 				break;
//STRIP001 			}
//STRIP001 
//STRIP001 		if( !pSplitColl )
//STRIP001 			pSplitColl = GetTxtCollFromPool( RES_POOLCOLL_HEADLINE2 );
//STRIP001 	}
//STRIP001 #endif
//STRIP001 
//STRIP001 	return SplitDoc( SPLITDOC_TO_HTML, rPath, pSplitColl );
//STRIP001 }

//STRIP001 BOOL SwDoc::SplitDoc( USHORT eDocType, const String& rPath,
//STRIP001 						const SwTxtFmtColl* pSplitColl )
//STRIP001 {
//STRIP001 	// ueber alle Node der Vorlage Iterieren und dafuer einzelne
//STRIP001 	// Dokumente erzeugen und in diesem gegen
//STRIP001 	// - gelinkte Bereiche (GlobalDoc)
//STRIP001 	// - Links (HTML)
//STRIP001 	// austauschen.
//STRIP001 	// Am Ende wird dieses Doc als GlobalDoc/HTML-Doc gespreichert.
//STRIP001 	if( !pDocShell || !pDocShell->GetMedium() ||
//STRIP001 		( SPLITDOC_TO_GLOBALDOC == eDocType && IsGlobalDoc() ) )
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	USHORT nOutl = 0;
//STRIP001 	SwOutlineNodes* pOutlNds = (SwOutlineNodes*)&GetNodes().GetOutLineNds();
//STRIP001 	SwNodePtr pSttNd;
//STRIP001 
//STRIP001 	if( pSplitColl )
//STRIP001 	{
//STRIP001 		// wenn keine OutlineNumerierung ist, dann benutze eigenes Array
//STRIP001 		// und sammel die Nodes zusammen.
//STRIP001 		if( NO_NUMBERING == pSplitColl->GetOutlineLevel() )
//STRIP001 		{
//STRIP001 			pOutlNds = new SwOutlineNodes( 8, 8 );
//STRIP001 			SwClientIter aIter( *(SwModify*)pSplitColl );
//STRIP001 			for( SwTxtNode* pTNd = (SwTxtNode*)aIter.First( TYPE( SwTxtNode ));
//STRIP001 					pTNd; pTNd = (SwTxtNode*)aIter.Next() )
//STRIP001 				if( pTNd->GetNodes().IsDocNodes() )
//STRIP001 					pOutlNds->Insert( pTNd );
//STRIP001 
//STRIP001 			if( !pOutlNds->Count() )
//STRIP001 			{
//STRIP001 				delete pOutlNds;
//STRIP001 				return FALSE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		// dann suche die Gliederungs - Vorlage, der 1. Ebene
//STRIP001 		const SwTxtFmtColls& rFmtColls =*GetTxtFmtColls();
//STRIP001 		for( USHORT n = rFmtColls.Count(); n; )
//STRIP001 			if( !rFmtColls[ --n ]->GetOutlineLevel() )
//STRIP001 			{
//STRIP001 				pSplitColl = rFmtColls[ n ];
//STRIP001 				break;
//STRIP001 			}
//STRIP001 
//STRIP001 		if( !pSplitColl )
//STRIP001 			return FALSE;
//STRIP001 	}
//STRIP001 
//STRIP001 	const SfxFilter* pFilter;
//STRIP001 	switch( eDocType )
//STRIP001 	{
//STRIP001 	case SPLITDOC_TO_HTML:
//STRIP001 		pFilter = SwIoSystem::GetFilterOfFormat( String::CreateFromAscii(
//STRIP001 							RTL_CONSTASCII_STRINGPARAM( "HTML" )));
//STRIP001 		break;
//STRIP001 
//STRIP001 	default:
//STRIP001 //	case SPLITDOC_TO_GLOBALDOC:
//STRIP001 		pFilter = SwIoSystem::GetFilterOfFormat(
//STRIP001 									String::CreateFromAscii( FILTER_XML ));
//STRIP001 		eDocType = SPLITDOC_TO_GLOBALDOC;
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	if( !pFilter )
//STRIP001 		return FALSE;
//STRIP001 
//STRIP001 	// Undo/Redline aufjedenfall abschalten
//STRIP001 	DoUndo( FALSE );
//STRIP001 	SetRedlineMode_intern( GetRedlineMode() & ~REDLINE_ON );
//STRIP001 
//STRIP001 	String sExt( pFilter->GetSuffixes().GetToken(0, ',') );
//STRIP001 	if( !sExt.Len() )
//STRIP001 		sExt.AssignAscii( "sxw" );
//STRIP001 	if( '.' != sExt.GetChar( 0 ) )
//STRIP001 		sExt.Insert( '.', 0 );
//STRIP001 
//STRIP001 	INetURLObject aEntry(rPath);
//STRIP001 	String sLeading(aEntry.GetBase());
//STRIP001 	aEntry.removeSegment();
//STRIP001 	String sPath = aEntry.GetMainURL( INetURLObject::NO_DECODE );
//STRIP001 	utl::TempFile aTemp(sLeading,&sExt,&sPath );
//STRIP001 	aTemp.EnableKillingFile();
//STRIP001 
//STRIP001 	DateTime aTmplDate;
//STRIP001 	{
//STRIP001 		Time a2Min( 0 ); a2Min.SetMin( 2 );
//STRIP001 		aTmplDate += a2Min;
//STRIP001 	}
//STRIP001 
//STRIP001 
//STRIP001 	// alle Ungueltigen ueberspringen
//STRIP001 	while( nOutl < pOutlNds->Count() &&
//STRIP001 		pOutlNds->GetObject( nOutl )->GetIndex() < GetNodes().GetEndOfExtras().GetIndex() )
//STRIP001 		++nOutl;
//STRIP001 
//STRIP001 	do {
//STRIP001 		pSttNd = 0;
//STRIP001 
//STRIP001 		SwNodePtr pNd;
//STRIP001 		for( ; nOutl < pOutlNds->Count(); ++nOutl )
//STRIP001 			if( ( pNd = pOutlNds->GetObject( nOutl ))->GetTxtNode()->
//STRIP001 					GetTxtColl() == pSplitColl &&
//STRIP001 				!pNd->FindTableNode() )
//STRIP001 			{
//STRIP001 				pSttNd = pNd;
//STRIP001 				break;
//STRIP001 			}
//STRIP001 
//STRIP001 		if( pSttNd )
//STRIP001 		{
//STRIP001 			SwNodePtr pEndNd = 0;
//STRIP001 			for( ++nOutl; nOutl < pOutlNds->Count(); ++nOutl )
//STRIP001 			{
//STRIP001 				pNd = pOutlNds->GetObject( nOutl );
//STRIP001 				SwTxtFmtColl* pTColl = pNd->GetTxtNode()->GetTxtColl();
//STRIP001 
//STRIP001 				if( ( pTColl == pSplitColl ||
//STRIP001 					( NO_NUMBERING != pSplitColl->GetOutlineLevel() &&
//STRIP001 						pTColl->GetOutlineLevel() <
//STRIP001 						pSplitColl->GetOutlineLevel() )) &&
//STRIP001 					!pNd->FindTableNode() )
//STRIP001 				{
//STRIP001 					pEndNd = pNd;
//STRIP001 					break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 			SwNodeIndex aEndIdx( pEndNd ? *pEndNd
//STRIP001 										: GetNodes().GetEndOfContent() );
//STRIP001 
//STRIP001 			// die Nodes komplett rausschreiben
//STRIP001 			String sFileName;
//STRIP001 			if( pSttNd->GetIndex() + 1 < aEndIdx.GetIndex() )
//STRIP001 			{
//STRIP001 				SfxObjectShellRef xDocSh( new SwDocShell( SFX_CREATE_MODE_INTERNAL ));
//STRIP001 				if( xDocSh->DoInitNew( 0 ) )
//STRIP001 				{
//STRIP001 					SwDoc* pDoc = ((SwDocShell*)(&xDocSh))->GetDoc();
//STRIP001 
//STRIP001 					// die Vorlage ist das GlobalDoc
//STRIP001 					SfxDocumentInfo aDocInfo( *pDoc->GetInfo() );
//STRIP001 					aDocInfo.SetTemplateName( aEmptyStr );
//STRIP001 					aDocInfo.SetTemplateDate( aTmplDate );
//STRIP001 					aDocInfo.SetTemplateFileName( rPath );
//STRIP001 					//JP 14.06.99: Set the text of the "split para" as title
//STRIP001 					//				from the new doc. Is the current doc has
//STRIP001 					//				a title, insert it at begin.
//STRIP001 					String sTitle( aDocInfo.GetTitle() );
//STRIP001 					if( sTitle.Len() )
//STRIP001 						sTitle.AppendAscii( RTL_CONSTASCII_STRINGPARAM( ": " ));
//STRIP001 					sTitle += ((SwTxtNode*)pSttNd)->GetExpandTxt();
//STRIP001 					aDocInfo.SetTitle( sTitle );
//STRIP001 					pDoc->SetInfo( aDocInfo );
//STRIP001 
//STRIP001 					// Vorlagen ersetzen
//STRIP001 					pDoc->ReplaceStyles( *this );
//STRIP001 
//STRIP001 					// KapitelNumerierung uebernehmen
//STRIP001 					if( pOutlineRule )
//STRIP001 						pDoc->SetOutlineNumRule( *pOutlineRule );
//STRIP001 
//STRIP001 					SwNodeRange aRg( *pSttNd, 0, aEndIdx.GetNode() );
//STRIP001 					SwNodeIndex aTmpIdx( pDoc->GetNodes().GetEndOfContent() );
//STRIP001 					GetNodes()._Copy( aRg, aTmpIdx, FALSE );
//STRIP001 
//STRIP001 					// den initialen TextNode loeschen
//STRIP001 					SwNodeIndex aIdx( pDoc->GetNodes().GetEndOfExtras(), 2 );
//STRIP001 					if( aIdx.GetIndex() + 1 !=
//STRIP001 						pDoc->GetNodes().GetEndOfContent().GetIndex() )
//STRIP001 						pDoc->GetNodes().Delete( aIdx, 1 );
//STRIP001 
//STRIP001 					// alle Flys in dem Bereich
//STRIP001 					_CopyFlyInFly( aRg, aIdx );
//STRIP001 
//STRIP001 
//STRIP001 					// und noch alle Bookmarks
//STRIP001 					// ?????
//STRIP001 
//STRIP001 					utl::TempFile aTempFile2(sLeading,&sExt,&sPath );
//STRIP001 					sFileName = aTempFile2.GetURL();
//STRIP001 					SfxMedium* pTmpMed = new SfxMedium( sFileName,
//STRIP001 												STREAM_STD_READWRITE, TRUE );
//STRIP001 					pTmpMed->SetFilter( pFilter );
//STRIP001 
//STRIP001 					// fuer den HTML-Filter mussen wir aber ein Layout
//STRIP001 					// haben, damit Textrahmen/Controls/OLE-Objecte korrekt
//STRIP001 					// als Grafik exportiert werden koennen.
//STRIP001 					if( SPLITDOC_TO_HTML == eDocType &&
//STRIP001 						pDoc->GetSpzFrmFmts()->Count() )
//STRIP001 					{
//STRIP001 						/* SfxViewFrame* pFrame = */
//STRIP001 							SFX_APP()->CreateViewFrame( *xDocSh, 0, TRUE );
//STRIP001 					}
//STRIP001 					xDocSh->DoSaveAs( *pTmpMed );
//STRIP001 					xDocSh->DoSaveCompleted( pTmpMed );
//STRIP001 
//STRIP001 					// beim Fehler wird keine FileLinkSection eingefuegt
//STRIP001 					if( xDocSh->GetError() )
//STRIP001 						sFileName.Erase();
//STRIP001 				}
//STRIP001 				xDocSh->DoClose();
//STRIP001 			}
//STRIP001 
//STRIP001 			// dann koennen ja die Bereiche eingefuegt werden
//STRIP001 			if( sFileName.Len() )
//STRIP001 			{
//STRIP001 				switch( eDocType )
//STRIP001 				{
//STRIP001 				case SPLITDOC_TO_HTML:
//STRIP001 					{
//STRIP001 						// loesche alle Nodes im Bereich und setze im "Start-
//STRIP001 						// Node" den Link auf das gespeicherte Doc
//STRIP001 						ULONG nNodeDiff = aEndIdx.GetIndex() -
//STRIP001 											pSttNd->GetIndex() - 1;
//STRIP001 						if( nNodeDiff )
//STRIP001 						{
//STRIP001 							SwPaM aTmp( *pSttNd, aEndIdx.GetNode(), 1, -1 );
//STRIP001 							aTmp.GetPoint()->nContent.Assign( 0, 0 );
//STRIP001 							aTmp.GetMark()->nContent.Assign( 0, 0 );
//STRIP001 							SwNodeIndex aSIdx( aTmp.GetMark()->nNode );
//STRIP001 							SwNodeIndex aEIdx( aTmp.GetPoint()->nNode );
//STRIP001 
//STRIP001 							// versuche hinters Ende zu verschieben
//STRIP001 							if( !aTmp.Move( fnMoveForward, fnGoNode ) )
//STRIP001 							{
//STRIP001 								// na gut, dann an den Anfang
//STRIP001 								aTmp.Exchange();
//STRIP001 								if( !aTmp.Move( fnMoveBackward, fnGoNode ))
//STRIP001 								{
//STRIP001 									ASSERT( FALSE, "kein Node mehr vorhanden" );
//STRIP001 								}
//STRIP001 							}
//STRIP001 								// Bookmarks usw. verschieben
//STRIP001 							CorrAbs( aSIdx, aEIdx, *aTmp.GetPoint(), TRUE);
//STRIP001 
//STRIP001 							// stehen noch FlyFrames rum, loesche auch diese
//STRIP001 							const SwPosition* pAPos;
//STRIP001 							for( USHORT n = 0; n < GetSpzFrmFmts()->Count(); ++n )
//STRIP001 							{
//STRIP001 								SwFrmFmt* pFly = (*GetSpzFrmFmts())[n];
//STRIP001 								const SwFmtAnchor* pAnchor = &pFly->GetAnchor();
//STRIP001 								if( ( FLY_AT_CNTNT == pAnchor->GetAnchorId() ||
//STRIP001 										FLY_AUTO_CNTNT == pAnchor->GetAnchorId() ) &&
//STRIP001 									0 != ( pAPos = pAnchor->GetCntntAnchor() ) &&
//STRIP001 									aSIdx <= pAPos->nNode &&
//STRIP001 									pAPos->nNode < aEIdx )
//STRIP001 								{
//STRIP001 									DelLayoutFmt( pFly );
//STRIP001 									--n;
//STRIP001 								}
//STRIP001 							}
//STRIP001 
//STRIP001 							GetNodes().Delete( aSIdx, nNodeDiff );
//STRIP001 						}
//STRIP001 
//STRIP001 						// dann setze im StartNode noch den Link:
//STRIP001 						SwFmtINetFmt aINet( so3::StaticBaseUrl::SmartRelToAbs(
//STRIP001 												sFileName ), aEmptyStr );
//STRIP001 						SwTxtNode* pTNd = (SwTxtNode*)pSttNd;
//STRIP001 						pTNd->Insert( aINet, 0, pTNd->GetTxt().Len() );
//STRIP001 
//STRIP001 						// wenn der nicht mehr gefunden wird, kann das nur
//STRIP001 						// ein Bug sein!
//STRIP001 						if( !pOutlNds->Seek_Entry( pSttNd, &nOutl ))
//STRIP001 							pSttNd = 0;
//STRIP001 						++nOutl;
//STRIP001 					}
//STRIP001 					break;
//STRIP001 
//STRIP001 				default:
//STRIP001 					{
//STRIP001 						String sNm( INetURLObject( sFileName ).GetName() );
//STRIP001 						SwSection aSect( FILE_LINK_SECTION,
//STRIP001 										GetUniqueSectionName( &sNm ));
//STRIP001 						SwSectionFmt* pFmt = MakeSectionFmt( 0 );
//STRIP001 						aSect.SetLinkFileName(
//STRIP001 							so3::StaticBaseUrl::SmartRelToAbs( sFileName ) );
//STRIP001 						aSect.SetProtect();
//STRIP001 
//STRIP001 						aEndIdx--;	// im InsertSection ist Ende inclusive
//STRIP001 						while( aEndIdx.GetNode().IsStartNode() )
//STRIP001 							aEndIdx--;
//STRIP001 
//STRIP001 						// JP 06.07.99 - Bug 67361 - is any Section ends or
//STRIP001 						// starts in the new sectionrange, they must end or
//STRIP001 						// start before or behind the range!
//STRIP001 						SwSectionNode* pSectNd = pSttNd->FindSectionNode();
//STRIP001 						while( pSectNd && pSectNd->EndOfSectionIndex()
//STRIP001 								<= aEndIdx.GetIndex() )
//STRIP001 						{
//STRIP001 							const SwNode* pSectEnd = pSectNd->EndOfSectionNode();
//STRIP001 							if( pSectNd->GetIndex() + 1 ==
//STRIP001 									pSttNd->GetIndex() )
//STRIP001 							{
//STRIP001 								BOOL bMvIdx = aEndIdx == *pSectEnd;
//STRIP001 								DelSectionFmt( pSectNd->GetSection().GetFmt() );
//STRIP001 								if( bMvIdx )
//STRIP001 									aEndIdx--;
//STRIP001 							}
//STRIP001 							else
//STRIP001 							{
//STRIP001 								SwNodeRange aRg( *pSttNd, *pSectEnd );
//STRIP001 								SwNodeIndex aIdx( *pSectEnd, 1 );
//STRIP001 								GetNodes()._MoveNodes( aRg, GetNodes(), aIdx );
//STRIP001 							}
//STRIP001 							pSectNd = pSttNd->FindSectionNode();
//STRIP001 						}
//STRIP001 
//STRIP001 						pSectNd = aEndIdx.GetNode().FindSectionNode();
//STRIP001 						while( pSectNd && pSectNd->GetIndex() >
//STRIP001 								pSttNd->GetIndex() )
//STRIP001 						{
//STRIP001 							SwNodeRange aRg( *pSectNd, 1, aEndIdx, 1 );
//STRIP001 							SwNodeIndex aIdx( *pSectNd );
//STRIP001 							GetNodes()._MoveNodes( aRg, GetNodes(), aIdx );
//STRIP001 
//STRIP001 							pSectNd = pSttNd->FindSectionNode();
//STRIP001 						}
//STRIP001 
//STRIP001 						pSectNd = GetNodes().InsertSection(
//STRIP001 											SwNodeIndex( *pSttNd ),
//STRIP001 											*pFmt, aSect, &aEndIdx, FALSE );
//STRIP001 						pSectNd->GetSection().CreateLink( CREATE_CONNECT );
//STRIP001 					}
//STRIP001 					break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	} while( pSttNd );
//STRIP001 
//STRIP001 //	if( pOutlNds != (SwOutlineNodes*)&GetNodes().GetOutLineNds();
//STRIP001 	if( pOutlNds != &GetNodes().GetOutLineNds() )
//STRIP001 		delete pOutlNds;
//STRIP001 
//STRIP001 	SfxFilter* pDelFilter = 0;
//STRIP001 	SfxFactoryFilterContainer* pFCntnr;
//STRIP001 
//STRIP001 #ifdef DBG_UTIL
//STRIP001 	USHORT nFltCnt;
//STRIP001 #endif
//STRIP001 
//STRIP001 	switch( eDocType )
//STRIP001 	{
//STRIP001 	case SPLITDOC_TO_HTML:
//STRIP001 		if( IsGlobalDoc() )
//STRIP001 		{
//STRIP001 			// dann alles verbliebenen Bereiche aufheben
//STRIP001 			while( GetSections().Count() )
//STRIP001 				DelSectionFmt( GetSections()[ 0 ] );
//STRIP001 
//STRIP001 			// normally the GlobalDocShell has no HTML filter, but we can
//STRIP001 			// write the format. So for the SFX we must make sure that a
//STRIP001 			// HTML filter for this Factory exist. So add here a copy of the
//STRIP001 			// DocShell filter and remove it after the saving. Bug 93556
//STRIP001 			pDelFilter = new SfxFilter( *pFilter );
//STRIP001 			pFCntnr = pDocShell->GetFactory().GetFilterContainer();
//STRIP001 #ifdef DBG_UTIL
//STRIP001 			nFltCnt = pFCntnr->GetFilterCount();
//STRIP001 #endif
//STRIP001 			pFCntnr->AddFilter( pDelFilter, 0 );
//STRIP001 
//STRIP001 #ifdef DBG_UTIL
//STRIP001 			ASSERT( nFltCnt != pFCntnr->GetFilterCount(), "can't add the filter" );
//STRIP001 #endif
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 //	case SPLITDOC_TO_GLOBALDOC:
//STRIP001 	default:
//STRIP001 		// dann das Globaldoc speichern
//STRIP001 		SetGlobalDoc( TRUE );
//STRIP001 		SetGlblDocSaveLinks( FALSE );
//STRIP001 	}
//STRIP001 
//STRIP001 	//JP 23.8.2001: use ExecuteSlot instead of Save & SaveCompleted - so the
//STRIP001 	//				Medium istn't locked after reopen the document. Bug 91462
//STRIP001     SfxRequest aReq( SID_SAVEASDOC, SFX_CALLMODE_SYNCHRON, GetAttrPool() );
//STRIP001 	aReq.AppendItem( SfxStringItem( SID_FILE_NAME, rPath ) );
//STRIP001 	aReq.AppendItem( SfxBoolItem( SID_SAVETO, sal_True ) );
//STRIP001 	aReq.AppendItem( SfxStringItem( SID_FILTER_NAME, pFilter->GetName() ) );
//STRIP001 	const SfxBoolItem *pRet = (const SfxBoolItem*)pDocShell->ExecuteSlot( aReq );
//STRIP001 
//STRIP001 	if( pDelFilter )
//STRIP001 	{
//STRIP001 		pFCntnr->DeleteFilter( pDelFilter );
//STRIP001 #ifdef DBG_UTIL
//STRIP001 		ASSERT( nFltCnt == pFCntnr->GetFilterCount(), "can't remove the filter" );
//STRIP001 #endif
//STRIP001 	}
//STRIP001 
//STRIP001 	return pRet && pRet->GetValue();
//STRIP001 }


}
