/*************************************************************************
 *
 *  $RCSfile: sw_edfmt.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 17:20:36 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

#include "doc.hxx"
#include "editsh.hxx"
// auto strip #include "swtable.hxx"
// auto strip #include "pam.hxx"
// auto strip #ifndef _DOCARY_HXX
// auto strip #include <docary.hxx>
// auto strip #endif

#ifndef _FCHRFMT_HXX //autogen
#include <fchrfmt.hxx>
#endif
// auto strip #ifndef _FRMFMT_HXX //autogen
// auto strip #include <frmfmt.hxx>
// auto strip #endif
// auto strip #ifndef _CHARFMT_HXX //autogen
// auto strip #include <charfmt.hxx>
// auto strip #endif
// auto strip #include "ndtxt.hxx"    // Fuer GetXXXFmt
// auto strip #include "hints.hxx"
namespace binfilter {

/*************************************
 * Formate
 *************************************/
// Char
// OPT: inline


//STRIP001 USHORT SwEditShell::GetCharFmtCount() const
//STRIP001 {
//STRIP001 	return GetDoc()->GetCharFmts()->Count();
//STRIP001 }


//STRIP001 SwCharFmt& SwEditShell::GetCharFmt(USHORT nFmt) const
//STRIP001 {
//STRIP001 	return *((*(GetDoc()->GetCharFmts()))[nFmt]);
//STRIP001 }


/*N*/ SwCharFmt* SwEditShell::GetCurCharFmt() const
/*N*/ {
/*N*/ 	SwCharFmt *pFmt = 0;
/*N*/ 	SfxItemSet aSet( GetDoc()->GetAttrPool(), RES_TXTATR_CHARFMT,
/*N*/ 												RES_TXTATR_CHARFMT );
/*N*/ 	const SfxPoolItem* pItem;
/*N*/ 	if( GetAttr( aSet ) && SFX_ITEM_SET ==
/*N*/ 		aSet.GetItemState( RES_TXTATR_CHARFMT, FALSE, &pItem ) )
/*N*/ 		pFmt = ((SwFmtCharFmt*)pItem)->GetCharFmt();
/*N*/ 
/*N*/ 	return pFmt;
/*N*/ }


//STRIP001 void SwEditShell::FillByEx(SwCharFmt* pCharFmt, BOOL bReset)
//STRIP001 {
//STRIP001 	if ( bReset )
//STRIP001 		pCharFmt->ResetAllAttr();
//STRIP001 
//STRIP001 	SwPaM* pPam = GetCrsr();
//STRIP001 	const SwCntntNode* pCNd = pPam->GetCntntNode();
//STRIP001 	if( pCNd->IsTxtNode() )
//STRIP001 	{
//STRIP001 		xub_StrLen nStt, nEnd;
//STRIP001 		if( pPam->HasMark() )
//STRIP001 		{
//STRIP001 			const SwPosition* pPtPos = pPam->GetPoint();
//STRIP001 			const SwPosition* pMkPos = pPam->GetMark();
//STRIP001 			if( pPtPos->nNode == pMkPos->nNode )		// im selben Node ?
//STRIP001 			{
//STRIP001 				nStt = pPtPos->nContent.GetIndex();
//STRIP001 				if( nStt < pMkPos->nContent.GetIndex() )
//STRIP001 					nEnd = pMkPos->nContent.GetIndex();
//STRIP001 				else
//STRIP001 				{
//STRIP001 					nEnd = nStt;
//STRIP001 					nStt = pMkPos->nContent.GetIndex();
//STRIP001 				}
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				nStt = pMkPos->nContent.GetIndex();
//STRIP001 				if( pPtPos->nNode < pMkPos->nNode )
//STRIP001 				{
//STRIP001 					nEnd = nStt;
//STRIP001 					nStt = 0;
//STRIP001 				}
//STRIP001 				else
//STRIP001 					nEnd = ((SwTxtNode*)pCNd)->GetTxt().Len();
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 			nStt = nEnd = pPam->GetPoint()->nContent.GetIndex();
//STRIP001 
//STRIP001 		SfxItemSet aSet( pDoc->GetAttrPool(),
//STRIP001 							pCharFmt->GetAttrSet().GetRanges() );
//STRIP001 		((SwTxtNode*)pCNd)->GetAttr( aSet, nStt, nEnd );
//STRIP001 		pCharFmt->SetAttr( aSet );
//STRIP001 	}
//STRIP001 	else if( pCNd->GetpSwAttrSet() )
//STRIP001 		pCharFmt->SetAttr( *pCNd->GetpSwAttrSet() );
//STRIP001 }

// Frm
//STRIP001 USHORT SwEditShell::GetTblFrmFmtCount(BOOL bUsed) const
//STRIP001 {
//STRIP001 	return GetDoc()->GetTblFrmFmtCount(bUsed);
//STRIP001 }

//STRIP001 SwFrmFmt& SwEditShell::GetTblFrmFmt(USHORT nFmt, BOOL bUsed ) const
//STRIP001 {
//STRIP001 	return GetDoc()->GetTblFrmFmt(nFmt, bUsed );
//STRIP001 }

//STRIP001 String SwEditShell::GetUniqueTblName() const
//STRIP001 {
//STRIP001 	return GetDoc()->GetUniqueTblName();
//STRIP001 }


//STRIP001 SwCharFmt* SwEditShell::MakeCharFmt( const String& rName,
//STRIP001 									SwCharFmt* pDerivedFrom )
//STRIP001 {
//STRIP001 	if( !pDerivedFrom )
//STRIP001 		pDerivedFrom = GetDoc()->GetDfltCharFmt();
//STRIP001 
//STRIP001 	return GetDoc()->MakeCharFmt( rName, pDerivedFrom );
//STRIP001 }

//----------------------------------
// inlines im Product


//STRIP001 SwTxtFmtColl* SwEditShell::GetTxtCollFromPool( USHORT nId )
//STRIP001 {
//STRIP001 	return GetDoc()->GetTxtCollFromPool( nId );
//STRIP001 }


	// return das geforderte automatische  Format - Basis-Klasse !
//STRIP001 SwFmt* SwEditShell::GetFmtFromPool( USHORT nId )
//STRIP001 {
//STRIP001 	return GetDoc()->GetFmtFromPool( nId );
//STRIP001 }


//STRIP001 SwPageDesc* SwEditShell::GetPageDescFromPool( USHORT nId )
//STRIP001 {
//STRIP001 	return GetDoc()->GetPageDescFromPool( nId );
//STRIP001 }


//STRIP001 BOOL SwEditShell::IsUsed( const SwModify& rModify ) const
//STRIP001 {
//STRIP001 	return pDoc->IsUsed( rModify );
//STRIP001 }

//STRIP001 const SwFlyFrmFmt* SwEditShell::FindFlyByName( const String& rName, BYTE nNdTyp ) const
//STRIP001 {
//STRIP001 	return pDoc->FindFlyByName(rName, nNdTyp);
//STRIP001 }

//STRIP001 SwCharFmt* SwEditShell::FindCharFmtByName( const String& rName ) const
//STRIP001 {
//STRIP001 	return pDoc->FindCharFmtByName( rName );
//STRIP001 }

//STRIP001 SwFrmFmt* SwEditShell::FindFrmFmtByName( const String& rName ) const
//STRIP001 {
//STRIP001 	return pDoc->FindFrmFmtByName( rName );
//STRIP001 }

//STRIP001 SwTxtFmtColl* SwEditShell::FindTxtFmtCollByName( const String& rName ) const
//STRIP001 {
//STRIP001 	return pDoc->FindTxtFmtCollByName( rName );
//STRIP001 }

//STRIP001 #ifdef USED

//STRIP001 SwGrfFmtColl* SwEditShell::FindGrfFmtCollByName( const String& rName ) const
//STRIP001 {
//STRIP001 	return pDoc->FindGrfFmtCollByName( rName );
//STRIP001 }
//STRIP001 #endif





}
