/*************************************************************************
 *
 *  $RCSfile: sw_pamcor.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:49:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#include "editsh.hxx"
#include "pam.hxx"

#include "edimp.hxx"
namespace binfilter {


/*
 * MACROS um ueber alle CrsrShells zu iterieren
 */
//STRIP001 #define PCURSH ((SwCrsrShell*)_pStartShell)
//STRIP001 #define FOREACHSHELL_START( pEShell ) \
//STRIP001     {\
//STRIP001 		register ViewShell *_pStartShell = pEShell; \
//STRIP001 		do { \
//STRIP001 			if( _pStartShell->IsA( TYPE( SwCrsrShell )) ) \
//STRIP001 			{

//STRIP001 #define FOREACHSHELL_END( pEShell ) \
//STRIP001 			} \
//STRIP001         } while((_pStartShell=(ViewShell*)_pStartShell->GetNext())!= pEShell ); \
//STRIP001 	}

/*  */

//STRIP001 #define _PaMCorrAbs2( pPam ) \
//STRIP001 	for( int nb = 0; nb < 2; ++nb )	\
//STRIP001 		if( (pPam)->GetBound( BOOL(nb) ).nNode == nOldNode )	\
//STRIP001 		{ \
//STRIP001 			(pPam)->GetBound( BOOL(nb) ) = aNewPos; \
//STRIP001 			(pPam)->GetBound( BOOL(nb) ).nContent += nOffset; \
//STRIP001 		}



//STRIP001 void PaMCorrAbs( SwEditShell* pShell,
//STRIP001 				const SwNodeIndex &rOldNode,
//STRIP001 				const SwPosition &rNewPos,
//STRIP001 				const USHORT nOffset)
//STRIP001 {
//STRIP001 	const ULONG nOldNode = rOldNode.GetIndex();
//STRIP001 	const SwPosition aNewPos( rNewPos );
//STRIP001 
//STRIP001 	FOREACHSHELL_START( pShell )
//STRIP001 		register SwPaM *_pStkCrsr = PCURSH->GetStkCrsr();
//STRIP001 // Alle ueberfluessigen Crsr sind vom Stack, oder ??
//STRIP001 //		ASSERT( !_pStkCrsr, "Es stehen noch Crsr auf dem CrsrStack" );
//STRIP001 		if( _pStkCrsr )
//STRIP001 		do {
//STRIP001 			_PaMCorrAbs2( _pStkCrsr )
//STRIP001 		} while ( (_pStkCrsr != 0 ) &&
//STRIP001 			((_pStkCrsr=(SwPaM *)_pStkCrsr->GetNext()) != PCURSH->GetStkCrsr()) );
//STRIP001 
//STRIP001 		FOREACHPAM_START(PCURSH)
//STRIP001 			_PaMCorrAbs2( PCURCRSR )
//STRIP001 		FOREACHPAM_END(PCURSH)
//STRIP001 		if( PCURSH->IsTableMode() )
//STRIP001 			_PaMCorrAbs2( PCURSH->GetTblCrs() )
//STRIP001 
//STRIP001 	FOREACHSHELL_END( pShell )
//STRIP001 }


//STRIP001 void SwEditShell::PaMCorrAbs( const SwNodeIndex &rOldNode,
//STRIP001 							  const SwPosition &rNewPos,
//STRIP001 							  const USHORT nOffset )
//STRIP001 {
//STRIP001 	// alle Verzeichnisse/Bookmarks/.. verschieben.
//STRIP001 	GetDoc()->CorrAbs( rOldNode, rNewPos, nOffset );
//STRIP001 	::PaMCorrAbs( this, rOldNode, rNewPos, nOffset );
//STRIP001 }

/*  */

//STRIP001 #define _PaMCorrAbs3( pPam ) \
//STRIP001 	for( int nb = 0; nb < 2; ++nb )	\
//STRIP001 		if( (pPam)->GetBound( BOOL(nb) ).nNode >= nSttNode && \
//STRIP001 			(pPam)->GetBound( BOOL(nb) ).nNode <= nEndNode ) \
//STRIP001 			(pPam)->GetBound( BOOL(nb) ) = aNewPos;



//STRIP001 void PaMCorrAbs( SwEditShell* pShell,
//STRIP001 				 const SwNodeIndex &rStartNode,
//STRIP001 				 const SwNodeIndex &rEndNode,
//STRIP001 				 const SwPosition &rNewPos )
//STRIP001 {
//STRIP001 	const ULONG nSttNode = rStartNode.GetIndex();
//STRIP001 	const ULONG nEndNode = rEndNode.GetIndex();
//STRIP001 	const SwPosition aNewPos( rNewPos );
//STRIP001 
//STRIP001 	FOREACHSHELL_START( pShell )
//STRIP001 		register SwPaM *_pStkCrsr = PCURSH->GetStkCrsr();
//STRIP001 // Alle ueberfluessigen Crsr sind vom Stack, oder ??
//STRIP001 //		ASSERT( !_pStkCrsr, "Es stehen noch Crsr auf dem CrsrStack" );
//STRIP001 		if( _pStkCrsr )
//STRIP001 		do {
//STRIP001 			_PaMCorrAbs3( _pStkCrsr )
//STRIP001 		} while ( (_pStkCrsr != 0 ) &&
//STRIP001 			((_pStkCrsr=(SwPaM *)_pStkCrsr->GetNext()) != PCURSH->GetStkCrsr()) );
//STRIP001 
//STRIP001 		FOREACHPAM_START(PCURSH)
//STRIP001 			_PaMCorrAbs3( PCURCRSR )
//STRIP001 		FOREACHPAM_END(PCURSH)
//STRIP001 
//STRIP001 		if( PCURSH->IsTableMode() )
//STRIP001 			_PaMCorrAbs3( PCURSH->GetTblCrs() )
//STRIP001 
//STRIP001 	FOREACHSHELL_END( pShell )
//STRIP001 }


//STRIP001 void SwEditShell::PaMCorrAbs( const SwNodeIndex &rStartNode,
//STRIP001 							  const SwNodeIndex &rEndNode,
//STRIP001 							  const SwPosition &rNewPos )
//STRIP001 {
//STRIP001 	// alle Verzeichnisse/Bookmarks/.. verschieben.
//STRIP001 	GetDoc()->CorrAbs( rStartNode, rEndNode, rNewPos );
//STRIP001 	::PaMCorrAbs( this, rStartNode, rEndNode, rNewPos );
//STRIP001 }

/*  */

//STRIP001 #define _PaMCorrRel1( pPam ) \
//STRIP001 	for( int nb = 0; nb < 2; ++nb )	\
//STRIP001 		if( (pPam)->GetBound( BOOL(nb) ).nNode == nOldNode ) \
//STRIP001 		{ \
//STRIP001             (pPam)->GetBound( BOOL(nb) ).nNode = aNewPos.nNode; \
//STRIP001 			(pPam)->GetBound( BOOL(nb) ).nContent.Assign( (SwIndexReg*) \
//STRIP001 							aNewPos.nContent.GetIdxReg(), \
//STRIP001 							nCntIdx + (pPam)->GetBound( BOOL(nb) ).nContent. \
//STRIP001 								GetIndex() ); \
//STRIP001 		}



//STRIP001 void PaMCorrRel( SwEditShell *pShell,
//STRIP001 				 const SwNodeIndex &rOldNode,
//STRIP001 				 const SwPosition &rNewPos,
//STRIP001 				 const USHORT nOffset )
//STRIP001 {
//STRIP001 	const ULONG nOldNode = rOldNode.GetIndex();
//STRIP001 	SwPosition aNewPos( rNewPos );
//STRIP001 	USHORT nCntIdx = rNewPos.nContent.GetIndex() + nOffset;
//STRIP001 
//STRIP001 	FOREACHSHELL_START( pShell )
//STRIP001 		register SwPaM *_pStkCrsr = PCURSH->GetStkCrsr();
//STRIP001 // Alle ueberfluessigen Crsr sind vom Stack, oder ??
//STRIP001 //		ASSERT( !_pStkCrsr, "Es stehen noch Crsr auf dem CrsrStack" );
//STRIP001 		if( _pStkCrsr )
//STRIP001 		do {
//STRIP001 			_PaMCorrRel1( _pStkCrsr )
//STRIP001 		} while ( (_pStkCrsr != 0 ) &&
//STRIP001 			((_pStkCrsr=(SwPaM *)_pStkCrsr->GetNext()) != PCURSH->GetStkCrsr()) );
//STRIP001 
//STRIP001 		FOREACHPAM_START(PCURSH)
//STRIP001 			_PaMCorrRel1( PCURCRSR )
//STRIP001 		FOREACHPAM_END(PCURSH)
//STRIP001 
//STRIP001 		if( PCURSH->IsTableMode() )
//STRIP001 			_PaMCorrRel1( PCURSH->GetTblCrs() )
//STRIP001 
//STRIP001 	FOREACHSHELL_END( pShell )
//STRIP001 }


//STRIP001 void SwEditShell::PaMCorrRel( const SwNodeIndex &rOldNode,
//STRIP001 							  const SwPosition &rNewPos,
//STRIP001 							  const USHORT nOffset )
//STRIP001 {
//STRIP001 	// alle Verzeichnisse/Bookmarks/.. verschieben.
//STRIP001 	GetDoc()->CorrRel( rOldNode, rNewPos, nOffset );
//STRIP001 	::PaMCorrRel( this, rOldNode, rNewPos, nOffset );
//STRIP001 }

/*  */


//STRIP001 void lcl_PaMCorrAbs( SwPaM* pPam, const SwPosition& rStt,
//STRIP001 						const SwPosition& rEnd, const SwPosition& rNewPos )
//STRIP001 {
//STRIP001 	if( rStt <= pPam->GetBound() && pPam->GetBound() <= rEnd )
//STRIP001 		// dann auf die neue Position setzen
//STRIP001 		pPam->GetBound() = rNewPos;
//STRIP001 
//STRIP001 	// teste, ob sich die Position innerhalb des Ranges befindet
//STRIP001 	if( rStt <= pPam->GetBound(FALSE) && pPam->GetBound(FALSE) <= rEnd )
//STRIP001 		pPam->GetBound(FALSE) = rNewPos;
//STRIP001 }


//STRIP001 void PaMCorrAbs( SwEditShell *pShell,
//STRIP001 				const SwPaM& rRange,
//STRIP001 				const SwPosition& rNewPos )
//STRIP001 {
//STRIP001 	SwPosition aStart( *rRange.Start() );
//STRIP001 	SwPosition aEnd( *rRange.End() );
//STRIP001 	SwPosition aNewPos( rNewPos );
//STRIP001 
//STRIP001 	FOREACHSHELL_START( pShell )
//STRIP001 		register SwPaM *_pStkCrsr = PCURSH->GetStkCrsr();
//STRIP001 // Alle ueberfluessigen Crsr sind vom Stack, oder ??
//STRIP001 //		ASSERT( !_pStkCrsr, "Es stehen noch Crsr auf dem CrsrStack" );
//STRIP001 		if( _pStkCrsr )
//STRIP001 		do {
//STRIP001 			lcl_PaMCorrAbs( _pStkCrsr, aStart, aEnd, aNewPos );
//STRIP001 		} while ( (_pStkCrsr != 0 ) &&
//STRIP001 			((_pStkCrsr=(SwPaM *)_pStkCrsr->GetNext()) != PCURSH->GetStkCrsr()) );
//STRIP001 
//STRIP001 		FOREACHPAM_START(PCURSH)
//STRIP001 			lcl_PaMCorrAbs( PCURCRSR, aStart, aEnd, aNewPos );
//STRIP001 		FOREACHPAM_END(PCURSH)
//STRIP001 
//STRIP001 		if( PCURSH->IsTableMode() )
//STRIP001 			lcl_PaMCorrAbs( PCURSH->GetTblCrs(), aStart, aEnd, aNewPos );
//STRIP001 
//STRIP001 	FOREACHSHELL_END( pShell )
//STRIP001 }


//STRIP001 void SwEditShell::PaMCorrAbs( const SwPaM& rRange, const SwPosition& rNewPos )
//STRIP001 {
//STRIP001 	// alle Verzeichnisse/Bookmarks/.. verschieben.
//STRIP001 	GetDoc()->CorrAbs( rRange, rNewPos );
//STRIP001 	::PaMCorrAbs( this, rRange, rNewPos );
//STRIP001 }



}
