/*************************************************************************
 *
 *  $RCSfile: acorrect.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:49:47 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _ACORRECT_HXX
#define _ACORRECT_HXX

#ifndef _MySVXACORR_HXX //autogen
#include <bf_svx/svxacorr.hxx>
#endif
namespace binfilter {

class SwEditShell;
class SwPaM;
class SwNodeIndex;
struct SwPosition;

class SwDontExpandItem
{
	SfxItemSet* pDontExpItems;
public:
	SwDontExpandItem() :
		pDontExpItems(0){}
//STRIP001 	~SwDontExpandItem();

//STRIP001 	void SaveDontExpandItems( const SwPosition& rPos );
//STRIP001 	void RestoreDontExpandItems( const SwPosition& rPos );

};

//STRIP001 class SwAutoCorrDoc : public SvxAutoCorrDoc
//STRIP001 {
//STRIP001 	SwEditShell& rEditSh;
//STRIP001 	SwPaM& rCrsr;
//STRIP001 	SwNodeIndex* pIdx;
//STRIP001 	USHORT nUndoId;
//STRIP001 
//STRIP001 	void DeleteSel( SwPaM& rDelPam );
//STRIP001 
//STRIP001 public:
//STRIP001 	SwAutoCorrDoc( SwEditShell& rEditShell, SwPaM& rPam, sal_Unicode cIns = 0 );
//STRIP001 	~SwAutoCorrDoc();
//STRIP001 
//STRIP001 	virtual BOOL Delete( xub_StrLen nStt, xub_StrLen nEnd );
//STRIP001 	virtual BOOL Insert( xub_StrLen nPos, const String& rTxt );
//STRIP001 	virtual BOOL Replace( xub_StrLen nPos, const String& rTxt );
//STRIP001 
//STRIP001 	virtual BOOL SetAttr( xub_StrLen nStt, xub_StrLen nEnd, USHORT nSlotId,
//STRIP001 							SfxPoolItem& );
//STRIP001 
//STRIP001 	virtual BOOL SetINetAttr( xub_StrLen nStt, xub_StrLen nEnd, const String& rURL );
//STRIP001 
//STRIP001 	// returne den Text eines vorherigen Absatzes.
//STRIP001 	// Dieser darf nicht leer sein!
//STRIP001 	// Gibt es diesen nicht oder gibt es davor nur Leere, dann returne 0
//STRIP001 	// Das Flag gibt an:
//STRIP001 	//		TRUE: den, vor der normalen Einfuegeposition (TRUE)
//STRIP001 	// 		FALSE: den, in den das korrigierte Wort eingfuegt wurde.
//STRIP001 	//				(Muss nicht der gleiche Absatz sein!!!!)
//STRIP001 	virtual const String* GetPrevPara( BOOL bAtNormalPos );
//STRIP001 
//STRIP001 	virtual BOOL ChgAutoCorrWord( xub_StrLen& rSttPos, xub_StrLen nEndPos,
//STRIP001 								  SvxAutoCorrect& rACorrect,
//STRIP001 								  const String** ppPara );
//STRIP001 
//STRIP001 	// wird nach dem austauschen der Zeichen von den Funktionen
//STRIP001 	//	- FnCptlSttWrd
//STRIP001 	// 	- FnCptlSttSntnc
//STRIP001 	// gerufen. Dann koennen die Worte ggfs. in die Ausnahmelisten
//STRIP001 	// aufgenommen werden.
//STRIP001 	virtual void SaveCpltSttWord( ULONG nFlag, xub_StrLen nPos,
//STRIP001 									const String& rExceptWord, sal_Unicode cChar );
//STRIP001 	virtual LanguageType GetLanguage( xub_StrLen nPos, BOOL bPrevPara ) const;
//STRIP001 };

class SwAutoCorrExceptWord
{
	String sWord;
	ULONG nFlags, nNode;
	xub_StrLen nCntnt;
	sal_Unicode cChar;
	LanguageType eLanguage;
	BOOL bDeleted;
public:
	SwAutoCorrExceptWord( ULONG nAFlags, ULONG nNd, xub_StrLen nContent,
										const String& rWord, sal_Unicode cChr,
										LanguageType eLang )
		: sWord( rWord ), nFlags( nAFlags ), nNode( nNd ),
			nCntnt( nContent ), cChar( cChr ), bDeleted( FALSE ),
			eLanguage(eLang)
	{}

	BOOL IsDeleted() const							{ return bDeleted; }
//STRIP001 	void CheckChar( const SwPosition& rPos, sal_Unicode cChar );
//STRIP001 	BOOL CheckDelChar( const SwPosition& rPos );
};


} //namespace binfilter
#endif
