/*************************************************************************
 *
 *  $RCSfile: sw_sw2block.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 17:48:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #ifndef _SVSTOR_HXX //autogen
// auto strip #include <so3/svstor.hxx>
// auto strip #endif
// auto strip #ifndef _UNOTOOLS_CHARCLASS_HXX
// auto strip #include <unotools/charclass.hxx>
// auto strip #endif
// auto strip #ifndef _SFXDOCFILE_HXX
// auto strip #include <bf_sfx2/docfile.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #ifndef _DOC_HXX
// auto strip #include <doc.hxx>
// auto strip #endif

#ifndef _ERRHDL_HXX
#include <errhdl.hxx>
#endif

// auto strip #ifndef _PAM_HXX
// auto strip #include <pam.hxx>
// auto strip #endif
// auto strip #ifndef _RDSWG_HXX
// auto strip #include <rdswg.hxx>
// auto strip #endif
// auto strip #ifndef _SWBLOCKS_HXX
// auto strip #include <swblocks.hxx>
// auto strip #endif
// auto strip #ifndef _MDIEXP_HXX
// auto strip #include <mdiexp.hxx>		// Progress
// auto strip #endif
#ifndef _STATSTR_HRC
#include <statstr.hrc>
#endif
// auto strip #ifndef _SWGPAR_HXX
// auto strip #include <swgpar.hxx>
// auto strip #endif
#ifndef _SWSWERROR_H
#include <swerror.h>
#endif
namespace binfilter {

// Die folgenden Daten werden durch SwSwgReader::Scan() (hier definiert)
// eingetragen und in die Instanz uebernommen

//STRIP001 static struct {                     // Infos ueber den Contents-Block:
//STRIP001 	long  nStart;                   // Anfang des Records (Laengenfeld)
//STRIP001 	long  nSize;                    // Laenge des Records
//STRIP001 	short nBlks;                    // Anzahl Elements im Record
//STRIP001 } aBlockInfo;


//////////////////////////////////////////////////////////////////////////


//////////////////////////////////////////////////////////////////////////


//STRIP001 Sw2TextBlocks::Sw2TextBlocks( const String& rFile )
//STRIP001 	: SwImpBlocks( rFile, FALSE ),
//STRIP001 	nColls( 0 ), nNamedFmts( 0 ),
//STRIP001 	pText( 0 ), pRdr( 0 )
//STRIP001 {
//STRIP001 	pDoc = new SwDoc;
//STRIP001 
//STRIP001 	pMed = new SfxMedium( rFile, STREAM_WRITE, FALSE );
//STRIP001 	bReadOnly = 0 != pMed->GetInStream()->GetError();
//STRIP001 	delete pMed;
//STRIP001 
//STRIP001 	pMed = new SfxMedium( rFile, STREAM_READ, FALSE );
//STRIP001 	// ein SvPersist mit einem Temp-Storage muss
//STRIP001 	// fuer OLE-Objekte bereitstehen
//STRIP001 	refPersist = new SvPersist;
//STRIP001 	refPersist->DoOwnerLoad( new SvStorage( aEmptyStr ) );
//STRIP001 	pDoc->SetPersist( refPersist );
//STRIP001 	LoadDoc();
//STRIP001 }


//STRIP001 Sw2TextBlocks::~Sw2TextBlocks()
//STRIP001 {
//STRIP001 	delete pRdr;
//STRIP001 	delete pMed;
//STRIP001 	delete pDoc;
//STRIP001 }


//STRIP001 ULONG Sw2TextBlocks::Delete( USHORT )
//STRIP001 {
//STRIP001 	return ERR_SWG_OLD_GLOSSARY;
//STRIP001 }


//STRIP001 ULONG Sw2TextBlocks::Rename( USHORT, const String&, const String& )
//STRIP001 {
//STRIP001 	return ERR_SWG_OLD_GLOSSARY;
//STRIP001 }

//STRIP001 ULONG Sw2TextBlocks::CopyBlock( SwImpBlocks&, String&, const String&  )
//STRIP001 {
//STRIP001 	return ERR_SWG_OLD_GLOSSARY;
//STRIP001 }


//STRIP001 ULONG Sw2TextBlocks::MakeBlockList()
//STRIP001 {
//STRIP001 	return 0;
//STRIP001 }


//STRIP001 ULONG Sw2TextBlocks::GetDoc( USHORT nIdx )
//STRIP001 {
//STRIP001 	swistream& r = pRdr->r;
//STRIP001 	r.seek( aNames[ nIdx ]->nPos );
//STRIP001 	if( r.next() != SWG_TEXTBLOCK )
//STRIP001 	{
//STRIP001 		pRdr->r.setbad();
//STRIP001 		return ERR_SWG_FILE_FORMAT_ERROR;
//STRIP001 	}
//STRIP001 	BYTE cFlag;
//STRIP001 	r >> cFlag;
//STRIP001 	// Fehler: Block ist leer
//STRIP001 	if( !cFlag )
//STRIP001 	{
//STRIP001 		pRdr->r.setbad();
//STRIP001 		return ERR_SWG_FILE_FORMAT_ERROR;
//STRIP001 	}
//STRIP001 	BYTE eCharSet = pRdr->aHdr.cCodeSet;
//STRIP001 	if( cFlag & 0x02 ) r >> eCharSet;
//STRIP001 	BYTE eOld = pRdr->aHdr.cCodeSet;
//STRIP001 	pRdr->aHdr.cCodeSet = eCharSet;
//STRIP001 	// Bookmark-Text ueberlesen
//STRIP001 	r.next(); r.skipnext(); r.skip();
//STRIP001 	if( pText ) *pText = pRdr->InContentsText( TRUE );
//STRIP001 	else
//STRIP001 	{
//STRIP001 		pRdr->pPaM = MakePaM();
//STRIP001 		USHORT nOldOptions = pRdr->nOptions;
//STRIP001 		pRdr->nOptions = SWGRD_NORMAL;
//STRIP001 		pRdr->InContents( TRUE, TRUE );
//STRIP001 		pRdr->nOptions = nOldOptions;
//STRIP001 		delete pRdr->pPaM;
//STRIP001 		pRdr->pPaM = NULL;
//STRIP001 	}
//STRIP001 	pRdr->aHdr.cCodeSet = eOld;
//STRIP001 	if( SVSTREAM_OK != pMed->GetInStream()->GetError() )
//STRIP001 		return ERR_SWG_READ_ERROR;
//STRIP001 
//STRIP001 	return pRdr->nErrno;
//STRIP001 }


//STRIP001 ULONG Sw2TextBlocks::PutDoc()
//STRIP001 {
//STRIP001 	return ERR_SWG_OLD_GLOSSARY;
//STRIP001 }


//STRIP001 ULONG Sw2TextBlocks::GetText( USHORT nIdx, String& rText )
//STRIP001 {
//STRIP001 	pText = &rText;
//STRIP001 	ULONG nErr = GetDoc( nIdx );
//STRIP001 	pText = NULL;
//STRIP001 	if( nErr )
//STRIP001 		rText.Erase();
//STRIP001 	return nErr;
//STRIP001 }


//STRIP001 ULONG Sw2TextBlocks::PutText( const String&, const String&, const String& )
//STRIP001 {
//STRIP001 	return ERR_SWG_OLD_GLOSSARY;
//STRIP001 }

// Initiales Laden der Doc-Datei. Es werden die Vorlagen
// und die Blocknamen geladen.


//STRIP001 ULONG Sw2TextBlocks::LoadDoc()
//STRIP001 {
//STRIP001 	delete pRdr;
//STRIP001 	pRdr = new SwSwgReader( pDoc, 0, *pMed->GetInStream(), aEmptyStr, TRUE );
//STRIP001 	pRdr->LoadFileHeader();
//STRIP001 	aBlockInfo.nStart = 0L;
//STRIP001 	aBlockInfo.nSize  = 0L;
//STRIP001 	aBlockInfo.nBlks  = 0;
//STRIP001 	// Eine Textbausteindatei kann auch (initial) leer sein
//STRIP001 	if( !pRdr->r.eof() )
//STRIP001 	{
//STRIP001 		if( pRdr->Scan( &aNames ) != 0 )
//STRIP001 			pRdr->r.setbad();
//STRIP001 	}
//STRIP001 	nStart = aBlockInfo.nStart;
//STRIP001 	nSize  = aBlockInfo.nSize;
//STRIP001 	nBlks  = aBlockInfo.nBlks;
//STRIP001 	// Doc-Start ist hinter dem Dateikopf und der Kennung SWG_DOCUMENT
//STRIP001 	pRdr->r.seek( 0x20 );
//STRIP001 	pRdr->r.next();
//STRIP001 	nDocStart = pRdr->r.tell() - 3;
//STRIP001 	nDocSize  = pRdr->r.size() + 3;
//STRIP001 	pRdr->r.clear();
//STRIP001 	nColls = pRdr->nColl;
//STRIP001 	nNamedFmts = pRdr->nNamedFmt;
//STRIP001 	if( pRdr->nErrno )
//STRIP001 		ClearDoc();
//STRIP001 	return pRdr->nErrno;
//STRIP001 }


//STRIP001 ULONG Sw2TextBlocks::OpenFile( BOOL bReadOnly )
//STRIP001 {
//STRIP001 	return bReadOnly ? 0 : ERR_SWG_OLD_GLOSSARY;
//STRIP001 }


//STRIP001 void Sw2TextBlocks::CloseFile()
//STRIP001 {
//STRIP001 }

//////////////////////////////////////////////////////////////////////////

// Eine Methode des Readers muss leider hier residieren:

// Scannen des (einzigen) Contents-Records nach Textbausteinen und Aufbau
// Der Tabelle der Bausteine. Der Header ist bereits eingelesen.


//STRIP001 void SwSwgReader::ScanContents( SwBlockNames* pNames )
//STRIP001 {
//STRIP001 	// Speicherung der lokalen Daten:
//STRIP001 	// Der Record-Header ist immer vier Bytes lang und bereits eingelesen
//STRIP001 	// (siehe SwSwgReader::Scan() fuer Details)
//STRIP001 	aBlockInfo.nSize  = r.size() + 3;
//STRIP001 	aBlockInfo.nStart = r.tell() - 3;
//STRIP001 	long nextrec = r.getskip();
//STRIP001 	// Den Contents-Record nur scannen, wenn noch keine Bookmarks
//STRIP001 	// eingelesen worden sind
//STRIP001 	USHORT nCntId;	// ist immer IDX_NO_VALUE, da ohne LayoutInfos
//STRIP001 	r >> nCntId >> aBlockInfo.nBlks;
//STRIP001 	// Die Blockzahl kann falsch sein, also korrigieren
//STRIP001 	aBlockInfo.nBlks = 0;
//STRIP001 	// Kurznamen in Grossbuchstaben wandeln
//STRIP001 	const CharClass& rCC = GetAppCharClass();
//STRIP001 	BOOL bScanC = BOOL( pNames->Count() == 0 );
//STRIP001 	long nNext;
//STRIP001 	while( r.good() && r.tell() < nextrec )
//STRIP001 	{
//STRIP001 		long nPos = r.tell();
//STRIP001 		switch( r.next() )
//STRIP001 		{
//STRIP001 			case SWG_TEXTBLOCK:
//STRIP001 				nNext = r.getskip();
//STRIP001 				if( bScanC )
//STRIP001 				{
//STRIP001 					BYTE cFlags;
//STRIP001 					// Flag bits: 0x01 - used, 0x02 - charset follows
//STRIP001 					r >> cFlags;
//STRIP001 					if( cFlags )
//STRIP001 					{
//STRIP001 						BYTE eCharSet = (BYTE)gsl_getSystemTextEncoding();
//STRIP001 						if( cFlags & 0x02 )
//STRIP001 						  r >> eCharSet;
//STRIP001 						BYTE eSave = aHdr.cCodeSet;
//STRIP001 						aHdr.cCodeSet = eCharSet;
//STRIP001 						// Textblock ist physikalisch vorhanden
//STRIP001 						String aLong( GetText() );
//STRIP001 						String aShort( GetText() );
//STRIP001 						String s( rCC.upper( aShort ) );
//STRIP001 						aHdr.cCodeSet = eSave;
//STRIP001 						SwBlockName* pNew = new SwBlockName( s, aLong, nPos );
//STRIP001 						pNames->C40_PTR_INSERT( SwBlockName, pNew );
//STRIP001 					}
//STRIP001 				}
//STRIP001 				aBlockInfo.nBlks++;
//STRIP001 				r.skip( nNext );
//STRIP001 				break;
//STRIP001 			case SWG_TEXTNODE:
//STRIP001 			case SWG_GRFNODE:
//STRIP001 			case SWG_OLENODE:
//STRIP001 			case SWG_TABLE:
//STRIP001 			case SWG_TOXGROUP:
//STRIP001 				r.skip(); break;
//STRIP001 			default:
//STRIP001 				Error();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	r.next();
//STRIP001 }



//STRIP001 ULONG Sw2TextBlocks::BeginPutDoc( const String&, const String& )
//STRIP001 {
//STRIP001 	return ERR_SWG_OLD_GLOSSARY;
//STRIP001 }


//STRIP001 void Sw2TextBlocks::StatLineStartPercent()		// zum Anzeigen des Prozessbars
//STRIP001 {
//STRIP001 	SvStream* pFstrm = pMed->GetInStream();
//STRIP001 	ULONG nPos = pFstrm->Tell(), nEnde = pFstrm->Seek( STREAM_SEEK_TO_END );
//STRIP001 	pFstrm->Seek( nPos );
//STRIP001 	pFstrm->ResetError();
//STRIP001 
//STRIP001 	::StartProgress( STR_STATSTR_SWGREAD, nPos, nEnde, pDoc->GetDocShell() );
//STRIP001 }

//STRIP001 short Sw2TextBlocks::GetFileType ( void ) const
//STRIP001 {
//STRIP001 	return SWBLK_SW2;
//STRIP001 }


}
