/*************************************************************************
 *
 *  $RCSfile: sw_undobj1.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 18:04:31 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #ifndef _HINTIDS_HXX
// auto strip #include <hintids.hxx>
// auto strip #endif

// auto strip #ifndef _SFXITEMITER_HXX //autogen
// auto strip #include <svtools/itemiter.hxx>
// auto strip #endif

// auto strip #ifndef _FMTFLCNT_HXX //autogen
// auto strip #include <fmtflcnt.hxx>
// auto strip #endif
#ifndef _FMTANCHR_HXX //autogen
#include <fmtanchr.hxx>
#endif
// auto strip #ifndef _FMTCNTNT_HXX //autogen
// auto strip #include <fmtcntnt.hxx>
// auto strip #endif
// auto strip #ifndef _TXTFLCNT_HXX //autogen
// auto strip #include <txtflcnt.hxx>
// auto strip #endif
#ifndef _FRMFMT_HXX //autogen
#include <frmfmt.hxx>
#endif
#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif
// auto strip #ifndef _FLYFRM_HXX //autogen
// auto strip #include <flyfrm.hxx>
// auto strip #endif
// auto strip #ifndef _FMTFLCNT_HXX //autogen
// auto strip #include <fmtflcnt.hxx>
// auto strip #endif
#ifndef _UNDOBJ_HXX
#include <undobj.hxx>
#endif
// auto strip #ifndef _ROLBCK_HXX
// auto strip #include <rolbck.hxx>	  	// fuer die Attribut History
// auto strip #endif
// auto strip #ifndef _DOC_HXX
// auto strip #include <doc.hxx>
// auto strip #endif
// auto strip #ifndef _DOCARY_HXX
// auto strip #include <docary.hxx>
// auto strip #endif
// auto strip #ifndef _ROOTFRM_HXX
// auto strip #include <rootfrm.hxx>
// auto strip #endif
#ifndef _SWUNDO_HXX
#include <swundo.hxx>			// fuer die UndoIds
#endif
#ifndef _PAM_HXX
#include <pam.hxx>
#endif
// auto strip #ifndef _NDTXT_HXX
// auto strip #include <ndtxt.hxx>
// auto strip #endif
// auto strip #ifndef _HINTS_HXX
// auto strip #include <hints.hxx>
// auto strip #endif
// OD 26.06.2003 #108784#
// auto strip #ifndef _DCONTACT_HXX
// auto strip #include <dcontact.hxx>
// auto strip #endif
namespace binfilter {

// Inline Methode vom UndoIter
//STRIP001 inline SwDoc& SwUndoIter::GetDoc() const { return *pAktPam->GetDoc(); }

//---------------------------------------------------------------------

/*N*/ SwUndoFlyBase::SwUndoFlyBase( SwFrmFmt* pFormat, USHORT nUndoId )
/*N*/ 	: SwUndo( nUndoId ), pFrmFmt( pFormat )
/*N*/ {
/*N*/ #ifdef COMPACT
/*N*/ 	pFormat->GetDoc()->DelUndoGroups();
/*N*/ #endif
/*N*/ }

/*N*/ SwUndoFlyBase::~SwUndoFlyBase()
/*N*/ {
/*N*/ 	if( bDelFmt )		// loeschen waehrend eines Undo's ??
/*?*/ 		delete pFrmFmt;
/*N*/ }

//STRIP001 void SwUndoFlyBase::InsFly( SwUndoIter& rUndoIter, BOOL bShowSelFrm )
//STRIP001 {
//STRIP001 	SwDoc* pDoc = &rUndoIter.GetDoc();
//STRIP001 
//STRIP001 	// ins Array wieder eintragen
//STRIP001 	SwSpzFrmFmts& rFlyFmts = *(SwSpzFrmFmts*)pDoc->GetSpzFrmFmts();
//STRIP001 	rFlyFmts.Insert( pFrmFmt, rFlyFmts.Count() );
//STRIP001 
//STRIP001     // OD 26.06.2003 #108784# - insert 'master' drawing object into drawing page
//STRIP001     if ( RES_DRAWFRMFMT == pFrmFmt->Which() )
//STRIP001     {
//STRIP001         SwDrawContact* pDrawContact =
//STRIP001             static_cast<SwDrawContact*>(pFrmFmt->FindContactObj());
//STRIP001         if ( pDrawContact )
//STRIP001         {
//STRIP001             pDrawContact->InsertMasterIntoDrawPage();
//STRIP001         }
//STRIP001     }
//STRIP001 
//STRIP001 	SwFmtAnchor aAnchor( (RndStdIds)nRndId );
//STRIP001 
//STRIP001 	if( FLY_PAGE == nRndId )
//STRIP001 		aAnchor.SetPageNum( (USHORT)nNdPgPos );
//STRIP001 	else
//STRIP001 	{
//STRIP001 		SwPosition aNewPos( *rUndoIter.pAktPam->GetPoint() );
//STRIP001 		aNewPos.nNode = nNdPgPos;
//STRIP001 		if( FLY_IN_CNTNT == nRndId || FLY_AUTO_CNTNT == nRndId )
//STRIP001 			aNewPos.nContent.Assign( aNewPos.nNode.GetNode().GetCntntNode(),
//STRIP001 									nCntPos );
//STRIP001 		aAnchor.SetAnchor( &aNewPos );
//STRIP001 	}
//STRIP001 
//STRIP001 	pFrmFmt->SetAttr( aAnchor );		// Anker neu setzen
//STRIP001 
//STRIP001 	if( RES_DRAWFRMFMT != pFrmFmt->Which() )
//STRIP001 	{
//STRIP001 		// Content holen und -Attribut neu setzen
//STRIP001 		SwNodeIndex aIdx( pDoc->GetNodes() );
//STRIP001 		RestoreSection( pDoc, &aIdx, SwFlyStartNode );
//STRIP001 		pFrmFmt->SetAttr( SwFmtCntnt( aIdx.GetNode().GetStartNode() ));
//STRIP001 	}
//STRIP001 
//STRIP001 	//JP 18.12.98: Bug 60505 - InCntntAttribut erst setzen, wenn der Inhalt
//STRIP001 	//				vorhanden ist! Sonst wuerde das Layout den Fly vorher
//STRIP001 	//				formatieren, aber keine Inhalt finden; so geschene bei
//STRIP001 	//				Grafiken aus dem Internet
//STRIP001 	if( FLY_IN_CNTNT == nRndId )
//STRIP001 	{
//STRIP001 		// es muss mindestens das Attribut im TextNode stehen
//STRIP001 		SwCntntNode* pCNd = aAnchor.GetCntntAnchor()->nNode.GetNode().GetCntntNode();
//STRIP001 		ASSERT( pCNd->IsTxtNode(), "Kein Textnode an dieser Position" );
//STRIP001 		((SwTxtNode*)pCNd)->Insert( SwFmtFlyCnt(
//STRIP001 								(SwFlyFrmFmt*)pFrmFmt ), nCntPos, nCntPos );
//STRIP001 	}
//STRIP001 
//STRIP001 	pFrmFmt->MakeFrms();
//STRIP001 
//STRIP001 	if( bShowSelFrm )
//STRIP001 		rUndoIter.pSelFmt = pFrmFmt;
//STRIP001 
//STRIP001 	if( GetHistory() )
//STRIP001 		GetHistory()->Rollback( pDoc );
//STRIP001 
//STRIP001 	switch( nRndId )
//STRIP001 	{
//STRIP001 	case FLY_IN_CNTNT:
//STRIP001 	case FLY_AUTO_CNTNT:
//STRIP001 		{
//STRIP001 			const SwFmtAnchor& rAnchor = pFrmFmt->GetAnchor();
//STRIP001 			nNdPgPos = rAnchor.GetCntntAnchor()->nNode.GetIndex();
//STRIP001 			nCntPos = rAnchor.GetCntntAnchor()->nContent.GetIndex();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	case FLY_AT_CNTNT:
//STRIP001 	case FLY_AT_FLY:
//STRIP001 		{
//STRIP001 			const SwFmtAnchor& rAnchor = pFrmFmt->GetAnchor();
//STRIP001 			nNdPgPos = rAnchor.GetCntntAnchor()->nNode.GetIndex();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	case FLY_PAGE:
//STRIP001 		break;
//STRIP001 	}
//STRIP001 	bDelFmt =  FALSE;
//STRIP001 }

//STRIP001 void SwUndoFlyBase::DelFly( SwDoc* pDoc )
//STRIP001 {
//STRIP001 	bDelFmt = TRUE; 					// im DTOR das Format loeschen
//STRIP001 	pFrmFmt->DelFrms(); 				// Frms vernichten.
//STRIP001 
//STRIP001 	// alle Uno-Objecte sollten sich jetzt abmelden
//STRIP001 	{
//STRIP001 		SwPtrMsgPoolItem aMsgHint( RES_REMOVE_UNO_OBJECT, pFrmFmt );
//STRIP001 		pFrmFmt->Modify( &aMsgHint, &aMsgHint );
//STRIP001 	}
//STRIP001 
//STRIP001 	if ( RES_DRAWFRMFMT != pFrmFmt->Which() )
//STRIP001 	{
//STRIP001 		// gibt es ueberhaupt Inhalt, dann sicher diesen
//STRIP001 		const SwFmtCntnt& rCntnt = pFrmFmt->GetCntnt();
//STRIP001 		ASSERT( rCntnt.GetCntntIdx(), "Fly ohne Inhalt" );
//STRIP001 
//STRIP001 		SaveSection( pDoc, *rCntnt.GetCntntIdx() );
//STRIP001 		((SwFmtCntnt&)rCntnt).SetNewCntntIdx( (const SwNodeIndex*)0 );
//STRIP001 	}
//STRIP001     // OD 02.07.2003 #108784# - remove 'master' drawing object from drawing page
//STRIP001     else if ( RES_DRAWFRMFMT == pFrmFmt->Which() )
//STRIP001     {
//STRIP001         SwDrawContact* pDrawContact =
//STRIP001             static_cast<SwDrawContact*>(pFrmFmt->FindContactObj());
//STRIP001         if ( pDrawContact )
//STRIP001         {
//STRIP001             pDrawContact->RemoveMasterFromDrawPage();
//STRIP001         }
//STRIP001     }
//STRIP001 
//STRIP001 	const SwFmtAnchor& rAnchor = pFrmFmt->GetAnchor();
//STRIP001 	const SwPosition* pPos = rAnchor.GetCntntAnchor();
//STRIP001 	// die Positionen im Nodes-Array haben sich verschoben
//STRIP001 	if( FLY_IN_CNTNT == ( nRndId = rAnchor.GetAnchorId() ) )
//STRIP001 	{
//STRIP001 		nNdPgPos = pPos->nNode.GetIndex();
//STRIP001 		nCntPos = pPos->nContent.GetIndex();
//STRIP001 		SwTxtNode *pTxtNd = pDoc->GetNodes()[ pPos->nNode ]->GetTxtNode();
//STRIP001 		ASSERT( pTxtNd, "Kein Textnode gefunden" );
//STRIP001 		SwTxtFlyCnt* pAttr = (SwTxtFlyCnt*)pTxtNd->GetTxtAttr( nCntPos );
//STRIP001 		// Attribut steht noch im TextNode, loeschen
//STRIP001 		if( pAttr && pAttr->GetFlyCnt().GetFrmFmt() == pFrmFmt )
//STRIP001 		{
//STRIP001 			// Pointer auf 0, nicht loeschen
//STRIP001 			((SwFmtFlyCnt&)pAttr->GetFlyCnt()).SetFlyFmt();
//STRIP001 			SwIndex aIdx( pPos->nContent );
//STRIP001 			pTxtNd->Erase( aIdx, 1 );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( FLY_AUTO_CNTNT == nRndId )
//STRIP001 	{
//STRIP001 		nNdPgPos = pPos->nNode.GetIndex();
//STRIP001 		nCntPos = pPos->nContent.GetIndex();
//STRIP001 	}
//STRIP001 	else if( FLY_AT_CNTNT == nRndId || FLY_AT_FLY == nRndId )
//STRIP001 		nNdPgPos = pPos->nNode.GetIndex();
//STRIP001 	else
//STRIP001 		nNdPgPos = rAnchor.GetPageNum();
//STRIP001 
//STRIP001 	pFrmFmt->ResetAttr( RES_ANCHOR );		// Anchor loeschen
//STRIP001 
//STRIP001 
//STRIP001 	// aus dem Array austragen
//STRIP001 	SwSpzFrmFmts& rFlyFmts = *(SwSpzFrmFmts*)pDoc->GetSpzFrmFmts();
//STRIP001 	rFlyFmts.Remove( rFlyFmts.GetPos( pFrmFmt ));
//STRIP001 }

// ----- Undo-InsertFly ------

/*N*/ SwUndoInsLayFmt::SwUndoInsLayFmt( SwFrmFmt* pFormat )
/*N*/ 	: SwUndoFlyBase( pFormat,
/*N*/ 			RES_DRAWFRMFMT == pFormat->Which() ? UNDO_INSDRAWFMT : UNDO_INSLAYFMT )
/*N*/ {
/*N*/ 	const SwFmtAnchor& rAnchor = pFrmFmt->GetAnchor();
/*N*/ 	nRndId = rAnchor.GetAnchorId();
/*N*/ 	bDelFmt = FALSE;
/*N*/ 	switch( nRndId )
/*N*/ 	{
/*N*/ 	case FLY_PAGE:
/*N*/ 		nNdPgPos = rAnchor.GetPageNum();
/*N*/ 		break;
/*N*/ 	case FLY_AT_CNTNT:
/*N*/ 	case FLY_AT_FLY:
/*N*/ 		nNdPgPos = rAnchor.GetCntntAnchor()->nNode.GetIndex();
/*N*/ 		break;
/*N*/ 	case FLY_IN_CNTNT:
/*N*/ 	case FLY_AUTO_CNTNT:
/*N*/ 		{
/*N*/ 			const SwPosition* pPos = rAnchor.GetCntntAnchor();
/*N*/ 			nCntPos = pPos->nContent.GetIndex();
/*N*/ 			nNdPgPos = pPos->nNode.GetIndex();
/*N*/ 		}
/*N*/ 		break;
/*N*/ 	default:
/*N*/ 		ASSERT( FALSE, "Was denn fuer ein FlyFrame?" );
/*N*/ 	}
/*N*/ }

//STRIP001 void SwUndoInsLayFmt::Undo( SwUndoIter& rUndoIter )
//STRIP001 {
//STRIP001 	const SwFmtCntnt& rCntnt = pFrmFmt->GetCntnt();
//STRIP001 	if( rCntnt.GetCntntIdx() ) 	// kein Inhalt
//STRIP001 		RemoveIdxFromSection( rUndoIter.GetDoc(),
//STRIP001 								rCntnt.GetCntntIdx()->GetIndex() );
//STRIP001 
//STRIP001 	DelFly( &rUndoIter.GetDoc() );
//STRIP001 }

//STRIP001 void SwUndoInsLayFmt::Redo( SwUndoIter& rUndoIter )
//STRIP001 {
//STRIP001 	rUndoIter.pLastUndoObj = 0;
//STRIP001 	InsFly( rUndoIter );
//STRIP001 }

//STRIP001 void SwUndoInsLayFmt::Repeat( SwUndoIter& rUndoIter )
//STRIP001 {
//STRIP001 	if( UNDO_INSLAYFMT == rUndoIter.GetLastUndoId() &&
//STRIP001 		pFrmFmt == ((SwUndoInsLayFmt*)rUndoIter.pLastUndoObj)->pFrmFmt )
//STRIP001 		return;
//STRIP001 
//STRIP001 	SwDoc* pDoc = &rUndoIter.GetDoc();
//STRIP001 	// erfrage und setze den Anker neu
//STRIP001 	SwFmtAnchor aAnchor( pFrmFmt->GetAnchor() );
//STRIP001 	if( FLY_AT_CNTNT == aAnchor.GetAnchorId() ||
//STRIP001 		FLY_AUTO_CNTNT == aAnchor.GetAnchorId() ||
//STRIP001 		FLY_IN_CNTNT == aAnchor.GetAnchorId() )
//STRIP001 	{
//STRIP001 		SwPosition aPos( *rUndoIter.pAktPam->GetPoint() );
//STRIP001 		if( FLY_AT_CNTNT == aAnchor.GetAnchorId() )
//STRIP001 			aPos.nContent.Assign( 0, 0 );
//STRIP001 		aAnchor.SetAnchor( &aPos );
//STRIP001 	}
//STRIP001 	else if( FLY_AT_FLY == aAnchor.GetAnchorId() )
//STRIP001 	{
//STRIP001 		const SwStartNode* pSttNd = rUndoIter.pAktPam->GetNode()->FindFlyStartNode();
//STRIP001 		if( pSttNd )
//STRIP001 		{
//STRIP001 			SwPosition aPos( *pSttNd );
//STRIP001 			aAnchor.SetAnchor( &aPos );
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			rUndoIter.pLastUndoObj = this;
//STRIP001 			return ;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( FLY_PAGE == aAnchor.GetAnchorId() )
//STRIP001 	{
//STRIP001 		aAnchor.SetPageNum( pDoc->GetRootFrm()->GetCurrPage(
//STRIP001 										rUndoIter.pAktPam ));
//STRIP001 	}
//STRIP001 	else
//STRIP001 		ASSERT( FALSE, "was fuer ein Anker ist es denn nun?" );
//STRIP001 
//STRIP001 	SwFrmFmt* pFlyFmt = pDoc->CopyLayoutFmt( *pFrmFmt, aAnchor );
//STRIP001 	rUndoIter.pSelFmt = pFlyFmt;
//STRIP001 
//STRIP001 	rUndoIter.pLastUndoObj = this;
//STRIP001 }

// ----- Undo-DeleteFly ------

/*N*/ SwUndoDelLayFmt::SwUndoDelLayFmt( SwFrmFmt* pFormat )
/*N*/ 	: SwUndoFlyBase( pFormat, UNDO_DELLAYFMT ), bShowSelFrm( TRUE )
/*N*/ {
DBG_BF_ASSERT(0, "STRIP"); //STRIP001 	SwDoc* pDoc = pFormat->GetDoc();
//STRIP001 	DelFly( pDoc );
//STRIP001 
//STRIP001 	SwNodeIndex* pIdx = GetMvSttIdx();
//STRIP001 	SwNode* pNd;
//STRIP001 	if( 1 == GetMvNodeCnt() && pIdx &&
//STRIP001 		( pNd = (*pDoc->GetUndoNds())[ *pIdx ] )->IsNoTxtNode() )
//STRIP001 	{
//STRIP001 		// dann setze eine andere Undo-ID; Grafik oder OLE
//STRIP001 		if( pNd->IsGrfNode() )
//STRIP001 			SetId( UNDO_DELGRF );
//STRIP001 		else if( pNd->IsOLENode() )
//STRIP001 			SetId( UNDO_DELOLE );
//STRIP001 	}
/*N*/ }

//STRIP001 void SwUndoDelLayFmt::Undo( SwUndoIter& rUndoIter )
//STRIP001 {
//STRIP001 	InsFly( rUndoIter, bShowSelFrm );
//STRIP001 }

//STRIP001 void SwUndoDelLayFmt::Redo( SwUndoIter& rUndoIter )
//STRIP001 {
//STRIP001 	const SwFmtCntnt& rCntnt = pFrmFmt->GetCntnt();
//STRIP001 	if( rCntnt.GetCntntIdx() ) 	// kein Inhalt
//STRIP001 		RemoveIdxFromSection( rUndoIter.GetDoc(),
//STRIP001 								rCntnt.GetCntntIdx()->GetIndex() );
//STRIP001 
//STRIP001 	DelFly( &rUndoIter.GetDoc() );
//STRIP001 }

//STRIP001 void SwUndoDelLayFmt::Redo()
//STRIP001 {
//STRIP001 	const SwFmtCntnt& rCntnt = pFrmFmt->GetCntnt();
//STRIP001 	if( rCntnt.GetCntntIdx() ) 	// kein Inhalt
//STRIP001 		RemoveIdxFromSection( *pFrmFmt->GetDoc(),
//STRIP001 								rCntnt.GetCntntIdx()->GetIndex() );
//STRIP001 
//STRIP001 	DelFly( pFrmFmt->GetDoc() );
//STRIP001 }

/*  */

/*N*/ SwUndoSetFlyFmt::SwUndoSetFlyFmt( SwFrmFmt& rFlyFmt, SwFrmFmt& rNewFrmFmt )
/*N*/ 	: SwUndo( UNDO_SETFLYFRMFMT ), SwClient( &rFlyFmt ), pFrmFmt( &rFlyFmt ),
/*N*/ 	pNewFmt( &rNewFrmFmt ), pOldFmt( (SwFrmFmt*)rFlyFmt.DerivedFrom() ),
/*N*/ 	pItemSet( new SfxItemSet( *rFlyFmt.GetAttrSet().GetPool(),
/*N*/ 								rFlyFmt.GetAttrSet().GetRanges() )),
/*N*/ 	nOldNode( 0 ), nOldCntnt( 0 ), nOldAnchorTyp( 0 ),
/*N*/ 	nNewNode( 0 ), nNewCntnt( 0 ), nNewAnchorTyp( 0 ), bAnchorChgd( FALSE )
/*N*/ {
/*N*/ }

/*N*/ SwUndoSetFlyFmt::~SwUndoSetFlyFmt()
/*N*/ {
/*N*/ 	delete pItemSet;
/*N*/ }

//STRIP001 void SwUndoSetFlyFmt::GetAnchor( SwFmtAnchor& rAnchor,
//STRIP001 								ULONG nNode, xub_StrLen nCntnt )
//STRIP001 {
//STRIP001 	RndStdIds nAnchorTyp = rAnchor.GetAnchorId();
//STRIP001 	if( FLY_PAGE != nAnchorTyp )
//STRIP001 	{
//STRIP001 		SwNode* pNd = pFrmFmt->GetDoc()->GetNodes()[ nNode ];
//STRIP001 
//STRIP001 		if( FLY_AT_FLY == nAnchorTyp
//STRIP001 				? ( !pNd->IsStartNode() || SwFlyStartNode !=
//STRIP001 					((SwStartNode*)pNd)->GetStartNodeType() )
//STRIP001 				: !pNd->IsTxtNode() )
//STRIP001 			pNd = 0;				// ungueltige Position
//STRIP001 		else
//STRIP001 		{
//STRIP001 			SwPosition aPos( *pNd );
//STRIP001 			if( FLY_IN_CNTNT == nAnchorTyp ||
//STRIP001 				FLY_AUTO_CNTNT == nAnchorTyp )
//STRIP001 			{
//STRIP001 				if( nCntnt > ((SwTxtNode*)pNd)->GetTxt().Len() )
//STRIP001 					pNd = 0;		// ungueltige Position
//STRIP001 				else
//STRIP001 					aPos.nContent.Assign( (SwTxtNode*)pNd, nCntnt );
//STRIP001 			}
//STRIP001 			if( pNd )
//STRIP001 				rAnchor.SetAnchor( &aPos );
//STRIP001 		}
//STRIP001 
//STRIP001 		if( !pNd )
//STRIP001 		{
//STRIP001 			// ungueltige Position - setze auf 1. Seite
//STRIP001 			rAnchor.SetType( FLY_PAGE );
//STRIP001 			rAnchor.SetPageNum( 1 );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else
//STRIP001 		rAnchor.SetPageNum( nCntnt );
//STRIP001 }

//STRIP001 void SwUndoSetFlyFmt::Undo( SwUndoIter& rIter )
//STRIP001 {
//STRIP001 	SwDoc& rDoc = rIter.GetDoc();
//STRIP001 
//STRIP001 	// ist das neue Format noch vorhanden ??
//STRIP001 	if( USHRT_MAX != rDoc.GetFrmFmts()->GetPos( (const SwFrmFmtPtr)pOldFmt ) )
//STRIP001 	{
//STRIP001 		if( bAnchorChgd )
//STRIP001 			pFrmFmt->DelFrms();
//STRIP001 
//STRIP001 		if( pFrmFmt->DerivedFrom() != pOldFmt )
//STRIP001 			pFrmFmt->SetDerivedFrom( pOldFmt );
//STRIP001 
//STRIP001 		SfxItemIter aIter( *pItemSet );
//STRIP001 		const SfxPoolItem* pItem = aIter.GetCurItem();
//STRIP001 		while( pItem )
//STRIP001 		{
//STRIP001 			if( IsInvalidItem( pItem ))
//STRIP001 				pFrmFmt->ResetAttr( pItemSet->GetWhichByPos(
//STRIP001 										aIter.GetCurPos() ));
//STRIP001 			else
//STRIP001 				pFrmFmt->SetAttr( *pItem );
//STRIP001 
//STRIP001 			if( aIter.IsAtEnd() )
//STRIP001 				break;
//STRIP001 			pItem = aIter.NextItem();
//STRIP001 		}
//STRIP001 
//STRIP001 		if( bAnchorChgd )
//STRIP001 		{
//STRIP001 			const SwFmtAnchor& rOldAnch = pFrmFmt->GetAnchor();
//STRIP001 			if( FLY_IN_CNTNT == rOldAnch.GetAnchorId() )
//STRIP001 			{
//STRIP001 				// Bei InCntnt's wird es spannend: Das TxtAttribut muss
//STRIP001 				// vernichtet werden. Leider reisst dies neben den Frms
//STRIP001 				// auch noch das Format mit in sein Grab. Um dass zu
//STRIP001 				// unterbinden loesen wir vorher die Verbindung zwischen
//STRIP001 				// Attribut und Format.
//STRIP001 				const SwPosition *pPos = rOldAnch.GetCntntAnchor();
//STRIP001 				SwTxtNode *pTxtNode = pPos->nNode.GetNode().GetTxtNode();
//STRIP001 				ASSERT( pTxtNode->HasHints(), "Missing FlyInCnt-Hint." );
//STRIP001 				const xub_StrLen nIdx = pPos->nContent.GetIndex();
//STRIP001 				SwTxtAttr * pHnt = pTxtNode->GetTxtAttr( nIdx, RES_TXTATR_FLYCNT );
//STRIP001 #ifndef PRODUCT
//STRIP001 				ASSERT( pHnt && pHnt->Which() == RES_TXTATR_FLYCNT,
//STRIP001 							"Missing FlyInCnt-Hint." );
//STRIP001 				ASSERT( pHnt && pHnt->GetFlyCnt().GetFrmFmt() == pFrmFmt,
//STRIP001 							"Wrong TxtFlyCnt-Hint." );
//STRIP001 #endif
//STRIP001 				((SwFmtFlyCnt&)pHnt->GetFlyCnt()).SetFlyFmt();
//STRIP001 
//STRIP001 				// Die Verbindung ist geloest, jetzt muss noch das Attribut
//STRIP001 				// vernichtet werden.
//STRIP001 				pTxtNode->Delete( RES_TXTATR_FLYCNT, nIdx, nIdx );
//STRIP001 			}
//STRIP001 
//STRIP001 			// Anker umsetzen
//STRIP001 			SwFmtAnchor aNewAnchor( (RndStdIds) nOldAnchorTyp );
//STRIP001 			GetAnchor( aNewAnchor, nOldNode, nOldCntnt );
//STRIP001 			pFrmFmt->SetAttr( aNewAnchor );
//STRIP001 
//STRIP001 			if( FLY_IN_CNTNT == aNewAnchor.GetAnchorId() )
//STRIP001 			{
//STRIP001 				SwPosition* pPos = (SwPosition*)aNewAnchor.GetCntntAnchor();
//STRIP001 				pPos->nNode.GetNode().GetTxtNode()->Insert(
//STRIP001 						SwFmtFlyCnt( (SwFlyFrmFmt*)pFrmFmt ), nOldCntnt, 0 );
//STRIP001 			}
//STRIP001 
//STRIP001 			pFrmFmt->MakeFrms();
//STRIP001 		}
//STRIP001 		rIter.pSelFmt = pFrmFmt;
//STRIP001 	}
//STRIP001 }

//STRIP001 void SwUndoSetFlyFmt::Redo( SwUndoIter& rIter )
//STRIP001 {
//STRIP001 	SwDoc& rDoc = rIter.GetDoc();
//STRIP001 
//STRIP001 	// ist das neue Format noch vorhanden ??
//STRIP001 	if( USHRT_MAX != rDoc.GetFrmFmts()->GetPos( (const SwFrmFmtPtr)pNewFmt ) )
//STRIP001 	{
//STRIP001 
//STRIP001 		if( bAnchorChgd )
//STRIP001 		{
//STRIP001 			SwFmtAnchor aNewAnchor( (RndStdIds) nNewAnchorTyp );
//STRIP001 			GetAnchor( aNewAnchor, nNewNode, nNewCntnt );
//STRIP001 			SfxItemSet aSet( rDoc.GetAttrPool(), aFrmFmtSetRange );
//STRIP001 			aSet.Put( aNewAnchor );
//STRIP001 			rDoc.SetFrmFmtToFly( *pFrmFmt, *pNewFmt, &aSet );
//STRIP001 		}
//STRIP001 		else
//STRIP001 			rDoc.SetFrmFmtToFly( *pFrmFmt, *pNewFmt, 0 );
//STRIP001 
//STRIP001 		rIter.pSelFmt = pFrmFmt;
//STRIP001 	}
//STRIP001 }

//STRIP001 void SwUndoSetFlyFmt::PutAttr( USHORT nWhich, const SfxPoolItem* pItem )
//STRIP001 {
//STRIP001 	if( pItem && pItem != GetDfltAttr( nWhich ) )
//STRIP001 	{
//STRIP001 		// Sonderbehandlung fuer den Anchor
//STRIP001 		if( RES_ANCHOR == nWhich )
//STRIP001 		{
//STRIP001 			// nur den 1. Ankerwechsel vermerken
//STRIP001 			ASSERT( !bAnchorChgd, "mehrfacher Ankerwechsel nicht erlaubt!" );
//STRIP001 
//STRIP001 			bAnchorChgd = TRUE;
//STRIP001 
//STRIP001 			const SwFmtAnchor* pAnchor = (SwFmtAnchor*)pItem;
//STRIP001 			switch( nOldAnchorTyp = pAnchor->GetAnchorId() )
//STRIP001 			{
//STRIP001 			case FLY_IN_CNTNT:
//STRIP001 			case FLY_AUTO_CNTNT:
//STRIP001 				nOldCntnt = pAnchor->GetCntntAnchor()->nContent.GetIndex();
//STRIP001 			case FLY_AT_CNTNT:
//STRIP001 			case FLY_AT_FLY:
//STRIP001 				nOldNode = pAnchor->GetCntntAnchor()->nNode.GetIndex();
//STRIP001 				break;
//STRIP001 
//STRIP001 			default:
//STRIP001 				nOldCntnt = pAnchor->GetPageNum();
//STRIP001 			}
//STRIP001 
//STRIP001 			pAnchor = (SwFmtAnchor*)&pFrmFmt->GetAnchor();
//STRIP001 			switch( nNewAnchorTyp = pAnchor->GetAnchorId() )
//STRIP001 			{
//STRIP001 			case FLY_IN_CNTNT:
//STRIP001 			case FLY_AUTO_CNTNT:
//STRIP001 				nNewCntnt = pAnchor->GetCntntAnchor()->nContent.GetIndex();
//STRIP001 			case FLY_AT_CNTNT:
//STRIP001 			case FLY_AT_FLY:
//STRIP001 				nNewNode = pAnchor->GetCntntAnchor()->nNode.GetIndex();
//STRIP001 				break;
//STRIP001 
//STRIP001 			default:
//STRIP001 				nNewCntnt = pAnchor->GetPageNum();
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 			pItemSet->Put( *pItem );
//STRIP001 	}
//STRIP001 	else
//STRIP001 		pItemSet->InvalidateItem( nWhich );
//STRIP001 }

//STRIP001 void SwUndoSetFlyFmt::Modify( SfxPoolItem* pOld, SfxPoolItem* )
//STRIP001 {
//STRIP001 	if( pOld )
//STRIP001 	{
//STRIP001 		USHORT nWhich = pOld->Which();
//STRIP001 
//STRIP001 		if( nWhich < POOLATTR_END )
//STRIP001 			PutAttr( nWhich, pOld );
//STRIP001 		else if( RES_ATTRSET_CHG == nWhich )
//STRIP001 		{
//STRIP001 			SfxItemIter aIter( *((SwAttrSetChg*)pOld)->GetChgSet() );
//STRIP001 			const SfxPoolItem* pItem = aIter.GetCurItem();
//STRIP001 			while( pItem )
//STRIP001 			{
//STRIP001 				PutAttr( pItem->Which(), pItem );
//STRIP001 				if( aIter.IsAtEnd() )
//STRIP001 					break;
//STRIP001 				pItem = aIter.NextItem();
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }

}
