/*************************************************************************
 *
 *  $RCSfile: sw_labprt.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 18:46:45 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #ifndef _SV_PRNSETUP_HXX_ //autogen
// auto strip #include <svtools/prnsetup.hxx>
// auto strip #endif
// auto strip #ifndef _SV_PRINT_HXX
// auto strip #include <vcl/print.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif
// auto strip #ifndef _ERRHDL_HXX
// auto strip #include <errhdl.hxx>
// auto strip #endif

// auto strip #ifndef _WRTSH_HXX
// auto strip #include <wrtsh.hxx>
// auto strip #endif
// auto strip #ifndef _LABEL_HXX
// auto strip #include <label.hxx>
// auto strip #endif
// auto strip #ifndef _LABPRT_HXX
// auto strip #include <labprt.hxx>
// auto strip #endif
// auto strip #ifndef _LABIMG_HXX
// auto strip #include <labimg.hxx>
// auto strip #endif
// auto strip #ifndef _LABIMP_HXX
// auto strip #include <labimp.hxx>
// auto strip #endif

#ifndef _CMDID_H
#include <cmdid.h>
#endif
#ifndef _LABPRT_HRC
#include <labprt.hrc>
#endif
namespace binfilter {


// --------------------------------------------------------------------------



//STRIP001 SwLabPrtPage::SwLabPrtPage(Window* pParent, const SfxItemSet& rSet) :
//STRIP001 
//STRIP001 	SfxTabPage(pParent, SW_RES(TP_LAB_PRT), rSet),
//STRIP001 
//STRIP001 	pPrinter( 0 ),
//STRIP001 	aPageButton    (this, SW_RES(BTN_PAGE   )),
//STRIP001 	aSingleButton  (this, SW_RES(BTN_SINGLE )),
//STRIP001 	aColText	   (this, SW_RES(TXT_COL    )),
//STRIP001 	aColField	   (this, SW_RES(FLD_COL    )),
//STRIP001 	aRowText	   (this, SW_RES(TXT_ROW    )),
//STRIP001 	aRowField	   (this, SW_RES(FLD_ROW    )),
//STRIP001 	aSynchronCB	   (this, SW_RES(CB_SYNCHRON)),
//STRIP001     aFLDontKnow    (this, SW_RES(FL_DONTKNOW)),
//STRIP001 	aPrinterInfo   (this, SW_RES(INF_PRINTER)),
//STRIP001 	aPrtSetup	   (this, SW_RES(BTN_PRTSETUP)),
//STRIP001     aFLPrinter     (this, SW_RES(FL_PRINTER ))
//STRIP001 
//STRIP001 {
//STRIP001 	FreeResource();
//STRIP001 	SetExchangeSupport();
//STRIP001 
//STRIP001 	// Handler installieren
//STRIP001 	Link aLk = LINK(this, SwLabPrtPage, CountHdl);
//STRIP001 	aPageButton  .SetClickHdl( aLk );
//STRIP001 	aSingleButton.SetClickHdl( aLk );
//STRIP001 
//STRIP001 	aPrtSetup.SetClickHdl( aLk );
//STRIP001 }

// --------------------------------------------------------------------------



//STRIP001 SwLabPrtPage::~SwLabPrtPage()
//STRIP001 {
//STRIP001 	if (pPrinter)
//STRIP001 		delete pPrinter;
//STRIP001 }

// --------------------------------------------------------------------------



//STRIP001 IMPL_LINK( SwLabPrtPage, CountHdl, Button *, pButton )
//STRIP001 {
//STRIP001 	if (pButton == &aPrtSetup)
//STRIP001 	{
//STRIP001 		// Druck-Setup aufrufen
//STRIP001 		if (!pPrinter)
//STRIP001 			pPrinter = new Printer;
//STRIP001 
//STRIP001 		PrinterSetupDialog* pDlg = new PrinterSetupDialog(this );
//STRIP001 		pDlg->SetPrinter(pPrinter);
//STRIP001 		pDlg->Execute();
//STRIP001 		delete pDlg;
//STRIP001 		GrabFocus();
//STRIP001 		aPrinterInfo.SetText(pPrinter->GetName());
//STRIP001 		return 0;
//STRIP001 	}
//STRIP001 	const BOOL bEnable = pButton == &aSingleButton;
//STRIP001 	aColText .Enable(bEnable);
//STRIP001 	aColField.Enable(bEnable);
//STRIP001 	aRowText .Enable(bEnable);
//STRIP001 	aRowField.Enable(bEnable);
//STRIP001 	aSynchronCB.Enable(!bEnable);
//STRIP001 
//STRIP001 	if ( bEnable )
//STRIP001 		aColField.GrabFocus();
//STRIP001 #ifndef PRODUCT
//STRIP001 	else
//STRIP001 		ASSERT( pButton == &aPageButton, "NewButton?" );
//STRIP001 #endif
//STRIP001 	return 0;
//STRIP001 }

// --------------------------------------------------------------------------



//STRIP001 SfxTabPage* SwLabPrtPage::Create(Window* pParent, const SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	return new SwLabPrtPage( pParent, rSet );
//STRIP001 }

// --------------------------------------------------------------------------



//STRIP001 void SwLabPrtPage::ActivatePage( const SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	Reset(rSet);
//STRIP001 }

// --------------------------------------------------------------------------



//STRIP001 int SwLabPrtPage::DeactivatePage(SfxItemSet* pSet)
//STRIP001 {
//STRIP001 	if ( pSet )
//STRIP001 		FillItemSet(*pSet);
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }

// --------------------------------------------------------------------------



//STRIP001 void SwLabPrtPage::FillItem(SwLabItem& rItem)
//STRIP001 {
//STRIP001 	rItem.bPage = aPageButton.IsChecked();
//STRIP001 	rItem.nCol	= (USHORT) aColField.GetValue();
//STRIP001 	rItem.nRow	= (USHORT) aRowField.GetValue();
//STRIP001 	rItem.bSynchron = aSynchronCB.IsChecked() && aSynchronCB.IsEnabled();
//STRIP001 }

// --------------------------------------------------------------------------



//STRIP001 BOOL SwLabPrtPage::FillItemSet(SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	SwLabItem aItem;
//STRIP001 	GetParent()->GetLabItem(aItem);
//STRIP001 	FillItem(aItem);
//STRIP001 	rSet.Put(aItem);
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }

// --------------------------------------------------------------------------



//STRIP001 void SwLabPrtPage::Reset(const SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	SwLabItem aItem;
//STRIP001 	GetParent()->GetLabItem(aItem);
//STRIP001 
//STRIP001 	aColField.SetValue	 (aItem.nCol);
//STRIP001 	aRowField.SetValue	 (aItem.nRow);
//STRIP001 
//STRIP001 	if (aItem.bPage)
//STRIP001 	{
//STRIP001 		aPageButton.Check();
//STRIP001 		aPageButton.GetClickHdl().Call(&aPageButton);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aSingleButton.GetClickHdl().Call(&aSingleButton);
//STRIP001 		aSingleButton.Check();
//STRIP001 	}
//STRIP001 
//STRIP001 	if (pPrinter)
//STRIP001 	{
//STRIP001 		// Drucker anzeigen
//STRIP001 		aPrinterInfo.SetText(pPrinter->GetName());
//STRIP001 	}
//STRIP001 	else
//STRIP001 		aPrinterInfo.SetText(Printer::GetDefaultPrinterName());
//STRIP001 
//STRIP001 	aColField.SetMax(aItem.nCols);
//STRIP001 	aRowField.SetMax(aItem.nRows);
//STRIP001 
//STRIP001 	aColField.SetLast(aColField.GetMax());
//STRIP001 	aRowField.SetLast(aRowField.GetMax());
//STRIP001 
//STRIP001 	aSynchronCB.Check(aItem.bSynchron);
//STRIP001 }




}
