/*************************************************************************
 *
 *  $RCSfile: sw_conarc.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:57:03 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #ifndef _SVDOBJ_HXX //autogen
//STRIP001 #include <bf_svx/svdobj.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 
//STRIP001 #include "view.hxx"
//STRIP001 #include "edtwin.hxx"
//STRIP001 #include "wrtsh.hxx"
//STRIP001 #include "drawbase.hxx"
//STRIP001 #include "conarc.hxx"
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Konstruktor
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 ConstArc::ConstArc(SwWrtShell* pWrtShell, SwEditWin* pEditWin, SwView* pSwView)
//STRIP001 	: SwDrawBase(pWrtShell, pEditWin, pSwView),	nAnzButUp(0)
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonDown-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 BOOL ConstArc::MouseButtonDown( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	BOOL bReturn;
//STRIP001 
//STRIP001 	if ((bReturn = SwDrawBase::MouseButtonDown(rMEvt)) == TRUE)
//STRIP001 	{
//STRIP001 		if (!nAnzButUp)
//STRIP001 			aStartPnt = pWin->PixelToLogic(rMEvt.GetPosPixel());
//STRIP001 	}
//STRIP001 	return (bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* MouseButtonUp-event
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 BOOL ConstArc::MouseButtonUp( const MouseEvent& rMEvt )
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 
//STRIP001 	if ((pSh->IsDrawCreate() || pWin->IsDrawAction()) && rMEvt.IsLeft())
//STRIP001 	{
//STRIP001 		Point aPnt(pWin->PixelToLogic(rMEvt.GetPosPixel()));
//STRIP001 		if (!nAnzButUp && aPnt == aStartPnt)
//STRIP001 		{
//STRIP001 			SwDrawBase::MouseButtonUp(rMEvt);
//STRIP001 			bReturn = TRUE;
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{	nAnzButUp++;
//STRIP001 
//STRIP001 			if (nAnzButUp == 3)		// Kreisbogenerzeugung beendet
//STRIP001 			{
//STRIP001 				SwDrawBase::MouseButtonUp(rMEvt);
//STRIP001 				nAnzButUp = 0;
//STRIP001 				bReturn = TRUE;
//STRIP001 			}
//STRIP001 			else
//STRIP001 				pSh->EndCreate(SDRCREATE_NEXTPOINT);
//STRIP001 		}
//STRIP001 	}
//STRIP001 /*	else if ( pView->IsCreateObj() && rMEvt.IsRight() )
//STRIP001 	{
//STRIP001 		pView->EndCreateObj( SDRCREATE_FORCEEND );
//STRIP001 		bReturn = TRUE;
//STRIP001 	}*/
//STRIP001 
//STRIP001 	return (bReturn);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Function aktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 
//STRIP001 
//STRIP001 void ConstArc::Activate(const USHORT nSlotId)
//STRIP001 {
//STRIP001 	switch (nSlotId)
//STRIP001 	{
//STRIP001 		case SID_DRAW_ARC:
//STRIP001 			pWin->SetDrawMode(OBJ_CARC);
//STRIP001 			break;
//STRIP001 		case SID_DRAW_PIE:
//STRIP001 			pWin->SetDrawMode(OBJ_SECT);
//STRIP001 			break;
//STRIP001 		case SID_DRAW_CIRCLECUT:
//STRIP001 			pWin->SetDrawMode(OBJ_CCUT);
//STRIP001 			break;
//STRIP001 		default:
//STRIP001 			pWin->SetDrawMode(OBJ_NONE);
//STRIP001 			break;
//STRIP001 	}
//STRIP001 
//STRIP001 	SwDrawBase::Activate(nSlotId);
//STRIP001 }
//STRIP001 
//STRIP001 /*************************************************************************
//STRIP001 |*
//STRIP001 |* Funktion deaktivieren
//STRIP001 |*
//STRIP001 \************************************************************************/
//STRIP001 
//STRIP001 void ConstArc::Deactivate()
//STRIP001 {
//STRIP001 	nAnzButUp = 0;
//STRIP001 
//STRIP001 	SwDrawBase::Deactivate();
//STRIP001 }



}
