/*************************************************************************
 *
 *  $RCSfile: sw_tbxmgr.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 19:17:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

#include "cmdid.h"
// auto strip #include "swtypes.hxx"			// nur wegen aEmptyString??
// auto strip #include "errhdl.hxx"
// auto strip #include "wdocsh.hxx"
// auto strip #include "tbxmgr.hxx"
namespace binfilter {


/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 SwPopupWindowTbxMgr::SwPopupWindowTbxMgr( USHORT nId, WindowAlign eAlign,
//STRIP001 					  ResId aRIdWin, ResId aRIdTbx,
//STRIP001 					  SfxBindings& rBindings ) :
//STRIP001 				SvxPopupWindowTbxMgr( nId, eAlign, aRIdWin, aRIdTbx, rBindings),
//STRIP001 				bWeb(FALSE),
//STRIP001 				aRIdWinTemp(aRIdWin),
//STRIP001 				aRIdTbxTemp(aRIdTbx)
//STRIP001 {
//STRIP001 	SfxObjectShell* pObjShell = SfxObjectShell::Current();
//STRIP001 	if(PTR_CAST(SwWebDocShell, pObjShell))
//STRIP001 	{
//STRIP001 		bWeb = TRUE;
//STRIP001 		ToolBox& rTbx = GetTbxMgr().GetToolBox();
//STRIP001 		// jetzt muessen ein paar Items aus der Toolbox versteckt werden:
//STRIP001 		switch(nId)
//STRIP001 		{
//STRIP001 			case FN_INSERT_CTRL:
//STRIP001 				rTbx.ShowItem(FN_INSERT_FRAME_INTERACT_NOCOL);
//STRIP001 				rTbx.HideItem(FN_INSERT_FRAME_INTERACT);
//STRIP001 				rTbx.HideItem(FN_INSERT_FOOTNOTE);
//STRIP001 				rTbx.HideItem(FN_INSERT_ENDNOTE);
//STRIP001 				rTbx.HideItem(FN_PAGE_STYLE_SET_COLS);
//STRIP001 				rTbx.HideItem(FN_INSERT_IDX_ENTRY_DLG);
//STRIP001 
//STRIP001 			break;
//STRIP001 			case FN_INSERT_FIELD_CTRL:
//STRIP001 				rTbx.HideItem(FN_INSERT_FLD_PGNUMBER);
//STRIP001 				rTbx.HideItem(FN_INSERT_FLD_PGCOUNT);
//STRIP001 				rTbx.HideItem(FN_INSERT_FLD_TOPIC);
//STRIP001 				rTbx.HideItem(FN_INSERT_FLD_TITLE);
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	else if( FN_INSERT_CTRL == nId)
//STRIP001 	{
//STRIP001 		ToolBox& rTbx = GetTbxMgr().GetToolBox();
//STRIP001 		rTbx.ShowItem(FN_INSERT_FRAME_INTERACT);
//STRIP001 		rTbx.HideItem(FN_INSERT_FRAME_INTERACT_NOCOL);
//STRIP001 	}
//STRIP001 
//STRIP001 	Size aSize = GetTbxMgr().CalcWindowSizePixel();
//STRIP001 	GetTbxMgr().SetPosSizePixel( Point(), aSize );
//STRIP001 	SetOutputSizePixel( aSize );
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SwPopupWindowTbxMgr::StateChanged(USHORT nSID, SfxItemState eState,
//STRIP001 													const SfxPoolItem* pState)
//STRIP001 {
//STRIP001 	static USHORT __READONLY_DATA aInsertCtrl[] =
//STRIP001 	{
//STRIP001 		FN_INSERT_FRAME_INTERACT,
//STRIP001 		FN_INSERT_FOOTNOTE,
//STRIP001 		FN_INSERT_ENDNOTE,
//STRIP001 		FN_PAGE_STYLE_SET_COLS,
//STRIP001 		FN_INSERT_IDX_ENTRY_DLG,
//STRIP001 		0
//STRIP001 	};
//STRIP001 	static USHORT __READONLY_DATA aInsertFld[] =
//STRIP001 	{
//STRIP001 		FN_INSERT_FLD_PGNUMBER,
//STRIP001 		FN_INSERT_FLD_PGCOUNT,
//STRIP001 		FN_INSERT_FLD_TOPIC,
//STRIP001 		FN_INSERT_FLD_TITLE,
//STRIP001 		0
//STRIP001 	};
//STRIP001 
//STRIP001 	SfxObjectShell* pObjShell = SfxObjectShell::Current();
//STRIP001 	BOOL bNewWeb = 0 != PTR_CAST(SwWebDocShell, pObjShell);
//STRIP001 	if(bWeb != bNewWeb)
//STRIP001 	{
//STRIP001 		bWeb = bNewWeb;
//STRIP001 		ToolBox& rTbx = GetTbxMgr().GetToolBox();
//STRIP001 		// jetzt muessen ein paar Items aus der Toolbox versteckt werden:
//STRIP001 		const USHORT* pSid = 0;
//STRIP001 
//STRIP001 		switch(nSID)
//STRIP001 		{
//STRIP001 			case FN_INSERT_CTRL:
//STRIP001 			pSid = &aInsertCtrl[0];
//STRIP001 				if(bWeb)
//STRIP001 					rTbx.ShowItem(FN_INSERT_FRAME_INTERACT_NOCOL);
//STRIP001 				else
//STRIP001 					rTbx.HideItem(FN_INSERT_FRAME_INTERACT_NOCOL);
//STRIP001 			break;
//STRIP001 			case FN_INSERT_FIELD_CTRL:
//STRIP001 				pSid = & aInsertFld[0];
//STRIP001 			break;
//STRIP001 		}
//STRIP001 		if(pSid)
//STRIP001 		{
//STRIP001 			if(bWeb)
//STRIP001 				while(*pSid)
//STRIP001 				{
//STRIP001 					rTbx.HideItem(*pSid);
//STRIP001 					pSid++;
//STRIP001 				}
//STRIP001 			else
//STRIP001 				while(*pSid)
//STRIP001 				{
//STRIP001 					rTbx.ShowItem(*pSid);
//STRIP001 					pSid++;
//STRIP001 				}
//STRIP001 			Size aSize = GetTbxMgr().CalcWindowSizePixel();
//STRIP001 			GetTbxMgr().SetPosSizePixel( Point(), aSize );
//STRIP001 			SetOutputSizePixel( aSize );
//STRIP001 		}
//STRIP001 	}
//STRIP001 	SfxPopupWindow::StateChanged(nSID, eState, pState);
//STRIP001 }


//STRIP001 SfxPopupWindow* SwPopupWindowTbxMgr::Clone() const
//STRIP001 {
//STRIP001 	return new SwPopupWindowTbxMgr(
//STRIP001 			GetId(),
//STRIP001 			((SwPopupWindowTbxMgr*)this)->GetTbxMgr().GetToolBox().GetAlign(),
//STRIP001 			aRIdWinTemp,
//STRIP001 			aRIdTbxTemp,
//STRIP001 			(SfxBindings&)GetBindings()
//STRIP001 			);
//STRIP001 }

}
