/*************************************************************************
 *
 *  $RCSfile: sw_txtq.cxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 07:57:16 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
namespace binfilter {


//STRIP001 #pragma hdrstop
//STRIP001 
//STRIP001 #include "cmdid.h"
//STRIP001 #include "hintids.hxx"
//STRIP001 
//STRIP001 
//STRIP001 #ifndef _LIST_HXX //autogen steht hier wg. "internal Microsoft error"
//STRIP001 #include <tools/list.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFXENUMITEM_HXX //autogen
//STRIP001 #include <svtools/eitem.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFXSTRITEM_HXX //autogen
//STRIP001 #include <svtools/stritem.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFXINTITEM_HXX //autogen
//STRIP001 #include <svtools/intitem.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFX_WHITER_HXX //autogen
//STRIP001 #include <svtools/whiter.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SFXREQUEST_HXX //autogen
//STRIP001 #include <bf_sfx2/request.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SVX_LRSPITEM_HXX //autogen
//STRIP001 #include <bf_svx/lrspitem.hxx>
//STRIP001 #endif
//STRIP001 #ifndef _SVX_ULSPITEM_HXX //autogen
//STRIP001 #include <bf_svx/ulspitem.hxx>
//STRIP001 #endif
//STRIP001 
//STRIP001 #include "wrtsh.hxx"
//STRIP001 #include "frmatr.hxx"
//STRIP001 #include "pagedesc.hxx"
//STRIP001 #include "fmtcol.hxx"
//STRIP001 #include "charfmt.hxx"
//STRIP001 #include "textsh.hxx"
//STRIP001 #include "num.hxx"
//STRIP001 #include "fldbas.hxx"
//STRIP001 
//STRIP001 /*--------------------------------------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 void SwTextShell::StateQuery( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	register SwWrtShell& rSh = GetShell();
//STRIP001 	SfxWhichIter aIter( rSet );
//STRIP001 	USHORT nWhich = aIter.FirstWhich();
//STRIP001 	register BOOL bFlag;
//STRIP001 
//STRIP001 	switch( nWhich )
//STRIP001 	{
//STRIP001 		case FN_GET_SELECTION:
//STRIP001 		case FN_GET_SELECTED_TEXT:
//STRIP001 			{
//STRIP001 				String sSelection;
//STRIP001 				rSh.GetSelectedText( sSelection,
//STRIP001 					FN_GET_SELECTION == nWhich
//STRIP001 							? GETSELTXT_PARABRK_KEEP
//STRIP001 							: GETSELTXT_PARABRK_TO_BLANK );
//STRIP001 				rSet.Put( SfxStringItem( nWhich, sSelection ) );
//STRIP001 				nWhich = 0;
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		case FN_GETSET_LINE_TEXT:
//STRIP001 		{
//STRIP001 			rSh.StartAction();
//STRIP001 			rSh.Push();
//STRIP001 			rSh.LeftMargin(FALSE);
//STRIP001 			rSh.RightMargin(TRUE);
//STRIP001 			rSet.Put( SfxStringItem( nWhich, rSh.GetSelTxt() ) );
//STRIP001 			rSh.Pop(FALSE);
//STRIP001 			rSh.EndAction();
//STRIP001 			nWhich = 0;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_GET_CURSOR_XPOS:
//STRIP001 			{
//STRIP001 				const SvxLRSpaceItem& rLR = rSh.GetPageDesc( rSh.GetCurPageDesc()
//STRIP001 													).GetMaster().GetLRSpace();
//STRIP001 				long nRet = rSh.GetCharRect().Left() -
//STRIP001 								(rLR.GetLeft() + DOCUMENTBORDER);
//STRIP001 				rSet.Put( SfxInt32Item( nWhich, nRet ) );
//STRIP001 				nWhich = 0;
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		case FN_GET_CURSOR_YPOS:
//STRIP001 			{
//STRIP001 				const SvxULSpaceItem& rUL = rSh.GetPageDesc( rSh.GetCurPageDesc()
//STRIP001 													).GetMaster().GetULSpace();
//STRIP001 				long nRet = rSh.GetCharRect().Top() -
//STRIP001 								(rUL.GetUpper() + DOCUMENTBORDER);
//STRIP001 				rSet.Put( SfxInt32Item( nWhich, nRet ) );
//STRIP001 				nWhich = 0;
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		case FN_GET_PAGECOUNT:
//STRIP001 			{
//STRIP001 				rSet.Put( SfxUInt16Item( nWhich, rSh.GetPageCnt()));
//STRIP001 				nWhich = 0;
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		case FN_GET_PAGENUMBER:
//STRIP001 		case FN_GET_LOG_PAGENUMBER:
//STRIP001 			{
//STRIP001 				USHORT nPage, nLogPage;
//STRIP001 				rSh.GetPageNum( nPage, nLogPage,
//STRIP001 				   rSh.IsCrsrVisible(), FALSE);
//STRIP001 				rSet.Put( SfxUInt16Item( nWhich,
//STRIP001 					nWhich == FN_GET_PAGENUMBER ? nPage : nLogPage));
//STRIP001 				nWhich = 0;
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		case FN_IS_START_OF_PARA:
//STRIP001 			bFlag = rSh.IsSttOfPara();
//STRIP001 			break;
//STRIP001 		case FN_IS_START_OF_WORD:
//STRIP001 			bFlag = rSh.IsSttWrd();
//STRIP001 			break;
//STRIP001 		case FN_IS_START_OF_DOC:
//STRIP001 			bFlag = rSh.IsStartOfDoc();
//STRIP001 			break;
//STRIP001 		case FN_IS_END_OF_PARA:
//STRIP001 			bFlag = rSh.IsEndOfPara();
//STRIP001 			break;
//STRIP001 		case FN_IS_END_OF_WORD:
//STRIP001 			bFlag = rSh.IsEndWrd();
//STRIP001 			break;
//STRIP001 		case FN_IS_END_OF_DOC:
//STRIP001 			bFlag = rSh.IsEndOfDoc();
//STRIP001 			break;
//STRIP001 		case FN_GET_NO_OF_SEL:
//STRIP001 				rSet.Put( SfxUInt16Item( nWhich, rSh.GetCrsrCnt(FALSE) ) );
//STRIP001 				nWhich = 0;
//STRIP001 			break;
//STRIP001 		case FN_GET_CUR_VALUE:
//STRIP001 		{
//STRIP001 				String aRet;
//STRIP001 				if(rSh.HasSelection())
//STRIP001 					aRet = rSh.GetSelTxt();
//STRIP001 				else if( rSh.GetCurFld())
//STRIP001 				{
//STRIP001 					SwField* pFld = rSh.GetCurFld();
//STRIP001 					aRet = pFld->GetCntnt();
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					rSh.Push();
//STRIP001 					rSh.SelNearestWrd();
//STRIP001 					aRet = rSh.GetSelTxt();
//STRIP001 					rSh.Pop(FALSE);
//STRIP001 				}
//STRIP001 				rSet.Put(SfxStringItem(nWhich, aRet));
//STRIP001 				nWhich = 0;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_IS_START_OF_PAGE:
//STRIP001 			break;
//STRIP001 		case FN_IS_END_OF_PAGE:
//STRIP001 			break;
//STRIP001 		case FN_IS_START_OF_SENT:
//STRIP001 			break;
//STRIP001 		case FN_IS_END_OF_SENT:
//STRIP001 		{
//STRIP001 			bFlag = FALSE;
//STRIP001 
//STRIP001 			if (!rSh.IsSttOfPara())
//STRIP001 			{
//STRIP001 				switch (rSh.GetChar(FALSE, -1))
//STRIP001 				{
//STRIP001 					case ';':
//STRIP001 					case '.':
//STRIP001 					case ':':
//STRIP001 					case '!':
//STRIP001 					case '?':
//STRIP001 						bFlag = TRUE;
//STRIP001 						break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_IS_END_OF_LINE:
//STRIP001 		{
//STRIP001 			BOOL bLocked = rSh.IsViewLocked();
//STRIP001 			if (!bLocked)
//STRIP001 				rSh.LockView(TRUE);
//STRIP001 			Point aStartPos = rSh.GetCrsrDocPos();
//STRIP001 			rSh.Push();
//STRIP001 			rSh.RightMargin(FALSE);
//STRIP001 			bFlag = aStartPos == rSh.GetCrsrDocPos();
//STRIP001 			rSh.Pop(FALSE);
//STRIP001 			if (!bLocked)
//STRIP001 				rSh.LockView(FALSE);
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_GET_CHAR_STYLE_COUNT:
//STRIP001 		{
//STRIP001 			rSet.Put( SfxUInt16Item( nWhich,
//STRIP001 									rSh.GetCharFmtCount() - 1 ));
//STRIP001 			nWhich = 0;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_GET_PARA_STYLE_COUNT:
//STRIP001 		{
//STRIP001 			rSet.Put( SfxUInt16Item( nWhich,
//STRIP001 									rSh.GetTxtFmtCollCount() - 1 ));
//STRIP001 			nWhich = 0;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		default:
//STRIP001 			ASSERT(FALSE, falscher Dispatcher);
//STRIP001 			return;
//STRIP001 	}
//STRIP001 	if( nWhich )
//STRIP001 		rSet.Put( SfxBoolItem( nWhich, bFlag ) );
//STRIP001 }
//STRIP001 
//STRIP001 /*--------------------------------------------------
//STRIP001 
//STRIP001 --------------------------------------------------*/
//STRIP001 
//STRIP001 void SwTextShell::ExecQuery(SfxRequest &rReq)
//STRIP001 {
//STRIP001 	register SwWrtShell& rSh = GetShell();
//STRIP001 	const SfxItemSet* pArgs = rReq.GetArgs();
//STRIP001 	USHORT nSlot = rReq.GetSlot();
//STRIP001 
//STRIP001 	switch( nSlot )
//STRIP001 	{
//STRIP001 		case FN_GET_CHAR_STYLE_AT:
//STRIP001 		{
//STRIP001 			if(pArgs)
//STRIP001 			{
//STRIP001 				String aStyle = aEmptyStr;
//STRIP001 
//STRIP001 				const USHORT nIndex = ((SfxUInt16Item &)pArgs->
//STRIP001 												Get(nSlot)).GetValue();
//STRIP001 				if( nIndex <  rSh.GetCharFmtCount() - 1 )
//STRIP001 					aStyle = rSh.GetCharFmt(nIndex+1).GetName();
//STRIP001 				rReq.SetReturnValue(SfxStringItem(nSlot, aStyle));
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_GET_PARA_STYLE_AT:
//STRIP001 		{
//STRIP001 			if(pArgs)
//STRIP001 			{
//STRIP001 				String aStyle = aEmptyStr;
//STRIP001 				const USHORT nIndex = ((SfxUInt16Item &)pArgs->
//STRIP001 												Get(nSlot)).GetValue();
//STRIP001 				USHORT nCount = rSh.GetTxtFmtCollCount() - 1;
//STRIP001 				if(nIndex < nCount)
//STRIP001 					aStyle = rSh.GetTxtFmtColl(nIndex + 1).GetName();
//STRIP001 				rReq.SetReturnValue(SfxStringItem(nSlot, aStyle));
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_GETSET_LINE_TEXT:
//STRIP001 		if(pArgs)
//STRIP001 		{
//STRIP001 			const String sArg = ((SfxStringItem &)pArgs->
//STRIP001 												Get(nSlot)).GetValue();
//STRIP001 			rSh.StartAction();
//STRIP001 			rSh.Push();
//STRIP001 			rSh.LeftMargin(FALSE);
//STRIP001 			rSh.RightMargin(TRUE);
//STRIP001 			rSh.Insert(sArg);
//STRIP001 			rSh.Pop(FALSE);
//STRIP001 			rSh.EndAction();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_GET_LINE_COUNT:
//STRIP001 		{
//STRIP001 			BOOL bActPos = FALSE;
//STRIP001 			if(pArgs && SFX_ITEM_SET == pArgs->GetItemState(FN_GET_LINE_COUNT))
//STRIP001 				bActPos = ((const SfxBoolItem&)pArgs->Get(FN_GET_LINE_COUNT)).GetValue();
//STRIP001 			rReq.SetReturnValue(SfxUInt16Item(FN_GET_LINE_COUNT, rSh.GetLineCount(bActPos)));
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		default:
//STRIP001 			ASSERT(FALSE, falscher Dispatcher);
//STRIP001 			return;
//STRIP001 	}
//STRIP001 }


}
