/*************************************************************************
 *
 *  $RCSfile: sw_view0.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 19:26:34 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/


#pragma hdrstop

// auto strip #include "hintids.hxx"

// auto strip #ifndef _SV_GRAPH_HXX
// auto strip #include <vcl/graph.hxx>
// auto strip #endif
#ifndef _SVX_GALBRWS_HXX_
#include <bf_svx/galbrws.hxx>
#endif
// auto strip #ifndef _SVX_SRCHITEM_HXX
// auto strip #include <bf_svx/srchitem.hxx>
// auto strip #endif
#ifndef _SFXAPP_HXX //autogen
#include <bf_sfx2/app.hxx>
#endif
#ifndef _SVX_SRCHDLG_HXX //autogen
#include <bf_svx/srchdlg.hxx>
#endif
#ifndef _SFX_TEMPLDLG_HXX //autogen
#include <bf_sfx2/templdlg.hxx>
#endif
#ifndef _UIVWIMP_HXX
#include <uivwimp.hxx>
#endif

// auto strip #ifndef _NAVIPI_HXX //autogen
// auto strip #include <navipi.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

#ifndef _WRTSH_HXX
#include <wrtsh.hxx>
#endif
// auto strip #include "view.hxx"
// auto strip #include "basesh.hxx"
// auto strip #include "docsh.hxx"
#include "globals.hrc"
#include "cmdid.h"		 	// FN_		 ...
#include "globdoc.hxx"
// auto strip #include "wview.hxx"
#include "shells.hrc"

#define OLEObjects
#define SwView
#define SearchAttributes
#define ReplaceAttributes
#define SearchSettings
#define _ExecSearch ExecSearch
#define _StateSearch StateSearch
#define Frames
#define Graphics
#define Tables
#define Controls
#define GlobalContents
#define Text
#define Frame
#define Graphic
#define Object
#define Draw
#define TextDrawText
#define TextInTable
#define ListInText
#define ListInTable
#define WebTextInTable
#define WebListInText
#define WebListInTable
#define TextPage
#include "itemdef.hxx"
#include <svtools/moduleoptions.hxx>
namespace binfilter {
// auto strip #include <bf_svx/svxslots.hxx>
#include "swslots.hxx"

using namespace ::com::sun::star;
using namespace ::rtl;

//STRIP008 #include <svtools/moduleoptions.hxx>

#define C2S(cChar) UniString::CreateFromAscii(cChar)

/*N*/ SFX_IMPL_VIEWFACTORY(SwView, SW_RES(STR_NONAME))
/*N*/ {
/*N*/     if ( SvtModuleOptions().IsWriter() )
/*N*/     {
/*N*/         SFX_VIEW_REGISTRATION(SwDocShell);
/*N*/         SFX_VIEW_REGISTRATION(SwGlobalDocShell);
/*N*/     }
/*N*/ }

/*N*/ SFX_IMPL_INTERFACE( SwView, SfxViewShell, SW_RES(RID_TOOLS_TOOLBOX) )
/*N*/ {
/*N*/ 	SFX_CHILDWINDOW_CONTEXT_REGISTRATION(SID_NAVIGATOR);
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(SfxTemplateDialogWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(SvxSearchDialogWrapper::GetChildWindowId());
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(FN_REDLINE_ACCEPT);
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(SID_HYPERLINK_DIALOG);
/*N*/ 	SFX_CHILDWINDOW_REGISTRATION(GalleryChildWindow::GetChildWindowId());
/*N*/     SFX_CHILDWINDOW_REGISTRATION(FN_INSERT_FIELD_DATA_ONLY);
/*N*/ 
/*N*/ 		SFX_FEATURED_CHILDWINDOW_REGISTRATION(FN_SYNC_LABELS, 1);
/*N*/ 	SFX_OBJECTBAR_REGISTRATION(	SFX_OBJECTBAR_TOOLS|
/*N*/ 								SFX_VISIBILITY_STANDARD|SFX_VISIBILITY_SERVER,
/*N*/ 								SW_RES(RID_TOOLS_TOOLBOX) );
/*N*/ }

/*N*/ TYPEINIT1(SwView,SfxViewShell)

/*-----------------13.12.97 11:06-------------------

--------------------------------------------------*/
/*N*/ ShellModes	SwView::GetShellMode()
/*N*/ {
/*N*/ 	return pViewImpl->GetShellMode();
/*N*/ }

/*-----------------13.12.97 11:28-------------------

--------------------------------------------------*/
/*N*/ view::XSelectionSupplier* SwView::GetUNOObject()
/*N*/ {
/*N*/ 	return pViewImpl->GetUNOObject();
/*N*/ }
/* -----------------------------06.05.2002 13:18------------------------------

 ---------------------------------------------------------------------------*/
/*N*/ void SwView::ApplyAccessiblityOptions(SvtAccessibilityOptions& rAccessibilityOptions)
/*N*/ {
/*N*/     pWrtShell->ApplyAccessiblityOptions(rAccessibilityOptions);
/*M*/     //to enable the right state of the selection cursor in readonly documents
/*M*/     if(GetDocShell()->IsReadOnly())
/*M*/         pWrtShell->ShowCrsr();
/*M*/ 
/*N*/ }
}
