/*************************************************************************
 *
 *  $RCSfile: frmhtml.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: mwu $ $Date: 2003/11/06 08:26:14 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _FRMHTML_HXX
#define _FRMHTML_HXX

#include <bf_sfx2/frmdescr.hxx>
#include <bf_sfx2/sfxhtml.hxx>
class SvULongs;
namespace binfilter {

class SfxFrameHTMLParser;
class SfxDocumentInfo;
class _SfxFrameHTMLContexts;
class SfxFrameSetObjectShell;
class SfxMedium;
namespace svtools { class AsynchronLink; }

//STRIP001 class _SfxFrameHTMLContext
//STRIP001 {
//STRIP001 	friend class SfxFrameHTMLParser;
//STRIP001 	friend class _SfxFrameHTMLContexts;
//STRIP001 
//STRIP001 	USHORT nLine;
//STRIP001 	USHORT nFrame;
//STRIP001 	SfxFrameSetDescriptor *pFrameSet;
//STRIP001 
//STRIP001 	_SfxFrameHTMLContext( const SfxFrameHTMLParser *pParser );
//STRIP001 	~_SfxFrameHTMLContext();
//STRIP001 };

//STRIP001 SV_DECL_PTRARR_DEL( _SfxFrameHTMLContexts, _SfxFrameHTMLContext*, 1, 1 )

// Der SfxFrameHTMLParser kennt zwei Modi:
// 1. wenn pDocFSet==0, wird der Parse-Vorgang abgebrochen, sobald sich
//    entscheiden laesst, ob das Dokument Frames enthaelt oder nicht. Es
//    werden jedoch keine FrameSet-Descriptoren gefuellt.
// 2. wenn pDocFSet!=0 wird der uebergebene FrameSet-Descriptor gefuellt.
//    Es findet kein Check mehr statt, ob das Dokument Frames enthaelt
//    und diese auch angezeigt wuerden!

//STRIP001 class SfxFrameHTMLParser : public SfxHTMLParser
//STRIP001 {
//STRIP001 	friend class _SfxFrameHTMLContext;
//STRIP001 
//STRIP001 	SfxFrameSetObjectShell*	pDoc;				// Dokument
//STRIP001 	SfxFrameSetDescriptor*	pFrameSet;			// aktuelles FrameSet
//STRIP001 	SfxFrameSetDescriptor*	pDocFrameSet;		// Dokument-FrameSet
//STRIP001 	String 					aScriptSource;
//STRIP001 	HTMLScriptLanguage 		eScriptType;
//STRIP001 	_SfxFrameHTMLContexts 	aContextStack;		// Kontext-Stack
//STRIP001 
//STRIP001 	USHORT 					nLine;				// aktuelle Line
//STRIP001 	USHORT 					nFrame;				// aktueller Frame
//STRIP001 
//STRIP001 	BOOL 					bIsFrameDoc : 1;	// ist es ein Frames Dokument
//STRIP001 	BOOL 					bInNoFrames : 1;	// wir sind in einem NoFrames
//STRIP001 	BOOL					bIgnoreRawData : 1;
//STRIP001 	BOOL					bParseScriptAgain : 1;
//STRIP001     ::svtools::AsynchronLink*	pDeleteLink;
//STRIP001 	String					aBaseURL;
//STRIP001 
//STRIP001 	// einen FrameSet-Kontext ...
//STRIP001 	void 					SaveContext();		// ... speichern
//STRIP001 												// ... initialisieren
//STRIP001 	void 					InitContext( SfxFrameSetDescriptor * );
//STRIP001 	void 					RestoreContext();	// ... restaurieren
//STRIP001 
//STRIP001 	// den aktuelle Frame holen (kann 0 sein, wenn Frameset voll ist!)
//STRIP001 	SfxFrameDescriptor*		GetCurrentFrame() const;
//STRIP001 
//STRIP001 	// zum naechsten Frame gehen
//STRIP001 	void 					IncFramePos();
//STRIP001 
//STRIP001 	// parsen einer ROW/COL-Spezifikation
//STRIP001 	void 					ParseSizeSpec( const String& rSpec, SvULongs& rSizes,
//STRIP001 								SvUShorts& rAttrs ) const;
//STRIP001 
//STRIP001 	// Auswerten einzelner Tags
//STRIP001 	void 					InsertTitle();		// <TITLE> ... </TITLE>
//STRIP001 	void 					NewFrameSet();		// <FRAMESET>
//STRIP001 	void 					EndFrameSet();		// </FRAMESET>
//STRIP001 	void 					InsertFrame();		// <FRAME>
//STRIP001 	SfxDocumentInfo*		GetDocInfo();
//STRIP001 
//STRIP001 	DECL_STATIC_LINK(		SfxFrameHTMLParser, Delete_Impl, void* );
//STRIP001 
//STRIP001 protected:
//STRIP001 	// wird fuer jedes Token gerufen, das in CallParser erkannt wird
//STRIP001 	virtual void 			NextToken( int nToken );
//STRIP001 	virtual void			Continue( int nToken );
//STRIP001 	void					NewScript();
//STRIP001 	void					EndScript();
//STRIP001 
//STRIP001 public:
//STRIP001 							SfxFrameHTMLParser( SvStream& rStream,
//STRIP001 									SfxFrameSetObjectShell* _pDoc=0 );
//STRIP001 							SfxFrameHTMLParser( SfxMedium& rMedium,
//STRIP001 									SfxFrameSetObjectShell* _pDoc=0 );
//STRIP001 							~SfxFrameHTMLParser();
//STRIP001 
//STRIP001 	virtual SvParserState 	CallParser();   // Aufruf des Parsers
//STRIP001 	void					EndParser();	// Parser asynchron deleten
//STRIP001 
//STRIP001 	BOOL 					IsFrameDoc() const
//STRIP001 							{ return bIsFrameDoc; }
//STRIP001 
//STRIP001 	// Diese Methoden koennen auch von anderen Parsern benutzt werden
//STRIP001 	static void 			ParseFrameOptions(SfxFrameDescriptor*,
//STRIP001 													const HTMLOptions*);
//STRIP001 };

}//end of namespace binfilter
#endif

