/*************************************************************************
 *
 *  $RCSfile: frmhtmlw.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 20:57:37 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _FRMHTMLW_HXX
#define _FRMHTMLW_HXX

// auto strip #include <bf_sfx2/frmdescr.hxx>

// auto strip #ifndef _STREAM_HXX
// auto strip #include <tools/stream.hxx>
// auto strip #endif

// auto strip #ifndef _PARHTML_HXX
// auto strip #include <svtools/parhtml.hxx>
// auto strip #endif
// auto strip #ifndef _HTMLOUT_HXX
// auto strip #include <svtools/htmlout.hxx>
// auto strip #endif
// auto strip #ifndef _HTMLKYWD_HXX
// auto strip #include <svtools/htmlkywd.hxx>
// auto strip #endif
namespace binfilter {

class SfxDocumentInfo;
class SfxFrameSetObjectShell;
class SfxFrame;

//STRIP001 class SfxFrameHTMLWriter
//STRIP001 {
//STRIP001 	static const sal_Char 	sNewLine[];
//STRIP001 	ByteString 				aFill;
//STRIP001 	SvStream* 				pStrm;		// der Stream
//STRIP001 	USHORT					nNestCnt;		// FRAMESET-Schachtungstiefe
//STRIP001 	SfxFrameSetObjectShell*	pDoc;
//STRIP001 
//STRIP001 							// den Header ausgeben
//STRIP001 	void 					OutHeader( rtl_TextEncoding eDestEnc );
//STRIP001 	void 					OutFooter();	// den Footer ausgeben
//STRIP001 	void 					OutNestSpace();	// Spaces fuer Schachtelung ausgeben
//STRIP001 	void 					Out_FrameSetDescriptor(
//STRIP001 		const SfxFrameSetDescriptor *pFSet, BOOL bFlatten,
//STRIP001 		SfxFrame* pTopFrame, rtl_TextEncoding eDestEnc,
//STRIP001 							String *pNonConvertableChars = 0 );
//STRIP001 	SvStream& 				Strm()
//STRIP001 							{ return *pStrm; }
//STRIP001 	static void 			OutMeta( SvStream& rStrm,
//STRIP001 								const sal_Char *pIndent, const String& rName,
//STRIP001 								const String& rContent, BOOL bHTTPEquiv,
//STRIP001 								rtl_TextEncoding eDestEnc,
//STRIP001 							String *pNonConvertableChars = 0 );
//STRIP001 	inline static void 		OutMeta( SvStream& rStrm,
//STRIP001 								const sal_Char *pIndent, const sal_Char *pName,
//STRIP001 								const String& rContent, BOOL bHTTPEquiv,
//STRIP001 								rtl_TextEncoding eDestEnc,
//STRIP001 							String *pNonConvertableChars = 0 );
//STRIP001 
//STRIP001 public:
//STRIP001 	SfxFrameHTMLWriter();
//STRIP001 	~SfxFrameHTMLWriter();
//STRIP001 
//STRIP001 	static void Out_DocInfo( SvStream& rStrm, const SfxDocumentInfo* pInfo,
//STRIP001 							 const sal_Char *pIndent,
//STRIP001 							rtl_TextEncoding eDestEnc = RTL_TEXTENCODING_MS_1252,
//STRIP001 							String *pNonConvertableChars = 0 );
//STRIP001 
//STRIP001 	static void Out_FrameDescriptor(
//STRIP001 		SvStream&, const SfxFrameDescriptor*,
//STRIP001 		BOOL bFlatten = FALSE, SfxFrame* pTopFrame = 0,
//STRIP001 		rtl_TextEncoding eDestEnc = RTL_TEXTENCODING_MS_1252,
//STRIP001 		String *pNonConvertableChars = 0 );
//STRIP001 
//STRIP001 	ULONG Write( SfxFrameSetObjectShell *pDoc,  SvStream& rOut,
//STRIP001 				 const SfxFrameSetDescriptor* pSet = 0, BOOL bFlatten = FALSE,
//STRIP001 				 SfxFrame* pTopFrame = 0 );
//STRIP001 	static String CreateDataURL(SfxFrameSetObjectShell *pDoc,
//STRIP001 								const SfxFrameSetDescriptor* pSet,
//STRIP001 								SfxFrame* pTopFrame );
//STRIP001 	static String CreateURL( SfxFrame* pTopFrame );
//STRIP001 };

/*  */

//STRIP001 inline void SfxFrameHTMLWriter::OutMeta( SvStream& rStrm,
//STRIP001 							const sal_Char *pIndent, const sal_Char *pName,
//STRIP001 							const String& rContent, BOOL bHTTPEquiv,
//STRIP001 							rtl_TextEncoding eDestEnc,
//STRIP001 							String *pNonConvertableChars )
//STRIP001 {
//STRIP001 	String sTmp = String::CreateFromAscii( pName );
//STRIP001 	OutMeta( rStrm, pIndent, sTmp, rContent, bHTTPEquiv, eDestEnc, pNonConvertableChars );
//STRIP001 }
//STRIP001 
//STRIP001 inline void SfxFrameHTMLWriter::OutFooter()
//STRIP001 {
//STRIP001 	// </HTML>
//STRIP001 	HTMLOutFuncs::Out_AsciiTag( Strm(), sHTML_html, FALSE ) << sNewLine;
//STRIP001 }
//STRIP001 
//STRIP001 inline void SfxFrameHTMLWriter::OutNestSpace()
//STRIP001 {
//STRIP001 	if( nNestCnt>0 )
//STRIP001 		Strm() << aFill.Copy( 0, nNestCnt ).GetBuffer();
//STRIP001 }

}//end of namespace binfilter
#endif

