/*************************************************************************
 *
 *  $RCSfile: tabdlg.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:04:39 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SFXTABDLG_HXX
#define _SFXTABDLG_HXX

// auto strip #ifndef _SV_TABDLG_HXX //autogen
// auto strip #include <vcl/tabdlg.hxx>
// auto strip #endif
// auto strip #ifndef _SV_BUTTON_HXX //autogen
// auto strip #include <vcl/button.hxx>
// auto strip #endif
// auto strip #ifndef _SV_TABCTRL_HXX //autogen
// auto strip #include <vcl/tabctrl.hxx>
// auto strip #endif
#ifndef _SV_TABPAGE_HXX //autogen
#include <vcl/tabpage.hxx>
#endif
// auto strip #ifndef _SFXITEMPOOL_HXX //autogen
// auto strip #include <svtools/itempool.hxx>
// auto strip #endif
#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif
class SfxPoolItem; 
namespace binfilter {

class SfxTabDialog;
class SfxViewFrame;
class SfxTabPage;
class SfxBindings;

// typedefs --------------------------------------------------------------

typedef SfxTabPage* (*CreateTabPage)(Window *pParent, const SfxItemSet &rAttrSet);
typedef USHORT*		(*GetTabPageRanges)(); // liefert internationale Which-Wert

struct TabDlg_Impl;
struct TabPageImpl;
class SfxUs_Impl;

// class SfxTabDialog ----------------------------------------------------

#define ID_TABCONTROL	1
#define RET_USER 		100
#define RET_USER_CANCEL	101

//STRIP001 class SfxTabDialogItem: public SfxSetItem
//STRIP001 {
//STRIP001 public:
//STRIP001 	TYPEINFO();
//STRIP001                             SfxTabDialogItem( USHORT nId, const SfxItemSet& rItemSet );
//STRIP001                             SfxTabDialogItem(const SfxTabDialogItem& rAttr, SfxItemPool* pItemPool=NULL);
//STRIP001 	virtual SfxPoolItem*    Clone(SfxItemPool* pToPool) const;
//STRIP001 	virtual SfxPoolItem*    Create(SvStream& rStream, USHORT nVersion) const;
//STRIP001 };

//STRIP001 class SfxTabDialog : public TabDialog
//STRIP001 {
//STRIP001 private:
//STRIP001 friend class SfxTabPage;
//STRIP001 friend class SfxTabDialogController;
//STRIP001 
//STRIP001 	SfxViewFrame*	pFrame;
//STRIP001 
//STRIP001 	TabControl		aTabCtrl;
//STRIP001 	OKButton		aOKBtn;
//STRIP001 	PushButton*		pUserBtn;
//STRIP001 	CancelButton	aCancelBtn;
//STRIP001 	HelpButton		aHelpBtn;
//STRIP001 	PushButton		aResetBtn;
//STRIP001 	PushButton		aBaseFmtBtn;
//STRIP001 
//STRIP001 	const SfxItemSet*	pSet;
//STRIP001 	SfxItemSet*			pOutSet;
//STRIP001 	TabDlg_Impl*		pImpl;
//STRIP001 	USHORT*				pRanges;
//STRIP001 	USHORT				nResId;
//STRIP001 	USHORT				nAppPageId;
//STRIP001 	BOOL				bItemsReset;
//STRIP001 	BOOL				bFmt;
//STRIP001 
//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 	DECL_LINK( ActivatePageHdl, TabControl * );
//STRIP001 	DECL_LINK( DeactivatePageHdl, TabControl * );
//STRIP001 	DECL_LINK( OkHdl, Button * );
//STRIP001 	DECL_LINK( ResetHdl, Button * );
//STRIP001 	DECL_LINK( BaseFmtHdl, Button * );
//STRIP001 	DECL_LINK( UserHdl, Button * );
//STRIP001 	DECL_LINK( CancelHdl, Button * );
//STRIP001 	void			Init_Impl(BOOL, const String *);
//STRIP001 #endif
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual short				Ok();
//STRIP001 	// wird im Sfx gel"oscht!
//STRIP001 	virtual SfxItemSet*			CreateInputItemSet( USHORT nId );
//STRIP001 	// wird *nicht* im Sfx gel"oscht!
//STRIP001 	virtual const SfxItemSet*	GetRefreshedSet();
//STRIP001 	virtual void				PageCreated( USHORT nId, SfxTabPage &rPage );
//STRIP001 #if SUPD>=636
//STRIP001     virtual long                Notify( NotifyEvent& rNEvt );
//STRIP001 #endif
//STRIP001 
//STRIP001 	SfxItemSet*		pExampleSet;
//STRIP001 	SfxItemSet*		GetInputSetImpl();
//STRIP001 	SfxTabPage*		GetTabPage( USHORT nPageId ) const;
//STRIP001 
//STRIP001 	BOOL			IsInOK() const;
//STRIP001 	/**	prepare to leace the current page. Calls the DeactivatePage method of the current page, (if necessary),
//STRIP001 		handles the item sets to copy.
//STRIP001 		@return TRUE if it is allowed to leave the current page, FALSE otherwise
//STRIP001 	*/
//STRIP001 	BOOL			PrepareLeaveCurrentPage();
//STRIP001 
//STRIP001 public:
//STRIP001     SfxTabDialog( Window* pParent, const ResId &rResId, USHORT nSetId, SfxBindings& rBindings,
//STRIP001 				  BOOL bEditFmt = FALSE, const String *pUserButtonText = 0 );
//STRIP001 	SfxTabDialog( Window* pParent, const ResId &rResId, const SfxItemSet * = 0,
//STRIP001 				  BOOL bEditFmt = FALSE, const String *pUserButtonText = 0 );
//STRIP001 	SfxTabDialog( SfxViewFrame *pViewFrame, Window* pParent, const ResId &rResId,
//STRIP001 				  const SfxItemSet * = 0, BOOL bEditFmt = FALSE,
//STRIP001 				  const String *pUserButtonText = 0 );
//STRIP001 	~SfxTabDialog();
//STRIP001 
//STRIP001 	void				AddTabPage( USHORT nId,
//STRIP001 									CreateTabPage pCreateFunc,		// != 0
//STRIP001 									GetTabPageRanges pRangesFunc,	// darf 0 sein
//STRIP001 									BOOL bItemsOnDemand = FALSE);
//STRIP001 	void				AddTabPage( USHORT nId,
//STRIP001 									const String &rRiderText,
//STRIP001 									CreateTabPage pCreateFunc,		// != 0
//STRIP001 									GetTabPageRanges pRangesFunc,	// darf 0 sein
//STRIP001 									BOOL bItemsOnDemand = FALSE,
//STRIP001 									USHORT nPos = TAB_APPEND);
//STRIP001 	void				AddTabPage( USHORT nId,
//STRIP001 									const Bitmap &rRiderBitmap,
//STRIP001 									CreateTabPage pCreateFunc,		// != 0
//STRIP001 									GetTabPageRanges pRangesFunc,	// darf 0 sein
//STRIP001 									BOOL bItemsOnDemand = FALSE,
//STRIP001 									USHORT nPos = TAB_APPEND);
//STRIP001 	void				RemoveTabPage( USHORT nId );
//STRIP001 
//STRIP001 	void				SetCurPageId( USHORT nId ) { nAppPageId = nId; }
//STRIP001 	USHORT				GetCurPageId() const
//STRIP001 							{ return aTabCtrl.GetCurPageId(); }
//STRIP001 	void				ShowPage( USHORT nId );
//STRIP001 
//STRIP001 						// liefert ggf. per Map konvertierte lokale Slots
//STRIP001 	const USHORT*		GetInputRanges( const SfxItemPool& );
//STRIP001 	void				SetInputSet( const SfxItemSet* pInSet );
//STRIP001 	const SfxItemSet*	GetOutputItemSet() const { return pOutSet; }
//STRIP001 	const SfxItemSet*	GetOutputItemSet( USHORT nId ) const;
//STRIP001 	int					FillOutputItemSet();
//STRIP001 	const BOOL			IsFormat() const { return bFmt; }
//STRIP001 
//STRIP001 	const OKButton& 	GetOKButton() const { return aOKBtn; }
//STRIP001 	OKButton&			GetOKButton() { return aOKBtn; }
//STRIP001 	const CancelButton& GetCancelButton() const { return aCancelBtn; }
//STRIP001 	CancelButton&		GetCancelButton() { return aCancelBtn; }
//STRIP001 	const HelpButton&	GetHelpButton() const { return aHelpBtn; }
//STRIP001 	HelpButton&			GetHelpButton() { return aHelpBtn; }
//STRIP001 	const PushButton& 	GetResetButton() const { return aResetBtn; }
//STRIP001 	PushButton&			GetResetButton() { return aResetBtn; }
//STRIP001 
//STRIP001 	const PushButton*	GetApplyButton() const;
//STRIP001 	PushButton*			GetApplyButton();
//STRIP001 
//STRIP001 	const PushButton*	GetUserButton() const { return pUserBtn; }
//STRIP001 	PushButton*			GetUserButton() { return pUserBtn; }
//STRIP001 	void				RemoveResetButton();
//STRIP001 
//STRIP001 	short				Execute();
//STRIP001 	void				Start( BOOL bShow = TRUE );
//STRIP001 
//STRIP001 	const SfxItemSet*	GetExampleSet() const { return pExampleSet; }
//STRIP001 	SfxViewFrame*		GetViewFrame() const { return pFrame; }
//STRIP001 
//STRIP001 	void				EnableApplyButton(BOOL bEnable = TRUE);
//STRIP001 	BOOL				IsApplyButtonEnabled() const;
//STRIP001 	void				SetApplyHandler(const Link& _rHdl);
//STRIP001 	Link				GetApplyHandler() const;
//STRIP001 
//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 	void				Start_Impl();
//STRIP001 	BOOL				OK_Impl() { return PrepareLeaveCurrentPage(); }
//STRIP001 #endif
//STRIP001 };

// class SfxTabPage ------------------------------------------------------

//STRIP001 class SfxTabPage: public TabPage
//STRIP001 {
//STRIP001 friend class SfxTabDialog;
//STRIP001 
//STRIP001 private:
//STRIP001 	const SfxItemSet*	pSet;
//STRIP001 	String				aUserString;
//STRIP001 	BOOL				bHasExchangeSupport;
//STRIP001 	SfxTabDialog*		pTabDlg;
//STRIP001 	TabPageImpl*		pImpl;
//STRIP001 
//STRIP001 	void				SetTabDialog( SfxTabDialog* pNew ) { pTabDlg = pNew; }
//STRIP001 	void				SetInputSet( const SfxItemSet* pNew ) { pSet = pNew; }
//STRIP001 
//STRIP001 protected:
//STRIP001 	SfxTabPage( Window *pParent, const ResId &, const SfxItemSet &rAttrSet );
//STRIP001 	SfxTabPage( Window *pParent, WinBits nStyle, const SfxItemSet &rAttrSet );
//STRIP001 
//STRIP001 	USHORT				GetSlot( USHORT nWhich ) const
//STRIP001 							{ return pSet->GetPool()->GetSlotId( nWhich ); }
//STRIP001 	USHORT				GetWhich( USHORT nSlot ) const
//STRIP001 							{ return pSet->GetPool()->GetWhich( nSlot ); }
//STRIP001 	const SfxPoolItem* 	GetOldItem( const SfxItemSet& rSet, USHORT nSlot );
//STRIP001 	const SfxPoolItem* 	GetExchangeItem( const SfxItemSet& rSet, USHORT nSlot );
//STRIP001 	SfxTabDialog*		GetTabDialog() const { return pTabDlg; }
//STRIP001 
//STRIP001 public:
//STRIP001 	virtual             ~SfxTabPage();
//STRIP001 
//STRIP001 	const SfxItemSet&	GetItemSet() const { return *pSet; }
//STRIP001 
//STRIP001 	virtual BOOL		FillItemSet( SfxItemSet& ) = 0;
//STRIP001 	virtual void		Reset( const SfxItemSet& ) = 0;
//STRIP001 
//STRIP001 	BOOL				HasExchangeSupport() const
//STRIP001 							{ return bHasExchangeSupport; }
//STRIP001 	void				SetExchangeSupport( BOOL bNew = TRUE )
//STRIP001 							{ bHasExchangeSupport = bNew; }
//STRIP001 
//STRIP001 	enum {
//STRIP001 		KEEP_PAGE = 0x0000,		// Fehlerbehandlung; Seite nicht wechseln
//STRIP001 			// 2. F"ullen eines ItemSets f"ur die Aktualilsierung
//STRIP001 			// "ubergeordneter Beispiele; dieser Pointer kann immer
//STRIP001 			// NULL sein!!
//STRIP001 		LEAVE_PAGE = 0x0001,
//STRIP001 			// Set aktualisieren und andere Page aktualisieren
//STRIP001 		REFRESH_SET = 0x0002
//STRIP001 	};
//STRIP001 
//STRIP001 	virtual void		ActivatePage( const SfxItemSet& );
//STRIP001 	virtual int			DeactivatePage( SfxItemSet* pSet = 0 );
//STRIP001 	void				SetUserData(const String& rString)
//STRIP001 							{ aUserString = rString; }
//STRIP001 	String				GetUserData() { return aUserString; }
//STRIP001 	virtual void		FillUserData();
//STRIP001 	virtual BOOL		IsReadOnly() const;
//STRIP001 
//STRIP001 	static const SfxPoolItem* GetItem( const SfxItemSet& rSet, USHORT nSlot );
//STRIP001 };

}//end of namespace binfilter
#endif

