/*************************************************************************
 *
 *  $RCSfile: optdict.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: hr $ $Date: 2004/08/03 21:22:01 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/
#ifndef _SVX_OPTDICT_HXX
#define _SVX_OPTDICT_HXX

// include ---------------------------------------------------------------

// auto strip #ifndef _SV_DIALOG_HXX //autogen
// auto strip #include <vcl/dialog.hxx>
// auto strip #endif
// auto strip #ifndef _SV_FIXED_HXX //autogen
// auto strip #include <vcl/fixed.hxx>
// auto strip #endif
// auto strip #ifndef _SV_LSTBOX_HXX //autogen
// auto strip #include <vcl/lstbox.hxx>
// auto strip #endif
// auto strip #ifndef _SV_BUTTON_HXX //autogen
// auto strip #include <vcl/button.hxx>
// auto strip #endif
// auto strip #ifndef _SV_GROUP_HXX //autogen
// auto strip #include <vcl/group.hxx>
// auto strip #endif
// auto strip #ifndef _SV_COMBOBOX_HXX //autogen
// auto strip #include <vcl/combobox.hxx>
// auto strip #endif

// auto strip #ifndef _SV_TIMER_HXX //autogen
// auto strip #include <vcl/timer.hxx>
// auto strip #endif
// auto strip #ifndef _SV_EDIT_HXX //autogen
// auto strip #include <vcl/edit.hxx>
// auto strip #endif

// auto strip #ifndef _SV_DECOVIEW_HXX //autogen
// auto strip #include <vcl/decoview.hxx>
// auto strip #endif

// auto strip #ifndef _COM_SUN_STAR_UTIL_LANGUAGE_HPP_
// auto strip #include <com/sun/star/util/Language.hpp>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_UNO_REFERENCE_HXX_
// auto strip #include <com/sun/star/uno/Reference.hxx>
// auto strip #endif
// auto strip #ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
// auto strip #include <com/sun/star/uno/Sequence.hxx>
// auto strip #endif


// auto strip #ifndef _SVX_SIMPTABL_HXX
// auto strip #include "simptabl.hxx"
// auto strip #endif
// auto strip #ifndef _SVX_LANGBOX_HXX
// auto strip #include <langbox.hxx>
// auto strip #endif

namespace com{namespace sun{namespace star{
namespace linguistic2{
	class XDictionary;
	class XDictionary1;
	class XSpellChecker1;
	class XSpellChecker;
}}}}
namespace binfilter {

// forward ---------------------------------------------------------------


// class SvxNewDictionaryDialog ------------------------------------------

//STRIP001 class SvxNewDictionaryDialog : public ModalDialog
//STRIP001 {
//STRIP001 private:
//STRIP001 	FixedText			aNameText;
//STRIP001 	Edit				aNameEdit;
//STRIP001 	FixedText			aLanguageText;
//STRIP001 	SvxLanguageBox		aLanguageLB;
//STRIP001 	CheckBox			aExceptBtn;
//STRIP001     FixedLine            aNewDictBox;
//STRIP001 	OKButton			aOKBtn;
//STRIP001 	CancelButton		aCancelBtn;
//STRIP001 	HelpButton			aHelpBtn;
//STRIP001 	::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::linguistic2::XSpellChecker1 > 	xSpell;
//STRIP001 	::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::linguistic2::XDictionary1 >	xNewDic;
//STRIP001 
//STRIP001 #ifdef _SVX_OPTDICT_CXX
//STRIP001 	DECL_LINK( OKHdl_Impl, Button * );
//STRIP001 	DECL_LINK( ModifyHdl_Impl, Edit * );
//STRIP001 #endif
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxNewDictionaryDialog( Window* pParent,
//STRIP001 			::com::sun::star::uno::Reference<
//STRIP001 				::com::sun::star::linguistic2::XSpellChecker1 >  &xSpl );
//STRIP001 
//STRIP001 	::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::linguistic2::XDictionary1 >
//STRIP001 				GetNewDictionary() { return xNewDic; }
//STRIP001 };

// class SvxDictEdit ----------------------------------------------------

//STRIP001 class SvxDictEdit : public Edit
//STRIP001 {
//STRIP001 	Link 	aActionLink;
//STRIP001 	sal_Bool 	bSpaces;
//STRIP001 
//STRIP001 	public:
//STRIP001 					SvxDictEdit(Window* pParent, const ResId& rResId) :
//STRIP001 						Edit(pParent, rResId), bSpaces(sal_False){}
//STRIP001 
//STRIP001 	void 			SetActionHdl( const Link& rLink )
//STRIP001 								{ aActionLink = rLink;}
//STRIP001 
//STRIP001 	void 			SetSpaces(sal_Bool bSet)
//STRIP001 								{bSpaces = bSet;}
//STRIP001 
//STRIP001 	virtual void	KeyInput( const KeyEvent& rKEvent );
//STRIP001 };

// class SvxEditDictionaryDialog -----------------------------------------

//STRIP001 class SvxEditDictionaryDialog : public ModalDialog
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001 	FixedText				aBookFT;
//STRIP001 	ListBox					aAllDictsLB;
//STRIP001 	FixedText				aLangFT;
//STRIP001 	SvxLanguageBox			aLangLB;
//STRIP001 
//STRIP001 	FixedText				aWordFT;
//STRIP001 	SvxDictEdit				aWordED;
//STRIP001 	FixedText				aReplaceFT;
//STRIP001 	SvxDictEdit				aReplaceED;
//STRIP001 	SvTabListBox 			aWordsLB;
//STRIP001 	PushButton 				aNewReplacePB;
//STRIP001 	PushButton 				aDeletePB;
//STRIP001     FixedLine                aEditDictsBox;
//STRIP001 
//STRIP001 	CancelButton			aCloseBtn;
//STRIP001 	HelpButton				aHelpBtn;
//STRIP001 	String					sModify;
//STRIP001 	String					sNew;
//STRIP001 	DecorationView			aDecoView;
//STRIP001 
//STRIP001 	::com::sun::star::uno::Sequence<
//STRIP001 		::com::sun::star::uno::Reference<
//STRIP001 			::com::sun::star::linguistic2::XDictionary >  >	aDics;	//! snapshot copy to work on
//STRIP001 	::com::sun::star::uno::Reference<
//STRIP001 		::com::sun::star::linguistic2::XSpellChecker1 >		xSpell;
//STRIP001 
//STRIP001 	short				nOld;
//STRIP001 	long				nWidth;
//STRIP001 	sal_Bool			bFirstSelect;
//STRIP001 	sal_Bool			bDoNothing;
//STRIP001 	BOOL				bDicIsReadonly;
//STRIP001 
//STRIP001 #ifdef _SVX_OPTDICT_CXX
//STRIP001 	DECL_LINK( SelectBookHdl_Impl, ListBox * );
//STRIP001 	DECL_LINK( SelectLangHdl_Impl, ListBox * );
//STRIP001 	DECL_LINK(SelectHdl, SvTabListBox*);
//STRIP001 	DECL_LINK(NewDelHdl, PushButton*);
//STRIP001 	DECL_LINK(ModifyHdl, Edit*);
//STRIP001 
//STRIP001 
//STRIP001 	void			ShowWords_Impl( sal_uInt16 nId );
//STRIP001 	void			SetLanguage_Impl( ::com::sun::star::util::Language nLanguage );
//STRIP001 	sal_Bool			IsDicReadonly_Impl() const { return bDicIsReadonly; }
//STRIP001 	void			SetDicReadonly_Impl( ::com::sun::star::uno::Reference<
//STRIP001 							::com::sun::star::linguistic2::XDictionary1 >  &xDic );
//STRIP001 
//STRIP001 	void			RemoveDictEntry(SvLBoxEntry* pEntry);
//STRIP001 	USHORT			GetLBInsertPos(const String &rDicWord);
//STRIP001 
//STRIP001 #endif
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	virtual void	Paint( const Rectangle& rRect );
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxEditDictionaryDialog( Window* pParent,
//STRIP001 			const String& rName,
//STRIP001 			::com::sun::star::uno::Reference<
//STRIP001 				::com::sun::star::linguistic2::XSpellChecker1> &xSpl );
//STRIP001 	~SvxEditDictionaryDialog();
//STRIP001 
//STRIP001 	sal_uInt16 GetSelectedDict() {return aAllDictsLB.GetSelectEntryPos();}
//STRIP001 };


}//end of namespace binfilter
#endif

